# `SciMLOperators.jl`

*Unified operator interface for `SciML.ai` and beyond*

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/SciMLOperators/stable)

[![codecov](https://codecov.io/gh/SciML/SciMLOperators.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/SciMLOperators.jl)
[![Build Status](https://github.com/SciML/SciMLOperators.jl/workflows/CI/badge.svg)](https://github.com/SciML/SciMLOperators.jl/actions?query=workflow%3ACI)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

`SciMLOperators` is a package for managing linear, nonlinear,
time-dependent, and parameter dependent operators acting on vectors,
(or column-vectors of matrices). We provide wrappers for matrix-free
operators, fast tensor-product evaluations, pre-cached mutating
evaluations, as well as `Zygote`-compatible non-mutating evaluations.

The lazily implemented operator algebra allows the user to update the
operator state by passing in an update function that accepts arbitrary
parameter objects. Further, our operators behave like `AbstractMatrix` types
thanks to  overloads defined for methods in `Base`, and `LinearAlgebra`.

Therefore, an `AbstractSciMLOperator` can be passed to `LinearSolve.jl`,
or `NonlinearSolve.jl` as a linear/nonlinear operator, or to
`OrdinaryDiffEq.jl` as an `ODEFunction`. Examples of usage within the
`SciML` ecosystem are provided in the documentation.

## Installation

`SciMLOperators.jl` is a registered package and can be installed via

```
julia> import Pkg
julia> Pkg.add("SciMLOperators")
```

## Examples

Let `M`, `D`, `F` be matrix-based, diagonal-matrix-based, and function-based
`SciMLOperators` respectively.

Let `M`, `D`, `F` be matrix-based, diagonal-matrix-based, and function-based
`SciMLOperators` respectively.

```@example operator_algebra
using SciMLOperators, LinearAlgebra
N = 4
function f(v, u, p, t)
    u .* v
end
function f(w, v, u, p, t)
    w .= u .* v
end

u = rand(4)
p = nothing # parameter struct
t = 0.0     # time

M = MatrixOperator(rand(N, N))
D = DiagonalOperator(rand(N))
F = FunctionOperator(f, zeros(N), zeros(N); u, p, t)
```

Then, the following codes just work.

```@example operator_algebra
L1 = 2M + 3F + LinearAlgebra.I + rand(N, N)
L2 = D * F * M'
L3 = kron(M, D, F)
L4 = lu(M) \ D
L5 = [M; D]' * [M F; F D] * [F; D]
```

Each `L#` can be applied to `AbstractVector`s of appropriate sizes:

```@example operator_algebra
v = rand(N)
w = L1(v, u, p, t) # == L1 * v

v_kron = rand(N^3)
w_kron = L3(v_kron, u, p, t) # == L3 * v_kron
```

For mutating operator evaluations, call `cache_operator` to generate an
in-place cache, so the operation is nonallocating.

```@example operator_algebra
α, β = rand(2)

# allocate cache
L2 = cache_operator(L2, u)
L4 = cache_operator(L4, u)

# allocation-free evaluation
L2(w, v, u, p, t) # == mul!(w, L2, v)
L4(w, v, u, p, t, α, β) # == mul!(w, L4, v, α, β)
```

## Roadmap

  - [ ] [Complete integration with `SciML` ecosystem](https://github.com/SciML/SciMLOperators.jl/issues/142)
  - [ ] [Block-matrices](https://github.com/SciML/SciMLOperators.jl/issues/161)
  - [x] [Benchmark and speed-up tensorbproduct evaluations](https://github.com/SciML/SciMLOperators.jl/issues/58)
  - [ ] [Fast tensor-sum (`kronsum`) evaluation](https://github.com/SciML/SciMLOperators.jl/issues/53)
  - [ ] [Fully flesh out operator array algebra](https://github.com/SciML/SciMLOperators.jl/issues/62)
  - [ ] [Operator fusion/matrix chain multiplication at constant `(u, p, t)`-slices](https://github.com/SciML/SciMLOperators.jl/issues/51)

#
"""
    BatchedDiagonalOperator(diag; update_func, update_func!, accepted_kwargs)

Represents a time-dependent elementwise scaling (diagonal-scaling) operation.
Acts on `AbstractArray`s of the same size as `diag`. The update function is
called by `update_coefficients!` and is assumed to have the following signature:

    update_func(diag::AbstractArray, u, p, t; <accepted kwarg fields>) -> [modifies diag]
"""
struct BatchedDiagonalOperator{T, D, F, F!} <: AbstractSciMLOperator{T}
    diag::D
    update_func::F
    update_func!::F!

    function BatchedDiagonalOperator(diag::AbstractArray, update_func, update_func!)
        return new{
            eltype(diag),
            typeof(diag),
            typeof(update_func),
            typeof(update_func!),
        }(
            diag,
            update_func,
            update_func!
        )
    end
end

function DiagonalOperator(
        u::AbstractArray;
        update_func = nothing,
        update_func! = nothing,
        accepted_kwargs = nothing
    )
    update_func = preprocess_update_func(update_func, accepted_kwargs)
    update_func! = preprocess_update_func(update_func!, accepted_kwargs)

    return BatchedDiagonalOperator(u, update_func, update_func!)
end

# traits
function Base.show(io::IO, L::BatchedDiagonalOperator)
    n, k = size(L.diag)
    return print(io, "BatchedDiagonalOperator($n × $n, k = $k)")
end
Base.size(L::BatchedDiagonalOperator) = (N = size(L.diag, 1); (N, N))
Base.iszero(L::BatchedDiagonalOperator) = iszero(L.diag)
Base.transpose(L::BatchedDiagonalOperator) = L
Base.adjoint(L::BatchedDiagonalOperator) = conj(L)
function Base.conj(L::BatchedDiagonalOperator) # TODO - test this thoroughly
    update_func,
        update_func! = if isreal(L)
        L.update_func, L.update_func!
    else
        uf = L.update_func === nothing ? nothing :
            (
                L, u, p, t; kwargs...,
            ) -> conj(
                L.update_func(
                    conj(L.diag),
                    u,
                    p,
                    t;
                    kwargs...
                )
            )
        uf! = L.update_func! === nothing ? nothing :
            (
                L, u, p, t; kwargs...,
            ) -> begin
                L.update_func!(conj!(L.diag), u, p, t; kwargs...)
                conj!(L.diag)
            end
        uf, uf!
    end

    return DiagonalOperator(
        conj(L.diag);
        update_func = update_func,
        update_func! = update_func!,
        accepted_kwargs = NoKwargFilter()
    )
end

function Base.convert(::Type{AbstractMatrix}, L::BatchedDiagonalOperator)
    m, n = size(L)
    msg = """$L cannot be represented by an $m × $n AbstractMatrix"""
    throw(ArgumentError(msg))
end

LinearAlgebra.issymmetric(L::BatchedDiagonalOperator) = true
function LinearAlgebra.ishermitian(L::BatchedDiagonalOperator)
    return if isreal(L)
        true
    else
        vec(L.diag) |> Diagonal |> ishermitian
    end
end
LinearAlgebra.isposdef(L::BatchedDiagonalOperator) = isposdef(Diagonal(vec(L.diag)))

function update_coefficients(L::BatchedDiagonalOperator, u, p, t; kwargs...)
    if !isnothingfunc(L.update_func)
        return @reset L.diag = L.update_func(L.diag, u, p, t; kwargs...)
    elseif !isnothingfunc(L.update_func!)
        L.update_func!(L.diag, u, p, t; kwargs...)
        return L
    end
end

function update_coefficients!(L::BatchedDiagonalOperator, u, p, t; kwargs...)
    if !isnothingfunc(L.update_func!)
        L.update_func!(L.diag, u, p, t; kwargs...)
    elseif !isnothingfunc(L.update_func)
        if !ArrayInterface.ismutable(L.diag)
            msg = """`update_coefficients!` cannot update a `BatchedDiagonalOperator`
            holding an immutable diagonal ($(typeof(L.diag))) through an
            out-of-place `update_func`. Use `update_coefficients(L, u, p, t)`
            instead, or construct the operator with a mutating `update_func!`."""
            throw(ArgumentError(msg))
        end
        copyto!(L.diag, L.update_func(L.diag, u, p, t; kwargs...))
    end
    return nothing
end

getops(L::BatchedDiagonalOperator) = (L.diag,)

# Copy method to avoid aliasing
function Base.copy(L::BatchedDiagonalOperator)
    return BatchedDiagonalOperator(
        copy(L.diag),
        L.update_func,
        L.update_func!
    )
end

function isconstant(L::BatchedDiagonalOperator)
    return update_func_isconstant(L.update_func) & update_func_isconstant(L.update_func!)
end
islinear(::BatchedDiagonalOperator) = true
isconvertible(::BatchedDiagonalOperator) = false
has_adjoint(L::BatchedDiagonalOperator) = true
has_ldiv(L::BatchedDiagonalOperator) = all(x -> !iszero(x), L.diag)
has_ldiv!(L::BatchedDiagonalOperator) = has_ldiv(L)

# operator application
Base.:*(L::BatchedDiagonalOperator, u::AbstractVecOrMat) = L.diag .* u
Base.:\(L::BatchedDiagonalOperator, u::AbstractVecOrMat) = L.diag .\ u

function LinearAlgebra.mul!(
        v::AbstractVecOrMat,
        L::BatchedDiagonalOperator,
        u::AbstractVecOrMat
    )
    V = vec(v)
    U = vec(u)
    d = vec(L.diag)
    D = Diagonal(d)
    mul!(V, D, U)

    return v
end

function LinearAlgebra.mul!(
        v::AbstractVecOrMat,
        L::BatchedDiagonalOperator,
        u::AbstractVecOrMat,
        α,
        β
    )
    V = vec(v)
    U = vec(u)
    d = vec(L.diag)
    D = Diagonal(d)
    mul!(V, D, U, α, β)

    return v
end

function LinearAlgebra.ldiv!(
        v::AbstractVecOrMat,
        L::BatchedDiagonalOperator,
        u::AbstractVecOrMat
    )
    V = vec(v)
    U = vec(u)
    d = vec(L.diag)
    D = Diagonal(d)
    ldiv!(V, D, U)

    return v
end

function LinearAlgebra.ldiv!(L::BatchedDiagonalOperator, u::AbstractVecOrMat)
    U = vec(u)
    d = vec(L.diag)
    D = Diagonal(d)
    ldiv!(D, U)
    return u
end

function (L::BatchedDiagonalOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    if !isconstant(L)
        L = update_coefficients(L, u, p, t; kwargs...)
    end
    return L.diag .* v
end

function (L::BatchedDiagonalOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    w .= L.diag .* v
    return w
end

function (L::BatchedDiagonalOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    if β == 0
        w .= α .* (L.diag .* v)
    else
        w .= α .* (L.diag .* v) .+ β .* w
    end
    return w
end
#

#
###
# left multiplication
###

for op in (:*, :\)
    @eval function Base.$op(u::AbstractVecOrMat, L::AbstractSciMLOperator)
        oper = u isa Transpose ? transpose : adjoint
        return $op(oper(L), oper(u)) |> oper
    end
end

function LinearAlgebra.mul!(
        v::AbstractVecOrMat,
        u::AbstractVecOrMat,
        L::AbstractSciMLOperator
    )
    op = (u isa Transpose) | (v isa Transpose) ? transpose : adjoint
    mul!(op(v), op(L), op(u))
    return v
end

function LinearAlgebra.mul!(
        v::AbstractVecOrMat,
        u::AbstractVecOrMat,
        L::AbstractSciMLOperator,
        α,
        β
    )
    op = (u isa Transpose) | (v isa Transpose) ? transpose : adjoint
    mul!(op(v), op(L), op(u), α, β)
    return v
end

function LinearAlgebra.ldiv!(
        v::AbstractVecOrMat,
        u::AbstractVecOrMat,
        L::AbstractSciMLOperator
    )
    op = (u isa Transpose) | (v isa Transpose) ? transpose : adjoint
    ldiv!(op(v), op(L), op(u))
    return v
end

function LinearAlgebra.ldiv!(u::AbstractVecOrMat, L::AbstractSciMLOperator)
    op = (u isa Transpose) ? transpose : adjoint
    ldiv!(op(L), op(u))
    return u
end

###
# fallback wrappers
###

"""
$TYPEDEF
    AdjointOperator(L)

Lazy adjoint wrapper for an `AbstractSciMLOperator`.

# Arguments

  - `L::AbstractSciMLOperator`: Operator to adjoint.

# Fields

  - `L`: Wrapped operator.

# Interface Rules

Construct through `adjoint(L)` or `L'`. The wrapper delegates updates and
matrix-like application to the adjoint action of `L`; it is valid only when
`has_adjoint(L)` is true.
"""
struct AdjointOperator{T, LType} <: AbstractSciMLOperator{T}
    L::LType

    function AdjointOperator(L::AbstractSciMLOperator{T}) where {T}
        return new{T, typeof(L)}(L)
    end
end

"""
$TYPEDEF
    TransposedOperator(L)

Lazy transpose wrapper for an `AbstractSciMLOperator`.

# Arguments

  - `L::AbstractSciMLOperator`: Operator to transpose.

# Fields

  - `L`: Wrapped operator.

# Interface Rules

Construct through `transpose(L)`. The wrapper delegates updates and
matrix-like application to the transpose action of `L`; complex operators
must distinguish this from `adjoint(L)`.
"""
struct TransposedOperator{T, LType} <: AbstractSciMLOperator{T}
    L::LType

    function TransposedOperator(L::AbstractSciMLOperator{T}) where {T}
        return new{T, typeof(L)}(L)
    end
end

AbstractAdjointVecOrMat = Adjoint{T, <:AbstractVecOrMat} where {T}
AbstractTransposedVecOrMat = Transpose{T, <:AbstractVecOrMat} where {T}

has_adjoint(::AdjointOperator) = true
has_adjoint(L::TransposedOperator) = isreal(L) & has_adjoint(L.L)

islinear(L::AdjointOperator) = islinear(L.L)
islinear(L::TransposedOperator) = islinear(L.L)

Base.transpose(L::AdjointOperator) = conj(L.L)
Base.adjoint(L::TransposedOperator) = conj(L.L)

function Base.show(io::IO, L::AdjointOperator)
    show(io, L.L)
    return print(io, "'")
end

function Base.show(io::IO, L::TransposedOperator)
    print(io, "transpose(")
    show(io, L.L)
    return print(io, ")")
end

for (op, LType, VType) in (
        (:adjoint, :AdjointOperator, :AbstractAdjointVecOrMat),
        (:transpose, :TransposedOperator, :AbstractTransposedVecOrMat),
    )
    # constructor
    @eval Base.$op(L::AbstractSciMLOperator) = $LType(L)

    @eval Base.convert(::Type{AbstractMatrix}, L::$LType) = $op(
        convert(
            AbstractMatrix,
            L.L
        )
    )
    @eval has_concretization(L::$LType) = has_concretization(L.L)

    # traits
    @eval Base.size(L::$LType) = size(L.L) |> reverse
    @eval Base.resize!(L::$LType, n::Integer) = (resize!(L.L, n); L)
    @eval Base.$op(L::$LType) = L.L

    @eval getops(L::$LType) = (L.L,)

    # Copy method to avoid aliasing
    @eval Base.copy(L::$LType) = $LType(copy(L.L))

    # Method forwarding (previously using @forward from MacroTools)
    # LinearAlgebra methods
    @eval LinearAlgebra.issymmetric(L::$LType) = LinearAlgebra.issymmetric(L.L)
    @eval LinearAlgebra.ishermitian(L::$LType) = LinearAlgebra.ishermitian(L.L)
    @eval LinearAlgebra.isposdef(L::$LType) = LinearAlgebra.isposdef(L.L)
    @eval LinearAlgebra.opnorm(L::$LType) = LinearAlgebra.opnorm(L.L)

    # SciML methods
    @eval isconstant(L::$LType) = isconstant(L.L)
    @eval has_mul(L::$LType) = has_mul(L.L)
    @eval has_mul!(L::$LType) = has_mul!(L.L)
    @eval has_ldiv(L::$LType) = has_ldiv(L.L)
    @eval has_ldiv!(L::$LType) = has_ldiv!(L.L)

    @eval function cache_internals(L::$LType, u::AbstractVecOrMat)
        @reset L.L = cache_operator(L.L, reshape(u, size(L, 1)))
        return L
    end

    # Like `ScaledOperator`, these wrappers hold no scratch of their own and so are
    # transparent to the sharing described in `getcache`. The reshape is the same one
    # `cache_internals` above does: what the wrapper is applied to is not what the operator
    # it wraps is applied to.
    @eval getcache(L::$LType) = getcache(L.L)
    @eval update_cache(L::$LType, new_cache) = @reset L.L = update_cache(L.L, new_cache)

    @eval function adopt_cache(L::$LType, cache, u::AbstractVecOrMat)
        inner = adopt_cache(L.L, cache, reshape(u, size(L, 1)))
        return inner === nothing ? nothing : (@reset L.L = inner)
    end

    # operator application
    @eval Base.:*(u::$VType, L::$LType) = $op(L.L * u.parent)
    @eval Base.:/(u::$VType, L::$LType) = $op(L.L \ u.parent)

    # v' ← u' * A'
    # v  ← A  * u
    @eval function LinearAlgebra.mul!(v::$VType, u::$VType, L::$LType)
        mul!(v.parent, L.L, u.parent)
        return v
    end

    # v' ← α * (u' * A') + β * v'
    # v  ← α * (A  * u ) + β * v
    @eval function LinearAlgebra.mul!(v::$VType, u::$VType, L::$LType, α, β)
        mul!(v.parent, L.L, u.parent, α, β)
        return v
    end

    # v' ← u' / A'
    # v  ← A  \ u
    @eval function LinearAlgebra.ldiv!(v::$VType, u::$VType, L::$LType)
        ldiv!(v.parent, L.L, u.parent)
        return v
    end

    # u' ← u' / A'
    # u  ← A  \ u
    @eval function LinearAlgebra.ldiv!(u::$VType, L::$LType)
        ldiv!(L.L, u.parent)
        return u
    end
end

# For AdjointOperator
# Out-of-place: v is action vector, u is update vector
function (L::AdjointOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    # Adjoint operator applied to v means L.L' * v
    # For matrices: (A')v = (v'A)'
    # This means we need to compute L.L(v', u, p, t)'
    # Update the operator first, then apply adjoint operator
    L_updated = update_coefficients(L.L, u, p, t; kwargs...)
    # (A')v = (v'A)' where v'A is computed by A'*v'
    return (L_updated' * v')'
end

# In-place: w is destination, v is action vector, u is update vector
function (L::AdjointOperator)(w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...)
    # Update the operator in-place
    update_coefficients!(L.L, u, p, t; kwargs...)
    # Use direct in-place multiplicatieon for adjoints
    mul!(w', v', L.L)
    return w
end

# In-place with scaling: w = α*(L*v) + β*w
function (L::AdjointOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    # Update the operator in-place
    update_coefficients!(L.L, u, p, t; kwargs...)
    mul!(w', v', L.L, α, β)
    return w
end

# For TransposedOperator
# Out-of-place
function (L::TransposedOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L_updated = update_coefficients(L.L, u, p, t; kwargs...)
    # (A^T)v = (v'A)' where v'A is computed by A'*v'
    return (L_updated' * v')'
end

# In-place
function (L::TransposedOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    update_coefficients!(L.L, u, p, t; kwargs...)
    mul!(w', v', L.L)
    return w
end

# In-place with scaling
function (L::TransposedOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L.L, u, p, t; kwargs...)
    mul!(w', v', L.L, α, β)
    return w
end
#

@setup_workload begin
    v = [1.0, 2.0]
    matrix_operator = MatrixOperator([2.0 1.0; 1.0 3.0])
    diagonal_operator = DiagonalOperator([2.0, 3.0])
    identity_operator = IdentityOperator(2)
    scalar_operator = ScalarOperator(2.0)
    function_operator = FunctionOperator(
        (v, u, p, t) -> 2 .* v,
        v;
        ifcache = false,
        isconstant = true,
        islinear = true
    )
    added_operator = matrix_operator + diagonal_operator
    composed_operator = matrix_operator * diagonal_operator
    block_operator = BlockDiagonalOperator(matrix_operator, diagonal_operator)
    tensor_operator = kron(identity_operator, diagonal_operator)

    @compile_workload begin
        matrix_operator * v
        mul!(similar(v), matrix_operator, v)
        diagonal_operator(v, nothing, nothing, 0.0)
        scalar_operator * v
        function_operator * v
        added_operator * v
        composed_operator * v
        (matrix_operator ∘ diagonal_operator) * v
        cache_operator(composed_operator, v) * v
        block_operator * [1.0, 2.0, 3.0, 4.0]
        tensor_operator * [1.0, 2.0, 3.0, 4.0]
    end
end

using SciMLOperators, LinearAlgebra
using Random
using Test

Random.seed!(0)
@testset "WOperator" begin
    J = rand(12, 12)
    u = rand(12)
    M = I(12)
    gamma = 1/123
    W = WOperator{true}(M, gamma, J, u)
    
    @test convert(AbstractMatrix, W) ≈ J - M/gamma
end

module SciMLOperatorsSparseArraysExt

import SciMLOperators
import SparseArrays: sparse, issparse
import SparseArrays
import LinearAlgebra

SparseArrays.sparse(L::SciMLOperators.MatrixOperator) = sparse(L.A)
SparseArrays.issparse(L::SciMLOperators.MatrixOperator) = issparse(L.A)
SparseArrays.sparse(L::SciMLOperators.ScaledOperator) = L.λ * sparse(L.L)
SparseArrays.sparse(L::SciMLOperators.AddedOperator) = sum(sparse, L.ops)
SparseArrays.sparse(L::SciMLOperators.ComposedOperator) = prod(sparse, L.ops)
SparseArrays.sparse(L::SciMLOperators.IdentityOperator) = sparse(LinearAlgebra.I, size(L))
function SparseArrays.sparse(L::SciMLOperators.TensorProductOperator)
    return LinearAlgebra.kron(sparse.(L.ops)...)
end
function SparseArrays.sparse(L::SciMLOperators.BlockDiagonalOperator)
    return SparseArrays.blockdiag(sparse.(L.ops)...)
end
function SparseArrays.sparse(L::SciMLOperators.NullOperator)
    return SparseArrays.spzeros(eltype(L), size(L))
end
SparseArrays.sparse(L::SciMLOperators.TensorSumOperator) = sum(sparse, L.products)

end

#
TENSOR_PROD_DOC = """
Computes the lazy pairwise Kronecker product, or tensor product,
operator of `AbstractMatrix`, and `AbstractSciMLOperator` subtypes.
Calling `⊗(ops...)` is equivalent to `Base.kron(ops...)`. Fast
operator evaluation is performed without forming the full tensor
product operator.

```
TensorProductOperator(A, B) = A ⊗ B
TensorProductOperator(A, B, C) = A ⊗ B ⊗ C

(A ⊗ B)(v) = vec(B * reshape(v, M, N) * transpose(A))
```
where `M = size(B, 2)`, and `N = size(A, 2)`

# Arguments

  - `A`: Left tensor factor, an `AbstractMatrix` or
    `AbstractSciMLOperator`.
  - `B`: Right tensor factor, an `AbstractMatrix` or
    `AbstractSciMLOperator`.
  - `ops...`: Additional factors for the variadic constructor.

# Returns

A lazy `TensorProductOperator` with the product size and action. Applying it
does not form the full Kronecker matrix; `cache_operator` may be used before
repeated in-place multiplication.

# Interface Rules

The factors must have compatible matrix dimensions for the requested action.
The vector or batch input is interpreted using the tensor-product layout, and
the output has the same batch shape with the product leading dimension.
Use `convert(AbstractMatrix, L)` only when every factor supports eager
materialization.

# Errors

Application throws a dimension error when the input does not match the
product's leading dimension. Eager conversion throws when any factor lacks a
concrete matrix representation.

# Examples

```
using SciMLOperators, LinearAlgebra

# Create basic operators
A = rand(3, 3)
B = rand(4, 4)
A_op = MatrixOperator(A)
B_op = MatrixOperator(B)

# Create tensor product operator
T = SciMLOperators.⊗(A_op, B_op)

# Apply to a vector using the new interface
v = rand(3*4)    # Action vector
u = rand(3*4)    # Update vector
p = nothing
t = 0.0

# Out-of-place application
result = T(v, u, p, t)

# For in-place operations, need to cache the operator first
T_cached = cache_operator(T, v)

# In-place application
w = zeros(size(T, 1))
T_cached(w, v, u, p, t)

# In-place with scaling
w_orig = copy(w)
α = 2.0
β = 0.5
T_cached(w, v, u, p, t, α, β) # w = α*(T*v) + β*w_orig
```
"""

"""
$SIGNATURES

$TENSOR_PROD_DOC
"""
struct TensorProductOperator{T, O, C} <: AbstractSciMLOperator{T}
    ops::O
    cache::C

    function TensorProductOperator(
            ops::NTuple{
                2,
                Union{AbstractMatrix, AbstractSciMLOperator},
            },
            cache::Union{Tuple, Nothing}
        )
        T = reduce(_promote_operator_eltype, ops)

        return new{
            T,
            typeof(ops),
            typeof(cache),
        }(ops, cache)
    end
end

function TensorProductOperator(
        outer::Union{AbstractMatrix, AbstractSciMLOperator},
        inner::Union{AbstractMatrix, AbstractSciMLOperator};
        cache = nothing
    )
    outer = outer isa AbstractMatrix ? MatrixOperator(outer) : outer
    inner = inner isa AbstractMatrix ? MatrixOperator(inner) : inner

    return TensorProductOperator((outer, inner), cache)
end

# constructors
TensorProductOperator(ops...) = foldr(TensorProductOperator, ops)
TensorProductOperator(op::AbstractSciMLOperator) = op
TensorProductOperator(op::AbstractMatrix) = MatrixOperator(op)
function TensorProductOperator(ii1::IdentityOperator, ii2::IdentityOperator)
    return IdentityOperator(ii1.len * ii2.len)
end
function TensorProductOperator(ii::IdentityOperator, op::TensorProductOperator)
    left = TensorProductOperator(ii, op.ops[1])
    if op.ops[2] isa IdentityOperator
        # We call the main method to avoid recursion with the method below
        return TensorProductOperator((left, op.ops[2]), nothing)
    end
    return TensorProductOperator(left, op.ops[2])
end
function TensorProductOperator(op::TensorProductOperator, ii::IdentityOperator)
    right = TensorProductOperator(op.ops[2], ii)
    if op.ops[1] isa IdentityOperator
        # We call the main method to avoid recursion with the method above
        return TensorProductOperator((op.ops[1], right), nothing)
    end
    return TensorProductOperator(op.ops[1], right)
end

"""
$SIGNATURES

$TENSOR_PROD_DOC
"""
⊗(ops::Union{AbstractMatrix, AbstractSciMLOperator}...) = TensorProductOperator(ops...)

"""
$SIGNATURES

Construct a lazy representation of the Kronecker product `A ⊗ B`. One of the
two factors can be an `AbstractMatrix`, which is then promoted to a
`MatrixOperator` automatically. To avoid fallback to the generic
[`Base.kron`](@ref), at least one of `A` and `B` must be an
`AbstractSciMLOperator`.
"""
Base.kron(A::AbstractSciMLOperator, B::AbstractSciMLOperator) = TensorProductOperator(A, B)
Base.kron(A::AbstractMatrix, B::AbstractSciMLOperator) = TensorProductOperator(A, B)
Base.kron(A::AbstractSciMLOperator, B::AbstractMatrix) = TensorProductOperator(A, B)

Base.kron(ops::AbstractSciMLOperator...) = TensorProductOperator(ops...)

function Base.convert(::Type{AbstractMatrix}, L::TensorProductOperator)
    return kron(map(op -> convert(AbstractMatrix, op), L.ops)...)
end

#LinearAlgebra.opnorm(L::TensorProductOperator) = prod(opnorm, L.ops)

function Base.show(io::IO, L::TensorProductOperator)
    print(io, "(")
    show(io, L.ops[1])
    print(io, " ⊗ ")
    show(io, L.ops[2])
    return print(io, ")")
end
Base.size(L::TensorProductOperator) = mapreduce(size, .*, L.ops)

for op in (
        :adjoint,
        :transpose,
    )
    @eval function Base.$op(L::TensorProductOperator)
        return TensorProductOperator(
            map($op, L.ops)...;
            cache = issquare(L.ops[2]) ? L.cache : nothing
        )
    end
end
function Base.conj(L::TensorProductOperator)
    return TensorProductOperator(map(conj, L.ops)...; cache = L.cache)
end

function update_coefficients(L::TensorProductOperator, u, p, t; kwargs...)
    ops = ()
    for op in L.ops
        ops = (ops..., update_coefficients(op, u, p, t; kwargs...))
    end

    return @reset L.ops = ops
end

getops(L::TensorProductOperator) = L.ops
getcache(L::TensorProductOperator) = L.cache
adopt_cache(L::TensorProductOperator, cache, v) = cache_internals(update_cache(L, cache), v)

# Copy method to avoid aliasing
function Base.copy(L::TensorProductOperator)
    return TensorProductOperator(
        map(copy, L.ops),
        L.cache === nothing ? nothing : deepcopy(L.cache)
    )
end

islinear(L::TensorProductOperator) = mapreduce(islinear, &, L.ops)
isconvertible(::TensorProductOperator) = false
has_concretization(L::TensorProductOperator) = all(has_concretization, L.ops)
Base.iszero(L::TensorProductOperator) = mapreduce(iszero, |, L.ops)
has_adjoint(L::TensorProductOperator) = mapreduce(has_adjoint, &, L.ops)
has_mul(L::TensorProductOperator) = mapreduce(has_mul, &, L.ops)
has_mul!(L::TensorProductOperator) = mapreduce(has_mul!, &, L.ops)
has_ldiv(L::TensorProductOperator) = mapreduce(has_ldiv, &, L.ops)
has_ldiv!(L::TensorProductOperator) = mapreduce(has_ldiv!, &, L.ops)

factorize(L::TensorProductOperator) = TensorProductOperator(map(factorize, L.ops)...)

"""
$(TYPEDEF)

Lazy Kronecker sum operator.

# Arguments

  - `outer`: A square matrix or `AbstractSciMLOperator` representing the first
    term in `outer ⊗ I`.
  - `inner`: A square matrix or `AbstractSciMLOperator` representing the second
    term in `I ⊗ inner`.

# Fields

$(FIELDS)

# Interface Rules

`TensorSumOperator(outer, inner)` represents `outer ⊗ I + I ⊗ inner` without
eagerly forming the Kronecker products. Both input operators must be square.
The operator forwards state updates to `outer` and `inner`, and its cached
application stores the two tensor-product terms needed by `mul!`.

`isconvertible(::TensorSumOperator)` is `false` because eager fusion is not the
default algebra path, but `has_concretization(L)` is `true` when both operands
can be materialized.

# Examples

```julia
using LinearAlgebra, SciMLOperators

A = MatrixOperator([1.0 2.0; 3.0 4.0])
B = MatrixOperator(Diagonal([5.0, 6.0, 7.0]))
L = TensorSumOperator(A, B)

v = ones(6)
L * v == Matrix(L) * v
```
"""
struct TensorSumOperator{T, O, P} <: AbstractSciMLOperator{T}
    ops::O
    products::P

    function TensorSumOperator(
            ops::NTuple{2, Union{AbstractMatrix, AbstractSciMLOperator}},
            products::NTuple{2, AbstractSciMLOperator}
        )
        outer, inner = ops
        @assert issquare(outer)
        @assert issquare(inner)
        T = reduce(_promote_operator_eltype, ops)
        return new{T, typeof(ops), typeof(products)}(ops, products)
    end
end

function TensorSumOperator(
        outer::Union{AbstractMatrix, AbstractSciMLOperator},
        inner::Union{AbstractMatrix, AbstractSciMLOperator}
    )
    outer = outer isa AbstractMatrix ? MatrixOperator(outer) : outer
    inner = inner isa AbstractMatrix ? MatrixOperator(inner) : inner
    @assert issquare(outer)
    @assert issquare(inner)
    products = (
        TensorProductOperator(outer, IdentityOperator(size(inner, 1))),
        TensorProductOperator(IdentityOperator(size(outer, 1)), inner),
    )
    return TensorSumOperator((outer, inner), products)
end

"""
$SIGNATURES

Construct the lazy Kronecker sum `A ⊗ I + I ⊗ B`.

# Arguments

  - `A`: A square matrix or `AbstractSciMLOperator`.
  - `B`: A square matrix or `AbstractSciMLOperator`.

# Returns

A `TensorSumOperator` whose action is equivalent to
`kron(A, I(size(B, 1))) + kron(I(size(A, 1)), B)`.

# Interface Rules

Both inputs must be square. Matrix inputs are wrapped in `MatrixOperator` so
the returned object participates in the `AbstractSciMLOperator` update,
caching, multiplication, and trait interfaces.

# Examples

```julia
using LinearAlgebra, SciMLOperators

A = [1.0 2.0; 3.0 4.0]
B = Diagonal([5.0, 6.0, 7.0])
L = kronsum(A, B)

v = ones(6)
L * v == Matrix(L) * v
```
"""
kronsum(A::Union{AbstractMatrix, AbstractSciMLOperator}, B::Union{AbstractMatrix, AbstractSciMLOperator}) = TensorSumOperator(A, B)

Base.convert(::Type{AbstractMatrix}, L::TensorSumOperator) = sum(map(op -> convert(AbstractMatrix, op), L.products))

function Base.show(io::IO, L::TensorSumOperator)
    print(io, "(")
    show(io, L.ops[1])
    print(io, " ⊕ ")
    show(io, L.ops[2])
    return print(io, ")")
end

Base.size(L::TensorSumOperator) = size(first(L.products))

for op in (
        :adjoint,
        :transpose,
    )
    @eval Base.$op(L::TensorSumOperator) = TensorSumOperator(map($op, L.ops)...)
end
Base.conj(L::TensorSumOperator) = TensorSumOperator(map(conj, L.ops)...)

function update_coefficients(L::TensorSumOperator, u, p, t; kwargs...)
    ops = ()
    for op in L.ops
        ops = (ops..., update_coefficients(op, u, p, t; kwargs...))
    end
    return TensorSumOperator(ops...)
end

getops(L::TensorSumOperator) = L.products

function Base.copy(L::TensorSumOperator)
    return TensorSumOperator(map(copy, L.ops)...)
end

islinear(L::TensorSumOperator) = all(islinear, L.ops)
isconvertible(::TensorSumOperator) = false
has_concretization(L::TensorSumOperator) = all(has_concretization, L.ops)
Base.iszero(L::TensorSumOperator) = all(iszero, L.ops)
has_adjoint(L::TensorSumOperator) = all(has_adjoint, L.ops)
has_mul(L::TensorSumOperator) = all(has_mul, L.ops)
has_mul!(L::TensorSumOperator) = all(has_mul!, L.ops)

function cache_internals(L::TensorSumOperator, v::AbstractVecOrMat)
    products = map(op -> cache_operator(op, v), L.products)
    return TensorSumOperator(L.ops, products)
end

function Base.:*(L::TensorSumOperator, v::AbstractVecOrMat)
    return sum(op -> op * v, L.products)
end

function LinearAlgebra.mul!(w::AbstractVecOrMat, L::TensorSumOperator, v::AbstractVecOrMat)
    mul!(w, L.products[1], v)
    mul!(w, L.products[2], v, true, true)
    return w
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::TensorSumOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    mul!(w, L.products[1], v, α, β)
    mul!(w, L.products[2], v, α, true)
    return w
end

function (L::TensorSumOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    return L * v
end

function (L::TensorSumOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    L = update_coefficients(L, u, p, t; kwargs...)
    L = cache_operator(L, v)
    return mul!(w, L, v)
end

function (L::TensorSumOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    L = update_coefficients(L, u, p, t; kwargs...)
    L = cache_operator(L, v)
    return mul!(w, L, v, α, β)
end

# operator application
function Base.:*(L::TensorProductOperator, v::AbstractVecOrMat)
    outer, inner = L.ops

    _, ni = size(inner)
    _, no = size(outer)
    m, n = size(L)
    k = size(v, 2)

    U = reshape(v, (ni, no * k))
    C = stack([inner * _v for _v in eachcol(U)])

    V = outer_mul(L, v, C)

    return v isa AbstractMatrix ? reshape(V, (m, k)) : reshape(V, (m,))
end

function Base.:\(L::TensorProductOperator, v::AbstractVecOrMat)
    outer, inner = L.ops

    mi, _ = size(inner)
    mo, _ = size(outer)
    m, n = size(L)
    k = size(v, 2)

    U = reshape(v, (mi, mo * k))
    C = inner \ U

    V = outer_div(L, v, C)

    return v isa AbstractMatrix ? reshape(V, (n, k)) : reshape(V, (n,))
end

# `c1` (3 and 5 arg `mul!`) and `c5` (3 arg `ldiv!`) are read for every input shape.
function _cache_self_c1_c5(L::TensorProductOperator, v::AbstractVecOrMat)
    outer, inner = L.ops

    mi, ni = size(inner)
    mo, no = size(outer)
    k = size(v, 2)

    c1 = outer isa IdentityOperator ? nothing : lmul!(false, similar(v, (mi, no * k))) # c1 = inner * v

    if mapreduce(issquare, &, L.ops)
        c5 = c1
    else
        c5 = lmul!(false, similar(v, (ni, mo * k))) # c5 = inner \ v
    end

    return c1, c5
end

# Cache slots 2, 3, 4, 6 and 7 are read only by the `k > 1` branches of `outer_mul!`
# and `outer_div!` — every path that reaches them returns early when the input has a
# single column. A vector input therefore only ever touches `c1` and `c5`, so the rest
# are left unallocated: 4 buffers down to 1 for square factors, 7 down to 2 otherwise.
function cache_self(L::TensorProductOperator, v::AbstractVector)
    c1, c5 = _cache_self_c1_c5(L, v)

    @reset L.cache = (c1, nothing, nothing, nothing, c5, nothing, nothing)
    return L
end

function cache_self(L::TensorProductOperator, v::AbstractMatrix)
    outer, inner = L.ops

    mi, ni = size(inner)
    mo, no = size(outer)
    k = size(v, 2)

    is_outer_identity = outer isa IdentityOperator

    # 3 and 5 arg mul!, 3 arg ldiv!
    c1, c5 = _cache_self_c1_c5(L, v)

    # 3 arg mul!
    c2 = is_outer_identity ? nothing : lmul!(false, similar(v, (no, mi, k))) # permute (2, 1, 3)
    c3 = is_outer_identity ? nothing : lmul!(false, similar(v, (mo, mi * k))) # c3 = outer * c2

    # 5 arg mul!
    c4 = is_outer_identity ? nothing : lmul!(false, similar(v, (mo * mi, k))) # cache v in 5 arg mul!

    # 3 arg ldiv!
    if mapreduce(issquare, &, L.ops)
        c6, c7 = c2, c3
    else
        c6 = lmul!(false, similar(v, (mo, ni, k))) # permute (2, 1, 3)
        c7 = lmul!(false, similar(v, (no, ni * k))) # c7 = outer \ c6
    end

    @reset L.cache = (c1, c2, c3, c4, c5, c6, c7)
    return L
end

function cache_internals(L::TensorProductOperator, v::AbstractVecOrMat)
    # Only this operator's own buffers are in question here — `iscached` is recursive, so
    # testing it would re-run `cache_self` and throw away a perfectly good cache whenever a
    # factor happens to be uncached, which is exactly the state `cache_operator` calls this
    # in. `ComposedOperator` guards the same way.
    if isnothing(L.cache)
        L = cache_self(L, v)
    end

    outer, inner = L.ops

    mi, ni = size(inner)
    _, no = size(outer)
    k = size(v, 2)

    vinner = reshape(v, (ni, no * k))
    vouter = reshape(@view(v[1:(no * mi * k)]), (no, mi * k))

    @reset L.ops[2] = cache_operator(inner, vinner)
    @reset L.ops[1] = cache_operator(outer, vouter)
    return L
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::TensorProductOperator,
        v::AbstractVecOrMat
    )
    @assert iscached(L) """cache needs to be set up for operator of type
    $L. Set up cache by calling `cache_operator(L, u)`"""

    outer, inner = L.ops

    mi, ni = size(inner)
    mo, no = size(outer)
    k = size(v, 2)

    C1 = first(L.cache)
    U = reshape(v, (ni, no * k))

    #=
        v .= kron(B, A) * v
        V .= A * U * B'
    =#

    outer isa IdentityOperator && return mul!(reshape(w, (mi, no * k)), inner, U)

    # C .= A * U
    mul!(C1, inner, U)

    # V .= U * B' <===> V' .= B * C'
    outer_mul!(w, L, v)

    return w
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::TensorProductOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    @assert iscached(L) """cache needs to be set up for operator of type
    $L. Set up cache by calling `cache_operator(L, u)`"""

    outer, inner = L.ops

    mi, ni = size(inner)
    mo, no = size(outer)
    k = size(v, 2)

    C1 = first(L.cache)
    U = reshape(v, (ni, no * k))

    """
        v .= α * kron(B, A) * u + β * v
        V .= α * (A * U * B') + β * v
    """

    outer isa IdentityOperator && return mul!(reshape(w, (mi, no * k)), inner, U, α, β)

    # C .= A * U
    mul!(C1, inner, U)

    # V = α(C * B') + β(V)
    c = reshape(C1, (mi * no, k))
    outer_mul!(w, L, c, α, β)

    return w
end

function LinearAlgebra.ldiv!(
        w::AbstractVecOrMat,
        L::TensorProductOperator,
        v::AbstractVecOrMat
    )
    @assert iscached(L) """cache needs to be set up for operator of type
    $L. Set up cache by calling `cache_operator(L, u)`"""

    outer, inner = L.ops

    mi, ni = size(inner)
    mo, no = size(outer)
    k = size(v, 2)

    C5 = L.cache[5]
    U = reshape(v, (mi, mo * k))

    """
        v .= kron(B, A) ldiv v
        V .= (A ldiv U) / B'
    """

    # C .= A \ U
    ldiv!(C5, inner, U)

    # V .= C / B' <==> V' .= B \ C'
    c = reshape(C5, (ni * mo, k))
    outer_div!(w, L, c)

    return w
end

function LinearAlgebra.ldiv!(L::TensorProductOperator, v::AbstractVecOrMat)
    outer, inner = L.ops

    msg = "Two-argument ldiv! is only available for square operators"
    @assert issquare(L) msg
    @assert issquare(inner) msg
    @assert issquare(outer) msg

    @assert iscached(L) """cache needs to be set up for operator of type
    $L. Set up cache by calling `cache_operator(L, v)`"""

    mi = size(inner, 1)
    mo = size(outer, 1)
    k = size(v, 2)

    U = reshape(v, (mi, mo * k))

    """
        u .= kron(B, A) ldiv u
        U .= (A ldiv U) / B'
    """

    # U .= A \ U
    ldiv!(inner, U)

    # U .= U / B' <==> U' .= B \ U'
    outer_div!(L, v)

    return v
end

# helper functions
const PERM = (2, 1, 3)

"""
    has_tensor_outer_mul_fast(outer) -> Bool

Return whether `outer` provides the specialized
[`tensor_outer_mul_fast!`](@ref) contract used by batched
`TensorProductOperator` multiplication.

# Developer API

This hook is for extension authors implementing an allocation-free fast path
for an `outer` operator type. Return `true` only when the corresponding
`tensor_outer_mul_fast!` methods are defined for both the unscaled and scaled
call signatures. End users should rely on `mul!` or `TensorProductOperator`
instead of calling or extending this hook directly.
"""
has_tensor_outer_mul_fast(outer) = false

"""
    tensor_outer_mul_fast!(w, outer, C, mi, mo, no, k[, α, β]) -> w

Write the batched outer multiplication used by `TensorProductOperator` into
`w` without allocating intermediate arrays.

# Arguments

  - `w`: destination with `mi * mo` rows and `k` columns.
  - `outer`: operator of size `(mo, no)`.
  - `C`: cached intermediate data with `mi * no` rows and `k` columns.
  - `mi`, `mo`, `no`, `k`: dimensions derived from the tensor-product factors
    and the batch size.
  - `α`, `β`: optional scaling coefficients; the scaled method must compute
    `w = α * outer_product + β * w`.

# Developer API

Only implement this hook together with
[`has_tensor_outer_mul_fast`](@ref) returning `true` for the same `outer`
type. Implement both call signatures, preserve the stated destination shape,
and return `w`. This contract exists for package extensions; ordinary callers
should use `mul!` on the enclosing `TensorProductOperator`.
"""
function tensor_outer_mul_fast! end

function outer_mul(L::TensorProductOperator, v::AbstractVecOrMat, C::AbstractVecOrMat)
    outer, inner = L.ops

    if outer isa IdentityOperator
        return C
    elseif outer isa ScaledOperator
        return outer.λ * outer_mul(outer.L, v, C)
    end

    k = size(v, 2)
    if k == 1
        return transpose(outer * transpose(C))
    end

    mi, _ = size(inner)
    mo, no = size(outer)
    #   m , n  = size(L)

    C = reshape(C, (mi, no, k))
    C = permutedims(C, PERM)
    C = reshape(C, (no, mi * k))

    V = outer * C
    V = reshape(V, (mo, mi, k))
    V = permutedims(V, PERM)

    return V
end

function outer_mul!(w::AbstractVecOrMat, L::TensorProductOperator, v::AbstractVecOrMat)
    outer, inner = L.ops

    C1 = first(L.cache)

    if outer isa ScaledOperator
        outer_mul!(w, outer.L, v)
        lmul!(outer.λ, w)
        return w
    end

    mi, _ = size(inner)
    mo, no = size(outer)
    #   m , n  = size(L)
    k = size(v, 2)

    if k == 1
        W = reshape(w, (mi, mo))
        C1 = reshape(C1, (mi, no))
        mul!(transpose(W), outer, transpose(C1))
        return w
    end

    if has_tensor_outer_mul_fast(outer)
        tensor_outer_mul_fast!(w, outer, C1, mi, mo, no, k)
        return w
    end

    C2, C3 = L.cache[2:3]

    C1 = reshape(C1, (mi, no, k))
    permutedims!(C2, C1, PERM)
    C2 = reshape(C2, (no, mi * k))
    mul!(C3, outer, C2)
    C3 = reshape(C3, (mo, mi, k))
    W = reshape(w, (mi, mo, k))
    permutedims!(W, C3, PERM)

    return w
end

function outer_mul!(
        w::AbstractVecOrMat, L::TensorProductOperator,
        v::AbstractVecOrMat, α, β
    )
    outer, inner = L.ops

    m, _ = size(L)
    k = size(v, 2)

    if outer isa ScaledOperator
        a = convert(Number, α * outer.λ)
        outer_mul!(w, outer.L, v, a, β)
        return w
    end

    mi, _ = size(inner)
    mo, no = size(outer)

    if k == 1
        W = reshape(w, (mi, mo))
        C = reshape(v, (mi, no))
        mul!(transpose(W), outer, transpose(C), α, β)
        return w
    end

    if has_tensor_outer_mul_fast(outer)
        tensor_outer_mul_fast!(w, outer, v, mi, mo, no, k, α, β)
        return w
    end

    C2, C3, c4 = L.cache[2:4]

    C = reshape(v, (mi, no, k))
    permutedims!(C2, C, PERM)
    C2 = reshape(C2, (no, mi * k))
    mul!(C3, outer, C2)
    C3 = reshape(C3, (mo, mi, k))
    W = reshape(w, (mi, mo, k))
    copy!(c4, w)
    permutedims!(W, C3, PERM)
    axpby!(β, c4, α, w)

    return w
end

function outer_div(L::TensorProductOperator, v::AbstractVecOrMat, C::AbstractVecOrMat)
    outer, inner = L.ops

    if outer isa IdentityOperator
        return C
    elseif outer isa ScaledOperator
        return outer.λ \ outer_div(outer.L, v, C)
    end

    k = size(v, 2)
    if k == 1
        return transpose(outer \ transpose(C))
    end

    _, ni = size(inner)
    mo, no = size(outer)

    C = reshape(C, (ni, mo, k))
    C = permutedims(C, PERM)
    C = reshape(C, (mo, ni * k))

    V = outer \ C
    V = reshape(V, (no, ni, k))
    V = permutedims(V, PERM)

    return V
end

function outer_div!(v::AbstractVecOrMat, L::TensorProductOperator, c::AbstractVecOrMat)
    outer, inner = L.ops

    if outer isa IdentityOperator
        copyto!(v, c)
        return v
    elseif outer isa ScaledOperator
        outer_div!(v, outer.L, c)
        ldiv!(outer.λ, v)
        return v
    end

    mi, ni = size(inner)
    mo, no = size(outer)
    k = size(c, 2)

    if k == 1
        V = reshape(v, (ni, no))
        C = reshape(c, (ni, mo))
        ldiv!(transpose(V), outer, transpose(C))
        return v
    end

    C6, C7 = L.cache[6:7]

    C = reshape(c, (ni, mo, k))
    permutedims!(C6, C, PERM)
    C6 = reshape(C6, (mo, ni * k))
    ldiv!(C7, outer, C6)
    C7 = reshape(C7, (no, ni, k))
    V = reshape(v, (ni, no, k))
    permutedims!(V, C7, PERM)

    return v
end

function outer_div!(L::TensorProductOperator, v::AbstractVecOrMat)
    outer, inner = L.ops

    if outer isa IdentityOperator
        return v
    elseif outer isa ScaledOperator
        outer_div!(outer.L, v)
        ldiv!(outer.λ, v)
        return u
    end

    _, ni = size(inner)
    _, no = size(outer)
    k = size(v, 2)

    U = reshape(v, (ni, no * k))

    if k == 1
        ldiv!(outer, transpose(U))
        return v
    end

    C = first(L.cache)

    U = reshape(U, (ni, no, k))
    C = reshape(C, (no, ni, k))
    permutedims!(C, U, PERM)
    C = reshape(C, (no, ni * k))
    ldiv!(outer, C)
    C = reshape(C, (no, ni, k))
    permutedims!(U, C, PERM)

    return v
end

# Out-of-place: v is action vector, u is update vector
function (L::TensorProductOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    return L * v
end

# In-place: w is destination, v is action vector, u is update vector
function (L::TensorProductOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    mul!(w, L, v)
    return w
end

# In-place with scaling: w = α*(L*v) + β*w
function (L::TensorProductOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    mul!(w, L, v, α, β)
    return w
end
#

using SciMLOperators, LinearAlgebra, BenchmarkTools
using SciMLOperators: IdentityOperator, ⊗

N = 12
K = 100
Id = IdentityOperator(N)
A = rand(N, N)
B = rand(N, N)
C = rand(N, N)

println("#===============================#")
println("2D Tensor Products")
println("#===============================#")

println("⊗(A, B)")

u = rand(N^2, K)
v = rand(N^2, K)

T = ⊗(A, B)
T = cache_operator(T, u)

@btime *($T, $u)
@btime mul!($v, $T, $u)

println("⊗(I, B)")

u = rand(N^2, K)
v = rand(N^2, K)

T = ⊗(Id, B)
T = cache_operator(T, u)

@btime *($T, $u)
@btime mul!($v, $T, $u)

println("⊗(A, I)")

u = rand(N^2, K)
v = rand(N^2, K)

T = ⊗(A, Id)
T = cache_operator(T, u)

@btime *($T, $u)
@btime mul!($v, $T, $u)

println("#===============================#")
println("3D Tensor Products")
println("#===============================#")

println("⊗(⊗(A, B), C)")

u = rand(N^3, K)
v = rand(N^3, K)

T = ⊗(⊗(A, B), C)
T = cache_operator(T, u)

@btime *($T, $u)
@btime mul!($v, $T, $u); #

println("⊗(A, ⊗(B, C))")

u = rand(N^3, K)
v = rand(N^3, K)

T = ⊗(A, ⊗(B, C))
T = cache_operator(T, u)

@btime *($T, $u)
@btime mul!($v, $T, $u); #

println("#===============================#")
#

using SciMLOperators, LinearAlgebra, SparseArrays
using ArrayInterface
using Random

using SciMLOperators: IdentityOperator,
    NullOperator,
    ScaledOperator,
    AddedOperator,
    ComposedOperator,
    AdjointOperator,
    TransposedOperator,
    InvertedOperator, AbstractAdjointVecOrMat,
    AbstractTransposedVecOrMat, getops,
    cache_operator

Random.seed!(0)
N = 8
K = 12

@testset "eltype on operator types" begin
    # `eltype` must work on the type, not just on an instance: the previous
    # `::Type{AbstractSciMLOperator{T}}` signature matched only the abstract type
    # itself, so concrete operator types fell through to `Base.eltype(::Type) = Any`.
    Ar = MatrixOperator(rand(N, N))
    Ac = MatrixOperator(rand(ComplexF64, N, N))

    for op in (Ar, Ac, ScalarOperator(rand()), IdentityOperator(N), Ar + Ac, Ar * Ar)
        @test eltype(typeof(op)) === eltype(op)
        @test eltype(typeof(op)) !== Any
    end

    @test eltype(typeof(Ar)) === Float64
    @test eltype(typeof(Ar + Ac)) === ComplexF64
end

@testset "IdentityOperator" begin
    A = rand(N, N) |> MatrixOperator
    u = rand(N, K)
    v = rand(N, K)
    w = zeros(N, K)
    p = nothing
    t = 0
    α = rand()
    β = rand()
    Id = IdentityOperator(N)

    @test issquare(Id)
    @test islinear(Id)
    @test convert(AbstractMatrix, Id) == Matrix(I, N, N)

    _Id = one(A)
    @test _Id isa IdentityOperator
    @test size(_Id) == (N, N)

    @test iscached(Id)
    @test size(Id) == (N, N)
    @test Id' isa IdentityOperator
    @test isconstant(Id)
    @test !ArrayInterface.issingular(Id)
    @test_throws MethodError resize!(Id, N)

    for op in (*, \)
        @test op(Id, u) ≈ u
    end

    # Test with new interface - same update and action vector
    @test Id(u, u, p, t) ≈ u

    # Test with different vectors for update and action
    @test Id(v, u, p, t) ≈ v

    # Test in-place operation
    copy!(w, zeros(N, K))
    Id(w, v, u, p, t)
    @test w ≈ v

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    Id(w, v, u, p, t, α, β)
    @test w ≈ α * v + β * orig_w

    # Original tests
    v = rand(N, K)
    @test mul!(v, Id, u) ≈ u
    v = rand(N, K)
    w_orig = copy(v)
    @test mul!(v, Id, u, α, β) ≈ α * (I * u) + β * w_orig

    v = rand(N, K)
    @test ldiv!(v, Id, u) ≈ u
    v = copy(u)
    @test ldiv!(Id, u) ≈ v

    for op in (*, ∘)
        @test op(Id, A) isa MatrixOperator
        @test op(A, Id) isa MatrixOperator
    end
end

@testset "NullOperator" begin
    A = rand(N, N) |> MatrixOperator
    B = rand(N + 3, N + 2) |> MatrixOperator
    C = rand(N, N + 3) |> MatrixOperator
    u = rand(N, K)
    v = rand(N, K)
    w = zeros(N, K)
    p = nothing
    t = 0
    α = rand()
    β = rand()
    Z = NullOperator(N)

    @test issquare(Z)
    @test islinear(Z)
    @test isconstant(Z)
    @test_throws MethodError resize!(Z, N)
    @test convert(AbstractMatrix, Z) == zeros(size(Z))

    _Z = zero(A)
    @test _Z isa NullOperator
    @test size(_Z) == (N, N)

    @test iscached(Z)
    @test size(Z) == (N, N)
    @test Z' isa NullOperator
    @test size(Z') == (N, N)

    @test Z * u ≈ zero(u)

    # Test with new interface - same update and action vector
    @test Z(u, u, p, t) ≈ zero(u)

    # Test with different vectors for update and action
    @test Z(v, u, p, t) ≈ zero(v)

    # Test in-place operation
    copy!(w, ones(N, K))
    Z(w, v, u, p, t)
    @test w ≈ zero(v)

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    Z(w, v, u, p, t, α, β)
    @test w ≈ β * orig_w

    # Original tests
    v = rand(N, K)
    @test mul!(v, Z, u) ≈ zero(u)
    v = rand(N, K)
    w_orig = copy(v)
    @test mul!(v, Z, u, α, β) ≈ α * (0 * u) + β * w_orig

    for op in (*, ∘)
        @test op(Z, A) isa NullOperator
        @test op(A, Z) isa NullOperator
    end
    for op in (+, -)
        @test op(Z, A) isa MatrixOperator
        @test op(A, Z) isa MatrixOperator
    end

    Zrect = NullOperator(N + 2, N)
    urect = rand(N, K)
    wrect = zeros(N + 2, K)

    @test !issquare(Zrect)
    @test !issymmetric(Zrect)
    @test !ishermitian(Zrect)
    @test size(Zrect) == (N + 2, N)
    @test convert(AbstractMatrix, Zrect) == zeros(Bool, size(Zrect))
    @test size(Zrect') == (N, N + 2)
    @test size(transpose(Zrect)) == (N, N + 2)

    @test Zrect * urect ≈ zero(wrect)
    @test Zrect(urect, urect, p, t) ≈ zero(wrect)

    copy!(wrect, ones(N + 2, K))
    Zrect(wrect, urect, urect, p, t)
    @test wrect ≈ zero(wrect)

    copy!(wrect, rand(N + 2, K))
    orig_wrect = copy(wrect)
    Zrect(wrect, urect, urect, p, t, α, β)
    @test wrect ≈ β * orig_wrect

    @test mul!(wrect, Zrect, urect) ≈ zero(wrect)
    copy!(wrect, rand(N + 2, K))
    orig_wrect = copy(wrect)
    @test mul!(wrect, Zrect, urect, α, β) ≈ β * orig_wrect

    @test size(Zrect * C) == (N + 2, N + 3)
    @test size(B * Zrect) == (N + 3, N)
    @test size(Zrect ∘ C) == (N + 2, N + 3)
    @test size(B ∘ Zrect) == (N + 3, N)
end

@testset "BlockDiagonalOperator" begin
    A = rand(3, 2)
    B = rand(4, 5)
    L = BlockDiagonalOperator(MatrixOperator(A), MatrixOperator(B))
    Lmat = [A zeros(3, 5); zeros(4, 2) B]
    v = rand(7, K)
    u = rand(7, K)
    w = zeros(7, K)
    p = nothing
    t = 0
    α = rand()
    β = rand()

    @test size(L) == (7, 7)
    @test islinear(L)
    @test isconstant(L)
    @test convert(AbstractMatrix, L) ≈ Lmat
    @test BlockDiagonalOperator(A, B) isa BlockDiagonalOperator

    @test L * v ≈ Lmat * v
    @test L(v, u, p, t) ≈ Lmat * v

    mul!(w, L, v)
    @test w ≈ Lmat * v

    copy!(w, rand(7, K))
    orig_w = copy(w)
    mul!(w, L, v, α, β)
    @test w ≈ α * Lmat * v + β * orig_w

    copy!(w, zeros(7, K))
    L(w, v, u, p, t)
    @test w ≈ Lmat * v

    copy!(w, rand(7, K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * Lmat * v + β * orig_w

    x = rand(7)
    @test L * x ≈ Lmat * x
    @test convert(AbstractMatrix, L') ≈ Lmat'
    @test convert(AbstractMatrix, transpose(L)) ≈ transpose(Lmat)
end

@testset "Unary +/-" begin
    A = MatrixOperator(rand(N, N))
    v = rand(N, K)

    # Test unary +
    @test +A === A

    # Test unary - on constant MatrixOperator (simplified to MatrixOperator)
    minusA = -A
    @test minusA isa ScaledOperator
    @test minusA * v ≈ -A.A * v
    @test eltype(minusA.λ) == eltype(A.A)
end

@testset "ScaledOperator" begin
    A = rand(N, N)
    D = Diagonal(rand(N))
    u = rand(N, K)       # Update vector
    v = rand(N, K)       # Action vector
    w = zeros(N, K)      # Output vector
    p = nothing
    t = 0
    α = rand()
    β = rand()
    a = rand()
    b = rand()

    op = ScaledOperator(α, MatrixOperator(A))

    @test op isa ScaledOperator
    @test isconstant(op)
    @test iscached(op)
    @test issquare(op)
    @test islinear(op)

    @test α * A * v ≈ op * v
    @test (β * op) * v ≈ β * α * A * v

    # Test with new interface - same vector for update and action
    @test op(u, u, p, t) ≈ α * A * u

    # Test with different vectors for update and action
    @test op(v, u, p, t) ≈ α * A * v

    # Test in-place operation
    copy!(w, zeros(N, K))
    op(w, v, u, p, t)
    @test w ≈ α * A * v

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    op(w, v, u, p, t, a, b)
    @test w ≈ a * (α * A * v) + b * orig_w

    opF = factorize(op)

    @test opF isa ScaledOperator
    @test isconstant(opF)
    @test iscached(opF)

    @test α * A ≈ convert(AbstractMatrix, op) ≈ convert(AbstractMatrix, opF)

    w = rand(N, K)
    @test mul!(w, op, v) ≈ α * A * v
    w = rand(N, K)
    w_orig = copy(w)
    @test mul!(w, op, v, a, b) ≈ a * (α * A * v) + b * w_orig

    op = ScaledOperator(α, MatrixOperator(D))
    w = rand(N, K)
    @test ldiv!(v, op, w) ≈ (α * D) \ w
    w = copy(v)
    @test ldiv!(op, w) ≈ (α * D) \ v
end

@testset "AddedOperator" begin
    A = rand(N, N) |> MatrixOperator
    B = rand(N, N) |> MatrixOperator
    C = rand(N, N) |> MatrixOperator
    α = rand()
    β = rand()
    u = rand(N, K)       # Update vector
    v = rand(N, K)       # Action vector
    w = zeros(N, K)      # Output vector
    p = nothing
    t = 0

    for op in (+, -)
        op1 = op(A, B)
        op2 = op(α * A, B)
        op3 = op(A, β * B)
        op4 = op(α * A, β * B)

        @test op1 isa AddedOperator
        @test op2 isa AddedOperator
        @test op3 isa AddedOperator
        @test op4 isa AddedOperator

        @test isconstant(op1)
        @test isconstant(op2)
        @test isconstant(op3)
        @test isconstant(op4)

        @test op1 * u ≈ op(A * u, B * u)
        @test op2 * u ≈ op(α * A * u, B * u)
        @test op3 * u ≈ op(A * u, β * B * u)
        @test op4 * u ≈ op(α * A * u, β * B * u)

        # Test new interface - combined case
        @test op1(u, u, p, t) ≈ op(A * u, B * u)
        @test op2(u, u, p, t) ≈ op(α * A * u, B * u)
        @test op3(u, u, p, t) ≈ op(A * u, β * B * u)
        @test op4(u, u, p, t) ≈ op(α * A * u, β * B * u)

        # Test new interface - separate vectors
        @test op1(v, u, p, t) ≈ op(A * v, B * v)
        @test op2(v, u, p, t) ≈ op(α * A * v, B * v)
        @test op3(v, u, p, t) ≈ op(A * v, β * B * v)
        @test op4(v, u, p, t) ≈ op(α * A * v, β * B * v)

        # Test in-place operation
        copy!(w, zeros(N, K))
        op1(w, v, u, p, t)
        @test w ≈ op(A * v, B * v)

        # Test in-place with scaling
        copy!(w, rand(N, K))
        orig_w = copy(w)
        op1(w, v, u, p, t, α, β)
        @test w ≈ α * op(A * v, B * v) + β * orig_w
    end

    op = AddedOperator(A, B)
    @test iscached(op)

    v = rand(N, K)
    @test mul!(v, op, u) ≈ (A + B) * u
    v = rand(N, K)
    w_orig = copy(v)
    @test mul!(v, op, u, α, β) ≈ α * (A + B) * u + β * w_orig

    # Test flattening of nested AddedOperators via direct constructor
    A = MatrixOperator(rand(N, N))
    B = MatrixOperator(rand(N, N))
    C = MatrixOperator(rand(N, N))

    # Create nested structure: (A + B) is an AddedOperator
    AB = A + B
    @test AB isa AddedOperator

    # When we create AddedOperator((AB, C)), it should flatten
    L = AddedOperator((AB, C))
    @test L isa AddedOperator
    @test length(L.ops) == 3  # Should have A, B, C (not AB and C)
    @test all(op -> !isa(op, AddedOperator), L.ops)

    # Verify correctness
    test_vec = rand(N, K)
    @test L * test_vec ≈ (A + B + C) * test_vec

    ## Time-Dependent Coefficients
    for T in (Float32, Float64, ComplexF32, ComplexF64)
        N = 100
        A = sprand(T, N, N, 2 / N)

        func1(a, u, p, t) = t
        func2(a, u, p, t) = t^2
        func3(a, u, p, t) = t^3
        func4(a, u, p, t) = t^4
        func5(a, u, p, t) = t^5

        O1 = MatrixOperator(A) + ScalarOperator(0.0, func1) * MatrixOperator(A) + ScalarOperator(0.0, func2) * MatrixOperator(A)

        O2 = MatrixOperator(A) + ScalarOperator(0.0, func3) * MatrixOperator(A) + ScalarOperator(0.0, func4) * MatrixOperator(A)

        O3 = MatrixOperator(A) + ScalarOperator(0.0, func5) * MatrixOperator(A)

        Op = -1im * (O1 - O2)

        @test length(Op.ops) == length(O1.ops) + length(O2.ops)
        @inferred Op + O3
    end
end

@testset "AddedOperator cache sharing" begin
    v = rand(N)
    nbuf(cache) = length(unique(objectid, [b for b in cache if b !== nothing]))
    # `getcache`, not `op.cache`: a wrapper such as `ScaledOperator` has no cache field and
    # reports the one belonging to the operator it wraps.
    nbuffers(L) = nbuf([b for op in L.ops for b in SciMLOperators.getcache(op)])

    # Summands with interchangeable caches reuse one set of buffers.
    C1 = MatrixOperator(rand(N, N)) * MatrixOperator(rand(N, N))
    C2 = MatrixOperator(rand(N, N)) * MatrixOperator(rand(N, N))
    L = cache_operator(C1 + C2, v)

    @test nbuffers(L) == 2                          # 4 without sharing
    @test L.ops[1].cache[1] !== L.ops[1].cache[2]   # slots live at once stay distinct
    @test L * v ≈ C1 * v + C2 * v
    @test mul!(zeros(N), L, v) ≈ C1 * v + C2 * v
    @test (@inferred cache_operator(C1 + C2, v)) isa AddedOperator

    # Setup allocates one cache, not one per summand: a summand takes an earlier one's
    # buffers outright rather than allocating its own and discarding them. Without that,
    # this grows by a full cache for every extra summand.
    let n = 4096, vn = rand(n)
        mk(M) = sum(
            ntuple(
                _ -> MatrixOperator(sprand(n, n, 1 / n)) * MatrixOperator(sprand(n, n, 1 / n)),
                M
            )
        )
        setup(M) = (Lm = mk(M); cache_operator(Lm, vn); @allocated cache_operator(Lm, vn))
        @test setup(8) < 2 * setup(2)
    end

    # Caches whose slots differ in eltype are never interchanged, even though both
    # summands are `ComposedOperator{ComplexF64}` of the same shape — `cache_self` takes
    # each slot's eltype from the inner factor, not from the composite.
    Ar = MatrixOperator(rand(N, N)) * MatrixOperator(rand(ComplexF64, N, N))
    Ac = MatrixOperator(rand(ComplexF64, N, N)) * MatrixOperator(rand(N, N))
    Lm = cache_operator(Ar + Ac, v)

    @test eltype(Ar) === eltype(Ac) === ComplexF64
    @test eltype(Lm.ops[1].cache[1]) === ComplexF64
    @test eltype(Lm.ops[2].cache[1]) === Float64

    # A square TensorProductOperator aliases cache slot 5 onto slot 1; sharing keeps it.
    T = TensorProductOperator(MatrixOperator(rand(2, 2)), MatrixOperator(rand(4, 4)))
    vt = rand(8)
    Lt = cache_operator(T + T, vt)

    @test Lt.ops[2].cache[1] === Lt.ops[1].cache[1]
    @test Lt.ops[2].cache[1] === Lt.ops[2].cache[5]
    @test nbuffers(Lt) == nbuf(cache_operator(T, vt).cache)   # two summands, one set
    @test mul!(zeros(8), Lt, vt) ≈ 2 * (T * vt)

    # A wrapper holding no scratch of its own reports and replaces the cache of the operator
    # it wraps. `A - B` lowers to `AddedOperator(A, -B)` with `-B` a `ScaledOperator`, so
    # without this the commonest sum of all would share nothing.
    @test nbuffers(cache_operator(2.0 * C1 + 3.0 * C2, v)) == 2   # 4 without forwarding
    @test nbuffers(cache_operator(C1 - C2, v)) == 2               # 4 without forwarding
    @test mul!(zeros(N), cache_operator(C1 - C2, v), v) ≈ C1 * v - C2 * v

    let C = cache_operator(C1, v)
        @test SciMLOperators.getcache(AdjointOperator(C)) === SciMLOperators.getcache(C)
    end

    # A tensor product whose factors are themselves composite shares as one with plain
    # factors does. Its `cache_internals` used to re-run `cache_self` whenever any factor
    # was uncached — the state `cache_operator` calls it in — discarding a donated cache.
    Tc() = TensorProductOperator(
        MatrixOperator(rand(2, 2)) * MatrixOperator(rand(2, 2)),
        MatrixOperator(rand(4, 4)) * MatrixOperator(rand(4, 4))
    )
    T1, T2 = Tc(), Tc()
    Lc = cache_operator(T1 + T2, vt)

    @test Lc.ops[1].cache[1] === Lc.ops[2].cache[1]
    @test mul!(zeros(8), Lc, vt) ≈ T1 * vt + T2 * vt

    # Which slots alias each other is part of the layout, so a cache that folds two slots
    # into one buffer is not interchangeable with one that keeps them apart, even when
    # every slot matches in type and size.
    let a = rand(4), b = rand(4)
        @test SciMLOperators._slots_match((a, a), (b, b))
        @test !SciMLOperators._slots_match((a, a), (rand(4), rand(4)))
        @test !SciMLOperators._slots_match((a, b), (b, b))
    end
end

@testset "ComposedOperator" begin
    A = rand(N, N)
    B = rand(N, N)
    C = rand(N, N)
    u = rand(N, K)       # Update vector
    v = rand(N, K)       # Action vector
    w = zeros(N, K)      # Output vector
    p = nothing
    t = 0
    α = rand()
    β = rand()

    ABCmulu = (A * B * C) * u
    ABCdivu = (A * B * C) \ u

    op = ∘(MatrixOperator.((A, B, C))...)

    @test op isa ComposedOperator
    @test isconstant(op)

    @test *(op.ops...) isa ComposedOperator
    @test issquare(op)
    @test islinear(op)

    opF = factorize(op)

    @test opF isa ComposedOperator
    @test isconstant(opF)
    @test issquare(opF)
    @test islinear(opF)

    @test ABCmulu ≈ op * u
    @test ABCdivu ≈ op \ u ≈ opF \ u

    # Test new interface - combined case
    @test op(u, u, p, t) ≈ ABCmulu

    # Test new interface - separate vectors
    @test op(v, u, p, t) ≈ (A * B * C) * v

    @test !iscached(op)
    op = cache_operator(op, u)
    @test iscached(op)

    # Test in-place operation with new interface
    copy!(w, zeros(N, K))
    op(w, v, u, p, t)
    @test w ≈ (A * B * C) * v

    # Test in-place with scaling with new interface
    copy!(w, rand(N, K))
    orig_w = copy(w)
    op(w, v, u, p, t, α, β)
    @test w ≈ α * ((A * B * C) * v) + β * orig_w

    # Original tests
    v = rand(N, K)
    @test mul!(v, op, u) ≈ ABCmulu
    v = rand(N, K)
    w_orig = copy(v)
    @test mul!(v, op, u, α, β) ≈ α * ABCmulu + β * w_orig

    A = rand(N) |> Diagonal
    B = rand(N) |> Diagonal
    C = rand(N) |> Diagonal

    op = ∘(MatrixOperator.((A, B, C))...)
    @test !iscached(op)
    op = cache_operator(op, u)
    @test iscached(op)
    v = rand(N, K)
    @test ldiv!(v, op, u) ≈ (A * B * C) \ u
    v = copy(u)
    @test ldiv!(op, u) ≈ (A * B * C) \ v

    # ensure composedoperators doesn't nest
    A = MatrixOperator(rand(N, N))
    L = A * (A * A) * A
    @test L isa ComposedOperator
    for op in L.ops
        @test !isa(op, ComposedOperator)
    end

    # Test caching of composed operator when inner ops do not support Base.:*
    # ComposedOperator caching was modified in PR # 174
    inner_op = qr(MatrixOperator(rand(N, N)))
    op = inner_op * factorize(MatrixOperator(rand(N, N)))
    @test !iscached(op)
    @test_nowarn op = cache_operator(op, rand(N))
    @test iscached(op)
    u = rand(N)
    @test ldiv!(rand(N), op, u) ≈ op \ u
end

@testset "has_concretization composites" begin
    A = MatrixOperator(rand(N, N))
    B = MatrixOperator(rand(N, N))
    F = FunctionOperator(
        (du, u, p, t) -> copyto!(du, u),
        zeros(N),
        zeros(N);
        isinplace = true,
        T = Float64,
        islinear = true
    )

    @test has_concretization(A)
    @test has_concretization(2A)
    @test has_concretization(A + B)
    @test has_concretization(A * B)
    @test has_concretization(inv(A))
    @test !has_concretization(F)
    @test !has_concretization(F * A)
    @test !has_concretization(A + F)
    @test !ishermitian(F * A)
end

@testset "Adjoint, Transpose" begin
    for (
            op,
            LType,
            VType,
        ) in (
            (adjoint, AdjointOperator, AbstractAdjointVecOrMat),
            (transpose, TransposedOperator, AbstractTransposedVecOrMat),
        )
        A = rand(N, N)
        D = Bidiagonal(rand(N, N), :L)
        u = rand(N, K)       # Update vector
        v = rand(N, K)       # Action vector
        w = zeros(N, K)      # Output vector
        p = nothing
        t = 0
        α = rand()
        β = rand()
        a = rand()
        b = rand()

        At = op(A)
        Dt = op(D)

        @test issquare(At)
        @test issquare(Dt)

        @test islinear(At)
        @test islinear(Dt)

        AA = MatrixOperator(A)
        DD = MatrixOperator(D)

        AAt = LType(AA)
        DDt = LType(DD)

        @test isconstant(AAt)
        @test isconstant(DDt)

        @test AAt.L === AA
        @test op(u) isa VType

        @test op(u) * AAt ≈ op(A * u)
        @test op(u) / AAt ≈ op(A \ u)

        # Not implementing separate test for adjoint/transpose operators
        # since they typically rely on the base operator implementations

        v = rand(N, K)
        @test mul!(op(v), op(u), AAt) ≈ op(A * u)
        v = rand(N, K)
        w_orig = copy(v)
        @test mul!(op(v), op(u), AAt, α, β) ≈ α * op(A * u) + β * op(w_orig)

        v = rand(N, K)
        @test ldiv!(op(v), op(u), DDt) ≈ op(D \ u)
        v = copy(u)
        @test ldiv!(op(u), DDt) ≈ op(D \ v)
    end
end

@testset "InvertedOperator" begin
    s = rand(N)
    D = Diagonal(s) |> MatrixOperator
    Di = InvertedOperator(D)
    u = rand(N)       # Update vector
    v = rand(N)       # Action vector
    w = zeros(N)      # Output vector
    p = nothing
    t = 0
    α = rand()
    β = rand()

    @test !iscached(Di)
    Di = cache_operator(Di, u)
    @test isconstant(Di)
    @test iscached(Di)

    @test issquare(Di)
    @test islinear(Di)

    @test Di * u ≈ u ./ s

    # Test new interface - same vectors
    @test Di(u, u, p, t) ≈ u ./ s

    # Test new interface - separate vectors
    @test Di(v, u, p, t) ≈ v ./ s

    # Test in-place operation
    copy!(w, zeros(N))
    Di(w, v, u, p, t)
    @test w ≈ v ./ s

    # Test in-place with scaling
    copy!(w, rand(N))
    orig_w = copy(w)
    Di(w, v, u, p, t, α, β)
    @test w ≈ α * (v ./ s) + β * orig_w

    # Original tests
    v = rand(N)
    @test mul!(v, Di, u) ≈ u ./ s
    v = rand(N)
    w_orig = copy(v)
    @test mul!(v, Di, u, α, β) ≈ α * (u ./ s) + β * w_orig

    @test Di \ u ≈ u .* s
    v = rand(N)
    @test ldiv!(v, Di, u) ≈ u .* s
    v = copy(u)
    @test ldiv!(Di, u) ≈ v .* s
end

"""
    IdentityOperator(len)

Matrix-free identity operator of size `(len, len)`.

# Arguments

  - `len::Integer`: Number of rows and columns.

# Fields

  - `len::Int`: Stored operator dimension.

# Interface Rules

`IdentityOperator` is constant, square, invertible, and supports the generic
`AbstractSciMLOperator` application, caching, and trait interfaces. It is
returned unchanged when composed with a compatible operator.

# Examples

```julia
using SciMLOperators

IdentityOperator(2) * [3.0, 4.0] == [3.0, 4.0]
```
"""
struct IdentityOperator <: AbstractSciMLOperator{Bool}
    len::Int
end

# constructors
function Base.one(L::AbstractSciMLOperator)
    @assert issquare(L)
    N = size(L, 1)
    return IdentityOperator(N)
end

Base.convert(::Type{AbstractMatrix}, ii::IdentityOperator) = Diagonal(ones(Bool, ii.len))
has_concretization(::IdentityOperator) = true

# Copy method to avoid aliasing - IdentityOperator has no mutable fields, can return self
Base.copy(L::IdentityOperator) = L

# traits
Base.show(io::IO, ii::IdentityOperator) = print(io, "IdentityOperator($(ii.len))")
Base.size(ii::IdentityOperator) = (ii.len, ii.len)
Base.adjoint(A::IdentityOperator) = A
Base.transpose(A::IdentityOperator) = A
Base.conj(A::IdentityOperator) = A

LinearAlgebra.opnorm(::IdentityOperator, p::Real = 2) = true
for pred in (:issymmetric, :ishermitian, :isposdef)
    @eval LinearAlgebra.$pred(::IdentityOperator) = true
end
ArrayInterface.issingular(::IdentityOperator) = false

getops(::IdentityOperator) = ()
isconstant(::IdentityOperator) = true
islinear(::IdentityOperator) = true
has_adjoint(::IdentityOperator) = true
has_mul!(::IdentityOperator) = true
has_ldiv(::IdentityOperator) = true
has_ldiv!(::IdentityOperator) = true

# operator application
for op in (:*, :\)
    @eval function Base.$op(ii::IdentityOperator, v::AbstractVecOrMat)
        @assert size(v, 1) == ii.len
        return copy(v)
    end
end

@inline function LinearAlgebra.mul!(
        w::AbstractVecOrMat, ii::IdentityOperator, v::AbstractVecOrMat
    )
    @assert size(v, 1) == ii.len
    return copy!(w, v)
end

@inline function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        ii::IdentityOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    @assert size(v, 1) == ii.len
    return mul!(w, I, v, α, β)
end

function LinearAlgebra.ldiv!(w::AbstractVecOrMat, ii::IdentityOperator, v::AbstractVecOrMat)
    @assert size(v, 1) == ii.len
    return copy!(w, v)
end

function LinearAlgebra.ldiv!(ii::IdentityOperator, v::AbstractVecOrMat)
    @assert size(v, 1) == ii.len
    return v
end

# Out-of-place: v is action vector, u is update vector
function (ii::IdentityOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    @assert size(v, 1) == ii.len
    update_coefficients(ii, u, p, t; kwargs...)
    return copy(v)
end

# In-place: w is destination, v is action vector, u is update vector
@inline function (ii::IdentityOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    @assert size(v, 1) == ii.len
    return copy!(w, v)
end

# In-place with scaling: w = α*(ii*v) + β*w
@inline function (ii::IdentityOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    @assert size(v, 1) == ii.len
    return mul!(w, I, v, α, β)
end

# operator fusion with identity returns operator itself
for op in (:*, :∘)
    @eval function Base.$op(left::IdentityOperator, right::IdentityOperator)
        @assert left.len == right.len
        return left
    end

    @eval function Base.$op(ii::IdentityOperator, A::AbstractSciMLOperator)
        @assert size(A, 1) == ii.len
        return A
    end

    @eval function Base.$op(A::AbstractSciMLOperator, ii::IdentityOperator)
        @assert size(A, 2) == ii.len
        return A
    end

end

function Base.:\(ii::IdentityOperator, A::AbstractSciMLOperator)
    @assert size(A, 1) == ii.len
    return A
end

function Base.:/(A::AbstractSciMLOperator, ii::IdentityOperator)
    @assert size(A, 2) == ii.len
    return A
end

"""
    NullOperator(M, N)
    NullOperator(N)

Matrix-free zero operator of size `(M, N)`. The one-argument constructor
creates a square zero operator.

# Arguments

  - `M::Integer`: Number of output rows.
  - `N::Integer`: Number of input columns.

# Fields

  - `M::Int`: Stored output dimension.
  - `N::Int`: Stored input dimension.

# Interface Rules

The operator is constant and linear. It returns a zero result with the input
container's element type and batch shape, and composition with a compatible
operator remains a `NullOperator` with the composed dimensions.

# Examples

```julia
using SciMLOperators

NullOperator(2, 3) * ones(3) == zeros(2)
```
"""
struct NullOperator <: AbstractSciMLOperator{Bool}
    M::Int
    N::Int
end

# constructors
NullOperator(N::Integer) = NullOperator(N, N)

for op in (:*, :∘)
    @eval function Base.$op(ii::IdentityOperator, nn::NullOperator)
        @assert ii.len == nn.M
        return nn
    end

    @eval function Base.$op(nn::NullOperator, ii::IdentityOperator)
        @assert nn.N == ii.len
        return nn
    end
end

function Base.zero(L::AbstractSciMLOperator)
    return NullOperator(size(L)...)
end

function Base.convert(::Type{AbstractMatrix}, nn::NullOperator)
    return nn.M == nn.N ? Diagonal(zeros(Bool, nn.N)) : zeros(Bool, size(nn))
end
has_concretization(::NullOperator) = true

# Copy method to avoid aliasing - NullOperator has no mutable fields, can return self
Base.copy(L::NullOperator) = L

# traits
function Base.show(io::IO, nn::NullOperator)
    return nn.M == nn.N ? print(io, "NullOperator($(nn.M))") :
        print(io, "NullOperator($(nn.M), $(nn.N))")
end
Base.size(nn::NullOperator) = (nn.M, nn.N)
Base.adjoint(A::NullOperator) = NullOperator(A.N, A.M)
Base.transpose(A::NullOperator) = NullOperator(A.N, A.M)
Base.conj(A::NullOperator) = A
LinearAlgebra.opnorm(::NullOperator, p::Real = 2) = false
for pred in (:issymmetric, :ishermitian)
    @eval LinearAlgebra.$pred(nn::NullOperator) = issquare(nn)
end
LinearAlgebra.isposdef(::NullOperator) = false

getops(::NullOperator) = ()
isconstant(::NullOperator) = true
islinear(::NullOperator) = true
Base.iszero(::NullOperator) = true
has_adjoint(::NullOperator) = true
has_mul!(::NullOperator) = true

# operator application
function _null_output(nn::NullOperator, v::AbstractVecOrMat)
    @assert size(v, 1) == nn.N
    nn.M == nn.N && return zero(v)
    return v isa AbstractMatrix ? zeros(eltype(v), nn.M, size(v, 2)) : zeros(eltype(v), nn.M)
end

Base.:*(nn::NullOperator, v::AbstractVecOrMat) = _null_output(nn, v)

function LinearAlgebra.mul!(w::AbstractVecOrMat, nn::NullOperator, v::AbstractVecOrMat)
    @assert size(v, 1) == nn.N
    @assert size(w, 1) == nn.M
    return lmul!(false, w)
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        nn::NullOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    @assert size(v, 1) == nn.N
    @assert size(w, 1) == nn.M
    return lmul!(β, w)
end

# Out-of-place: v is action vector, u is update vector
function (nn::NullOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    return _null_output(nn, v)
end

# In-place: w is destination, v is action vector, u is update vector
function (nn::NullOperator)(w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...)
    @assert size(v, 1) == nn.N
    @assert size(w, 1) == nn.M
    lmul!(false, w)
    return w
end

# In-place with scaling: w = α*(nn*v) + β*w
function (nn::NullOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    @assert size(v, 1) == nn.N
    @assert size(w, 1) == nn.M
    lmul!(β, w)
    return w
end

# operator fusion, composition
for op in (:*, :∘)
    @eval function Base.$op(left::NullOperator, right::NullOperator)
        @assert left.N == right.M
        return NullOperator(left.M, right.N)
    end

    @eval function Base.$op(nn::NullOperator, A::AbstractSciMLOperator)
        @assert size(A, 1) == nn.N
        return NullOperator(nn.M, size(A, 2))
    end

    @eval function Base.$op(A::AbstractSciMLOperator, nn::NullOperator)
        @assert size(A, 2) == nn.M
        return NullOperator(size(A, 1), nn.N)
    end
end

Base.:*(::AbstractSciMLScalarOperator, nn::NullOperator) = nn
Base.:*(nn::NullOperator, ::AbstractSciMLScalarOperator) = nn

# operator addition, subtraction with NullOperator returns operator itself
for op in (:+, :-)
    @eval function Base.$op(left::NullOperator, right::NullOperator)
        @assert size(left) == size(right)
        return left
    end

    @eval function Base.$op(nn::NullOperator, A::AbstractSciMLOperator)
        @assert size(A) == size(nn)
        return A
    end

    @eval function Base.$op(A::AbstractSciMLOperator, nn::NullOperator)
        @assert size(A) == size(nn)
        return A
    end
end

Base.:+(nn::NullOperator, α::AbstractSciMLScalarOperator) = α
Base.:+(α::AbstractSciMLScalarOperator, nn::NullOperator) = α
Base.:-(nn::NullOperator, α::AbstractSciMLScalarOperator) = -α
Base.:-(α::AbstractSciMLScalarOperator, nn::NullOperator) = α

"""
$TYPEDEF

    ScaledOperator(λ, L)

Lazy scalar multiple of an `AbstractSciMLOperator`, representing `λ * L`.

# Arguments

  - `λ`: A number, `UniformScaling`, or `AbstractSciMLScalarOperator`.
  - `L::AbstractSciMLOperator`: Operator being scaled.

# Fields

  - `λ`: Lazy scalar factor.
  - `L`: Wrapped operator.

# Interface Rules

Updates, caching, and trait queries are forwarded to both fields. The result
is linear exactly when `L` is linear; division traits additionally require a
nonzero current scalar value. Prefer `λ * L` to constructing this type
directly.
"""
struct ScaledOperator{
        T,
        λType,
        LType,
    } <: AbstractSciMLOperator{T}
    λ::λType
    L::LType

    function ScaledOperator(
            λ::AbstractSciMLScalarOperator{Tλ},
            L::AbstractSciMLOperator{TL}
        ) where {Tλ, TL}
        T = promote_type(Tλ, TL)
        return new{T, typeof(λ), typeof(L)}(λ, L)
    end
end

# constructors
for T in SCALINGNUMBERTYPES[2:end]
    @eval function ScaledOperator(λ::$T, L::AbstractSciMLOperator)
        T2 = _promote_operator_eltype(λ, L)
        Λ = λ isa UniformScaling ? UniformScaling(T2(λ.λ)) : T2(λ)
        return ScaledOperator(ScalarOperator(Λ), L)
    end
end

for T in SCALINGNUMBERTYPES
    @eval function ScaledOperator(λ::$T, L::ScaledOperator)
        λ = λ * L.λ
        return ScaledOperator(λ, L.L)
    end

    for LT in SCALINGCOMBINETYPES
        @eval Base.:*(λ::$T, L::$LT) = ScaledOperator(λ, L)
        @eval Base.:*(L::$LT, λ::$T) = ScaledOperator(λ, L)

        @eval Base.:\(λ::$T, L::$LT) = ScaledOperator(inv(λ), L)
        @eval Base.:\(L::$LT, λ::$T) = ScaledOperator(λ, inv(L))

        @eval Base.:/(L::$LT, λ::$T) = ScaledOperator(inv(λ), L)
        @eval Base.:/(λ::$T, L::$LT) = ScaledOperator(λ, inv(L))
    end
end

# Special cases for constant scalars. These simplify the structure when applicable
for T in SCALINGNUMBERTYPES[2:end]
    @eval function Base.:*(α::$T, L::ScaledOperator)
        isconstant(L.λ) && return ScaledOperator(α * L.λ, L.L)
        return ScaledOperator(L.λ, α * L.L) # Try to propagate the rule
    end
    @eval function Base.:*(L::ScaledOperator, α::$T)
        isconstant(L.λ) && return ScaledOperator(α * L.λ, L.L)
        return ScaledOperator(L.λ, α * L.L) # Try to propagate the rule
    end
end

Base.:+(L::AbstractSciMLOperator) = L
Base.:-(L::AbstractSciMLOperator{T}) where {T} = ScaledOperator(-one(T), L)

# Special cases for constant scalars. These simplify the structure when applicable
function Base.:-(L::ScaledOperator)
    isconstant(L.λ) && return ScaledOperator(-L.λ, L.L)
    return ScaledOperator(L.λ, -L.L) # Try to propagate the rule
end

function Base.convert(::Type{AbstractMatrix}, L::ScaledOperator)
    return convert(Number, L.λ) * convert(AbstractMatrix, L.L)
end
has_concretization(L::ScaledOperator) = has_concretization(L.λ) & has_concretization(L.L)

# traits
function Base.show(io::IO, L::ScaledOperator{T}) where {T}
    show(io, L.λ)
    print(io, " * ")
    return show(io, L.L)
end
Base.size(L::ScaledOperator) = size(L.L)
for op in (
        :adjoint,
        :transpose,
    )
    @eval Base.$op(L::ScaledOperator) = ScaledOperator($op(L.λ), $op(L.L))
end
Base.conj(L::ScaledOperator) = conj(L.λ) * conj(L.L)
Base.resize!(L::ScaledOperator, n::Integer) = (resize!(L.L, n); L)
LinearAlgebra.opnorm(L::ScaledOperator, p::Real = 2) = abs(L.λ) * opnorm(L.L, p)

function update_coefficients(L::ScaledOperator, u, p, t; kwargs...)
    @reset L.L = update_coefficients(L.L, u, p, t; kwargs...)
    @reset L.λ = update_coefficients(L.λ, u, p, t; kwargs...)

    return L
end

function update_coefficients!(L::ScaledOperator, u, p, t; kwargs...)
    update_coefficients!(L.L, u, p, t; kwargs...)
    update_coefficients!(L.λ, u, p, t; kwargs...)

    return nothing
end

getops(L::ScaledOperator) = (L.λ, L.L)

# Copy method to avoid aliasing
function Base.copy(L::ScaledOperator)
    return ScaledOperator(copy(L.λ), copy(L.L))
end

isconstant(L::ScaledOperator) = isconstant(L.L) & isconstant(L.λ)
islinear(L::ScaledOperator) = islinear(L.L)
Base.iszero(L::ScaledOperator) = iszero(L.L) | iszero(L.λ)
has_adjoint(L::ScaledOperator) = has_adjoint(L.L)
has_mul(L::ScaledOperator) = has_mul(L.L)
has_mul!(L::ScaledOperator) = has_mul!(L.L)
has_ldiv(L::ScaledOperator) = has_ldiv(L.L) & !iszero(L.λ)
has_ldiv!(L::ScaledOperator) = has_ldiv!(L.L) & !iszero(L.λ)

function cache_internals(L::ScaledOperator, v::AbstractVecOrMat)
    @reset L.L = cache_operator(L.L, v)
    @reset L.λ = cache_operator(L.λ, v)
    return L
end

# A scaling holds no scratch of its own, so it is transparent to the sharing described in
# `getcache`: the cache one field down is exactly as interchangeable as one held directly.
# Forwarding matters more than it looks — `A - B` lowers to `AddedOperator(A, -B)` with
# `-B` a `ScaledOperator`, so without this the commonest sum of all shares nothing.
getcache(L::ScaledOperator) = getcache(L.L)
update_cache(L::ScaledOperator, new_cache) = @reset L.L = update_cache(L.L, new_cache)

function adopt_cache(L::ScaledOperator, cache, v)
    inner = adopt_cache(L.L, cache, v)
    inner === nothing && return nothing

    @reset L.L = inner
    @reset L.λ = cache_operator(L.λ, v)
    return L
end

# getindex
Base.getindex(L::ScaledOperator, i::Int) = L.coeff * L.L[i]
Base.getindex(L::ScaledOperator, I::Vararg{Int, N}) where {N} = L.λ * L.L[I...]

factorize(L::ScaledOperator) = L.λ * factorize(L.L)
for fact in (
        :lu, :lu!,
        :qr, :qr!,
        :cholesky, :cholesky!,
        :ldlt, :ldlt!,
        :bunchkaufman, :bunchkaufman!,
        :lq, :lq!,
        :svd, :svd!,
    )
    @eval LinearAlgebra.$fact(L::ScaledOperator, args...) = L.λ *
        LinearAlgebra.$fact(L.L, args...)
end

# operator application, inversion
Base.:*(L::ScaledOperator, v::AbstractVecOrMat) = L.λ * (L.L * v)
Base.:\(L::ScaledOperator, v::AbstractVecOrMat) = L.λ \ (L.L \ v)

@inline function LinearAlgebra.mul!(
        w::AbstractVecOrMat, L::ScaledOperator, v::AbstractVecOrMat
    )
    iszero(L.λ) && return lmul!(false, w)
    a = convert(Number, L.λ)
    return mul!(w, L.L, v, a, false)
end

@inline function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::ScaledOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    iszero(L.λ) && return lmul!(β, w)
    a = convert(Number, L.λ * α)
    return mul!(w, L.L, v, a, β)
end

function LinearAlgebra.ldiv!(w::AbstractVecOrMat, L::ScaledOperator, v::AbstractVecOrMat)
    ldiv!(w, L.L, v)
    return ldiv!(L.λ, w)
end

function LinearAlgebra.ldiv!(L::ScaledOperator, v::AbstractVecOrMat)
    ldiv!(L.λ, v)
    return ldiv!(L.L, v)
end

# Out-of-place: v is action vector, u is update vector
function (L::ScaledOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    if iszero(L.λ)
        return zero(v)
    else
        return L.λ * (L.L * v)
    end
end

# In-place: w is destination, v is action vector, u is update vector
@inline function (L::ScaledOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    update_coefficients!(L.λ, u, p, t; kwargs...)
    a = convert(Number, L.λ)
    return L.L(w, v, u, p, t, a, false; kwargs...)
end

# In-place with scaling: w = α*(L*v) + β*w
@inline function (L::ScaledOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L.λ, u, p, t; kwargs...)
    a = convert(Number, L.λ * α)
    return L.L(w, v, u, p, t, a, β; kwargs...)
end

"""
    AddedOperator(A, B, ...)

Lazy sum of compatible `AbstractSciMLOperator`s.

# Arguments

  - `A, B, ...`: One or more operators with identical sizes.

# Fields

  - `ops`: Tuple of component operators. Nested sums are flattened.

# Interface Rules

The action is the sum of each component action. Updates, caching, and traits
are forwarded componentwise; a trait is true only when every required
component supports it. Use `A + B` rather than constructing this type
directly.
"""
struct AddedOperator{
        T,
        O <: Tuple{Vararg{AbstractSciMLOperator}},
    } <: AbstractSciMLOperator{T}
    ops::O

    function AddedOperator(ops)
        @assert !isempty(ops)
        # Flatten nested AddedOperators
        ops_flat = _flatten_added_operators(ops)
        _check_AddedOperator_sizes(ops_flat)
        T = mapreduce(eltype, promote_type, ops_flat)
        return new{T, typeof(ops_flat)}(ops_flat)
    end
end

function AddedOperator(ops::AbstractSciMLOperator...)
    return AddedOperator(ops)
end

AddedOperator(L::AbstractSciMLOperator) = L

# Helper function to flatten nested AddedOperators
@generated function _flatten_added_operators(ops::Tuple)
    exprs = ()
    for i in 1:length(ops.parameters)
        T = ops.parameters[i]
        if T <: AddedOperator
            # If this element is an AddedOperator, unpack its ops
            exprs = (exprs..., :(ops[$i].ops...))
        else
            # Otherwise, keep the element as-is
            exprs = (exprs..., :(ops[$i]))
        end
    end

    return quote
        tuple($(exprs...))
    end
end

@generated function _check_AddedOperator_sizes(ops::Tuple)
    ops_types = ops.parameters
    N = length(ops_types)
    sz_expr_list = ()
    sz_expr = :(sz = size(first(ops)))
    for i in 2:N
        sz_expr_list = (sz_expr_list..., :(size(ops[$i]) == sz))
    end

    return quote
        $sz_expr
        @assert all(tuple($(sz_expr_list...))) "Dimension mismatch: cannot add operators of different sizes."
        nothing
    end
end

# constructors
Base.:+(A::AbstractSciMLOperator, B::AbstractMatrix) = A + MatrixOperator(B)
Base.:+(A::AbstractMatrix, B::AbstractSciMLOperator) = MatrixOperator(A) + B

Base.:+(ops::AbstractSciMLOperator...) = reduce(+, ops)
Base.:+(A::AbstractSciMLOperator, B::AbstractSciMLOperator) = AddedOperator(A, B)
Base.:+(A::AbstractSciMLOperator, B::AddedOperator) = AddedOperator(A, B.ops...)
Base.:+(A::AddedOperator, B::AbstractSciMLOperator) = AddedOperator(A.ops..., B)
Base.:+(A::AddedOperator, B::AddedOperator) = AddedOperator(A.ops..., B.ops...)

function Base.:+(A::AddedOperator, Z::NullOperator)
    @assert size(A) == size(Z)
    return A
end

function Base.:+(Z::NullOperator, A::AddedOperator)
    @assert size(A) == size(Z)
    return A
end

function Base.:-(A::AddedOperator, Z::NullOperator)
    @assert size(A) == size(Z)
    return A
end

function Base.:-(Z::NullOperator, A::AddedOperator)
    @assert size(A) == size(Z)
    return -A
end

Base.:-(A::AddedOperator) = AddedOperator(map(-, A.ops))
Base.:-(A::AbstractSciMLOperator, B::AbstractSciMLOperator) = AddedOperator(A, -B)
Base.:-(A::AbstractSciMLOperator, B::AbstractMatrix) = A - MatrixOperator(B)
Base.:-(A::AbstractMatrix, B::AbstractSciMLOperator) = MatrixOperator(A) - B
Base.:-(A::AddedOperator, B::AbstractSciMLOperator) = AddedOperator(A.ops..., -B)
Base.:-(A::AbstractSciMLOperator, B::AddedOperator) = AddedOperator(A, (-B).ops...)
Base.:-(A::AddedOperator, B::AddedOperator) = AddedOperator(A.ops..., (-B).ops...)

function Base.:+(A::AddedOperator, α::AbstractSciMLScalarOperator)
    @assert issquare(A)
    return iszero(α) ? A : AddedOperator(A.ops..., α * IdentityOperator(size(A, 1)))
end

function Base.:+(α::AbstractSciMLScalarOperator, A::AddedOperator)
    @assert issquare(A)
    return iszero(α) ? A : AddedOperator(α * IdentityOperator(size(A, 1)), A.ops...)
end

function Base.:-(A::AddedOperator, α::AbstractSciMLScalarOperator)
    @assert issquare(A)
    return iszero(α) ? A : AddedOperator(A.ops..., (-α) * IdentityOperator(size(A, 1)))
end

function Base.:-(α::AbstractSciMLScalarOperator, A::AddedOperator)
    @assert issquare(A)
    return AddedOperator(α * IdentityOperator(size(A, 1)), (-A).ops...)
end

for op in (:+, :-)
    for T in SCALINGNUMBERTYPES
        for LT in SCALINGCOMBINETYPES
            @eval function Base.$op(L::$LT, λ::$T)
                @assert issquare(L)
                iszero(λ) && return L
                N = size(L, 1)
                Id = IdentityOperator(N)
                return AddedOperator(L, $op(λ) * Id)
            end

            @eval function Base.$op(λ::$T, L::$LT)
                @assert issquare(L)
                iszero(λ) && return $op(L)
                N = size(L, 1)
                Id = IdentityOperator(N)
                return AddedOperator(λ * Id, $op(L))
            end
        end
    end
end

for T in SCALINGNUMBERTYPES[2:end]
    @eval function Base.:*(λ::$T, L::AddedOperator)
        ops = map(op -> λ * op, L.ops)
        return AddedOperator(ops)
    end

    @eval function Base.:*(L::AddedOperator, λ::$T)
        ops = map(op -> λ * op, L.ops)
        return AddedOperator(ops)
    end

    @eval function Base.:/(L::AddedOperator, λ::$T)
        ops = map(op -> op / λ, L.ops)
        return AddedOperator(ops)
    end
end

function Base.convert(::Type{AbstractMatrix}, L::AddedOperator)
    return sum(op -> convert(AbstractMatrix, op), L.ops)
end
has_concretization(L::AddedOperator) = all(has_concretization, L.ops)

# traits
function Base.show(io::IO, L::AddedOperator)
    print(io, "(")
    show(io, L.ops[1])
    for i in 2:length(L.ops)
        print(io, " + ")
        show(io, L.ops[i])
    end
    return print(io, ")")
end
Base.size(L::AddedOperator) = size(first(L.ops))
for op in (
        :adjoint,
        :transpose,
    )
    @eval Base.$op(L::AddedOperator) = AddedOperator($op.(L.ops)...)
end
Base.conj(L::AddedOperator) = AddedOperator(conj.(L.ops))
function Base.resize!(L::AddedOperator, n::Integer)
    for op in L.ops
        resize!(op, n)
    end
    return L
end

@generated function update_coefficients(L::AddedOperator, u, p, t; kwargs...)
    ops_types = L.parameters[2].parameters
    N = length(ops_types)
    updates = [:(update_coefficients(L.ops[$i], u, p, t; kwargs...)) for i in 1:N]
    return :(AddedOperator($(Expr(:tuple, updates...))))
end

@generated function update_coefficients!(L::AddedOperator, u, p, t; kwargs...)
    ops_types = L.parameters[2].parameters
    N = length(ops_types)
    updates = [:(update_coefficients!(L.ops[$i], u, p, t; kwargs...)) for i in 1:N]
    return Expr(:block, updates..., :(nothing))
end

getops(L::AddedOperator) = L.ops

# Copy method to avoid aliasing
function Base.copy(L::AddedOperator)
    return AddedOperator(map(copy, L.ops))
end

islinear(L::AddedOperator) = all(islinear, getops(L))
Base.iszero(L::AddedOperator) = all(iszero, getops(L))
has_adjoint(L::AddedOperator) = all(has_adjoint, L.ops)

@generated function cache_internals(L::AddedOperator, v::AbstractVecOrMat)
    ops_types = L.parameters[2].parameters
    N = length(ops_types)
    syms = [Symbol(:op_, i) for i in 1:N]

    # `mul!` applies the summands one after another, so no two of their caches are ever
    # live at the same time and a summand can reuse the scratch of an earlier one. Only
    # summands of the same concrete type can qualify — that is what pins their element
    # types — so the candidates are picked out here, at compile time, and each summand
    # tries them all before allocating anything of its own.
    stmts = map(1:N) do i
        donors = Expr(:tuple, syms[findall(j -> ops_types[j] === ops_types[i], 1:(i - 1))]...)
        earlier = Expr(:tuple, syms[1:(i - 1)]...)
        return :($(syms[i]) = _cache_summand(L.ops[$i], $donors, $earlier, v))
    end

    return quote
        $(stmts...)
        return AddedOperator($(Expr(:tuple, syms...)))
    end
end

getindex(L::AddedOperator, i::Int) = sum(op -> op[i], L.ops)
getindex(L::AddedOperator, I::Vararg{Int, N}) where {N} = sum(op -> op[I...], L.ops)

function Base.:*(L::AddedOperator, v::AbstractVecOrMat)
    return sum(op -> iszero(op) ? zero(v) : op * v, L.ops)
end

@generated function LinearAlgebra.mul!(
        w::AbstractVecOrMat, L::AddedOperator, v::AbstractVecOrMat
    )
    ops_types = L.parameters[2].parameters
    N = length(ops_types)
    applications = [:(mul!(w, L.ops[$i], v, true, true)) for i in 2:N]
    return Expr(:block, :(mul!(w, L.ops[1], v)), applications..., :w)
end

@generated function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::AddedOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    ops_types = L.parameters[2].parameters
    N = length(ops_types)
    applications = [:(mul!(w, L.ops[$i], v, α, true)) for i in 1:N]
    return Expr(:block, :(lmul!(β, w)), applications..., :w)
end

# Out-of-place: v is action vector, u is update vector
function (L::AddedOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    # We don't need to update coefficients of L, as op(v, u, p, t) will do it for each op
    return sum(op -> op(v, u, p, t; kwargs...), L.ops)
end

# In-place: w is destination, v is action vector, u is update vector
@generated function (L::AddedOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    # We don't need to update coefficients of L, as op(w, v, u, p, t) will do it for each op

    ops_types = L.parameters[2].parameters
    N = length(ops_types)
    applications = [:(L.ops[$i](w, v, u, p, t, true, true; kwargs...)) for i in 2:N]
    return Expr(:block, :(L.ops[1](w, v, u, p, t; kwargs...)), applications..., :w)
end

# In-place with scaling: w = α*(L*v) + β*w
@generated function (L::AddedOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    # We don't need to update coefficients of L, as op(w, v, u, p, t) will do it for each op

    T = L.parameters[1]
    ops_types = L.parameters[2].parameters
    N = length(ops_types)
    applications = [:(L.ops[$i](w, v, u, p, t, α, true; kwargs...)) for i in 2:N]
    return Expr(:block, :(L.ops[1](w, v, u, p, t, α, β; kwargs...)), applications..., :w)
end

"""
    ComposedOperator(A, B, ...)

Lazy composition representing `A * B * ...`, with the rightmost operator
applied first.

# Arguments

  - `A, B, ...`: One or more dimension-compatible operators.

# Fields

  - `ops`: Tuple of component operators in multiplication order.
  - `cache`: Intermediate arrays used by in-place multiplication, or `nothing`.

# Interface Rules

Updates are forwarded to every component. Call `cache_operator` before
repeated in-place application when intermediate storage is required. The
composition is linear, convertible, or supports a trait only when all
components satisfy the corresponding contract.
"""
struct ComposedOperator{T, O, C} <: AbstractSciMLOperator{T}
    """ Tuple of N operators to be applied in reverse"""
    ops::O
    """ cache for 3 and 5 argument mul! """
    cache::C

    function ComposedOperator(ops, cache)
        @assert !isempty(ops)
        for i in reverse(2:length(ops))
            opcurr = ops[i]
            opnext = ops[i - 1]
            @assert size(opcurr, 1) == size(opnext, 2) "Dimension mismatch: cannot compose
          operators of sizes $(size(opnext)), and $(size(opcurr))."
        end

        T = promote_type(eltype.(ops)...)
        return new{T, typeof(ops), typeof(cache)}(ops, cache)
    end
end

function ComposedOperator(ops::AbstractSciMLOperator...; cache = nothing)
    return ComposedOperator(ops, cache)
end

# constructors
for op in (:*, :∘)
    @eval Base.$op(ops::AbstractSciMLOperator...) = reduce($op, ops)
    @eval Base.$op(A::AbstractSciMLOperator, B::AbstractSciMLOperator) = ComposedOperator(
        A,
        B
    )
    @eval Base.$op(A::ComposedOperator, B::AbstractSciMLOperator) = ComposedOperator(
        A.ops...,
        B
    )
    @eval Base.$op(A::AbstractSciMLOperator, B::ComposedOperator) = ComposedOperator(
        A,
        B.ops...
    )
    @eval Base.$op(A::ComposedOperator, B::ComposedOperator) = ComposedOperator(
        A.ops...,
        B.ops...
    )
end

for op in (:*, :∘)
    # identity
    @eval function Base.$op(ii::IdentityOperator, A::ComposedOperator)
        @assert size(A, 1) == ii.len
        return A
    end

    @eval function Base.$op(A::ComposedOperator, ii::IdentityOperator)
        @assert size(A, 2) == ii.len
        return A
    end

    # null operator
    @eval function Base.$op(nn::NullOperator, A::ComposedOperator)
        @assert size(A, 1) == nn.N
        return NullOperator(nn.M, size(A, 2))
    end

    @eval function Base.$op(A::ComposedOperator, nn::NullOperator)
        @assert size(A, 2) == nn.M
        return NullOperator(size(A, 1), nn.N)
    end

    # scalar operator
    @eval function Base.$op(λ::AbstractSciMLScalarOperator, L::ComposedOperator)
        return ScaledOperator(λ, L)
    end

    @eval function Base.$op(L::ComposedOperator, λ::AbstractSciMLScalarOperator)
        return ScaledOperator(λ, L)
    end
end

function Base.convert(::Type{AbstractMatrix}, L::ComposedOperator)
    return prod(op -> convert(AbstractMatrix, op), L.ops)
end
has_concretization(L::ComposedOperator) = all(has_concretization, L.ops)

# traits
function Base.show(io::IO, L::ComposedOperator)
    print(io, "(")
    show(io, L.ops[1])
    for i in 2:length(L.ops)
        print(io, " * ")
        show(io, L.ops[i])
    end
    return print(io, ")")
end
Base.size(L::ComposedOperator) = (size(first(L.ops), 1), size(last(L.ops), 2))
for op in (
        :adjoint,
        :transpose,
    )
    @eval Base.$op(L::ComposedOperator) = ComposedOperator(
        $op.(reverse(L.ops))...;
        cache = iscached(L) ? reverse(L.cache) : nothing
    )
end
Base.conj(L::ComposedOperator) = ComposedOperator(conj.(L.ops); cache = L.cache)
function Base.resize!(L::ComposedOperator, n::Integer)
    for op in L.ops
        resize!(op, n)
    end

    for v in L.cache
        resize!(v, n)
    end

    return L
end

LinearAlgebra.opnorm(L::ComposedOperator) = prod(opnorm, L.ops)

function update_coefficients(L::ComposedOperator, u, p, t; kwargs...)
    ops = ()
    for op in L.ops
        ops = (ops..., update_coefficients(op, u, p, t; kwargs...))
    end

    return @reset L.ops = ops
end

getops(L::ComposedOperator) = L.ops
getcache(L::ComposedOperator) = L.cache
adopt_cache(L::ComposedOperator, cache, v) = cache_internals(update_cache(L, cache), v)

# Copy method to avoid aliasing
function Base.copy(L::ComposedOperator)
    return ComposedOperator(
        map(copy, L.ops),
        L.cache === nothing ? nothing : deepcopy(L.cache)
    )
end

islinear(L::ComposedOperator) = all(islinear, L.ops)
Base.iszero(L::ComposedOperator) = all(iszero, getops(L))
has_adjoint(L::ComposedOperator) = all(has_adjoint, L.ops)
has_mul(L::ComposedOperator) = all(has_mul, L.ops)
has_mul!(L::ComposedOperator) = all(has_mul!, L.ops)
has_ldiv(L::ComposedOperator) = all(has_ldiv, L.ops)
has_ldiv!(L::ComposedOperator) = all(has_ldiv!, L.ops)

factorize(L::ComposedOperator) = prod(factorize, L.ops)
for fact in (
        :lu, :lu!,
        :qr, :qr!,
        :cholesky, :cholesky!,
        :ldlt, :ldlt!,
        :bunchkaufman, :bunchkaufman!,
        :lq, :lq!,
        :svd, :svd!,
    )
    @eval LinearAlgebra.$fact(L::ComposedOperator, args...) = prod(
        op -> LinearAlgebra.$fact(op, args...),
        reverse(L.ops)
    )
end

# operator application
# https://github.com/SciML/SciMLOperators.jl/pull/94
#Base.:*(L::ComposedOperator, u::AbstractVecOrMat) = foldl((acc, op) -> op * acc, reverse(L.ops); init=u)
#Base.:\(L::ComposedOperator, u::AbstractVecOrMat) = foldl((acc, op) -> op \ acc, L.ops; init=u)

function Base.:\(L::ComposedOperator, v::AbstractVecOrMat)
    for op in L.ops
        v = op \ v
    end

    return v
end

@generated function Base.:*(L::ComposedOperator, v::AbstractVecOrMat)
    N = length(L.parameters[2].parameters)  # Number of operators

    # Generate the composition in reverse order
    # v = L.ops[N] * v
    # v = L.ops[N-1] * v
    # ...
    # v = L.ops[1] * v
    exprs = []
    for i in N:-1:1
        push!(exprs, :(v = L.ops[$i] * v))
    end

    return quote
        $(exprs...)
        v
    end
end

@generated function cache_self(L::ComposedOperator, v::AbstractVecOrMat)
    N = length(L.parameters[2].parameters)  # Number of operators

    # Build cache from the end backwards (starting from zero(v))
    # For each operator from N down to 2, create a cache entry
    exprs = [:(cache = (zero(v),))]

    for i in N:-1:2
        push!(
            exprs, quote
                op = L.ops[$i]
                M = size(op, 1)
                sz = v isa AbstractMatrix ? (M, K) : (M,)

                T = if op isa FunctionOperator
                    # FunctionOperator isn't guaranteed to play by the rules of
                    # `promote_type`. For example, an irFFT is a complex operation
                    # that accepts complex vector and returns ones.
                    output_eltype(op)
                else
                    promote_type(eltype.((op, cache[1]))...)
                end

                cache = (similar(v, T, sz), cache...)
            end
        )
    end

    return quote
        K = size(v, 2)
        $(exprs...)
        @reset L.cache = cache
        L
    end
end

@generated function cache_internals(L::ComposedOperator, v::AbstractVecOrMat)
    N = length(L.parameters[2].parameters)  # Number of operators

    # Cache each operator with its corresponding cache entry
    exprs = []
    for i in N:-1:1
        push!(exprs, :(ops = (cache_operator(L.ops[$i], L.cache[$i]), ops...)))
    end

    return quote
        if isnothing(L.cache)
            L = cache_self(L, v)
        end

        ops = ()
        $(exprs...)
        @reset L.ops = ops
    end
end

@generated function LinearAlgebra.mul!(w::AbstractVecOrMat, L::ComposedOperator, v::AbstractVecOrMat)
    N = length(L.parameters[2].parameters)  # Number of operators

    # Generate the mul! calls in reverse order
    # vecs conceptually is (w, L.cache[1], L.cache[2], ..., L.cache[N-1], v)
    # For i in reverse(1:N):
    #   mul!(vecs[i], L.ops[i], vecs[i+1])

    exprs = []
    for i in N:-1:1
        if i == N
            # Last operator: mul!(L.cache[N-1], L.ops[N], v)
            push!(exprs, :(mul!(L.cache[$(N - 1)], L.ops[$i], v)))
        elseif i == 1
            # First operator: mul!(w, L.ops[1], L.cache[1])
            push!(exprs, :(mul!(w, L.ops[$i], L.cache[1])))
        else
            # Middle operators: mul!(L.cache[i-1], L.ops[i], L.cache[i])
            push!(exprs, :(mul!(L.cache[$(i - 1)], L.ops[$i], L.cache[$i])))
        end
    end

    return quote
        @assert iscached(L) """cache needs to be set up for operator of type
        $L. Set up cache by calling `cache_operator(L, v)`"""

        $(exprs...)
        w
    end
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::ComposedOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    @assert iscached(L) """cache needs to be set up for operator of type
    $L. Set up cache by calling `cache_operator(L, v)`."""

    cache = L.cache[end]
    copy!(cache, w)

    mul!(w, L, v)
    lmul!(α, w)
    return axpy!(β, cache, w)
end

@generated function LinearAlgebra.ldiv!(w::AbstractVecOrMat, L::ComposedOperator, v::AbstractVecOrMat)
    N = length(L.parameters[2].parameters)  # Number of operators

    # Generate the ldiv! calls in forward order
    # vecs conceptually is (v, reverse(L.cache[1:(N-1)])..., w)
    # = (v, L.cache[N-1], L.cache[N-2], ..., L.cache[1], w)
    # For i in 1:N:
    #   ldiv!(vecs[i+1], L.ops[i], vecs[i])

    exprs = []
    for i in 1:N
        if i == 1
            # First operator: ldiv!(L.cache[N-1], L.ops[1], v)
            push!(exprs, :(ldiv!(L.cache[$(N - 1)], L.ops[$i], v)))
        elseif i == N
            # Last operator: ldiv!(w, L.ops[N], L.cache[1])
            push!(exprs, :(ldiv!(w, L.ops[$i], L.cache[1])))
        else
            # Middle operators: ldiv!(L.cache[N-i], L.ops[i], L.cache[N-i+1])
            push!(exprs, :(ldiv!(L.cache[$(N - i)], L.ops[$i], L.cache[$(N - i + 1)])))
        end
    end

    return quote
        @assert iscached(L) """cache needs to be set up for operator of type
        $L. Set up cache by calling `cache_operator(L, v)`."""

        $(exprs...)
        w
    end
end

function LinearAlgebra.ldiv!(L::ComposedOperator, v::AbstractVecOrMat)
    for i in 1:length(L.ops)
        ldiv!(L.ops[i], v)
    end
    return v
end

# Out-of-place: v is action vector, u is update vector
function (L::ComposedOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    result = v
    for op in reverse(L.ops)
        result = op(result, u, p, t; kwargs...)
    end
    return result
end

# In-place: w is destination, v is action vector, u is update vector
@generated function (L::ComposedOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    N = length(L.parameters[2].parameters)  # Number of operators

    # Generate the operator call expressions in reverse order
    # vecs conceptually is (w, L.cache[1], L.cache[2], ..., L.cache[N-1], v)
    # For i in reverse(1:N):
    #   L.ops[i](vecs[i], vecs[i+1], u, p, t; kwargs...)

    exprs = []
    for i in N:-1:1
        if i == N
            # Last operator: L.ops[N](L.cache[N-1], v, u, p, t; kwargs...)
            push!(exprs, :(L.ops[$i](L.cache[$(N - 1)], v, u, p, t; kwargs...)))
        elseif i == 1
            # First operator: L.ops[1](w, L.cache[1], u, p, t; kwargs...)
            push!(exprs, :(L.ops[$i](w, L.cache[1], u, p, t; kwargs...)))
        else
            # Middle operators: L.ops[i](L.cache[i-1], L.cache[i], u, p, t; kwargs...)
            push!(exprs, :(L.ops[$i](L.cache[$(i - 1)], L.cache[$i], u, p, t; kwargs...)))
        end
    end

    return quote
        update_coefficients!(L, u, p, t; kwargs...)
        @assert iscached(L) "Cache needs to be set up for ComposedOperator. Call cache_operator(L, u) first."

        $(exprs...)
        w
    end
end

# In-place with scaling: w = α*(L*v) + β*w
function (L::ComposedOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    @assert iscached(L) "Cache needs to be set up for ComposedOperator. Call cache_operator(L, u) first."

    cache = L.cache[end]
    copy!(cache, w)

    L(w, v, u, p, t; kwargs...)
    lmul!(α, w)
    return axpy!(β, cache, w)
end

"""
    InvertedOperator(L)

Lazy inverse of an `AbstractSciMLOperator`.

# Arguments

  - `L::AbstractSciMLOperator`: Operator whose current action is inverted.

# Fields

  - `L`: Wrapped operator.
  - `cache`: Optional work arrays used by in-place division.

# Interface Rules

Construct this type through `inv(L)`. The wrapped operator must support the
division operations required by the chosen application form. Updates and
caching are forwarded to `L`; inversion does not materialize a matrix.
"""
struct InvertedOperator{T, LType, C} <: AbstractSciMLOperator{T}
    L::LType
    cache::C

    function InvertedOperator(L::AbstractSciMLOperator{T}, cache) where {T}
        return new{T, typeof(L), typeof(cache)}(L, cache)
    end
end

function InvertedOperator(L::AbstractSciMLOperator{T}; cache = nothing) where {T}
    return InvertedOperator(L, cache)
end

function InvertedOperator(A::AbstractMatrix{T}; cache = nothing) where {T}
    return InvertedOperator(MatrixOperator(A), cache)
end

Base.inv(L::AbstractSciMLOperator) = InvertedOperator(L)

Base.:\(A::AbstractSciMLOperator, B::AbstractSciMLOperator) = inv(A) * B
Base.:/(A::AbstractSciMLOperator, B::AbstractSciMLOperator) = A * inv(B)

function Base.convert(::Type{AbstractMatrix}, L::InvertedOperator)
    return inv(convert(AbstractMatrix, L.L))
end
has_concretization(L::InvertedOperator) = has_concretization(L.L)

function Base.show(io::IO, L::InvertedOperator)
    print(io, "1 / ")
    return show(io, L.L)
end
Base.size(L::InvertedOperator) = size(L.L) |> reverse
function Base.transpose(L::InvertedOperator)
    return InvertedOperator(transpose(L.L); cache = iscached(L) ? L.cache' : nothing)
end
function Base.adjoint(L::InvertedOperator)
    return InvertedOperator(adjoint(L.L); cache = iscached(L) ? L.cache' : nothing)
end
Base.conj(L::InvertedOperator) = InvertedOperator(conj(L.L); cache = L.cache)
function Base.resize!(L::InvertedOperator, n::Integer)
    resize!(L.L, n)
    resize!(L.cache, n)

    return L
end

function update_coefficients(L::InvertedOperator, u, p, t; kwargs...)
    if !isconstant(L.L)
        @reset L.L = update_coefficients(L.L, u, p, t; kwargs...)
    end
    return L
end

getops(L::InvertedOperator) = (L.L,)
getcache(L::InvertedOperator) = L.cache
adopt_cache(L::InvertedOperator, cache, v) = cache_internals(update_cache(L, cache), v)
islinear(L::InvertedOperator) = islinear(L.L)
isconvertible(::InvertedOperator) = false

has_mul(L::InvertedOperator) = has_ldiv(L.L)
has_mul!(L::InvertedOperator) = has_ldiv!(L.L)
has_ldiv(L::InvertedOperator) = has_mul(L.L)
has_ldiv!(L::InvertedOperator) = has_mul!(L.L)

# Method forwarding for InvertedOperator (previously using @forward from MacroTools)
# LinearAlgebra methods
LinearAlgebra.issymmetric(L::InvertedOperator) = LinearAlgebra.issymmetric(L.L)
LinearAlgebra.ishermitian(L::InvertedOperator) = LinearAlgebra.ishermitian(L.L)
LinearAlgebra.isposdef(L::InvertedOperator) = LinearAlgebra.isposdef(L.L)
LinearAlgebra.opnorm(L::InvertedOperator) = LinearAlgebra.opnorm(L.L)

# SciML methods
isconstant(L::InvertedOperator) = isconstant(L.L)
has_adjoint(L::InvertedOperator) = has_adjoint(L.L)

Base.:*(L::InvertedOperator, u::AbstractVecOrMat) = L.L \ u
Base.:\(L::InvertedOperator, u::AbstractVecOrMat) = L.L * u

# Copy method to avoid aliasing
function Base.copy(L::InvertedOperator)
    return InvertedOperator(
        copy(L.L),
        L.cache === nothing ? nothing : deepcopy(L.cache)
    )
end

function cache_self(L::InvertedOperator, u::AbstractVecOrMat)
    cache = zero(u)
    @reset L.cache = cache
    return L
end

function cache_internals(L::InvertedOperator, u::AbstractVecOrMat)
    @reset L.L = cache_operator(L.L, u)
    return L
end

function LinearAlgebra.mul!(w::AbstractVecOrMat, L::InvertedOperator, v::AbstractVecOrMat)
    return ldiv!(w, L.L, v)
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::InvertedOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    @assert iscached(L) """cache needs to be set up for operator of type
    $L. Set up cache by calling `cache_operator(L, v)`."""

    copy!(L.cache, w)
    ldiv!(w, L.L, v)
    lmul!(α, w)
    return axpy!(β, L.cache, w)
end

function LinearAlgebra.ldiv!(w::AbstractVecOrMat, L::InvertedOperator, v::AbstractVecOrMat)
    return mul!(w, L.L, v)
end

function LinearAlgebra.ldiv!(L::InvertedOperator, v::AbstractVecOrMat)
    @assert iscached(L) """cache needs to be set up for operator of type
    $L. Set up cache by calling `cache_operator(L, v)`."""

    copy!(L.cache, v)
    return mul!(v, L.L, L.cache)
end

# Out-of-place: v is action vector, u is update vector
function (L::InvertedOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    return L.L \ v
end

# In-place: w is destination, v is action vector, u is update vector
function (L::InvertedOperator)(w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...)
    update_coefficients!(L, u, p, t; kwargs...)
    ldiv!(w, L.L, v)
    return w
end

# In-place with scaling: w = α*(L*v) + β*w
function (L::InvertedOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    @assert iscached(L) "Cache needs to be set up for InvertedOperator. Call cache_operator(L, u) first."

    copy!(L.cache, w)
    ldiv!(w, L.L, v)
    lmul!(α, w)
    axpy!(β, L.cache, w)
    return w
end
#

module SciMLOperatorsLoopVectorizationExt

import LoopVectorization: @turbo
import SciMLOperators

const StridedMatrixOperator = SciMLOperators.MatrixOperator{<:Any, <:StridedMatrix}

SciMLOperators.has_tensor_outer_mul_fast(::StridedMatrixOperator) = true

function SciMLOperators.tensor_outer_mul_fast!(
        w, outer::StridedMatrixOperator, C, mi::Int, mo::Int, no::Int, k::Int
    )
    A = outer.A
    C = reshape(C, (mi, no, k))
    W = reshape(w, (mi, mo, k))

    @turbo for j in 1:k, m in 1:mo, i in 1:mi
        acc = zero(eltype(w))
        for o in 1:no
            acc += A[m, o] * C[i, o, j]
        end
        W[i, m, j] = acc
    end

    return w
end

function SciMLOperators.tensor_outer_mul_fast!(
        w, outer::StridedMatrixOperator, C, mi::Int, mo::Int, no::Int, k::Int, α, β
    )
    A = outer.A
    C = reshape(C, (mi, no, k))
    W = reshape(w, (mi, mo, k))

    @turbo for j in 1:k, m in 1:mo, i in 1:mi
        acc = zero(eltype(w))
        for o in 1:no
            acc += A[m, o] * C[i, o, j]
        end
        W[i, m, j] = α * acc + β * W[i, m, j]
    end

    return w
end

end

"""
SciMLOperators provides a common interface and lazy algebra for matrix-like,
matrix-free, state-dependent, and time-dependent operators used throughout
the SciML ecosystem.
"""
module SciMLOperators

using DocStringExtensions: DocStringExtensions, FIELDS, SIGNATURES, TYPEDEF
using PrecompileTools: @compile_workload, @setup_workload
using SciMLPublic: @public

using LinearAlgebra: LinearAlgebra, Adjoint, Bidiagonal, Factorization, I,
    Transpose, UniformScaling, axpby!, axpy!, ishermitian,
    isposdef, issuccess, issymmetric, lu, opnorm

import ArrayInterface
# MacroTools dependency removed - using explicit method forwarding instead
import Accessors: @reset

using Adapt: Adapt

# overload
import Base: show
import Base: zero, one
import Base: +, -, *, /, \, ==, conj, exp, kron
import Base: iszero, inv, adjoint, transpose, size, convert
import Base: Matrix
import LinearAlgebra: mul!, ldiv!, lmul!, rmul!, factorize
import LinearAlgebra: Diagonal

# Used for downstream checking
const isv1 = true

"""
$(TYPEDEF)

`AbstractSciMLOperator` is the extension point for matrix-like and
matrix-free operators. A subtype represents an operator ``L(u,p,t)`` whose
action on an array ``v`` is written ``L(u,p,t)v``. The subtype may be
constant, state-dependent, or time-dependent, and may be composed with other
SciML operators through the lazy algebra.

This is an interface type, not a constructor. The concrete type should be
public only when users are expected to construct or extend it; otherwise use
the qualified developer-facing API documented in this section.

## Mathematical Notation

An `AbstractSciMLOperator` ``L`` is an operator which is used to represent
the following type of equation:

```math
w = L(u,p,t)[v]
```

where `L[v]` is the operator application of ``L`` on the vector ``v``.

## Construction and Extension Rules

`AbstractSciMLOperator` is an interface, not a concrete constructor. New
operator types should subtype it with the scalar element type `T` and must
preserve their mathematical action when they participate in lazy algebra.

## Required Interface

A concrete subtype must implement `size(L) -> (m, n)`, `*(L, v)`, and
`mul!(w, L, v)`. The returned action has leading size `m` for an input whose
leading size is `n`, and the in-place method must return `w` after writing the
result. The scaling form `mul!(w, L, v, α, β)` is required when
`has_mul!(L) == true`; it must compute ``w \\leftarrow α(Lv) + βw``.

`has_mul(L)`, `has_mul!(L)`, `has_ldiv(L)`, and `has_ldiv!(L)` are promises,
not capability probes: return `true` only when the corresponding operation is
valid for all compatible inputs. `convert(AbstractMatrix, L)` is optional and
should be defined only when `isconvertible(L) == true`; its result must have
the same size and action as `L` in its current state.

An `AbstractSciMLOperator` can be called like a function in the following ways:

  - `L(v, u, p, t)` - Out-of-place application where `v` is the action vector and `u` is the update vector
  - `L(w, v, u, p, t)` - In-place application where `w` is the destination, `v` is the action vector, and `u` is the update vector
  - `L(w, v, u, p, t, α, β)` - In-place application with scaling: `w = α*(L*v) + β*w`

Operator state can be updated separately from application:

  - `update_coefficients!(L, u, p, t)` for in-place operator update
  - `L = update_coefficients(L, u, p, t)` for out-of-place operator update

SciMLOperators also overloads `Base.*`, `LinearAlgebra.mul!`,
`LinearAlgebra.ldiv!` for operator evaluation without updating operator state.
An `AbstractSciMLOperator` behaves like a matrix in these methods.
Allocation-free methods, suffixed with a `!` often need cache arrays.
To precache an `AbstractSciMLOperator`, call the function
`L = cache_operator(L, input_vector)`.

## Required Interface For Subtypes

A concrete subtype must define `Base.size(L)` and one of the following
application paths:

  - `Base.:*(L, v)` for out-of-place matrix-like application.
  - `LinearAlgebra.mul!(w, L, v)` and, when `has_mul!(L)` is `true`,
    `LinearAlgebra.mul!(w, L, v, α, β)` for in-place application.
  - `Base.convert(AbstractMatrix, L)` when `isconvertible(L)` is `true`.

If the operator state depends on `(u, p, t)` or accepted keyword arguments,
the subtype must implement `update_coefficients` for out-of-place state
updates or `update_coefficients!` for in-place state updates. The out-of-place
form returns a new operator and leaves `L` unchanged; the in-place form
returns `nothing`. Composite operators assume these update methods may be
called recursively on every operator returned by `getops(L)`.

The positional arguments are forwarded unchanged through a composite
operator. `u` is the state supplied by the caller and is not necessarily the
same shape as the action vector `v`; an operator whose action is nonlinear in
`v` should generally use `FunctionOperator` and report `islinear(L) == false`.
For a constant leaf, the default update is a no-op. A stateful leaf must
override `isconstant` rather than inheriting the empty-child default.

Subtypes that need preallocated work arrays for allocation-free application
must implement `cache_self(L, v)` for their own caches, `cache_internals(L, v)`
for child-operator caches, or both. `cache_operator(L, v)` calls these hooks
and downstream solvers may call it before repeated `mul!` evaluations.

## Caching Rules

`cache_operator(L, v)` may return either `L` or a cached replacement. A
subtype that advertises `has_mul!(L) == true` must ensure the cached result is
ready for repeated `mul!` calls with compatible vectors. Cache hooks may not
change the mathematical action, dimensions, or trait values of the operator.
A cached operator's scratch is mutable and is not safe to use concurrently
unless the subtype explicitly provides that guarantee.

Composite types expose their children through the developer-facing `getops`
method. A new composite must forward state updates, caching, and traits to
every child that contributes to its action. The public action must remain
unchanged by flattening, caching, or updating the composition.

## Trait Rules

Trait functions such as `isconstant`, `islinear`, `isconvertible`,
`has_concretization`, `has_mul`, `has_mul!`, `has_ldiv`, and `has_ldiv!`
are part of the public operator interface. A trait returning `true` is a
promise that the corresponding operation is valid for inputs with compatible
sizes. For example, `has_mul!(L)` means `mul!(w, L, v)` is available, and
`has_concretization(L)` means either `convert(AbstractMatrix, L)` or
`convert(Number, L)` can materialize the operator state without changing its
mathematical action.

`isconstant(L)` means repeated calls to `update_coefficients[!]` are not
required to keep `L` current. `islinear(L)` means the action is linear in
the vector being multiplied; state dependence on `(u, p, t)` is still allowed
for a linear operator.

## Keyword Arguments

When an operator accepts keywords during updates, its constructor must record
the accepted names with `accepted_kwargs`, normally as
`Val((:name1, :name2))`. Composite operators forward only those accepted
keywords to each component. Extension authors must therefore accept
`(u, p, t; kwargs...)` consistently in every update and application method
they advertise. An unlisted keyword must not be silently passed to a leaf
update function.

## Standard Actions

The behavior of a `SciMLOperator` is
indistinguishable from an `AbstractMatrix`. These operators can be
passed to linear solver packages, and even to ordinary differential
equation solvers. The list of overloads to the `AbstractMatrix`
interface includes, but is not limited to, the following:

  - `Base: size, zero, one, +, -, *, /, \\, ∘, inv, adjoint, transpose, convert`
  - `LinearAlgebra: mul!, ldiv!, lmul!, rmul!, factorize, issymmetric, ishermitian, isposdef`
  - `SparseArrays: sparse, issparse`

## Multidimensional arrays and batching

SciMLOperator can also be applied to `AbstractMatrix` subtypes where
operator-evaluation is done column-wise.

```julia
using LinearAlgebra, SciMLOperators

N = 4
K = 10
L = MatrixOperator(Matrix(I, N, N))
u_mat = rand(N, K)

v_mat = L(u_mat, nothing, nothing, 0.0)
size(v_mat) == (N, K) # true
```

`L` can also be applied to `AbstractArray`s that are not
`AbstractVecOrMat`s so long as their size in the first dimension is appropriate
for matrix-multiplication. Internally, `SciMLOperator`s reshapes an
`N`-dimensional array to an `AbstractMatrix`, and applies the operator via
matrix-multiplication.

## Operator update

This package can also be used to write state-dependent, time-dependent, and
parameter-dependent operators, whose state can be updated per
a user-defined function.
The updates can be done in-place, i.e. by mutating the object,
or out-of-place, i.e. in a non-mutating, `Zygote`-compatible way.

For example,

```julia
using LinearAlgebra, SciMLOperators

n = 4
v = rand(n)
u = rand(n)
p = rand(n)
t = rand()

# out-of-place update
mat_update_func = (A, u, p, t) -> t * (p * u')
sca_update_func = (a, u, p, t) -> t * sum(p)

M = MatrixOperator(zeros(n, n); update_func = mat_update_func)
α = ScalarOperator(0.0; update_func = sca_update_func)

L = α * M
L = cache_operator(L, v)

# L is initialized with zero state
L * v == zeros(n) # true

# update operator state with `(u, p, t)`
L = update_coefficients(L, u, p, t)
# and multiply
L * v != zeros(n) # true

# updates state and evaluates L*v at (u, p, t)
L(v, u, p, t) != zeros(n) # true
```

The out-of-place evaluation function `L(v, u, p, t)` calls
`update_coefficients` under the hood, which recursively calls
the `update_func` for each component `SciMLOperator`.
Therefore, the out-of-place evaluation function is equivalent to
calling `update_coefficients` followed by `Base.*`. Notice that
the out-of-place evaluation does not return the updated operator.

On the other hand, the in-place evaluation function, `L(w, v, u, p, t)`,
mutates `L`, and is equivalent to calling `update_coefficients!`
followed by `mul!`. The in-place update behavior works the same way,
with a few `<!>`s appended here and there. For example,

```julia
using LinearAlgebra, SciMLOperators

n = 4
w = rand(n)
v = rand(n)
u = rand(n)
p = rand(n)
t = rand()

# in-place update
_A = rand(n, n)
mat_update_func! = (A, u, p, t) -> (copy!(A, _A); lmul!(t, A); nothing)

M = MatrixOperator(zeros(n, n); update_func! = mat_update_func!)

L = M
L = cache_operator(L, v)

# L is initialized with zero state
L * v == zeros(n) # true

# update L in-place
update_coefficients!(L, v, p, t)
# and multiply
mul!(w, L, v) != zeros(n) # true

# updates L in-place, and evaluates w=L*v at (u, p, t)
L(w, v, u, p, t) != zeros(n) # true
```

The update behavior makes this package flexible enough to be used
in `OrdinaryDiffEq`. As the parameter object `p` is often reserved
for sensitivity computation via automatic-differentiation, a user may
prefer to pass in state information via other arguments. For that
reason, we allow update functions with arbitrary keyword arguments.

```julia
using SciMLOperators

n = 4
v = rand(n)
u = rand(n)
p = rand(n)
t = 0.0
mat_update_func = (A, u, p, t; scale = 0.0) -> scale * (p * u')

M = MatrixOperator(zeros(n, n); update_func = mat_update_func,
    accepted_kwargs = Val((:scale,)))

M(v, u, p, t) == zeros(n) # true
M(v, u, p, t; scale = 1.0) != zeros(n)
```
"""
abstract type AbstractSciMLOperator{T} end

"""
    AbstractSciMLScalarOperator{T} <: AbstractSciMLOperator{T}

Abstract interface for a scalar-valued linear scaling operator.

# Interface Rules

Subtypes must provide `convert(Number, operator)` for their current scalar
value and `eltype` through the type parameter `T`. Scalar application to an
array must preserve the array shape. If the subtype is stateful, its update
methods use the same `(u, p, t; kwargs...)` contract as
[`AbstractSciMLOperator`](@ref): the out-of-place form returns a new scalar
operator, while the in-place form mutates the operator and returns `nothing`.

`islinear` describes linearity in the array being scaled. `has_ldiv` and
`has_ldiv!` may be true only when the current scalar value is invertible.
Scalar addition, multiplication, division, and inversion remain lazy so that
later updates affect the composed expression. Use `ScalarOperator` when a
premade implementation is sufficient.

# Examples

```julia
using SciMLOperators

struct MutableScale <: AbstractSciMLScalarOperator{Float64}
    value::Float64
end

Base.convert(::Type{Number}, L::MutableScale) = L.value
Base.:*(L::MutableScale, v::AbstractArray) = L.value .* v
SciMLOperators.islinear(::MutableScale) = true

L = MutableScale(2.0)
L * [3.0, 4.0]
concretize(L) == 2.0
```

Use `ScalarOperator` to construct a concrete scalar operator. Custom scalar
operator types should only claim traits such as `has_ldiv` when the converted
scalar has the corresponding operation for the current state.
"""
abstract type AbstractSciMLScalarOperator{T} <: AbstractSciMLOperator{T} end

include("utils.jl")
include("interface.jl")
include("left.jl")

include("scalar.jl")
include("matrix.jl")
include("basic.jl")
include("block.jl")
include("batch.jl")
include("func.jl")
include("tensor.jl")
include("woperator.jl")
include("adapt.jl")
include("precompile.jl")

export
    IdentityOperator,
    NullOperator,
    ScalarOperator,
    MatrixOperator,
    DiagonalOperator,
    InvertibleOperator,
    AffineOperator,
    AddVector,
    FunctionOperator,
    BlockDiagonalOperator,
    TensorProductOperator,
    TensorSumOperator,
    WOperator,
    StaticWOperator,
    jacobian_stale,
    mark_jacobian_updated!,
    mark_jacobian_current!

export update_coefficients!,
    update_coefficients, isconstant,
    iscached,
    cache_operator, issquare,
    islinear,
    concretize,
    isconvertible, has_adjoint,
    has_expmv,
    has_expmv!,
    has_exp,
    has_mul,
    has_mul!,
    has_ldiv,
    has_ldiv!,
    has_concretization,
    kronsum

# Documented but not exported: core abstract types, lazy-algebra result types,
# and developer extension hooks used through qualified access downstream.
@public AbstractSciMLOperator, AbstractSciMLScalarOperator,
    AbstractWOperator,
    ScaledOperator, AddedOperator, ComposedOperator,
    InvertedOperator, AdjointOperator, TransposedOperator,
    AddedScalarOperator, ComposedScalarOperator, InvertedScalarOperator,
    has_tensor_outer_mul_fast, tensor_outer_mul_fast!,
    getcache, update_cache, adopt_cache

end # module

#

###
# kwarg filter
###

"""
$SIGNATURES

This type indicates to `preprocess_update_func` to not to filter keyword
arguments. Required in implementation of lazy `Base.adjoint`,
`Base.conj`, `Base.transpose`.
"""
struct NoKwargFilter end

function preprocess_update_func(update_func, accepted_kwargs)
    # Convert accepted_kwargs to Val for compile-time kwarg filtering to avoid allocations
    _accepted_kwargs = if accepted_kwargs === nothing
        Val(())
    elseif accepted_kwargs isa Tuple
        # Deprecation: Encourage users to use Val((...)) directly for better performance
        @warn """Passing accepted_kwargs as a plain Tuple is deprecated and will be removed in a future version.
        Please use Val((...)) instead for zero-allocation kwarg filtering.
        Example: accepted_kwargs = Val((:dtgamma,)) instead of accepted_kwargs = (:dtgamma,)
        This message will only be shown once per session.""" maxlog = 1
        Val(accepted_kwargs)
    else
        accepted_kwargs  # Already a Val or NoKwargFilter
    end
    # accepted_kwargs can be passed as nothing to indicate that we should not filter
    # (e.g. if the function already accepts all kwargs...).
    return (_accepted_kwargs isa NoKwargFilter) ? update_func :
        FilterKwargs(update_func, _accepted_kwargs)
end

update_func_isconstant(::Nothing) = true
function update_func_isconstant(update_func)
    if update_func isa FilterKwargs
        return update_func.f === DEFAULT_UPDATE_FUNC || update_func.f === nothing
    else
        return update_func === DEFAULT_UPDATE_FUNC
    end
end

# Keyword argument filtering
struct FilterKwargs{F, K}
    f::F
    accepted_kwargs::K
end

# Filter keyword arguments to those accepted by function.
# Avoid throwing errors here if a keyword argument is not provided: defer
# this to the function call for a more readable error.
function get_filtered_kwargs(
        kwargs::AbstractDict,
        accepted_kwargs::NTuple{N, Symbol}
    ) where {N}
    return (kw => kwargs[kw] for kw in accepted_kwargs if haskey(kwargs, kw))
end
function get_filtered_kwargs(
        kwargs::Union{AbstractDict, NamedTuple},
        ::Val{accepted_kwargs}
    ) where {accepted_kwargs}
    kwargs_nt = NamedTuple(kwargs)
    # Only extract keys that exist in kwargs_nt to avoid errors
    filtered_keys = filter(k -> haskey(kwargs_nt, k), accepted_kwargs)
    return NamedTuple{filtered_keys}(kwargs_nt)
end

function (f::FilterKwargs)(args...; kwargs...)
    filtered_kwargs = get_filtered_kwargs(kwargs, f.accepted_kwargs)
    return f.f(args...; filtered_kwargs...)
end

isnothingfunc(f::FilterKwargs) = isnothingfunc(f.f)
isnothingfunc(f::Nothing) = true
isnothingfunc(f) = false
#

_unwrap_val(x) = x
_unwrap_val(::Val{X}) where {X} = X

"""
$SIGNATURES

Return whether `L` can be materialized into a concrete scalar or matrix
representation for fallback operations.

# Arguments

  - `L`: An operator-like object.

# Returns

`true` when `concretize(L)` is expected to succeed by calling
`convert(AbstractMatrix, L)` or `convert(Number, L)`, and `false` otherwise.

# Interface Rules

Subtypes of `AbstractSciMLOperator` should define `has_concretization(L)` as
`true` only when their current state can be materialized without changing the
operator action. Composite operators should return `true` only when every
component needed for the materialization also has concretization.

This trait is intentionally separate from `isconvertible(L)`: an operator can
have a correct concrete representation but avoid cheap eager fusion in generic
algebra paths.

# Examples

```julia
using SciMLOperators

A = MatrixOperator([1.0 2.0; 3.0 4.0])
has_concretization(A) # true

F = FunctionOperator((y, x, u, p, t) -> copyto!(y, x), zeros(2), zeros(2);
    isinplace = true, T = Float64, islinear = true)
has_concretization(F) # false
```
"""
has_concretization(::AbstractSciMLOperator) = false
has_concretization(::Union{AbstractMatrix, UniformScaling, Factorization, Number}) = true

using SciMLOperators, LinearAlgebra
using Random
using Test

Random.seed!(0)
@testset "WOperator" begin
    J = rand(12, 12)
    u = rand(12)
    M = I(12)
    gamma = 1 / 123
    W = WOperator{true}(M, gamma, J, u)

    @test convert(AbstractMatrix, W) ≈ J - M / gamma

    # Scalar WOperator
    J_scalar = ScalarOperator(2.0)
    gamma_scalar = 0.5
    u_scalar = 1.0
    W_scalar = WOperator{false}(I, gamma_scalar, J_scalar, u_scalar)
    @test convert(Number, W_scalar) ≈ 2.0 - 1.0 / 0.5

    # Update and convert again
    update_coefficients!(W_scalar; gamma = 0.25)
    @test convert(Number, W_scalar) ≈ 2.0 - 1.0 / 0.25

    # Test deprecated dtgamma kwarg on WOperator
    W_scalar2 = WOperator{false}(I, 0.5, ScalarOperator(2.0), 1.0)
    @test_deprecated update_coefficients!(W_scalar2; dtgamma = 0.25)
    @test convert(Number, W_scalar2) ≈ 2.0 - 1.0 / 0.25

    # OOP WOperator with a MatrixOperator mass matrix: convert(AbstractMatrix, W)
    # must materialize the mass matrix so the result fits in the
    # Matrix-typed _concrete_form slot (issue #396).
    n = 3
    mm_data = randn(n, n)
    update_mm!(A, u, p, t) = (A[1, 1] = cos(t); A[2, 2] = u[1]; A)
    update_mm(A, u, p, t) = (B = copy(A); update_mm!(B, u, p, t); B)
    mm_op = MatrixOperator(
        copy(mm_data); update_func = update_mm, update_func! = update_mm!,
    )
    J_mm = randn(n, n)
    u_mm = randn(n)
    gamma_mm = 0.1
    W_mm = WOperator{false}(mm_op, gamma_mm, J_mm, u_mm)
    W_ref = -convert(AbstractMatrix, mm_op) / gamma_mm + J_mm
    @test convert(AbstractMatrix, W_mm) ≈ W_ref
    # Re-materialization after update_coefficients!
    update_coefficients!(W_mm, randn(n), nothing, 1.5; gamma = 0.2)
    W_ref2 = -convert(AbstractMatrix, W_mm.mass_matrix) / 0.2 + J_mm
    @test convert(AbstractMatrix, W_mm) ≈ W_ref2
    # And `\` works end-to-end
    b = randn(n)
    @test W_mm \ b ≈ convert(AbstractMatrix, W_mm) \ b

    # In-place WOperator with an operator-typed Jacobian: no external caller
    # maintains _concrete_form (jacobian2W! only handles plain-matrix J), so
    # convert must rebuild it with the current gamma. Regression test for the
    # silently-stale form built at init with gamma = 0 (Inf diagonal), see
    # SciML/OrdinaryDiffEq.jl#3933.
    J_op = MatrixOperator(randn(n, n))
    W_op = WOperator{true}(I(n), 0.0, J_op, randn(n))
    update_coefficients!(W_op; gamma = 0.25)
    @test convert(AbstractMatrix, W_op) ≈ -Matrix(1.0I, n, n) / 0.25 +
        convert(AbstractMatrix, J_op)
    @test all(isfinite, convert(AbstractMatrix, W_op))
    # Rebuilt again after gamma changes
    update_coefficients!(W_op; gamma = 0.5)
    @test convert(AbstractMatrix, W_op) ≈ -Matrix(1.0I, n, n) / 0.5 +
        convert(AbstractMatrix, J_op)

    J_sum = MatrixOperator(randn(n, n)) + MatrixOperator(randn(n, n))
    W_sum = WOperator{true}(I, 0.0, J_sum, randn(n))
    update_coefficients!(W_sum; gamma = 0.25)
    @test convert(AbstractMatrix, W_sum) ≈ -Matrix(1.0I, n, n) / 0.25 +
        convert(AbstractMatrix, J_sum)
    update_coefficients!(W_sum; gamma = 0.5)
    @test convert(AbstractMatrix, W_sum) ≈ -Matrix(1.0I, n, n) / 0.5 +
        convert(AbstractMatrix, J_sum)

    # Tensor-product Jacobian graph (the OrdinaryDiffEq AMF fd2d shape). Unlike
    # the AddedOperator of MatrixOperators above, these report
    # `isconvertible == false` yet still convert to an AbstractMatrix.
    N = 4
    h = 1 / (N + 1)
    D_op = MatrixOperator((1 / h^2) * Tridiagonal(ones(N - 1), -2 * ones(N), ones(N - 1)))
    J_kron = cache_operator(
        0.1 * Base.kron(D_op, IdentityOperator(N)) +
            0.1 * Base.kron(IdentityOperator(N), D_op),
        zeros(N^2)
    )
    @test !isconvertible(J_kron)
    W_kron = WOperator{true}(I, 1.0, J_kron, randn(N^2))
    update_coefficients!(W_kron; gamma = 0.25)
    @test convert(AbstractMatrix, W_kron) ≈ -Matrix(1.0I, N^2, N^2) / 0.25 +
        convert(AbstractMatrix, J_kron)
end

@testset "WOperator isconvertible honesty" begin
    n = 5
    u = rand(n)
    gamma = 0.1
    Mmat = Matrix(1.0I, n, n)
    concrete_J = MatrixOperator(rand(n, n))
    # A matrix-free operator: only `mul!`, no `convert(AbstractMatrix, ·)`.
    matfree(A) = FunctionOperator(
        (w, v, p, t) -> mul!(w, A, v), zeros(n), zeros(n); islinear = true
    )
    matfree_J = matfree(rand(n, n))
    matfree_M = matfree(Mmat)

    @test isconvertible(matfree_J) == false
    # `W` is convertible only when both the mass matrix and the Jacobian are; a matrix-free
    # part on either side makes `W` matrix-free (previously `isconvertible(W)` was vacuously
    # `true` because `getops(W) == ()`).
    @test isconvertible(WOperator{true}(Mmat, gamma, concrete_J, u)) == true
    @test isconvertible(WOperator{true}(Mmat, gamma, matfree_J, u)) == false
    @test isconvertible(WOperator{true}(matfree_M, gamma, concrete_J, u)) == false
end

@testset "Jacobian staleness flag" begin
    n = 6
    J = rand(n, n)
    u = rand(n)
    W = WOperator{true}(I, 0.25, J, u)

    # Starts stale: nobody has factorized this Jacobian yet.
    @test jacobian_stale(W)
    @test mark_jacobian_current!(W) === W
    @test !jacobian_stale(W)

    # A new gamma is visible in the field; an in-place write to J is not, which is the
    # whole reason the flag exists.
    update_coefficients!(W; gamma = 0.5)
    @test !jacobian_stale(W)

    J .= rand(n, n)
    @test mark_jacobian_updated!(W) === W
    @test jacobian_stale(W)
    mark_jacobian_updated!(W)
    @test jacobian_stale(W)          # idempotent, unlike a counter
    mark_jacobian_current!(W)
    @test !jacobian_stale(W)

    mark_jacobian_updated!(W)
    @test jacobian_stale(copy(W))

    # For the in-place, plain-matrix case `_concrete_form` is maintained by the owner
    # (OrdinaryDiffEq's `jacobian2W!`), so `Matrix(W)` is deliberately stale after an
    # in-place write to `J` — which is the invisibility the flag exists to cover.
    @test !(Matrix(W) ≈ J - Matrix(I(n)) / 0.5)
    Wop = WOperator{true}(I, 0.5, MatrixOperator(J), u)
    @test Matrix(Wop) ≈ J - Matrix(I(n)) / 0.5

    # Safe to call unconditionally on anything; conservatively stale when untracked.
    A = rand(2, 2)
    @test mark_jacobian_updated!(A) === A
    @test mark_jacobian_current!(A) === A
    @test jacobian_stale(A)
    @test jacobian_stale(nothing)
end

using SciMLOperators
using SciMLOperators: AbstractSciMLScalarOperator,
    ComposedScalarOperator,
    AddedScalarOperator,
    InvertedScalarOperator,
    IdentityOperator,
    AddedOperator,
    ScaledOperator

using LinearAlgebra, Random, Test
using ArrayInterface

Random.seed!(0)
N = 8
K = 12

@testset "ScalarOperator Basic Operations" begin
    a = rand()
    b = rand()
    x = rand()
    α = ScalarOperator(x)
    u = rand(N, K)

    @test α isa ScalarOperator
    @test iscached(α)
    @test issquare(α)
    @test islinear(α)

    @test convert(Float32, α) isa Float32
    @test convert(ScalarOperator, a) isa ScalarOperator

    @test size(α) == ()
    @test isconstant(α)
    @test !ArrayInterface.issingular(α)
    @test ArrayInterface.issingular(ScalarOperator(0.0))

    # Original lmul!/rmul! tests
    v = copy(u)
    @test lmul!(α, u) ≈ v * x
    v = copy(u)
    @test rmul!(u, α) ≈ x * v

    # Original mul!/ldiv! tests
    v = rand(N, K)
    @test mul!(v, α, u) ≈ u * x
    v = rand(N, K)
    w = copy(v)
    @test mul!(v, α, u, a, b) ≈ a * (x * u) + b * w

    v = rand(N, K)
    @test ldiv!(v, α, u) ≈ u / x
    w = copy(u)
    @test ldiv!(α, u) ≈ w / x

    # Original axpy! test
    X = rand(N, K)
    Y = rand(N, K)
    Z = copy(Y)
    a_scalar = rand()
    aa = ScalarOperator(a_scalar)
    @test axpy!(aa, X, Y) ≈ a_scalar * X + Z

    expα = exp(α)
    @test expα isa ScalarOperator
    @test convert(Number, expα) ≈ exp(x)
    @test expα * u ≈ exp(x) * u

    # Tests with the new interface
    v = copy(u)  # Action vector
    w = zeros(N, K)  # Output vector

    # Test with new interface
    result = α(v, u, nothing, 0.0)
    @test result ≈ v * x

    # Test in-place operations
    α(w, v, u, nothing, 0.0)
    @test w ≈ v * x

    # Test in-place operations with scaling
    orig_w = rand(N, K)
    copy!(w, orig_w)
    α(w, v, u, nothing, 0.0, a, b)
    @test w ≈ a * (x * v) + b * orig_w

    # Operations with UniformScalar
    α = ScalarOperator(1)
    @test α * I == α
    @test α + I isa AddedScalarOperator
end

@testset "ScalarOperator Combinations" begin
    x = rand()
    α = ScalarOperator(x)
    u = rand(N, K)  # Update vector
    v = rand(N, K)  # Action vector

    # Test scalar operator combinations
    β = α + α
    @test β isa AddedScalarOperator
    @test β(v, u, nothing, 0.0) ≈ x * v + x * v
    @test β * u ≈ x * u + x * u  # Original style test
    @inferred convert(Float32, β)
    @test convert(Number, β) ≈ x + x

    β = α * α
    @test β isa ComposedScalarOperator
    @test β(v, u, nothing, 0.0) ≈ x * x * v
    @test β * u ≈ x * x * u  # Original style test
    @inferred convert(Float32, β)
    @test convert(Number, β) ≈ x * x

    β = inv(α)
    @test β isa InvertedScalarOperator
    @test β(v, u, nothing, 0.0) ≈ (1 / x) * v
    @test β * u ≈ (1 / x) * u  # Original style test
    @inferred convert(Float32, β)
    @test convert(Number, β) ≈ 1 / x

    β = α * inv(α)
    @test β isa ComposedScalarOperator
    @test β * u ≈ u
    @inferred convert(Float32, β)
    @test convert(Number, β) ≈ true

    β = α / α
    @test β isa ComposedScalarOperator
    @test β * u ≈ u
    @inferred convert(Float32, β)
    @test convert(Number, β) ≈ true

    β = exp(α + α)
    @test β isa ScalarOperator
    @test β(v, u, nothing, 0.0) ≈ exp(2x) * v

    # Test combination with other operators
    for op in (MatrixOperator(rand(N, N)), SciMLOperators.IdentityOperator(N))
        @test α + op isa SciMLOperators.AddedOperator
        @test (α + op) * u ≈ x * u + op * u

        L = α + op
        @test L isa SciMLOperators.AddedOperator
        @test L(v, u, nothing, 0.0) ≈ x * v + op * v

        @test α * op isa SciMLOperators.ScaledOperator
        @test (α * op) * u ≈ x * (op * u)

        L = α * op
        @test L isa SciMLOperators.ScaledOperator
        @test L(v, u, nothing, 0.0) ≈ x * (op * v)

        # Division tests from original
        @test all(
            map(
                T -> (T isa SciMLOperators.ScaledOperator),
                (α / op, op / α, op \ α, α \ op)
            )
        )
        @test (α / op) * u ≈ (op \ α) * u ≈ α * (op \ u)
        @test (op / α) * u ≈ (α \ op) * u ≈ 1 / α * op * u
    end

    # Test for ComposedScalarOperator nesting (from original)
    α_new = ScalarOperator(rand())
    L = α_new * (α_new * α_new) * α_new
    @test L isa ComposedScalarOperator
    for op in L.ops
        @test !isa(op, ComposedScalarOperator)
    end
end

@testset "ScalarOperator scalar argument test" begin
    a = rand()
    u = rand()  # Update scalar
    v = rand()  # Action scalar
    p = nothing
    t = 0.0

    α = ScalarOperator(a)
    @test_throws MethodError α(u, p, t) ≈ u * a  # Original style
    @test α(v, u, p, t) ≈ v * a  # New interface
    @test_throws ArgumentError α(v, u, p, t, 1, 2)  # Keep error test
end

@testset "ScalarOperator update test" begin
    u = ones(N, K)  # Update vector
    v = ones(N, K)  # Action vector
    w = zeros(N, K)  # Output vector
    p = 2.0
    t = 4.0

    c = rand()
    d = rand()

    α = ScalarOperator(0.0; update_func = (a, u, p, t) -> p)
    β = ScalarOperator(0.0; update_func = (a, u, p, t) -> t)

    @test !isconstant(α)
    @test !isconstant(β)

    @test convert(Float32, α) isa Float32
    @test convert(Float32, β) isa Float32

    @test convert(Number, α) ≈ 0.0
    @test convert(Number, β) ≈ 0.0

    # Test update_coefficients
    update_coefficients!(α, u, p, t)
    update_coefficients!(β, u, p, t)

    @test convert(Number, α) ≈ p
    @test convert(Number, β) ≈ t

    # Original style tests
    @test_throws MethodError α(u, p, t) ≈ p * u
    @test_throws MethodError β(u, p, t) ≈ t * u

    # Tests with new interface
    @test α(v, u, p, t) ≈ p * v
    @test β(v, u, p, t) ≈ t * v

    # Test in-place with scaling
    orig_w = rand(N, K)
    copy!(w, orig_w)
    α(w, v, u, p, t, c, d)
    @test w ≈ c * p * v + d * orig_w

    # Retain original test with random vectors
    v_rand = rand(N, K)
    @test α(v_rand, u, p, t) ≈ p * v_rand
    v_rand = rand(N, K)
    w_rand = copy(v_rand)
    @test_broken α(v_rand, u, p, t, c, d) ≈ c * p * u + d * w_rand

    # Test operator combinations
    num = α + 2 / β * 3 - 4
    val = p + 2 / t * 3 - 4

    @test convert(Number, num) ≈ val

    # Test with keyword arguments
    γ = ScalarOperator(
        0.0; update_func = (args...; dtgamma) -> dtgamma,
        accepted_kwargs = Val((:dtgamma,))
    )

    dtgamma = rand()
    # Original tests
    @test_throws MethodError γ(u, p, t; dtgamma) ≈ dtgamma * u

    # New interface tests
    @test γ(v, u, p, t; dtgamma) ≈ dtgamma * v

    # In-place test with keywords
    w_test = zeros(N, K)
    γ(w_test, v, u, p, t; dtgamma)
    @test w_test ≈ dtgamma * v

    γ_added = γ + α
    # Original tests
    @test_throws MethodError γ_added(u, p, t; dtgamma) ≈ (dtgamma + p) * u

    # New interface tests
    @test γ_added(v, u, p, t; dtgamma) ≈ (dtgamma + p) * v

    # In-place test with keywords for combined operator
    w_test = zeros(N, K)
    γ_added(w_test, v, u, p, t; dtgamma)
    @test w_test ≈ (dtgamma + p) * v

    # In-place test with scaling and keywords
    w_test = rand(N, K)
    w_orig = copy(w_test)
    γ_added(w_test, v, u, p, t, c, d; dtgamma)
    @test w_test ≈ c * (dtgamma + p) * v + d * w_orig

    δ = exp(γ)
    @test δ(v, u, p, t; dtgamma) ≈ exp(dtgamma) * v
end

#

###
# operator update interface
###

"""
$SIGNATURES

The default update function for `AbstractSciMLOperator`s, a no-op that
leaves the operator state unchanged.

# Arguments

  - `A`: Current operator state.
  - `u`: State or update vector supplied by the caller.
  - `p`: Parameter object supplied by the caller.
  - `t`: Time or other scalar update value.

# Returns

The unchanged value `A`. The positional update arguments are accepted so this
function can be used wherever an operator update function is expected.
"""
DEFAULT_UPDATE_FUNC(A, u, p, t) = A

const UPDATE_COEFFS_WARNING = """
!!! warning
    The user-provided `update_func[!]` must not use `u` in
    its computation. Positional argument `(u, p, t)` to `update_func[!]` are
    passed down by `update_coefficients[!](L, u, p, t)`, where `u` is the
    input-vector to the composite `AbstractSciMLOperator`. For that reason,
    the values of `u`, or even shape, may not correspond to the input
    expected by `update_func[!]`. If an operator's state depends on its
    input vector, then it is, by definition, a nonlinear operator.
    We recommend sticking such nonlinearities in `FunctionOperator.`
    This topic is further discussed in
    [this issue](https://github.com/SciML/SciMLOperators.jl/issues/159).
"""

"""
$SIGNATURES

Update the state of `L` based on `u`, input vector, `p` parameter object,
`t`, and keyword arguments. Internally, `update_coefficients` calls the
user-provided `update_func` method for every component operator in `L`
with the positional arguments `(u, p, t)` and keyword arguments
corresponding to the symbols provided to the operator via kwarg
`accepted_kwargs`.

This method is out-of-place, i.e. fully non-mutating and `Zygote`-compatible.

$(UPDATE_COEFFS_WARNING)

# Arguments

  - `L`: Operator whose state should be updated.
  - `u`: State or update vector supplied to the operator.
  - `p`: Parameter object supplied to the operator.
  - `t`: Time or other scalar update value.

# Keyword Arguments

  - `kwargs...`: Keywords accepted by the operator's update function and
    recorded by its `accepted_kwargs` constructor option.

# Returns

A new operator representing the updated state. `L` is not mutated.

# Examples

```
using SciMLOperators

mat_update_func = (A, u, p, t; scale = 1.0) -> p * p' * scale * t

M = MatrixOperator(zeros(4,4); update_func = mat_update_func,
                   accepted_kwargs = Val((:scale,)))

L = M + IdentityOperator(4)

u = rand(4)
p = rand(4)
t = 1.0
v = rand(4)

# Update the operator to `(u,p,t)` and apply it to `v`
L = update_coefficients(L, u, p, t; scale = 2.0)
result = L * v

# Or use the interface which separates the update from the application
result = L(v, u, p, t; scale = 2.0)
```
"""
update_coefficients(L, u, p, t; kwargs...) = L

"""
$SIGNATURES

Update in-place the state of `L` based on `u`, input vector, `p` parameter
object, `t`, and keyword arguments. Internally, `update_coefficients!` calls
the user-provided mutating `update_func!` method for every component operator
in `L` with the positional arguments `(u, p, t)` and keyword arguments
corresponding to the symbols provided to the operator via kwarg
`accepted_kwargs`.

$(UPDATE_COEFFS_WARNING)

# Arguments

  - `L`: Operator whose state should be updated.
  - `u`: State or update vector supplied to the operator.
  - `p`: Parameter object supplied to the operator.
  - `t`: Time or other scalar update value.

# Keyword Arguments

  - `kwargs...`: Keywords accepted by the operator's mutating update function
    and recorded by its `accepted_kwargs` constructor option.

# Returns

`nothing`. The operator `L` is mutated in place.

# Examples

```
using SciMLOperators

_A = rand(4, 4)
mat_update_func! = (A, u, p, t; scale = 1.0) -> copy!(A, _A)

M = MatrixOperator(zeros(4,4); update_func! = mat_update_func!)

L = M + IdentityOperator(4)

u = rand(4)
p = rand(4)
t = 1.0
v = rand(4)

update_coefficients!(L, u, p, t)
L * v
```
"""
update_coefficients!(L, u, p, t; kwargs...) = nothing

# We cannot use @generate because we don't know the type structure of L in advance
function update_coefficients!(L::AbstractSciMLOperator, u, p, t; kwargs...)
    foreach(op -> update_coefficients!(op, u, p, t; kwargs...), getops(L))

    return nothing
end

###
# operator evaluation interface
###

# Out-of-place: v is action vector, u is update vector
function (L::AbstractSciMLOperator)(v, u, p, t; kwargs...)
    return update_coefficients(L, u, p, t; kwargs...) * v
end
# In-place: w is destination, v is action vector, u is update vector
function (L::AbstractSciMLOperator)(w, v, u, p, t; kwargs...)
    (update_coefficients!(L, u, p, t; kwargs...); mul!(w, L, v))
end
# In-place with scaling: w = α*(L*v) + β*w
function (L::AbstractSciMLOperator)(w, v, u, p, t, α, β; kwargs...)
    (update_coefficients!(L, u, p, t; kwargs...); mul!(w, L, v, α, β))
end

function (L::AbstractSciMLOperator)(w::Number, v::Number, u, p, t, args...; kwargs...)
    msg = """Nonallocating L(w, v, u, p, t) type methods are not available for
    subtypes of `Number`."""
    throw(ArgumentError(msg))
end

###
# operator caching interface
###

getops(L) = ()

"""
$SIGNATURES

Checks whether `L` has preallocated caches for inplace evaluations.

# Arguments

  - `L`: Operator to inspect. For a composite, all child caches are checked.

# Returns

`true` when the operator and every child needed for in-place evaluation has a
usable cache, otherwise `false`.
"""
function iscached(L::AbstractSciMLOperator)
    has_cache = hasfield(typeof(L), :cache) # TODO - confirm this is static
    isset = has_cache ? !isnothing(L.cache) : true

    return isset & all(iscached, getops(L))
end

"""
Check if `SciMLOperator` `L` has preallocated cache-arrays for in-place
computation.
"""
iscached(L) = true

iscached(
    ::Union{# LinearAlgebra
        AbstractMatrix,
        UniformScaling,
        Factorization, # Base
        Number,
    }
) = true

"""
$SIGNATURES

Allocate caches for `L` for in-place evaluation with `u`-like input vectors.

# Arguments

  - `L`: Operator to prepare.
  - `u`: Prototype vector or matrix whose shape determines compatible scratch.

# Returns

`L` or a cached replacement. The returned operator must have the same action,
size, and trait values as the input operator.

# Interface Rules

Call this before repeated `mul!` or callable in-place evaluations when the
operator needs scratch storage. A custom type that needs storage should
implement `cache_self` for its own buffers and `cache_internals` for child
operators.
"""
cache_operator(L, u) = L

function cache_operator(L::AbstractSciMLOperator, u::AbstractVecOrMat)
    L = cache_self(L, u)
    L = cache_internals(L, u)
    return L
end

cache_self(L::AbstractSciMLOperator, ::AbstractVecOrMat) = L
cache_internals(L::AbstractSciMLOperator, ::AbstractVecOrMat) = L

"""
$SIGNATURES

Return the cache held by `op`, or `nothing` when it holds none.

Defining this method opts `op`'s type into the scratch sharing `AddedOperator` does
between its summands, which is sound because `mul!` applies them strictly serially and no
two of their caches are ever live at once. A summand may then be given the cache of an
earlier one whose cache has the identical type and identically sized slots, so only define
this for operators where two such caches really are interchangeable — including which
slots deliberately alias each other. The `nothing` default keeps a type out of it entirely.

Two further conditions come with defining it. The first is on the operator's own
`cache_self`: it must treat the buffers it is handed as a template to `similar`, `zero` or
`reshape` and never retain a reference to them, since the whole point is that those buffers
may afterwards be replaced by an earlier summand's. Every `cache_self` in this package does.
The second is on the caller: applying the summands of an `AddedOperator` concurrently, by
hand, is no longer safe once they share scratch — a cached operator was never safe to apply
concurrently, but now its summands are not independently safe either.

A wrapper that holds no scratch of its own — `ScaledOperator`, `AdjointOperator`,
`TransposedOperator` — is transparent to all of this and forwards `getcache`,
[`update_cache`](@ref) and [`adopt_cache`](@ref) to the operator it wraps. A new wrapper of
that kind should do the same; without it the operator underneath drops out of sharing even
though its cache would have qualified.

See also [`adopt_cache`](@ref), which additionally spares the operator from allocating a
cache it would only discard.
"""
getcache(::AbstractSciMLOperator) = nothing

"""
$SIGNATURES

Replace `op`'s cache with `new_cache`. Only ever called with a `new_cache` of exactly
the same type as the one it replaces, so `op`'s type is unchanged.

# Arguments

  - `op`: Cached operator whose scratch should be replaced.
  - `new_cache`: Cache with the same type, shape, and aliasing layout as the
    existing cache.

# Returns

An operator with `new_cache` installed. Implementations must preserve the
operator action and type parameters.
"""
update_cache(op::AbstractSciMLOperator, new_cache) = @reset op.cache = new_cache

# Identical cache types already pin element type, layout and device, so only the extents
# are left to check. Anything else is conservatively treated as not interchangeable.
_slots_match(a::AbstractArray, b::AbstractArray) = size(a) == size(b)
_slots_match(::Nothing, ::Nothing) = true
function _slots_match(a::NTuple{N, Any}, b::NTuple{N, Any}) where {N}
    return all(map(_slots_match, a, b)) && _aliasing_matches(a, b)
end
_slots_match(a, b) = false

# Which slots deliberately point at the same buffer is part of the layout, not an accident
# of it: `TensorProductOperator` folds two of its slots into one exactly when both factors
# are square. Comparing the pattern keeps an operator that needs distinct buffers from ever
# being handed a cache that shares one, instead of relying on the sizes to give it away.
function _aliasing_matches(a::NTuple{N, Any}, b::NTuple{N, Any}) where {N}
    return all(
        ntuple(Val(N)) do i
            all(ntuple(j -> (a[i] === a[j]) === (b[i] === b[j]), Val(N)))
        end
    )
end

# Having the same cache type is settled at compile time; only the sizes cost anything at
# run time. Caches of differing type take the second method and are never interchanged.
function _swap_cache(op, mine::C, theirs::C) where {C}
    return _slots_match(mine, theirs) ? update_cache(op, theirs) : nothing
end
_swap_cache(op, mine, theirs) = nothing

# Point an *already cached* `op` at an interchangeable cache held by one of the `earlier`
# summands, so its own buffers can be collected. Leaves `op` alone when nothing matches.
#
# This does not make `op` work — `cache_operator` already did that — it makes it smaller.
# Nothing here describes what a cache ought to look like: the buffers being compared have
# already been allocated, so there is no second description of the layout that could drift
# out of sync with `cache_self`.
_deduplicate_cache(op, ::Tuple{}) = op

function _deduplicate_cache(op, earlier::Tuple)
    mine = getcache(op)
    mine === nothing && return op

    swapped = _swap_cache(op, mine, getcache(first(earlier)))
    swapped === nothing || return swapped

    return _deduplicate_cache(op, Base.tail(earlier))
end

"""
$SIGNATURES

Return `op` set up for in-place use with `v` using `cache` — the cache of an operator
already established as interchangeable with it — instead of allocating buffers of its own.
Return `nothing` to decline, in which case `op` is cached the ordinary way and then offered
the same cache after the fact, which costs an allocation that is immediately discarded.
What comes back must report `cache` as its own — [`getcache`](@ref) on it is checked against
what was handed over, and anything else is treated as having declined, since an
implementation that quietly allocated instead would otherwise skip the ordinary path too.

Declining is the default, because there is no implementation that is correct for every
operator: one that follows the `cache_self`/`cache_internals` split opts in with

    adopt_cache(op::MyOperator, cache, v) = cache_internals(update_cache(op, cache), v)

whereas one that defines its own `cache_operator` must instead do whatever that does, minus
the allocation — the line above would silently skip its internal caching entirely.

Defining this asks more of an operator than [`getcache`](@ref) alone. `getcache` only
claims that two caches of the same type with the same slot sizes are interchangeable, and
that is checked against buffers that already exist. This additionally claims that what
`cache_self` builds is a function of the operator's type, its operands' sizes and `v`, since
that is what the caller compares before any buffer exists. Leave it undefined when the cache
depends on anything else — `FunctionOperator` does, because it sizes buffers from
`traits.sizes`, which `size` does not expose.

# Arguments

  - `op`: Operator that may adopt the supplied cache.
  - `cache`: An interchangeable cache from another operator.
  - `v`: Prototype action vector or matrix used to build child caches.

# Returns

An operator using `cache`, or `nothing` to decline. Returning an operator that
silently allocates a different cache is a contract violation.
"""
adopt_cache(::AbstractSciMLOperator, cache, v) = nothing

# Everything `cache_self` may read: the operator's own size and, recursively, its operands'.
# `adopt_cache`'s contract is that a cache layout follows from the operator's type together
# with these, so equal types and equal signatures mean interchangeable caches.
_shape_signature(x) = ()
_shape_signature(x::AbstractArray) = size(x)
_shape_signature(L::AbstractSciMLOperator) = (size(L), map(_shape_signature, getops(L)))

# Cache `op`, taking the buffers of one of the `donors` outright when they are
# interchangeable, so that nothing is allocated only to be thrown away.
#
# Every donor already shares `op`'s concrete type — the caller settles that at compile time,
# which pins every element type — so only their shape signatures are compared here. The two
# checks are not redundant: `M(8, 8) * M(8, 8)` and `M(8, 16) * M(16, 8)` have identical
# types and identical overall size while needing different cache layouts.
#
# Falls back to caching `op` normally and deduplicating afterwards. That happens when no
# donor fits, and for any type that has not opted into `adopt_cache`.
function _cache_summand(op, donors::Tuple, earlier::Tuple, v)
    adopted = _try_adopt(op, donors, v)
    adopted === nothing || return adopted

    return _deduplicate_cache(cache_operator(op, v), earlier)
end

# Walk the same-typed candidates in order, taking the first whose sizes also line up.
_try_adopt(op, ::Tuple{}, v) = nothing

function _try_adopt(op, donors::Tuple, v)
    donor = first(donors)
    cache = getcache(donor)

    if cache !== nothing && _shape_signature(op) == _shape_signature(donor)
        adopted = adopt_cache(op, cache, v)
        # An `adopt_cache` that comes back reporting something other than the cache it was
        # handed did not use it — it allocated buffers of its own, and taking it at its word
        # would skip the post-hoc path as well and leave the summand sharing nothing. Take
        # the ordinary route instead, where `_deduplicate_cache` still gets its turn.
        if adopted !== nothing && getcache(adopted) === cache
            return adopted
        end
    end

    return _try_adopt(op, Base.tail(donors), v)
end

###
# operator traits
###

Base.size(A::AbstractSciMLOperator, d::Integer) = d <= 2 ? size(A)[d] : 1
Base.eltype(::Type{<:AbstractSciMLOperator{T}}) where {T} = T
Base.eltype(::AbstractSciMLOperator{T}) where {T} = T

_promote_operator_eltype(A, B) = promote_type(eltype(A), eltype(B))

Base.oneunit(L::AbstractSciMLOperator) = one(L)
Base.oneunit(LType::Type{<:AbstractSciMLOperator}) = one(LType)

Base.iszero(::AbstractSciMLOperator) = false # TODO

"""
$SIGNATURES

Check if `adjoint(L)` is lazily defined.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when `adjoint(L)` is supported without relying on an
unadvertised conversion fallback.
"""
has_adjoint(L::AbstractSciMLOperator) = false # L', adjoint(L)
"""
$SIGNATURES

Check if `expmv!(w, L, v, t)`, equivalent to `mul!(w, exp(t * A), v)`, is
defined for `Number` `t`, and `AbstractArray`s `w, v` of appropriate sizes.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when the in-place exponential action is part of the operator's
supported contract.
"""
has_expmv!(L::AbstractSciMLOperator) = false # expmv!(v, L, t, u)
"""
$SIGNATURES

Check if `expmv(L, v, t)`, equivalent to `exp(t * A) * v`, is defined for
`Number` `t`, and `AbstractArray` `u` of appropriate size.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when the out-of-place exponential action is supported.
"""
has_expmv(L::AbstractSciMLOperator) = false # v = exp(L, t, u)
"""
$SIGNATURES

Check if `exp(L)` is defined lazily.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when `exp(L)` is a supported lazy operation.
"""
has_exp(L::AbstractSciMLOperator) = islinear(L)
"""
$SIGNATURES

Check if `L * v` is defined for `AbstractArray` `u` of appropriate size.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when `L * v` is supported for compatible action arrays.
"""
has_mul(L::AbstractSciMLOperator) = true # du = L*u
"""
$SIGNATURES

Check if `mul!(w, L, v)` is defined for `AbstractArray`s `w, v` of
appropriate sizes.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when the in-place multiplication and its return-value contract
are supported for compatible arrays.
"""
has_mul!(L::AbstractSciMLOperator) = true # mul!(du, L, u)
"""
$SIGNATURES

Check if `L \\ v` is defined for `AbstractArray` `v` of appropriate size.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when the out-of-place solve is supported for compatible right-hand
sides.
"""
has_ldiv(L::AbstractSciMLOperator) = false # du = L\u
"""
$SIGNATURES

Check if `ldiv!(w, L, v)` is defined for `AbstractArray`s `w, v` of
appropriate sizes.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when the in-place solve is supported for compatible arrays.
"""
has_ldiv!(L::AbstractSciMLOperator) = false # ldiv!(du, L, u)

### Extra standard assumptions

"""
$SIGNATURES

Checks if an `L`'s state is constant or needs to be updated by calling
`update_coefficients`.

# Arguments

  - `L`: Operator or operator-like object to inspect.

# Returns

`true` when updating with supported `(u, p, t; kwargs...)` values cannot change
the operator action. A stateful leaf must override this trait explicitly.
"""
isconstant(
    ::Union{# LinearAlgebra
        AbstractMatrix,
        UniformScaling,
        Factorization, # Base
        Number,
    }
) = true
isconstant(L::AbstractSciMLOperator) = all(isconstant, getops(L))
isconstant(L) = false

"""
    isconvertible(L) -> Bool

Checks if `L` can be cheaply converted to an `AbstractMatrix` via eager fusion.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` only when `convert(AbstractMatrix, L)` is a supported operation for the
current operator state. This trait does not require eager conversion to be the
preferred execution path.
"""
isconvertible(L::AbstractSciMLOperator) = all(isconvertible, getops(L))

function isconvertible(
        ::Union{
            # LinearAlgebra
            AbstractMatrix,
            UniformScaling,
            Factorization,

            # Base
            Number,

            # SciMLOperators
            AbstractSciMLScalarOperator,
        }
    )
    return true
end

"""
    concretize(L) -> AbstractMatrix

    concretize(L) -> Number

Convert `SciMLOperator` to a concrete type via eager fusion. This method is a
no-op for types that are already concrete.

# Arguments

  - `L`: Matrix-like or scalar operator to materialize.

# Returns

An `AbstractMatrix` for matrix-like operators or a `Number` for scalar
operators, with the same current action as `L`.

# Errors

Throws the conversion error from `L` when the operator does not support the
requested concrete representation. Check `isconvertible(L)` before relying
on eager matrix materialization.
"""
function concretize(
        L::Union{# LinearAlgebra
            AbstractMatrix,
            Factorization, # SciMLOperators
            AbstractSciMLOperator,
        }
    )
    return convert(AbstractMatrix, L)
end

function concretize(
        L::Union{
            # LinearAlgebra
            UniformScaling,

            # Base
            Number,

            # SciMLOperators
            AbstractSciMLScalarOperator,
        }
    )
    return convert(Number, L)
end

"""
$SIGNATURES

Checks if `L` is a linear operator.

# Arguments

  - `L`: Operator to inspect.

# Returns

`true` when the action is linear in the action vector, even if the operator
state depends on `(u, p, t)`.
"""
islinear(::AbstractSciMLOperator) = false
islinear(L) = false

islinear(
    ::Union{# LinearAlgebra
        AbstractMatrix,
        UniformScaling,
        Factorization, # Base
        Number,
    }
) = true

has_mul(L) = false
has_mul(
    ::Union{# LinearAlgebra
        AbstractVecOrMat,
        AbstractMatrix,
        UniformScaling, # Base
        Number,
    }
) = true

has_mul!(L) = false
has_mul!(
    ::Union{# LinearAlgebra
        AbstractVecOrMat,
        AbstractMatrix,
        UniformScaling, # Base
        Number,
    }
) = true

has_ldiv(L) = false
has_ldiv(
    ::Union{
        AbstractMatrix,
        Factorization,
        Number,
    }
) = true

has_ldiv!(L) = false
has_ldiv!(
    ::Union{
        Diagonal,
        Bidiagonal,
        Factorization,
    }
) = true

has_adjoint(L) = islinear(L)
has_adjoint(
    ::Union{# LinearAlgebra
        AbstractMatrix,
        UniformScaling,
        Factorization, # Base
        Number,
    }
) = true

"""
Checks if `size(L, 1) == size(L, 2)`.

# Arguments

  - `L`: Matrix-like object or operator to inspect.

# Returns

`true` for a square operator and `false` for a rectangular operator or vector.
For multiple arguments, the result is the elementwise conjunction of their
individual square predicates.
"""
issquare(L) = ndims(L) >= 2 && size(L, 1) == size(L, 2)
issquare(::AbstractVector) = false
issquare(
    ::Union{# LinearAlgebra
        UniformScaling, # SciMLOperators
        AbstractSciMLScalarOperator, # Base
        Number,
    }
) = true
issquare(A...) = @. (&)(issquare(A)...)

Base.length(L::AbstractSciMLOperator) = prod(size(L))
Base.ndims(L::AbstractSciMLOperator) = length(size(L))
Base.isreal(L::AbstractSciMLOperator{T}) where {T} = T <: Real
Base.Matrix(L::AbstractSciMLOperator) = Matrix(convert(AbstractMatrix, L))

Base.exp(L::AbstractSciMLOperator, t) = exp(t * L)
expmv(L::AbstractSciMLOperator, u, p, t) = exp(L, t) * u
expmv!(v, L::AbstractSciMLOperator, u, p, t) = mul!(v, exp(L, t), u)

###
# fallback implementations
###

function Base.conj(L::AbstractSciMLOperator)
    isreal(L) && return L
    if !isconvertible(L)
        @warn """using convert-based fallback for Base.conj"""
    end
    return concretize(L) |> conj
end

function Base.:(==)(L1::AbstractSciMLOperator, L2::AbstractSciMLOperator)
    if !isconvertible(L1) || !isconvertible(L2)
        @warn """using convert-based fallback for Base.=="""
    end
    size(L1) != size(L2) && return false
    return concretize(L1) == concretize(L2)
end

function Base.getindex(L::AbstractSciMLOperator, I::Vararg{Int, N}) where {N}
    if !isconvertible(L)
        @warn """using convert-based fallback for Base.getindex"""
    end
    return concretize(L)[I...]
end

function Base.resize!(L::AbstractSciMLOperator, n::Integer)
    throw(MethodError(resize!, typeof.((L, n))))
end

Base.exp(L::AbstractSciMLOperator) = exp(Matrix(L))

function LinearAlgebra.opnorm(L::AbstractSciMLOperator, p::Real = 2)
    if !isconvertible(L)
        @warn """using convert-based fallback in LinearAlgebra.opnorm."""
    end
    return opnorm(concretize(L), p)
end

for op in (:sum, :prod)
    @eval function Base.$op(L::AbstractSciMLOperator; kwargs...)
        if !isconvertible(L)
            @warn """using convert-based fallback in $($op)."""
        end
        return $op(concretize(L); kwargs...)
    end
end

for pred in (
        :issymmetric,
        :ishermitian,
        :isposdef,
    )
    @eval function LinearAlgebra.$pred(L::AbstractSciMLOperator)
        has_concretization(L) || return false
        if !isconvertible(L)
            @warn """using convert-based fallback in $($pred)."""
        end
        return $pred(concretize(L))
    end
end

function LinearAlgebra.mul!(v::AbstractArray, L::AbstractSciMLOperator, u::AbstractArray)
    if !isconvertible(L)
        @warn """using convert-based fallback in mul!."""
    end
    return mul!(v, concretize(L), u)
end

function LinearAlgebra.mul!(
        v::AbstractArray,
        L::AbstractSciMLOperator,
        u::AbstractArray,
        α,
        β
    )
    if !isconvertible(L)
        @warn """using convert-based fallback in mul!."""
    end
    return mul!(v, concretize(L), u, α, β)
end

#

using SafeTestsets, Test, Pkg
const GROUP = get(ENV, "GROUP", "All")

function activate_downstream_env()
    Pkg.activate("downstream")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    Pkg.instantiate()
end

@time begin
    @testset "SciMLOperators" begin
        if GROUP == "All" || GROUP == "Core"
            @time @safetestset "Scalar Operators" begin
                include("scalar.jl")
            end
            @time @safetestset "Basic Operators" begin
                include("basic.jl")
            end
            @time @safetestset "Matrix Operators" begin
                include("matrix.jl")
            end
            @time @safetestset "Function Operator" begin
                include("func.jl")
            end
            @time @safetestset "Full tests" begin
                include("total.jl")
            end
            @time @safetestset "Zygote.jl" begin
                include("zygote.jl")
            end
            @time @safetestset "Copy methods" begin
                include("copy.jl")
            end
        elseif GROUP == "All" || GROUP == "Downstream"
            activate_downstream_env()
            @time @safetestset "AllocCheck" begin
                include("downstream/alloccheck.jl")
            end
        end
    end
end

#
using SciMLOperators, Zygote, LinearAlgebra
using Random

using SciMLOperators
using SciMLOperators: AbstractSciMLOperator,
    IdentityOperator, NullOperator,
    AdjointOperator, TransposedOperator,
    InvertedOperator, InvertibleOperator,
    BatchedDiagonalOperator, AddedOperator, ComposedOperator,
    AddedScalarOperator, ComposedScalarOperator, ScaledOperator,
    has_mul, has_ldiv

Random.seed!(0)
n = 3
N = n * n
K = 12

t = rand()
u0 = rand(N, K)
ps = rand(N)

s = rand()
v = rand(N, K)
M = rand(N, N)
Mi = inv(M)

sca_update_func = (a, u, p, t) -> sum(p) * s
vec_update_func = (b, u, p, t) -> Diagonal(p) * v
mat_update_func = (A, u, p, t) -> Diagonal(p) * M
inv_update_func = (A, u, p, t) -> Mi * inv(Diagonal(p))
tsr_update_func = (A, u, p, t) -> reshape(p, n, n) |> copy

α = ScalarOperator(zero(Float32), update_func = sca_update_func)
L_dia = DiagonalOperator(zeros(N, K); update_func = vec_update_func)
L_mat = MatrixOperator(zeros(N, N); update_func = mat_update_func)
L_mi = MatrixOperator(zeros(N, N); update_func = inv_update_func)
L_aff = AffineOperator(L_mat, L_mat, zeros(N, K); update_func = vec_update_func)
L_sca = α * L_mat
L_inv = InvertibleOperator(L_mat, L_mi)
L_fun = FunctionOperator(
    (v, u, p, t) -> Diagonal(p) * v, u0, u0; batch = true,
    op_inverse = (v, u, p, t) -> inv(Diagonal(p)) * v
)

Ti = MatrixOperator(zeros(n, n); update_func = tsr_update_func)
To = deepcopy(Ti)
L_tsr = TensorProductOperator(To, Ti)

for (LType, L) in (
        (IdentityOperator, IdentityOperator(N)),
        (NullOperator, NullOperator(N)),
        (MatrixOperator, L_mat),
        (AffineOperator, L_aff),
        (ScaledOperator, L_sca),
        (InvertedOperator, InvertedOperator(L_mat)),
        (InvertibleOperator, L_inv),
        (BatchedDiagonalOperator, L_dia),
        (AddedOperator, L_mat + L_dia),
        (ComposedOperator, L_mat * L_dia),
        (TensorProductOperator, L_tsr),
        (FunctionOperator, L_fun),

        ## ignore wrappers
        # (AdjointOperator, AdjointOperator(rand(N,N) |> MatrixOperator) |> adjoint),
        # (TransposedOperator, TransposedOperator(rand(N,N) |> MatrixOperator) |> transpose),

        (ScalarOperator, α),
        (AddedScalarOperator, α + α),
        (ComposedScalarOperator, α * α),
    )
    @assert L isa LType

    # Cache the operator for efficient application
    L_cached = cache_operator(L, u0)

    # Updated loss function using the new interface:
    # v is the action vector, u0 is the update vector
    loss_mul = function (p)
        v = Diagonal(p) * u0
        # Use new interface: L(v, u, p, t)
        w = L_cached(v, u0, p, t)
        return l = sum(w)
    end

    loss_div = function (p)
        v = Diagonal(p) * u0

        # Update coefficients first, then apply inverse
        L_updated = update_coefficients(L_cached, u0, p, t)
        w = L_updated \ v

        return l = sum(w)
    end

    @testset "$LType" begin
        l_mul = loss_mul(ps)
        g_mul = Zygote.gradient(loss_mul, ps)[1]

        if L isa NullOperator
            @test isa(g_mul, Nothing)
        else
            @test !isa(g_mul, Nothing)
        end

        if has_ldiv(L)
            l_div = loss_div(ps)
            g_div = Zygote.gradient(loss_div, ps)[1]

            @test !isa(g_div, Nothing)
        end
    end
end

"""
$(TYPEDEF)

Lazy block diagonal operator built from `AbstractSciMLOperator` blocks.

# Arguments

  - `ops`: Operators or matrices to place on the block diagonal. Matrix
    arguments are wrapped in `MatrixOperator`.

# Fields

$(FIELDS)

# Interface Rules

`BlockDiagonalOperator` applies each block to the corresponding slice of the
input and concatenates the results. Its size is the sum of block row and
column sizes. `update_coefficients[!]`, caching, and trait queries are
forwarded to each block, so a block diagonal operator has concretization,
in-place multiplication, or adjoint support only when the required component
operators do.

# Examples

```julia
using LinearAlgebra, SciMLOperators

A = MatrixOperator([1.0 2.0; 3.0 4.0])
B = MatrixOperator(Diagonal([5.0, 6.0, 7.0]))
L = BlockDiagonalOperator(A, B)

v = ones(5)
L * v == Matrix(L) * v
```
"""
struct BlockDiagonalOperator{
        T,
        O <: Tuple{Vararg{AbstractSciMLOperator}},
    } <: AbstractSciMLOperator{T}
    ops::O

    function BlockDiagonalOperator(ops::Tuple{Vararg{AbstractSciMLOperator}})
        @assert !isempty(ops)
        T = mapreduce(eltype, promote_type, ops)
        return new{T, typeof(ops)}(ops)
    end
end

function BlockDiagonalOperator(ops::Union{AbstractMatrix, AbstractSciMLOperator}...)
    return BlockDiagonalOperator(map(op -> op isa AbstractMatrix ? MatrixOperator(op) : op, ops))
end

getops(L::BlockDiagonalOperator) = L.ops

function Base.show(io::IO, L::BlockDiagonalOperator)
    print(io, "BlockDiagonalOperator(")
    show(io, L.ops[1])
    for i in 2:length(L.ops)
        print(io, ", ")
        show(io, L.ops[i])
    end
    return print(io, ")")
end

function Base.size(L::BlockDiagonalOperator)
    return (sum(op -> size(op, 1), L.ops), sum(op -> size(op, 2), L.ops))
end

function Base.convert(::Type{AbstractMatrix}, L::BlockDiagonalOperator)
    A = zeros(eltype(L), size(L))
    row_start = 1
    col_start = 1
    for op in L.ops
        m, n = size(op)
        rows = row_start:(row_start + m - 1)
        cols = col_start:(col_start + n - 1)
        A[rows, cols] .= convert(AbstractMatrix, op)
        row_start += m
        col_start += n
    end
    return A
end
has_concretization(L::BlockDiagonalOperator) = all(has_concretization, L.ops)

for op in (:adjoint, :transpose)
    @eval Base.$op(L::BlockDiagonalOperator) = BlockDiagonalOperator($op.(L.ops)...)
end
Base.conj(L::BlockDiagonalOperator) = BlockDiagonalOperator(conj.(L.ops)...)

function update_coefficients(L::BlockDiagonalOperator, u, p, t; kwargs...)
    ops = map(op -> update_coefficients(op, u, p, t; kwargs...), L.ops)
    return BlockDiagonalOperator(ops)
end

function update_coefficients!(L::BlockDiagonalOperator, u, p, t; kwargs...)
    for op in L.ops
        update_coefficients!(op, u, p, t; kwargs...)
    end
    return nothing
end

function Base.copy(L::BlockDiagonalOperator)
    return BlockDiagonalOperator(map(copy, L.ops))
end

function cache_internals(L::BlockDiagonalOperator, v::AbstractVecOrMat)
    ops = ()
    col_start = 1
    for op in L.ops
        n = size(op, 2)
        cols, col_start = _block_range(col_start, n)
        ops = (ops..., cache_operator(op, _block_view(v, cols)))
    end
    return BlockDiagonalOperator(ops)
end

isconstant(L::BlockDiagonalOperator) = all(isconstant, L.ops)
islinear(L::BlockDiagonalOperator) = all(islinear, L.ops)
Base.iszero(L::BlockDiagonalOperator) = all(iszero, L.ops)
has_adjoint(L::BlockDiagonalOperator) = all(has_adjoint, L.ops)
has_mul(L::BlockDiagonalOperator) = all(has_mul, L.ops)
has_mul!(L::BlockDiagonalOperator) = all(has_mul!, L.ops)

function _block_range(start::Int, len::Int)
    stop = start + len - 1
    return start:stop, stop + 1
end

function _block_view(v::AbstractMatrix, rows)
    return view(v, rows, :)
end
function _block_view(v::AbstractVector, rows)
    return view(v, rows)
end

function Base.:*(L::BlockDiagonalOperator, v::AbstractVecOrMat)
    @assert size(v, 1) == size(L, 2)
    T = promote_type(eltype(L), eltype(v))
    w = v isa AbstractMatrix ? similar(v, T, (size(L, 1), size(v, 2))) :
        similar(v, T, size(L, 1))
    return mul!(w, L, v)
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat, L::BlockDiagonalOperator, v::AbstractVecOrMat
    )
    @assert size(v, 1) == size(L, 2)
    @assert size(w, 1) == size(L, 1)
    row_start = 1
    col_start = 1
    for op in L.ops
        m, n = size(op)
        rows, row_start = _block_range(row_start, m)
        cols, col_start = _block_range(col_start, n)
        mul!(_block_view(w, rows), op, _block_view(v, cols))
    end
    return w
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::BlockDiagonalOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    @assert size(v, 1) == size(L, 2)
    @assert size(w, 1) == size(L, 1)
    row_start = 1
    col_start = 1
    for op in L.ops
        m, n = size(op)
        rows, row_start = _block_range(row_start, m)
        cols, col_start = _block_range(col_start, n)
        mul!(_block_view(w, rows), op, _block_view(v, cols), α, β)
    end
    return w
end

function (L::BlockDiagonalOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    return L * v
end

function (L::BlockDiagonalOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    return mul!(w, L, v)
end

function (L::BlockDiagonalOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    return mul!(w, L, v, α, β)
end

using SciMLOperators, LinearAlgebra
using SparseArrays
using Random
using Test
using LoopVectorization

using SciMLOperators: InvertibleOperator, InvertedOperator, ⊗, AbstractSciMLOperator
using FFTW

Random.seed!(0)
N = 8
K = 19

@testset "MatrixOperator, InvertibleOperator" begin
    # Vectors for testing
    u = rand(N, K)  # Both update and action vector
    v = rand(N, K)  # Output/action vector
    w = zeros(N, K)  # Output vector

    p = nothing
    t = 0
    α = rand()
    β = rand()

    A = rand(N, N)
    At = A'

    AA = MatrixOperator(A)
    AAt = AA'

    @test AA isa MatrixOperator
    @test AAt isa MatrixOperator

    @test isconstant(AA)
    @test isconstant(AAt)

    @test issquare(AA)
    @test islinear(AA)

    FF = factorize(AA)
    FFt = FF'

    @test FF isa InvertibleOperator
    @test FFt isa InvertibleOperator

    @test isconstant(FF)
    @test isconstant(FFt)

    @test_throws MethodError resize!(AA, N)

    @test eachindex(A) === eachindex(AA)
    @test eachindex(A') === eachindex(AAt) === eachindex(MatrixOperator(At))

    @test A ≈ convert(AbstractMatrix, AA) ≈ convert(AbstractMatrix, FF)
    @test At ≈ convert(AbstractMatrix, AAt) ≈ convert(AbstractMatrix, FFt)

    @test A ≈ Matrix(AA) ≈ Matrix(FF)
    @test At ≈ Matrix(AAt) ≈ Matrix(FFt)

    # Test with new interface - same vector for update and action
    @test A * u ≈ AA(u, u, p, t)
    @test At * u ≈ AAt(u, u, p, t)

    # Test with different vectors for update and action
    @test A * v ≈ AA(v, u, p, t)
    @test At * v ≈ AAt(v, u, p, t)

    @test A \ u ≈ AA \ u ≈ FF \ u
    @test At \ u ≈ AAt \ u ≈ FFt \ u

    # Test in-place operations
    copy!(w, zeros(N, K))
    AA(w, v, u, p, t)
    @test w ≈ A * v

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    AA(w, v, u, p, t, α, β)
    @test w ≈ α * (A * v) + β * orig_w
end

@testset "InvertibleOperator test" begin
    # Vectors for testing
    u = rand(N, K)  # Update vector
    v = rand(N, K)  # Action vector
    w = zeros(N, K)  # Output vector

    p = nothing
    t = 0
    α = rand()
    β = rand()

    d = rand(N, K)
    D = DiagonalOperator(d)
    Di = DiagonalOperator(inv.(d)) |> InvertedOperator

    L = InvertibleOperator(D, Di)
    L = cache_operator(L, u)

    @test iscached(L)

    # Test with new interface
    @test L(v, u, p, t) ≈ d .* v
    @test L \ u ≈ d .\ u

    # Test in-place operations
    copy!(w, zeros(N, K))
    L(w, v, u, p, t)
    @test w ≈ d .* v

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * (d .* v) + β * orig_w

    # Test division operations
    copy!(w, zeros(N, K))
    ldiv!(w, L, u)
    @test w ≈ d .\ u

    # Existing test for in-place ldiv!
    v = copy(u)
    ldiv!(L, v)
    @test v ≈ d .\ u
end

@testset "MatrixOperator update test" begin
    # Vectors for testing
    u = rand(N, K)  # Update vector
    v = rand(N, K)  # Action vector
    w = zeros(N, K)  # Output vector

    p = rand(N)
    t = rand()
    α = rand()
    β = rand()

    L = MatrixOperator(
        zeros(N, N);
        update_func = (A, u, p, t) -> p * p',
        update_func! = (A, u, p, t) -> A .= p * p'
    )

    @test !isconstant(L)

    # Expected matrix after update
    A = p * p'

    # Test with new interface - same vector for update and action
    @test L(u, u, p, t) ≈ A * u

    # Test with different vectors for update and action
    @test L(v, u, p, t) ≈ A * v

    # Test in-place operation
    copy!(w, zeros(N, K))
    L(w, v, u, p, t)
    @test w ≈ A * v

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * (A * v) + β * orig_w

    # update_coefficients! with only an out-of-place update_func (#409)
    Loop = MatrixOperator(zeros(N, N); update_func = (A, u, p, t) -> p * p')
    update_coefficients!(Loop, u, p, t)
    @test convert(AbstractMatrix, Loop) ≈ p * p'

    # immutable storage cannot be updated in place through an out-of-place func
    Limm = MatrixOperator(
        reshape(1.0:(N * N), N, N); update_func = (A, u, p, t) -> p * p'
    )
    @test_throws ArgumentError update_coefficients!(Limm, u, p, t)

    A = [
        -2.0 1 0 0 0
        1 -2 1 0 0
        0 1 -2 1 0
        0 0 1 -2 1
        0 0 0 1 -2
    ]
    v = [3.0, 2.0, 1.0, 2.0, 3.0]
    opA = MatrixOperator(A)

    function update_function!(B, u, p, t)
        dt = p
        B .= A .* u + dt * I
    end

    u = Array(1:1.0:5)
    p = 0.1
    t = 0.0
    opB = MatrixOperator(copy(A); update_func! = update_function!)

    function Bfunc!(w, v, u, p, t)
        dt = p
        w[1] = -(2 * u[1] - dt) * v[1] + v[2] * u[1]
        for i in 2:4
            w[i] = v[i - 1] * u[i] - (2 * u[i] - dt) * v[i] + v[i + 1] * u[i]
        end
        w[5] = v[4] * u[5] - (2 * u[5] - dt) * v[5]
        nothing
    end

    function Bfunc!(v, u, p, t)
        w = zeros(5)
        Bfunc!(w, v, u, p, t)
        w
    end

    mfopB = FunctionOperator(Bfunc!, zeros(5), zeros(5); u, p, t, isconstant = false)

    @test iszero(
        opB(v, Array(2:1.0:6), 0.5, nothing) -
            mfopB(v, Array(2:1.0:6), 0.5, nothing)
    )
end

@testset "DiagonalOperator update test" begin
    # Vectors for testing
    u = rand(N, K)  # Update vector
    v = rand(N, K)  # Action vector
    w = zeros(N, K)  # Output vector

    p = rand(N)
    t = rand()
    α = rand()
    β = rand()

    D = DiagonalOperator(
        zeros(N);
        update_func = (diag, u, p, t) -> p * t,
        update_func! = (diag, u, p, t) -> diag .= p * t
    )

    @test !isconstant(D)
    @test issquare(D)
    @test islinear(D)

    # Expected result after update
    expected = (p * t) .* v

    # Test with new interface - different vectors for update and action
    @test D(v, u, p, t) ≈ expected

    # Test in-place operation
    copy!(w, zeros(N, K))
    D(w, v, u, p, t)
    @test w ≈ expected

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    D(w, v, u, p, t, α, β)
    @test w ≈ α * expected + β * orig_w

    expD = exp(D)
    @test expD isa MatrixOperator
    @test expD.A isa Diagonal
    @test expD(v, u, p, t) ≈ exp.(p * t) .* v
end

@testset "Batched Diagonal Operator" begin
    # Vectors for testing
    u = rand(N, K)  # Update vector
    v = rand(N, K)  # Action vector
    w = zeros(N, K)  # Output vector

    d = rand(N, K)
    α = rand()
    β = rand()
    p = nothing
    t = 0.0

    L = DiagonalOperator(d)
    @test isconstant(L)
    @test_throws MethodError resize!(L, N)

    @test issquare(L)
    @test islinear(L)

    # Test with new interface
    @test L(v, u, p, t) ≈ d .* v

    # Test in-place operation
    copy!(w, zeros(N, K))
    L(w, v, u, p, t)
    @test w ≈ d .* v

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * (d .* v) + β * orig_w

    # Test division operations
    @test L \ u ≈ d .\ u

    copy!(w, zeros(N, K))
    ldiv!(w, L, u)
    @test w ≈ d .\ u

    # Existing test for in-place ldiv!
    v = copy(u)
    ldiv!(L, u)
    @test u ≈ d .\ v
end

@testset "Batched DiagonalOperator update test" begin
    # Vectors for testing
    u = rand(N, K)  # Update vector
    v = rand(N, K)  # Action vector
    w = zeros(N, K)  # Output vector

    d = zeros(N, K)
    p = rand(N, K)
    t = rand()

    D = DiagonalOperator(
        d;
        update_func = (diag, u, p, t) -> p * t,
        update_func! = (diag, u, p, t) -> diag .= p * t
    )

    @test !isconstant(D)
    @test issquare(D)
    @test islinear(D)

    # Expected result after update
    expected = (p * t) .* v

    # Test with new interface - different vectors for update and action
    @test D(v, u, p, t) ≈ expected

    # Test in-place operation
    copy!(w, zeros(N, K))
    D(w, v, u, p, t)
    @test w ≈ expected

    # update_coefficients! with only an out-of-place update_func (#409)
    Doop = DiagonalOperator(zeros(N, K); update_func = (diag, u, p, t) -> p * t)
    update_coefficients!(Doop, u, p, t)
    copy!(w, zeros(N, K))
    mul!(w, Doop, v)
    @test w ≈ (p * t) .* v

    # immutable storage cannot be updated in place through an out-of-place func
    Dimm = DiagonalOperator(
        reshape(1.0:(N * K), N, K); update_func = (diag, u, p, t) -> p * t
    )
    @test_throws ArgumentError update_coefficients!(Dimm, u, p, t)
end

@testset "AffineOperator" begin
    # Vectors for testing
    u = rand(N, K)  # Update vector
    v = rand(N, K)  # Action vector
    w = zeros(N, K)  # Output vector

    A = rand(N, N)
    B = rand(N, N)
    D = Diagonal(A)
    b = rand(N, K)
    α = rand()
    β = rand()
    p = nothing
    t = 0.0

    L = AffineOperator(MatrixOperator(A), MatrixOperator(B), b)
    @test isconstant(L)
    @test issquare(L)
    @test !islinear(L)

    # Test with new interface
    expected = A * v + B * b
    @test L(v, u, p, t) ≈ expected

    # Test in-place operation
    copy!(w, zeros(N, K))
    L(w, v, u, p, t)
    @test w ≈ expected

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * expected + β * orig_w

    L = AffineOperator(MatrixOperator(D), MatrixOperator(B), b)
    @test issquare(L)
    @test !islinear(L)

    # Test division operations
    @test L \ u ≈ D \ (u - B * b)

    copy!(w, zeros(N, K))
    ldiv!(w, L, u)
    @test w ≈ D \ (u - B * b)

    # Existing test for in-place ldiv!
    v = copy(u)
    ldiv!(L, u)
    @test u ≈ D \ (v - B * b)

    L = AddVector(b)
    @test issquare(L)
    @test !islinear(L)

    # Test with new interface
    expected = v + b
    @test L(v, u, p, t) ≈ expected
    @test L \ u ≈ u - b

    # Test in-place operation
    copy!(w, zeros(N, K))
    L(w, v, u, p, t)
    @test w ≈ expected

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * expected + β * orig_w

    # Test division operations
    copy!(w, zeros(N, K))
    ldiv!(w, L, u)
    @test w ≈ u - b

    # Existing test for in-place ldiv!
    v = copy(u)
    ldiv!(L, u)
    @test u ≈ v - b

    L = AddVector(MatrixOperator(B), b)
    @test issquare(L)
    @test !islinear(L)

    # Test with new interface
    expected = v + B * b
    @test L(v, u, p, t) ≈ expected
    @test L \ u ≈ u - B * b

    # Test in-place operation
    copy!(w, zeros(N, K))
    L(w, v, u, p, t)
    @test w ≈ expected

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * expected + β * orig_w

    # Test division operations
    copy!(w, zeros(N, K))
    ldiv!(w, L, u)
    @test w ≈ u - B * b

    # Existing test for in-place ldiv!
    v = copy(u)
    ldiv!(L, u)
    @test u ≈ v - B * b
end

@testset "AffineOperator update test" begin
    # Vectors for testing
    u = rand(N, K)  # Update vector
    v = rand(N, K)  # Action vector
    w = zeros(N, K)  # Output vector

    A = rand(N, N)
    B = rand(N, N)
    p = rand(N, K)
    t = rand()
    α = rand()
    β = rand()

    L = AffineOperator(
        A, B, zeros(N, K);
        update_func = (b, u, p, t) -> p * t,
        update_func! = (b, u, p, t) -> b .= p * t
    )

    @test !isconstant(L)

    # Expected updated bias and result
    b = p * t
    expected = A * v + B * b

    # Test with new interface - different vectors for update and action
    @test L(v, u, p, t) ≈ expected

    # Test in-place operation
    copy!(w, zeros(N, K))
    L(w, v, u, p, t)
    @test w ≈ expected

    # Test in-place with scaling
    copy!(w, rand(N, K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * expected + β * orig_w
end

@testset "TensorProductOperator, square = $square" for square in [false, true]
    m1, n1 = 3, 5
    m2, n2 = 7, 11
    m3, n3 = 13, 17

    if square
        n1, n2, n3 = m1, m2, m3
    end

    A = rand(m1, n1)
    B = rand(m2, n2)
    C = rand(m3, n3)
    α = rand()
    β = rand()
    p = nothing
    t = 0.0

    AB = kron(A, B)
    ABC = kron(A, B, C)

    # test Base.kron overload
    # ensure kron(mat, mat) is not a TensorProductOperator
    @test !isa(AB, AbstractSciMLOperator)
    @test !isa(ABC, AbstractSciMLOperator)

    # test Base.kron overload
    _A = rand(N, N)
    @test kron(_A, MatrixOperator(_A)) isa TensorProductOperator{Float64}
    @test kron(MatrixOperator(_A), _A) isa TensorProductOperator{Float64}

    @test kron(MatrixOperator(_A), MatrixOperator(_A)) isa TensorProductOperator{Float64}

    # Inputs/Update vectors
    u2 = rand(n1 * n2, K)
    u3 = rand(n1 * n2 * n3, K)

    # Action vectors (same as update vectors initially)
    v2 = copy(u2)
    v3 = copy(u3)

    # Output vectors
    w2 = zeros(m1 * m2, K)
    w3 = zeros(m1 * m2 * m3, K)

    opAB = TensorProductOperator(A, B)
    opABC = TensorProductOperator(A, B, C)

    @test opAB isa TensorProductOperator{Float64}
    @test opABC isa TensorProductOperator{Float64}

    @test isconstant(opAB)
    @test isconstant(opABC)

    @test islinear(opAB)
    @test islinear(opABC)

    if square
        @test issquare(opAB)
        @test issquare(opABC)
    else
        @test !issquare(opAB)
        @test !issquare(opABC)
    end

    @test AB ≈ convert(AbstractMatrix, opAB)
    @test ABC ≈ convert(AbstractMatrix, opABC)

    # factorization tests
    opAB_F = factorize(opAB)
    opABC_F = factorize(opABC)

    @test isconstant(opAB_F)
    @test isconstant(opABC_F)

    @test opAB_F isa TensorProductOperator{Float64}
    @test opABC_F isa TensorProductOperator{Float64}

    @test AB ≈ convert(AbstractMatrix, opAB_F)
    @test ABC ≈ convert(AbstractMatrix, opABC_F)

    # Test with new interface
    @test AB * v2 ≈ opAB(v2, u2, p, t)
    @test ABC * v3 ≈ opABC(v3, u3, p, t)

    @test AB \ w2 ≈ opAB \ w2
    @test AB \ w2 ≈ opAB_F \ w2
    @test ABC \ w3 ≈ opABC \ w3
    @test ABC \ w3 ≈ opABC_F \ w3

    @test !iscached(opAB)
    @test !iscached(opABC)

    @test !iscached(opAB_F)
    @test !iscached(opABC_F)

    opAB = cache_operator(opAB, u2)
    opABC = cache_operator(opABC, u3)

    opAB_F = cache_operator(opAB_F, u2)
    opABC_F = cache_operator(opABC_F, u3)

    @test iscached(opAB)
    @test iscached(opABC)

    @test iscached(opAB_F)
    @test iscached(opABC_F)

    N2 = n1 * n2
    N3 = n1 * n2 * n3
    M2 = m1 * m2
    M3 = m1 * m2 * m3

    # Test in-place operations with new interface
    v2 = rand(n1 * n2, K)  # Action vector
    w2 = zeros(M2, K)      # Output vector
    opAB(w2, v2, u2, p, t)
    @test w2 ≈ AB * v2

    v3 = rand(n1 * n2 * n3, K)  # Action vector
    w3 = zeros(M3, K)           # Output vector
    opABC(w3, v3, u3, p, t)
    @test w3 ≈ ABC * v3

    # Test in-place with scaling
    v2 = rand(n1 * n2, K)    # Action vector
    w2 = rand(M2, K)         # Output vector
    orig_w2 = copy(w2)
    opAB(w2, v2, u2, p, t, α, β)
    @test w2 ≈ α * AB * v2 + β * orig_w2

    v3 = rand(n1 * n2 * n3, K)  # Action vector
    w3 = rand(M3, K)            # Output vector
    orig_w3 = copy(w3)
    opABC(w3, v3, u3, p, t, α, β)
    @test w3 ≈ α * ABC * v3 + β * orig_w3

    if square
        # Test division operations with new interface
        v2 = rand(M2, K)     # Action vector (size of output space)
        u2 = rand(N2, K)     # Update vector (size of input space)
        w2 = zeros(N2, K)    # Output vector (size of input space)

        # ldiv! with new interface
        ldiv!(w2, opAB_F, v2)
        @test w2 ≈ AB \ v2

        v3 = rand(M3, K)     # Action vector
        u3 = rand(N3, K)     # Update vector
        w3 = zeros(N3, K)    # Output vector
        ldiv!(w3, opABC_F, v3)
        @test w3 ≈ ABC \ v3

        # In-place ldiv! (original style)
        v2 = rand(M2, K)
        u2 = copy(v2)
        ldiv!(opAB_F, v2)
        @test v2 ≈ AB \ u2

        v3 = rand(M3, K)
        u3 = copy(v3)
        ldiv!(opABC_F, v3)
        @test v3 ≈ ABC \ u3
    else # TODO
        v2 = rand(M2, K)     # Action vector
        u2 = rand(N2, K)     # Update vector
        w2 = zeros(N2, K)    # Output vector

        if VERSION < v"1.9-"
            @test_broken ldiv!(w2, opAB_F, v2) ≈ AB \ v2
        else
            @test ldiv!(w2, opAB_F, v2) ≈ AB \ v2
        end

        v3 = rand(M3, K)     # Action vector
        u3 = rand(N3, K)     # Update vector
        w3 = zeros(N3, K)    # Output vector
        @test_broken ldiv!(w3, opABC_F, v3) ≈ ABC \ v3 # errors
    end

    @testset "Simplified Structure with IdentityOperator" begin
        Id1 = IdentityOperator(m1)
        Id2 = IdentityOperator(m2)
        Id3 = IdentityOperator(m3)
        A1 = MatrixOperator(rand(n1, n1))
        A2 = MatrixOperator(rand(n2, n2))

        op1 = kron(A1, Id1, Id2, Id3)
        op2 = kron(Id1, A1, Id2, Id3)
        op3 = kron(Id1, Id2, A1, Id3)
        op4 = kron(Id1, Id2, Id3, A1)

        op5 = kron(A1, A2, Id1, Id2)
        op6 = kron(Id1, A1, A2, Id2)
        op7 = kron(Id1, Id2, A1, A2)

        # Test the structure of the resulting operators
        # The nesting depth structure should be 2 at most
        @test op1.ops[1] isa MatrixOperator
        @test op1.ops[2] isa IdentityOperator

        @test op2.ops[1] isa TensorProductOperator
        @test op2.ops[2] isa IdentityOperator
        @test op2.ops[1].ops[1] isa IdentityOperator
        @test op2.ops[1].ops[2] isa MatrixOperator

        @test op3.ops[1] isa TensorProductOperator
        @test op3.ops[2] isa IdentityOperator
        @test op3.ops[1].ops[1] isa IdentityOperator
        @test op3.ops[1].ops[2] isa MatrixOperator

        @test op4.ops[1] isa IdentityOperator
        @test op4.ops[2] isa MatrixOperator

        @test op5.ops[1] isa MatrixOperator
        @test op5.ops[2] isa TensorProductOperator
        @test op5.ops[2].ops[1] isa MatrixOperator
        @test op5.ops[2].ops[2] isa IdentityOperator

        @test op6.ops[1] isa TensorProductOperator
        @test op6.ops[2] isa TensorProductOperator
        @test op6.ops[1].ops[1] isa IdentityOperator
        @test op6.ops[1].ops[2] isa MatrixOperator
        @test op6.ops[2].ops[1] isa MatrixOperator
        @test op6.ops[2].ops[2] isa IdentityOperator

        @test op7.ops[1] isa TensorProductOperator
        @test op7.ops[2] isa MatrixOperator
        @test op7.ops[1].ops[1] isa IdentityOperator
        @test op7.ops[1].ops[2] isa MatrixOperator

        @test convert(AbstractMatrix, op1) ≈ kron(convert(AbstractMatrix, A1), I(m1 * m2 * m3))
        @test convert(AbstractMatrix, op2) ≈ kron(I(m1), convert(AbstractMatrix, A1), I(m2 * m3))
        @test convert(AbstractMatrix, op3) ≈ kron(I(m1 * m2), convert(AbstractMatrix, A1), I(m3))
        @test convert(AbstractMatrix, op4) ≈ kron(I(m1 * m2 * m3), convert(AbstractMatrix, A1))

        @test convert(AbstractMatrix, op5) ≈ kron(
            convert(AbstractMatrix, A1), convert(AbstractMatrix, A2), I(m1 * m2)
        )
        @test convert(AbstractMatrix, op6) ≈ kron(
            I(m1), convert(AbstractMatrix, A1), convert(AbstractMatrix, A2), I(m2)
        )
        @test convert(AbstractMatrix, op7) ≈ kron(
            I(m1 * m2), convert(AbstractMatrix, A1), convert(AbstractMatrix, A2)
        )

        for op in (op1, op2, op3, op4, op5, op6, op7)
            v = rand(size(op, 2), K)
            @test convert(AbstractMatrix, op) * v ≈ op * v
        end

    end
end

@testset "TensorProductOperator cache size, square = $square" for square in [false, true]
    m1, m2 = 3, 7
    n1, n2 = square ? (m1, m2) : (5, 11)

    A = rand(m1, n1)
    B = rand(m2, n2)
    AB = kron(A, B)
    α, β = rand(), rand()

    op = TensorProductOperator(A, B)

    # Number of distinct buffers, since slots are deliberately aliased when square.
    nbuffers(L) = length(unique(objectid, filter(!isnothing, collect(L.cache))))

    # A vector input can only ever reach cache slots 1 and 5, so the other five are
    # left unallocated: 4 buffers -> 1 when both factors are square, 7 -> 2 otherwise.
    opv = cache_operator(op, rand(n1 * n2))
    @test iscached(opv)
    @test nbuffers(opv) == (square ? 1 : 2)

    # A matrix input still gets the full cache.
    opm = cache_operator(op, rand(n1 * n2, K))
    @test nbuffers(opm) == (square ? 4 : 7)

    # Specifically, the slots reached only from the `k > 1` branches stay empty.
    @test opv.cache[1] isa AbstractMatrix
    @test all(isnothing, (opv.cache[i] for i in (2, 3, 4, 6, 7)))
    @test all(!isnothing, opm.cache)

    # Every in-place path a vector input can take still gives the right answer.
    v = rand(n1 * n2)
    w = zeros(m1 * m2)
    @test mul!(w, opv, v) ≈ AB * v

    w = rand(m1 * m2)
    orig_w = copy(w)
    @test mul!(w, opv, v, α, β) ≈ α * (AB * v) + β * orig_w

    if square
        # `c5` is the one slot besides `c1` a vector input can reach.
        opv_F = cache_operator(factorize(op), rand(n1 * n2))
        y = rand(m1 * m2)
        @test ldiv!(zeros(n1 * n2), opv_F, y) ≈ AB \ y
    end
end

@testset "TensorSumOperator" begin
    A = rand(3, 3)
    B = rand(4, 4)
    α = rand()
    β = rand()
    p = nothing
    t = 0.0

    expected = kron(A, Matrix(I, 4, 4)) + kron(Matrix(I, 3, 3), B)
    L = kronsum(MatrixOperator(A), MatrixOperator(B))
    L_from_matrices = kronsum(A, B)

    @test L isa TensorSumOperator{Float64}
    @test L_from_matrices isa TensorSumOperator{Float64}
    @test size(L) == size(expected)
    @test islinear(L)
    @test isconstant(L)
    @test !iscached(L)
    @test convert(AbstractMatrix, L) ≈ expected
    @test convert(AbstractMatrix, L_from_matrices) ≈ expected

    u = rand(size(L, 2), K)
    v = copy(u)
    w = zeros(size(L, 1), K)

    @test L * v ≈ expected * v
    @test L(v, u, p, t) ≈ expected * v

    L = cache_operator(L, u)
    @test iscached(L)

    mul!(w, L, v)
    @test w ≈ expected * v

    copy!(w, rand(size(L, 1), K))
    orig_w = copy(w)
    mul!(w, L, v, α, β)
    @test w ≈ α * expected * v + β * orig_w

    copy!(w, zeros(size(L, 1), K))
    L(w, v, u, p, t)
    @test w ≈ expected * v

    copy!(w, rand(size(L, 1), K))
    orig_w = copy(w)
    L(w, v, u, p, t, α, β)
    @test w ≈ α * expected * v + β * orig_w

    x = rand(size(L, 2))
    @test L * x ≈ expected * x
    @test convert(AbstractMatrix, L') ≈ expected'
    @test convert(AbstractMatrix, transpose(L)) ≈ transpose(expected)
    @test_throws AssertionError kronsum(rand(3, 4), B)

    A_update = MatrixOperator(zeros(3, 3); update_func = (A, u, p, t) -> p[1] * Matrix(I, 3, 3))
    B_update = MatrixOperator(zeros(4, 4); update_func = (B, u, p, t) -> p[2] * Matrix(I, 4, 4))
    L_update = kronsum(A_update, B_update)
    @test L_update(v, u, (2.0, 3.0), t) ≈ 5v
end

@testset "Sparse conversion tests" begin
    A = rand(2, 2)
    opA = MatrixOperator(A)
    # Construct operator including TensorProductOperator, AddedOperator,
    # IdentityOperator, ComposedOperator and ScaledOperator:
    opB = kron(2 * opA + I, opA * opA)
    B = kron(2 * A + I, A * A)
    opB_sparse = sparse(opB)
    @test opB_sparse ≈ B
    @test issparse(opB_sparse)

    L = BlockDiagonalOperator(opA, opB, NullOperator(2, 3))
    sL = sparse(L)
    @test issparse(sL)
    @test sL ≈ Matrix(L)

    # TensorSumOperator
    Lkronsum = kronsum(opB, opB)
    sLkronsum = sparse(Lkronsum)
    @test issparse(sLkronsum)
    @test sLkronsum ≈ Matrix(Lkronsum)
end

@testset "copyto! MatrixOperator <- MatrixOperator delegates to .A" begin
    # A MatrixOperator rhs must be unwrapped so the copy hits the underlying matrices'
    # specialized copyto! (sparse->sparse copies nzval/rowval/colptr) rather than the
    # generic element-wise fallback.
    for Amk in (() -> rand(6, 6), () -> sparse(Tridiagonal(rand(5), rand(6), rand(5))))
        A = Amk()
        src = MatrixOperator(copy(A))
        dest = MatrixOperator(zero(A))
        copyto!(dest, src)
        @test dest.A == A
        @test typeof(dest.A) === typeof(A)   # structure preserved (sparse stays sparse)
    end
    # plain-array rhs still works (existing method)
    d = MatrixOperator(zeros(3, 3))
    copyto!(d, [1.0 2 3; 4 5 6; 7 8 9])
    @test d.A == [1.0 2 3; 4 5 6; 7 8 9]
end

using SciMLOperators, LinearAlgebra
using Random
using Test

using SciMLOperators: ⊗

Random.seed!(0)
N = 8
K = 12
NK = N * K

@testset "(Unbatched) FunctionOperator ND array" begin
    N1, N2, N3 = 3, 4, 5
    M1, M2, M3 = 4, 5, 6

    u = nothing
    p = nothing
    t = 0.0
    α = rand()
    β = rand()

    for (sz_in, sz_out) in (
            ((N1, N2, N3), (N1, N2, N3)), # equal size
            ((N1, N2, N3), (M1, M2, M3)),
        )
        N = prod(sz_in)
        M = prod(sz_out)

        A = rand(M, N)
        u = nothing
        v = rand(sz_in...) # action vector
        w = rand(sz_out...) # output vector for in-place tests

        _mul(A, v) = reshape(A * vec(v), sz_out)
        f(v, u, p, t) = _mul(A, v)
        f(w, v, u, p, t) = (mul!(vec(w), A, vec(v)); w)

        kw = (;) # FunctionOp kwargs

        if sz_in == sz_out
            F = lu(A)
            _div(A, v) = reshape(A \ vec(v), sz_in)
            fi(v, u, p, t) = _div(A, v)
            fi(w, v, u, p, t) = (ldiv!(vec(w), F, vec(v)); w)

            kw = (; op_inverse = fi)
        end

        L = FunctionOperator(f, v, w; kw...)
        L = cache_operator(L, v)

        # test with ND-arrays and new interface
        @test _mul(A, v) ≈ L(v, u, p, t) ≈ L * v ≈ mul!(zero(w), L, v)
        @test α * _mul(A, v) + β * w ≈ mul!(copy(w), L, v, α, β)

        # Test with different update and action vectors
        action_vec = rand(sz_in...)
        @test _mul(A, action_vec) ≈ L(action_vec, u, p, t)

        if sz_in == sz_out
            @test _div(A, w) ≈ L \ w ≈ ldiv!(zero(v), L, w) ≈ ldiv!(L, copy(w))
        end

        # test with vec(Array)
        @test vec(_mul(A, v)) ≈ L(vec(v), u, p, t) ≈ L * vec(v) ≈
            mul!(vec(zero(w)), L, vec(v))
        @test vec(α * _mul(A, v) + β * w) ≈ mul!(vec(copy(w)), L, vec(v), α, β)

        if sz_in == sz_out
            @test vec(_div(A, w)) ≈ L \ vec(w) ≈ ldiv!(vec(zero(v)), L, vec(w)) ≈
                ldiv!(L, vec(copy(w)))
        end

        # Test in-place with different update and action vectors
        output_vec = zeros(sz_out...)
        L(output_vec, action_vec, u, p, t)
        @test output_vec ≈ _mul(A, action_vec)

        # Test in-place with scaling
        output_vec = rand(sz_out...)
        orig_output = copy(output_vec)
        L(output_vec, action_vec, u, p, t, α, β)
        @test output_vec ≈ α * _mul(A, action_vec) + β * orig_output

        @test_throws DimensionMismatch mul!(vec(w), L, v)
        @test_throws DimensionMismatch mul!(w, L, vec(v))
    end
end

@testset "(Unbatched) FunctionOperator" begin
    v = rand(N, K) # action vector
    w = zeros(N, K) # Output vector
    u = nothing
    p = nothing
    t = 0.0
    α = rand()
    β = rand()

    _mul(A, v) = reshape(A * vec(v), N, K)
    _div(A, v) = reshape(A \ vec(v), N, K)

    A = rand(NK, NK) |> Symmetric
    F = lu(A)
    Ai = inv(A)

    f1(v, u, p, t) = _mul(A, v)
    f1i(v, u, p, t) = _div(A, v)

    f2(w, v, u, p, t) = (mul!(vec(w), A, vec(v)); w)
    f2(w, v, u, p, t, α, β) = (mul!(vec(w), A, vec(v), α, β); w)
    f2i(w, v, u, p, t) = (ldiv!(vec(w), F, vec(v)); w)
    f2i(w, v, u, p, t, α, β) = (mul!(vec(w), Ai, vec(v), α, β); w)

    # out of place
    op1 = FunctionOperator(
        f1, v; op_inverse = f1i, ifcache = false, islinear = true,
        opnorm = true,
        issymmetric = true,
        ishermitian = true,
        isposdef = true
    )

    # in place
    op2 = FunctionOperator(
        f2, v, w; op_inverse = f2i, ifcache = false, islinear = true,
        opnorm = true,
        issymmetric = true,
        ishermitian = true,
        isposdef = true
    )

    # Test traits
    @test issquare(op1)
    @test issquare(op2)
    @test islinear(op1)
    @test islinear(op2)
    @test op1' === op1

    # Test operator properties
    @test size(op1) == (NK, NK)
    @test has_adjoint(op1)
    @test has_mul(op1)
    @test has_mul!(op1)
    @test has_ldiv(op1)
    @test !has_ldiv!(op1)

    @test size(op2) == (NK, NK)
    @test has_adjoint(op2)
    @test has_mul(op2)
    @test has_mul!(op2)
    @test has_ldiv(op2)
    @test has_ldiv!(op2)

    op1_no_inverse = FunctionOperator(f1, v; ifcache = false, islinear = true)
    op2_no_inverse = FunctionOperator(f2, v, w; ifcache = false, islinear = true)

    inverse_error(f) = try
        f()
        nothing
    catch err
        err
    end

    err = inverse_error(() -> op1_no_inverse \ v)
    @test err isa ArgumentError
    @test occursin("op_inverse", sprint(showerror, err))

    err = inverse_error(() -> ldiv!(w, op2_no_inverse, v))
    @test err isa ArgumentError
    @test occursin("op_inverse", sprint(showerror, err))

    @test !iscached(op1)
    @test !iscached(op2)
    @test !op1.traits.has_mul5
    @test op2.traits.has_mul5

    # 5-arg mul! (w/o cache)
    v = rand(N, K)
    w = copy(v)
    @test α * _mul(A, v) + β * w ≈ mul!(w, op2, v, α, β)

    # Create test vectors for new interface
    action_vec = rand(N, K)  # Action vector
    result_vec = zeros(N, K) # Result vector

    # Cache operators
    op1 = cache_operator(op1, v)
    op2 = cache_operator(op2, v)

    @test iscached(op1)
    @test iscached(op2)

    # Test standard operator operations (from original test)
    w = rand(N, K)
    @test _mul(A, v) ≈ op1 * v ≈ mul!(w, op2, v) ≈ mul!(w, op1, v)
    w = rand(N, K)
    @test _mul(A, v) ≈ op1(v, u, p, t) ≈ op2(v, u, p, t)
    v = rand(N, K)
    w = copy(v)
    @test α * _mul(A, v) + β * w ≈ mul!(w, op2, v, α, β)

    w = rand(N, K)
    @test _div(A, w) ≈ op1 \ w ≈ ldiv!(v, op2, w)
    w = copy(v)
    @test _div(A, w) ≈ ldiv!(op2, w)

    # Test with new interface - out of place
    @test _mul(A, action_vec) ≈ op1(action_vec, u, p, t)

    # Test with new interface - in place
    op2(result_vec, action_vec, u, p, t)
    @test result_vec ≈ _mul(A, action_vec)

    # Test in-place with scaling
    result_vec = rand(N, K)
    orig_result = copy(result_vec)
    op2(result_vec, action_vec, u, p, t, α, β)
    @test result_vec ≈ α * _mul(A, action_vec) + β * orig_result

    # Test inverse operations with new interface
    inv_result = zeros(N, K)
    @test _div(A, action_vec) ≈ op1 \ action_vec
    ldiv!(inv_result, op2, action_vec)
    @test inv_result ≈ _div(A, action_vec)
end

@testset "Batched FunctionOperator" begin
    v = rand(N, K)
    u = nothing
    p = nothing
    t = 0.0
    α = rand()
    β = rand()

    A = rand(N, N) |> Symmetric
    F = lu(A)
    Ai = inv(A)

    f1(v, u, p, t) = A * v
    f1i(v, u, p, t) = A \ v

    f2(w, v, u, p, t) = mul!(w, A, v)
    f2(w, v, u, p, t, α, β) = mul!(w, A, v, α, β)
    f2i(w, v, u, p, t) = ldiv!(w, F, v)
    f2i(w, v, u, p, t, α, β) = mul!(w, Ai, v, α, β)

    # out of place
    op1 = FunctionOperator(
        f1, v, A * v; op_inverse = f1i, ifcache = false,
        batch = true,
        islinear = true,
        opnorm = true,
        issymmetric = true,
        ishermitian = true,
        isposdef = true
    )

    # in place
    op2 = FunctionOperator(
        f2, v, A * v; op_inverse = f2i, ifcache = false,
        batch = true,
        islinear = true,
        opnorm = true,
        issymmetric = true,
        ishermitian = true,
        isposdef = true
    )

    @test issquare(op1)
    @test issquare(op2)

    @test islinear(op1)
    @test islinear(op2)

    @test op1' === op1

    @test size(op1) == (N, N)
    @test has_adjoint(op1)
    @test has_mul(op1)
    @test has_mul!(op1)
    @test has_ldiv(op1)
    @test !has_ldiv!(op1)

    @test size(op2) == (N, N)
    @test has_adjoint(op2)
    @test has_mul(op2)
    @test has_mul!(op2)
    @test has_ldiv(op2)
    @test has_ldiv!(op2)

    @test !iscached(op1)
    @test !iscached(op2)

    @test !op1.traits.has_mul5
    @test op2.traits.has_mul5

    # 5-arg mul! (w/o cache)
    v = rand(N, K)
    w = copy(v)
    @test α * *(A, v) + β * w ≈ mul!(w, op2, v, α, β)

    op1 = cache_operator(op1, v)
    op2 = cache_operator(op2, v)

    @test iscached(op1)
    @test iscached(op2)

    v = rand(N, K)
    @test *(A, v) ≈ op1 * v ≈ mul!(w, op2, v)

    # Test with new interface
    v = rand(N, K)
    @test *(A, v) ≈ op1(w, v, u, p, t) ≈ op2(w, v, u, p, t)

    v = rand(N, K)
    w = copy(v)
    @test α * *(A, v) + β * w ≈ mul!(w, op2, v, α, β)

    # Test old style calls
    w = rand(N, K)
    @test \(A, w) ≈ op1 \ w ≈ ldiv!(v, op2, w)
    w = copy(v)
    @test \(A, w) ≈ ldiv!(op2, w)

    # Test new interface ldiv
    w = rand(N, K)
    ldiv_result = zeros(N, K)
    ldiv!(ldiv_result, op2, w)
    @test ldiv_result ≈ A \ w
end

@testset "FunctionOperator update test" begin
    u = rand(N, N)  # Update vector
    v = rand(N, K)  # Action vector
    w = zeros(N, K) # Result vector
    p = rand(N)
    t = rand()
    scale = rand()

    # Accept a kwarg "scale" in operator action
    f(w, v, u, p, t; scale = 1.0) = mul!(w, Diagonal(u * p * t * scale), v)
    f(v, u, p, t; scale = 1.0) = Diagonal(u * p * t * scale) * v

    # Test with both tuple and Val forms of accepted_kwargs
    for acc_kw in ((:scale,), Val((:scale,)))
        # Function operator with keyword arguments
        L = FunctionOperator(
            f, v, w;
            u = u,
            p = zero(p),
            t = zero(t),
            batch = true,
            accepted_kwargs = acc_kw,
            scale = 1.0
        )

        @test_throws ArgumentError FunctionOperator(
            f, v, w; u = u, p = zero(p), t = zero(t), batch = true,
            accepted_kwargs = acc_kw
        )

        @test size(L) == (N, N)

        # Expected result with scaling
        A = Diagonal(u * p * t * scale)
        expected = A * v
        ans = u * p .* t .* scale

        # Test with new interface
        @test L(v, u, p, t; scale) ≈ expected

        # Test in-place with new interface
        copy!(w, zeros(N, K))
        L(w, v, u, p, t; scale)
        @test w ≈ expected

        # Test in-place with scaling
        copy!(w, rand(N, K))
        orig_w = copy(w)
        α_val = rand()
        β_val = rand()
        L(w, v, u, p, t, α_val, β_val; scale)
        @test w ≈ α_val * expected + β_val * orig_w

        # Test that outputs aren't accidentally mutated
        v1 = rand(N, K)
        v2 = rand(N, K)
        w1 = rand(N, K)
        w2 = rand(N, K)

        # Expected results with different vectors
        result1 = A * v1
        result2 = A * v2

        # Test output consistency
        w1 = zeros(N, K)
        w2 = zeros(N, K)

        L(w1, v1, u, p, t; scale)
        L(w2, v2, u, p, t; scale)

        @test w1 ≈ result1
        @test w2 ≈ result2

        # Test matrix-vector multiplication
        w1 = L * v1
        @test w1 ≈ A * v1
        w2 = L * v2
        @test w2 ≈ A * v2
        @test w1 ≈ A * v1  # Check v1 hasn't changed
        @test w1 + w2 ≈ A * (v1 + v2)

        # Test in-place matrix-vector multiplication
        v1 .= 0.0
        v2 .= 0.0

        mul!(w1, L, v1)
        @test w1 ≈ A * v1
        mul!(w2, L, v2)
        @test w2 ≈ A * v2
        @test w1 ≈ A * v1
        @test w1 + w2 ≈ A * (v1 + v2)

        # Test scaling
        v1 = rand(N, K)
        w1 = copy(v1)
        v2 = rand(N, K)
        w2 = copy(v2)
        a1, a2, b1, b2 = rand(4)

        res = copy(w1)
        mul!(res, L, v1, a1, b1)
        @test res ≈ a1 * A * v1 + b1 * w1
        res2 = copy(w2)
        mul!(res2, L, v2, a2, b2)
        @test res2 ≈ a2 * A * v2 + b2 * w2
        @test res ≈ a1 * A * v1 + b1 * w1
        @test res + res2 ≈ (a1 * A * v1 + b1 * w1) + (a2 * A * v2 + b2 * w2)
    end
end

using Documenter, SciMLOperators

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force = true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force = true)

include("pages.jl")

makedocs(sitename = "SciMLOperators.jl",
    authors = "Vedant Puri, Alex Jones, Chris Rackauckas",
    modules = [SciMLOperators],
    clean = true, doctest = false, linkcheck = true,
    warnonly = [:docs_block, :missing_docs, :cross_references, :linkcheck],
    format = Documenter.HTML(assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/SciMLOperators/stable"),
    pages = pages)

deploydocs(repo = "github.com/SciML/SciMLOperators.jl.git";
    push_preview = true)

"""
    AbstractWOperator{T} <: AbstractSciMLOperator{T}

Developer-facing interface for operators representing the implicit-solver
matrix ``W = J - MM / gamma``. This type is intentionally not exported and
should not be used as a user-facing construction target.

# Interface Rules

A concrete subtype must provide `size`, matrix-like `*`, and
`mul!(out, W, x)` with the same shape and return-value rules as
[`AbstractSciMLOperator`](@ref). If `has_mul!(W)` is true, it must also
provide `mul!(out, W, x, alpha, beta)` implementing
`out = alpha * (W * x) + beta * out`, and both mutating methods must return
`out`. It must also expose enough state for the implicit solver that owns it
to update the Jacobian and mass-matrix actions. Define `isconvertible` and
`convert(AbstractMatrix, W)` only when materialization is supported.

If a consumer caches a Jacobian-dependent factorization, it should implement
the [`jacobian_stale`](@ref), [`mark_jacobian_updated!`](@ref), and
[`mark_jacobian_current!`](@ref) protocol or keep an equivalent private
generation for its own subtype.
"""
abstract type AbstractWOperator{T} <: AbstractSciMLOperator{T} end

"""
$(TYPEDEF)

Small dense factorization helper for repeated solves with a fixed `W` matrix.

# Arguments

  - `W`: Concrete square matrix to solve against.
  - `callinv`: Whether very small matrices may store `inv(W)` for direct
    multiplication during `\\`.

# Fields

$(FIELDS)

# Interface Rules

`StaticWOperator` is a specialized helper for solver internals that need a
fixed W-operator solve. It supports `Wstatic \\ v`; it does not participate in
coefficient updates and should be reconstructed when the underlying matrix
changes. This is a developer-facing helper, not a general-purpose
factorization type; user code should normally use `factorize` or a solver's
documented linear-operator interface instead.

# Returns

`StaticWOperator(W, callinv) \\ v` returns the solution of `W * x = v`.

# Errors

The constructor and solve throw the same errors as the selected inverse or
factorization for nonsquare or singular input.

# Examples

```julia
using LinearAlgebra, SciMLOperators

W = StaticWOperator([2.0 0.0; 0.0 4.0])
W \\ [2.0, 8.0]
```
"""
struct StaticWOperator{isinv, T, F} <: AbstractWOperator{T}
    W::T
    F::F
    function StaticWOperator(W::T, callinv = true) where {T}
        n = size(W, 1)
        isinv = n <= 7 # cutoff where LU has noticeable overhead

        F = if isinv && callinv
            ArrayInterface.lu_instance(W)
        else
            lu(W, check = false)
        end
        # when constructing W for the first time for the type
        # inv(W) can be singular
        _W = if isinv && callinv
            inv(W)
        else
            W
        end
        return new{isinv, T, typeof(F)}(_W, F)
    end
end
Base.:\(W::StaticWOperator{isinv}, v::AbstractArray) where {isinv} = isinv ? W.W * v : W.F \ v

"""
$TYPEDEF

    WOperator{IIP}(mass_matrix, gamma, J, u[, jacvec])

A linear operator that represents the W matrix used by implicit ODE solvers,
defined as

```math
W = J - \\frac{1}{\\gamma}MM
```

where `MM` is the mass matrix, `gamma` is a scalar, and `J` is the Jacobian
operator. The sign convention matches the matrix action implemented by
`WOperator`: `W * x == J * x - (MM * x) / gamma`.

# Arguments

  - `mass_matrix`: A matrix-like object, `UniformScaling`, or `MatrixOperator`
    representing `MM`.
  - `gamma`: Scalar coefficient in the W-operator definition.
  - `J`: Jacobian represented as a number, matrix, or `AbstractSciMLOperator`.
  - `u`: Prototype state used to allocate the internal multiplication cache.
  - `jacvec`: Optional operator used for Jacobian-vector products in `mul!`.

# Fields

$(FIELDS)

The fields have the following interface-relevant meanings:

  - `mass_matrix`: The current mass-matrix action `MM`.
  - `gamma`: The scalar in the mass-matrix term.
  - `J`: The current Jacobian action.
  - `jacvec`: Optional replacement for `J` in matrix-free `mul!` calls.
  - `jac_stale`: Whether a consumer has been told that the Jacobian changed
    since its last factorization.

`_func_cache` and `_concrete_form` are implementation storage and are not
part of the extension contract.

# Interface Rules

`WOperator` is part of the public solver-developer interface used by implicit
ODE solvers. It supports matrix-like `*`, `\\`, `mul!`, indexing, sizing, and
concretization. Calling `update_coefficients!(W, u, p, t; gamma)` updates the
Jacobian, mass matrix, optional Jacobian-vector operator, and stored `gamma`.
Omitting `(u, p, t)` leaves those operators unchanged and only updates `gamma`
when it is supplied. The caller must call
[`mark_jacobian_updated!`](@ref) after mutating the contents of `J` in place;
the operator cannot observe that mutation automatically.

`IIP` controls whether conversion reuses the internally stored concrete form
as an in-place operator. The public contract is the mathematical action of
`W`; downstream code should not depend on `_func_cache` or `_concrete_form`.
This type is intended for solver developers extending the implicit-solver
interface. End users should construct it only when a solver's documentation
explicitly requests a `WOperator`.

# Returns

`WOperator{IIP}(mass_matrix, gamma, J, u, jacvec)` returns a mutable operator
with the size of `J`. `*`, `mul!`, `\\`, and `concretize` use the current
values of its fields and preserve the matrix action above.

# Errors

Construction or application can throw the dimension, conversion, or
factorization errors raised by the supplied mass matrix and Jacobian. A
matrix-free `J` or mass matrix cannot be materialized by
`convert(AbstractMatrix, W)` unless both operands support that conversion.

# Examples

```julia
using LinearAlgebra, SciMLOperators

J = MatrixOperator([1.0 2.0; 3.0 4.0])
W = WOperator{true}(I, 0.5, J, zeros(2))

v = [1.0, 2.0]
W * v == (Matrix(W) * v)
```
"""
mutable struct WOperator{
        IIP, T,
        MType,
        GType,
        JType,
        F,
        C,
        JV,
    } <: AbstractWOperator{T}
    mass_matrix::MType
    gamma::GType
    J::JType
    _func_cache::F           # cache used in `mul!`
    _concrete_form::C        # non-lazy form (matrix/number) of the operator
    jacvec::JV
    # Set by `mark_jacobian_updated!` whenever `J`'s contents change, cleared by the
    # consumer via `mark_jacobian_current!`. A solver that caches a factorization of `J`
    # across steps needs to tell a new `gamma` from a new Jacobian; `gamma` it can compare
    # directly, but an in-place write to `J` is otherwise invisible. See `jacobian_stale`.
    jac_stale::Bool

    function WOperator{IIP}(mass_matrix, gamma, J, u, jacvec = nothing) where {IIP}
        if J isa Union{Number, ScalarOperator}
            _concrete_form = -mass_matrix / gamma + convert(Number, J)
            _func_cache = nothing
        else
            AJ = J isa MatrixOperator ? convert(AbstractMatrix, J) : J
            mm = mass_matrix isa MatrixOperator ?
                convert(AbstractMatrix, mass_matrix) : mass_matrix
            _concrete_form = -mm / gamma + AJ
            _func_cache = zero(u)
        end
        T = eltype(_concrete_form)
        MType = typeof(mass_matrix)
        GType = typeof(gamma)
        JType = typeof(J)
        F = typeof(_func_cache)
        C = typeof(_concrete_form)
        JV = typeof(jacvec)
        return new{IIP, T, MType, GType, JType, F, C, JV}(
            mass_matrix, gamma, J,
            # Starts stale: nobody has factorized this Jacobian yet.
            _func_cache, _concrete_form, jacvec, true
        )
    end

    function Base.copy(W::WOperator{IIP, T, MType, GType, JType, F, C, JV}) where {IIP, T, MType, GType, JType, F, C, JV}
        return new{IIP, T, MType, GType, JType, F, C, JV}(
            W.mass_matrix,
            W.gamma,
            W.J,
            copy(W._func_cache),
            copy(W._concrete_form),
            W.jacvec,
            W.jac_stale
        )
    end
end
Base.eltype(W::WOperator) = eltype(W.J)

"""
    jacobian_stale(W) -> Bool

Report whether the Jacobian-dependent state of `W` may have changed since a
consumer last declared its cached factorization or reduction current.

# Arguments

  - `W`: The object whose Jacobian-dependent state is being queried. For a
    `WOperator`, this is its `jac_stale` flag. Other objects use the
    conservative fallback.

# Returns

`true` means that a consumer must assume its Jacobian-dependent cache is
stale. `false` means that the consumer may reuse that cache with respect to
the Jacobian; it must still handle changes to `gamma` according to its own
algorithm. The fallback returns `true`.

# Interface Rules

A solver that owns a factorization or reduction of `W.J` should query this
predicate before reusing it and call [`mark_jacobian_current!`](@ref) only
after refreshing its cache. The flag is shared by consumers, so a single
`WOperator` must not be used as the cache source for independent consumers;
give each consumer its own operator or track its own generation.

# Examples

```julia
using LinearAlgebra, SciMLOperators

W = WOperator{true}(I, 0.5, [1.0 0.0; 0.0 2.0], zeros(2))
jacobian_stale(W) # true until the consumer has initialized its cache
mark_jacobian_current!(W)
!jacobian_stale(W)
```
"""
jacobian_stale(W::WOperator) = W.jac_stale
jacobian_stale(::Any) = true

"""
    mark_jacobian_updated!(W) -> W

Announce that the contents of `W`'s Jacobian have changed, invalidating any
Jacobian-dependent factorization or reduction a solver may be holding. A
no-op for anything that does not track a Jacobian, so it is safe to call
unconditionally after an in-place Jacobian update.

# Arguments

  - `W`: A `WOperator`, or any object for which the unconditional no-op
    fallback is desired.

# Returns

The same object `W`. For a `WOperator`, its `jac_stale` flag is set to `true`.

# Interface Rules

Call this after the contents of `W.J` have been changed in place. Changing
`gamma` is a different event and needs no announcement because it is visible
as a field. This function does not refactorize or otherwise update a cache.

# Examples

```julia
using LinearAlgebra, SciMLOperators

J = [1.0 0.0; 0.0 2.0]
W = WOperator{true}(I, 0.5, J, zeros(2))
mark_jacobian_current!(W)
J .= 3I
mark_jacobian_updated!(W)
jacobian_stale(W) # true
```
"""
mark_jacobian_updated!(A) = A
function mark_jacobian_updated!(W::WOperator)
    W.jac_stale = true
    return W
end

"""
    mark_jacobian_current!(W) -> W

Declare that the caller's Jacobian-dependent cache is up to date, clearing
the flag [`mark_jacobian_updated!`](@ref) set. A no-op off the type.

# Arguments

  - `W`: A `WOperator`, or any object for which the unconditional no-op
    fallback is desired.

# Returns

The same object `W`. For a `WOperator`, its `jac_stale` flag is set to `false`.

# Interface Rules

Call this only after the consumer has actually refreshed its factorization or
reduction. Calling it does not inspect `J` and does not refresh any cache.

# Examples

```julia
using LinearAlgebra, SciMLOperators

W = WOperator{true}(I, 0.5, [1.0 0.0; 0.0 2.0], zeros(2))
mark_jacobian_current!(W)
@assert !jacobian_stale(W)
```

!!! warning "One consumer per operator"
    This is a single shared flag, not a per-consumer generation count. Two solvers caching
    factorizations of the same `W` will race: whichever clears first hides the event from
    the other, which then reuses a stale factorization. Give each consumer its own
    `WOperator` if you need more than one.
"""
mark_jacobian_current!(A) = A
function mark_jacobian_current!(W::WOperator)
    W.jac_stale = false
    return W
end

# In WOperator update_coefficients!, accept both missing u/p/t and missing gamma and don't update them in that case.
# This helps support partial updating logic used with Newton solvers.
# Accept both `gamma` and deprecated `dtgamma` kwargs for backwards compatibility.
function update_coefficients!(
        W::WOperator,
        u = nothing,
        p = nothing,
        t = nothing;
        gamma = nothing,
        dtgamma = nothing
    )
    if dtgamma !== nothing
        Base.depwarn(
            "keyword argument `dtgamma` is deprecated, use `gamma` instead",
            :update_coefficients!
        )
        if gamma === nothing
            gamma = dtgamma
        end
    end
    if (u !== nothing) && (p !== nothing) && (t !== nothing)
        update_coefficients!(W.J, u, p, t)
        update_coefficients!(W.mass_matrix, u, p, t)
        !isnothing(W.jacvec) && update_coefficients!(W.jacvec, u, p, t)
    end
    gamma !== nothing && (W.gamma = gamma)
    return W
end

function Base.convert(::Type{AbstractMatrix}, W::WOperator{IIP}) where {IIP}
    if !IIP || W.J isa AbstractSciMLOperator
        # Mirror the constructor: materialize a MatrixOperator mass matrix so the
        # result type matches `_concrete_form` (otherwise this becomes an
        # AddedOperator and the assignment back into the Matrix-typed slot fails).
        # The IIP case with a plain-matrix `J` is maintained externally via
        # `jacobian2W!` writing into `_concrete_form`; when `J` is an operator no
        # caller maintains it, so it must be rebuilt here with the current gamma.
        mm = W.mass_matrix isa MatrixOperator ?
            convert(AbstractMatrix, W.mass_matrix) : W.mass_matrix
        concrete_form = -mm / W.gamma + convert(AbstractMatrix, W.J)
        # Operator arithmetic can make `_concrete_form` lazy even though its
        # concretization is a matrix, so the rebuilt value may not fit its field type.
        W.J isa AbstractSciMLOperator && return concrete_form
        W._concrete_form = concrete_form
    end
    return W._concrete_form
end
function Base.convert(::Type{Number}, W::WOperator)
    W._concrete_form = -W.mass_matrix / W.gamma + convert(Number, W.J)
    return W._concrete_form
end
# `convert(AbstractMatrix, W)` fuses `-M/γ` with `convert(AbstractMatrix, W.J)`, so `W` is
# convertible exactly when both its mass matrix `M` and its Jacobian `W.J` are. A matrix-free
# `W.J` (e.g. a Jacobian-vector-product operator) — or a matrix-free mass matrix — makes `W`
# matrix-free too; without this the default `all(isconvertible, getops(W)) ==
# all(isconvertible, ()) == true` would wrongly claim a matrix-free `W` is convertible.
isconvertible(W::WOperator) = isconvertible(W.mass_matrix) && isconvertible(W.J)
Base.size(W::WOperator) = size(W.J)
Base.size(W::WOperator, d::Integer) = d <= 2 ? size(W)[d] : 1
function Base.getindex(W::WOperator, i::Int)
    return -W.mass_matrix[i] / W.gamma + W.J[i]
end
function Base.getindex(W::WOperator, I::Vararg{Int, N}) where {N}
    return -W.mass_matrix[I...] / W.gamma + W.J[I...]
end
function Base.:*(W::WOperator, x::AbstractVecOrMat)
    return (W.mass_matrix * x) / -W.gamma + W.J * x
end
function Base.:*(W::WOperator, x::Number)
    return (W.mass_matrix * x) / -W.gamma + W.J * x
end
function Base.:\(W::WOperator, x::AbstractVecOrMat)
    return if size(W) == () # scalar operator
        convert(Number, W) \ x
    else
        convert(AbstractMatrix, W) \ x
    end
end
function Base.:\(W::WOperator, x::Number)
    return if size(W) == () # scalar operator
        convert(Number, W) \ x
    else
        convert(AbstractMatrix, W) \ x
    end
end

function LinearAlgebra.mul!(Y::AbstractVector, W::WOperator, B::AbstractVector)
    # Compute mass_matrix * B
    if isa(W.mass_matrix, UniformScaling)
        a = -W.mass_matrix.λ / W.gamma
        @. Y = a * B
    else
        mul!(Y, W.mass_matrix, B)
        lmul!(-inv(W.gamma), Y)
    end
    # Compute J * B and add
    if isnothing(W.jacvec)
        mul!(W._func_cache, W.J, B)
    else
        mul!(W._func_cache, W.jacvec, B)
    end
    return Y .+= W._func_cache
end

function LinearAlgebra.mul!(Y::AbstractArray, W::WOperator, B::AbstractArray)
    # Compute mass_matrix * B
    if isa(W.mass_matrix, UniformScaling)
        a = -W.mass_matrix.λ / W.gamma
        @. Y = a * B
    else
        mul!(vec(Y), W.mass_matrix, vec(B))
        lmul!(-inv(W.gamma), Y)
    end
    # Compute J * B and add
    if isnothing(W.jacvec)
        mul!(vec(W._func_cache), W.J, vec(B))
    else
        mul!(vec(W._func_cache), W.jacvec, vec(B))
    end
    return vec(Y) .+= vec(W._func_cache)
end

has_concretization(::AbstractWOperator) = true

function has_concretization(W::WOperator)
    return has_concretization(W.mass_matrix) & has_concretization(W.J)
end

using SciMLOperators
using LinearAlgebra
using Test

@testset "Copy methods for SciMLOperators" begin
    # Test MatrixOperator
    @testset "MatrixOperator" begin
        A = rand(5, 5)
        L = MatrixOperator(A)
        L_copy = copy(L)

        # Modify original
        L.A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.A[1, 1] != 999.0
        @test L_copy.A != L.A

        # `copy` must preserve `update_func!` — both its type (so the result is not a
        # different concrete type that can't be assigned back into a typed slot) and its
        # behavior (a copy of a state-dependent operator stays state-dependent).
        @test typeof(L_copy) === typeof(L)
        M = MatrixOperator(zeros(2, 2); update_func! = (B, u, p, t) -> (B[1, 1] = u[1]; B))
        M_copy = copy(M)
        @test typeof(M_copy) === typeof(M)
        update_coefficients!(M_copy, [7.0], nothing, nothing)
        @test M_copy.A[1, 1] == 7.0
    end

    # Test DiagonalOperator (which is a MatrixOperator with Diagonal matrix)
    @testset "DiagonalOperator" begin
        d = rand(5)
        L = DiagonalOperator(d)
        L_copy = copy(L)

        # Modify original
        L.A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.A[1, 1] != 999.0
        @test L_copy.A != L.A
    end

    # Test ScalarOperator
    @testset "ScalarOperator" begin
        L = ScalarOperator(2.0)
        L_copy = copy(L)

        # Modify original
        L.val = 999.0

        # Check that copy is not affected
        @test L_copy.val == 2.0
    end

    # Test AffineOperator
    @testset "AffineOperator" begin
        A = MatrixOperator(rand(5, 5))
        B = MatrixOperator(rand(5, 5))
        b = rand(5)
        L = AffineOperator(A, B, b)
        L_copy = copy(L)

        # Modify original
        L.b[1] = 999.0
        L.A.A[1, 1] = 888.0
        L.B.A[1, 1] = 777.0

        # Check that copy is not affected
        @test L_copy.b[1] != 999.0
        @test L_copy.A.A[1, 1] != 888.0
        @test L_copy.B.A[1, 1] != 777.0
    end

    # Test ComposedOperator
    @testset "ComposedOperator" begin
        A = MatrixOperator(rand(5, 5))
        B = MatrixOperator(rand(5, 5))
        L = A ∘ B
        L_copy = copy(L)

        # Modify original
        L.ops[1].A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.ops[1].A[1, 1] != 999.0
    end

    # Test InvertedOperator
    @testset "InvertedOperator" begin
        A = MatrixOperator(rand(5, 5) + 5I)  # Make sure it's invertible
        L = inv(A)
        L_copy = copy(L)

        # Modify original
        L.L.A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.L.A[1, 1] != 999.0
    end

    # Test TensorProductOperator
    @testset "TensorProductOperator" begin
        A = MatrixOperator(rand(3, 3))
        B = MatrixOperator(rand(2, 2))
        L = kron(A, B)  # Use kron instead of ⊗
        L_copy = copy(L)

        # Modify original
        L.ops[1].A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.ops[1].A[1, 1] != 999.0
    end

    # Test AdjointOperator
    @testset "AdjointOperator" begin
        A = MatrixOperator(rand(5, 5))
        L = SciMLOperators.AdjointOperator(A)  # Create AdjointOperator explicitly
        L_copy = copy(L)

        # Modify original
        L.L.A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.L.A[1, 1] != 999.0
    end

    # Test TransposedOperator
    @testset "TransposedOperator" begin
        A = MatrixOperator(rand(5, 5))
        L = SciMLOperators.TransposedOperator(A)  # Create TransposedOperator explicitly
        L_copy = copy(L)

        # Modify original
        L.L.A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.L.A[1, 1] != 999.0
    end

    # Test AddedScalarOperator
    @testset "AddedScalarOperator" begin
        α = ScalarOperator(2.0)
        β = ScalarOperator(3.0)
        L = α + β
        L_copy = copy(L)

        # Modify original
        L.ops[1].val = 999.0

        # Check that copy is not affected
        @test L_copy.ops[1].val == 2.0
    end

    # Test ComposedScalarOperator
    @testset "ComposedScalarOperator" begin
        α = ScalarOperator(2.0)
        β = ScalarOperator(3.0)
        L = α * β
        L_copy = copy(L)

        # Modify original
        L.ops[1].val = 999.0

        # Check that copy is not affected
        @test L_copy.ops[1].val == 2.0
    end

    # Test InvertedScalarOperator
    @testset "InvertedScalarOperator" begin
        α = ScalarOperator(2.0)
        L = inv(α)
        L_copy = copy(L)

        # Modify original
        L.λ.val = 999.0

        # Check that copy is not affected
        @test L_copy.λ.val == 2.0
    end

    # Test IdentityOperator (should return self)
    @testset "IdentityOperator" begin
        L = IdentityOperator(5)
        L_copy = copy(L)

        # Should be the same object since it's immutable
        @test L === L_copy
    end

    # Test NullOperator (should return self)
    @testset "NullOperator" begin
        L = NullOperator(5)
        L_copy = copy(L)

        # Should be the same object since it's immutable
        @test L === L_copy
    end

    # Test InvertibleOperator
    @testset "InvertibleOperator" begin
        A = rand(5, 5) + 5I  # Make sure it's invertible
        M = MatrixOperator(A)
        F = lu(A)
        L = InvertibleOperator(M, F)
        L_copy = copy(L)

        # Modify original
        L.L.A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.L.A[1, 1] != 999.0
    end

    # Test ScaledOperator
    @testset "ScaledOperator" begin
        α = ScalarOperator(2.0)
        A = MatrixOperator(rand(5, 5))
        L = α * A
        L_copy = copy(L)

        # Modify original
        L.λ.val = 999.0
        L.L.A[1, 1] = 888.0

        # Check that copy is not affected
        @test L_copy.λ.val == 2.0
        @test L_copy.L.A[1, 1] != 888.0
    end

    # Test AddedOperator
    @testset "AddedOperator" begin
        A = MatrixOperator(rand(5, 5))
        B = MatrixOperator(rand(5, 5))
        L = A + B
        L_copy = copy(L)

        # Modify original
        L.ops[1].A[1, 1] = 999.0

        # Check that copy is not affected
        @test L_copy.ops[1].A[1, 1] != 999.0
    end

    # Test that operators still work correctly after copying
    @testset "Functionality after copy" begin
        # MatrixOperator
        A = rand(5, 5)
        L = MatrixOperator(A)
        L_copy = copy(L)
        v = rand(5)
        @test L * v ≈ L_copy * v

        # ScalarOperator
        α = ScalarOperator(2.0)
        α_copy = copy(α)
        @test α * v ≈ α_copy * v

        # ComposedOperator
        B = MatrixOperator(rand(5, 5))
        comp = L ∘ B
        comp_copy = copy(comp)
        @test comp * v ≈ comp_copy * v

        # AffineOperator
        b = rand(5)
        aff = AffineOperator(L, B, b)
        aff_copy = copy(aff)
        @test aff * v ≈ aff_copy * v
    end
end

using SciMLOperators, Adapt, Test, LinearAlgebra

#
# Adapt.jl Integration Tests
#
# Tests verify that Adapt.adapt_structure correctly handles array-backed operators
# and recursively adapts nested/composite operators without GPU dependencies.
#

# ============================================================================
# Custom Test Adaptor (no GPU required)
# ============================================================================

"""
    CustomArray{T, N, AT <: AbstractArray{T, N}}

Lightweight array wrapper used to prove Adapt changed storage types.
"""
struct CustomArray{T, N, AT <: AbstractArray{T, N}} <: AbstractArray{T, N}
    data::AT
end

CustomArray(x::AT) where {T, N, AT <: AbstractArray{T, N}} = CustomArray{T, N, AT}(x)

Base.size(x::CustomArray) = size(x.data)
Base.getindex(x::CustomArray, I...) = getindex(x.data, I...)

function Adapt.adapt_storage(::Type{CustomArray}, x::AbstractArray)
    return CustomArray(x)
end

# ============================================================================
# Helpers
# ============================================================================

"""
    has_customarray(obj)

Recursively detect whether any field in `obj` contains a `CustomArray`.
"""
function has_customarray(obj)
    if obj isa CustomArray
        return true
    elseif obj isa Tuple || obj isa AbstractVector
        return any(has_customarray, obj)
    elseif obj isa SciMLOperators.AbstractSciMLOperator
        return any(fname -> has_customarray(getfield(obj, fname)), fieldnames(typeof(obj)))
    else
        return false
    end
end

# ============================================================================
# Test Suite
# ============================================================================

@testset "Adapt.jl Support for SciMLOperators" begin

    # ========================================================================
    # Direct Array-Backed Operators
    # ========================================================================

    @testset "MatrixOperator" begin
        L = MatrixOperator(rand(5, 5))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa MatrixOperator
        @test L_adapted.A isa CustomArray
        @test L_adapted.update_func === L.update_func
        @test L_adapted.update_func! === L.update_func!
    end

    @testset "BatchedDiagonalOperator" begin
        L = DiagonalOperator(rand(5, 3))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        # DiagonalOperator constructor returns BatchedDiagonalOperator.
        @test L_adapted isa SciMLOperators.BatchedDiagonalOperator
        @test L_adapted.diag isa CustomArray
        @test L_adapted.update_func === L.update_func
        @test L_adapted.update_func! === L.update_func!
    end

    @testset "AffineOperator" begin
        A = MatrixOperator(rand(5, 5))
        B = MatrixOperator(rand(5, 5))
        L = AffineOperator(A, B, rand(5))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa AffineOperator
        @test L_adapted.A isa MatrixOperator
        @test L_adapted.B isa MatrixOperator
        @test L_adapted.A.A isa CustomArray
        @test L_adapted.B.A isa CustomArray
        @test L_adapted.b isa CustomArray
    end

    @testset "FunctionOperator" begin
        input = rand(5)
        output = rand(5)
        op = (v, u, p, t) -> 0.5 .* v
        L = FunctionOperator(op, input, output; u = rand(3), p = rand(4), t = 0.0)
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa FunctionOperator
        @test L_adapted.u isa CustomArray
        @test L_adapted.p isa CustomArray
    end

    # ========================================================================
    # Recursive Wrapper Operators
    # ========================================================================

    @testset "ScaledOperator" begin
        L = 2.5 * MatrixOperator(rand(5, 5))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.ScaledOperator
        @test L_adapted.L isa MatrixOperator
        @test L_adapted.L.A isa CustomArray
    end

    @testset "AddedOperator" begin
        L = MatrixOperator(rand(5, 5)) + DiagonalOperator(rand(5, 3))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.AddedOperator
        @test L_adapted.ops[1] isa MatrixOperator
        @test L_adapted.ops[2] isa SciMLOperators.BatchedDiagonalOperator
        @test L_adapted.ops[1].A isa CustomArray
        @test L_adapted.ops[2].diag isa CustomArray
    end

    @testset "ComposedOperator" begin
        L = MatrixOperator(rand(5, 5)) * MatrixOperator(rand(5, 5))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.ComposedOperator
        @test L_adapted.ops[1].A isa CustomArray
        @test L_adapted.ops[2].A isa CustomArray
    end

    @testset "InvertedOperator" begin
        L = inv(MatrixOperator(rand(5, 5)))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.InvertedOperator
        @test L_adapted.L.A isa CustomArray
    end

    @testset "InvertibleOperator" begin
        L = lu(MatrixOperator(rand(5, 5)))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.InvertibleOperator
        @test L_adapted.L.A isa CustomArray
    end

    @testset "BlockDiagonalOperator" begin
        L = BlockDiagonalOperator(MatrixOperator(rand(3, 3)), MatrixOperator(rand(2, 2)))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.BlockDiagonalOperator
        @test L_adapted.ops[1].A isa CustomArray
        @test L_adapted.ops[2].A isa CustomArray
    end

    @testset "AdjointOperator/TransposedOperator" begin
        L_adj = SciMLOperators.AdjointOperator(MatrixOperator(rand(5, 5)))
        L_t = SciMLOperators.TransposedOperator(MatrixOperator(rand(5, 5)))

        L_adj_adapted = Adapt.adapt_structure(CustomArray, L_adj)
        L_t_adapted = Adapt.adapt_structure(CustomArray, L_t)

        @test L_adj_adapted isa SciMLOperators.AdjointOperator
        @test L_adj_adapted.L isa MatrixOperator
        @test L_adj_adapted.L.A isa CustomArray

        @test L_t_adapted isa SciMLOperators.TransposedOperator
        @test L_t_adapted.L isa MatrixOperator
        @test L_t_adapted.L.A isa CustomArray
    end

    @testset "TensorProductOperator" begin
        import SciMLOperators.⊗
        L = MatrixOperator(rand(3, 3)) ⊗ MatrixOperator(rand(2, 2))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.TensorProductOperator
        @test L_adapted.ops[1].A isa CustomArray
        @test L_adapted.ops[2].A isa CustomArray
    end

    @testset "TensorSumOperator" begin
        L = kronsum(MatrixOperator(rand(3, 3)), MatrixOperator(rand(2, 2)))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.TensorSumOperator
        @test L_adapted.ops[1].A isa CustomArray
        @test L_adapted.ops[2].A isa CustomArray
    end

    # ========================================================================
    # Complex Nested Structures
    # ========================================================================

    @testset "Deeply Nested Composite Operator" begin
        L_nested = (MatrixOperator(rand(5, 5)) + DiagonalOperator(rand(5, 3))) * MatrixOperator(rand(5, 5))
        L_adapted = Adapt.adapt_structure(CustomArray, L_nested)

        @test L_adapted isa SciMLOperators.ComposedOperator
        @test L_adapted.ops[1] isa SciMLOperators.AddedOperator
        @test has_customarray(L_adapted)
    end

    @testset "Affine with Composed Operators" begin
        L = 2.0 * AffineOperator(MatrixOperator(rand(5, 5)), MatrixOperator(rand(5, 5)), rand(5))
        L_adapted = Adapt.adapt_structure(CustomArray, L)

        @test L_adapted isa SciMLOperators.ScaledOperator
        @test L_adapted.L isa SciMLOperators.AffineOperator
        @test L_adapted.L.A.A isa CustomArray
        @test L_adapted.L.B.A isa CustomArray
        @test L_adapted.L.b isa CustomArray
    end

    # ========================================================================
    # Array-Free Operators
    # ========================================================================

    @testset "Array-Free Operators" begin
        L_id = Adapt.adapt_structure(CustomArray, IdentityOperator(5))
        L_null = Adapt.adapt_structure(CustomArray, NullOperator(5, 5))

        @test L_id isa SciMLOperators.IdentityOperator
        @test L_null isa SciMLOperators.NullOperator
        @test !has_customarray(L_id)
        @test !has_customarray(L_null)
    end

end

println("All Adapt tests passed!")

pages = [
    "Home" => "index.md",
    "tutorials/getting_started.md",
    "Tutorials" => Any[
        "Demonstration of Operator Algebras and Kron" => "tutorials/operator_algebras.md",
        "FFT Tutorial" => "tutorials/fftw.md",
    ],
    "interface.md",
    "Premade Operators" => "premade_operators.md",
]

#
using SciMLOperators, LinearAlgebra
using Random

using SciMLOperators: InvertibleOperator, ⊗
using FFTW

Random.seed!(0)
N = 8
K = 12

@testset "FunctionOperator FFTW test" begin
    n = 256
    L = 2π

    dx = L / n
    x = (-L / 2):dx:(L / 2 - dx) |> Array

    k = rfftfreq(n, 2π * n / L) |> Array
    m = length(k)
    P = plan_rfft(x)

    fwd(v, u, p, t) = P * v
    bwd(v, u, p, t) = P \ v

    fwd(w, v, u, p, t) = mul!(w, P, v)
    bwd(w, v, u, p, t) = ldiv!(w, P, v)

    ftr = FunctionOperator(
        fwd, x, im * k;
        T = ComplexF64, op_adjoint = bwd,
        op_inverse = bwd,
        op_adjoint_inverse = fwd, islinear = true
    )

    @test size(ftr) == (length(k), length(x))

    # derivative test
    ik = im * DiagonalOperator(k)
    Dx = ftr \ ik * ftr
    Dx = cache_operator(Dx, x)
    D2x = cache_operator(Dx * Dx, x)

    v = @. sin(5x)cos(7x)
    w = @. 5cos(5x)cos(7x) - 7sin(5x)sin(7x)
    w2x = @. 5(-5sin(5x)cos(7x) - 7cos(5x)sin(7x)) +
        -7(5cos(5x)sin(7x) + 7sin(5x)cos(7x))

    @test ≈(Dx * v, w; atol = 1.0e-8)
    @test ≈(D2x * v, w2x; atol = 1.0e-8)

    w2 = zero(w)
    @test ≈(mul!(w2, D2x, v), w2x; atol = 1.0e-8)
    w2 = zero(w)
    @test ≈(mul!(w2, Dx, v), w; atol = 1.0e-8)

    itr = inv(ftr)
    ftt = ftr'
    itt = itr'

    @test itr isa FunctionOperator
    @test ftt isa FunctionOperator
    @test itt isa FunctionOperator

    @test size(ftr) == (m, n)
    @test size(itr) == (n, m)
    @test size(ftt) == (n, m)
    @test size(itt) == (m, n)

    @test ftt.op == ftr.op_adjoint
    @test ftt.op_adjoint == ftr.op
    @test ftt.op_inverse == ftr.op_adjoint_inverse
    @test ftt.op_adjoint_inverse == ftr.op_inverse

    @test itr.op == ftr.op_inverse
    @test itr.op_adjoint == ftr.op_adjoint_inverse
    @test itr.op_inverse == ftr.op
    @test itr.op_adjoint_inverse == ftr.op_adjoint

    @test itt.op == ftr.op_adjoint_inverse
    @test itt.op_adjoint == ftr.op_inverse
    @test itt.op_inverse == ftr.op_adjoint
    @test itt.op_adjoint_inverse == ftr.op
end

@testset "Operator Algebra" begin
    N2 = N * N

    v = rand(N2, K)
    u = rand()
    p = rand()
    t = rand()

    A = rand(N, N)

    # Introduce update function for B
    B = MatrixOperator(zeros(N, N); update_func! = (A, u, p, t) -> (A .= p))

    # FunctionOp
    _C = rand(N, N) |> Symmetric
    f(v, u, p, t) = _C * v
    f(w, v, u, p, t) = mul!(w, _C, v)
    C = FunctionOperator(f, zeros(N); batch = true, issymmetric = true, p = p, u = u)

    # Introduce update function for D dependent on kwarg "matrix"
    D = MatrixOperator(
        zeros(N, N);
        update_func! = (A, u, p, t; matrix) -> (A .= p * t * matrix),
        accepted_kwargs = Val((:matrix,))
    )

    matrix = rand(N, N)
    diag = rand(N2)
    α = rand()
    β = rand()

    T1 = ⊗(A, B)
    T2 = ⊗(C, D)

    D1 = DiagonalOperator(zeros(N2); update_func! = (d, u, p, t) -> d .= p)
    D2 = DiagonalOperator(
        zeros(N2); update_func! = (d, u, p, t; diag) -> d .= p * t * diag,
        accepted_kwargs = Val((:diag,))
    )

    TT = [T1, T2]
    DD = Diagonal([D1, D2])

    op = TT' * DD * TT
    op = cache_operator(op, v)

    # Update operator
    @test_nowarn update_coefficients!(op, u, p, t; diag, matrix)

    # Form dense operator manually
    dense_T1 = kron(A, p * ones(N, N))
    dense_T2 = kron(_C, (p * t) .* matrix)
    dense_DD = Diagonal(vcat(p * ones(N2), p * t * diag))
    dense_op = hcat(dense_T1', dense_T2') * dense_DD * vcat(dense_T1, dense_T2)

    # Test correctness of op
    @test op * v ≈ dense_op * v

    # Test consistency with three-arg mul!
    w = rand(N2, K)
    @test mul!(w, op, v) ≈ op * v

    # Test consistency with in-place five-arg mul!
    w = rand(N2, K)
    w2 = copy(w)
    @test mul!(w, op, v, α, β) ≈ α * (op * v) + β * w2

    # Create a fresh operator for each test
    op_fresh = TT' * DD * TT
    op_fresh = cache_operator(op_fresh, v)
    # Use in-place update directly in test
    result1 = similar(v)
    mul!(result1, op_fresh, v)
    update_coefficients!(op_fresh, u, p, t; diag, matrix)
    @test result1 ≈ dense_op * v
end

@testset "Resize! test" begin
    M1 = 4
    M2 = 12

    v = rand(N)
    v1 = rand(M1)
    v2 = rand(M2)

    f(v, u, p, t) = 2 * v
    f(w, v, u, p, t) = (copy!(w, v); lmul!(2, w))

    fi(v, u, p, t) = 0.5 * v
    fi(w, v, u, p, t) = (copy!(w, v); lmul!(0.5, w))

    F = FunctionOperator(f, v, v; islinear = true, op_inverse = fi, issymmetric = true)

    multest(L, v) = @test mul!(zero(v), L, v) ≈ L * v

    function multest(L::SciMLOperators.AdjointOperator, v)
        @test mul!(adjoint(zero(v)), adjoint(v), L) ≈ adjoint(v) * L
    end

    function multest(L::SciMLOperators.TransposedOperator, v)
        @test mul!(transpose(zero(v)), transpose(v), L) ≈ transpose(v) * L
    end

    function multest(L::SciMLOperators.InvertedOperator, v)
        @test ldiv!(zero(v), L, v) ≈ L \ v
    end

    for (L, LT) in (
            (F, FunctionOperator),
            (F + F, SciMLOperators.AddedOperator),
            (F * 2, SciMLOperators.ScaledOperator),
            (F ∘ F, SciMLOperators.ComposedOperator),
            (AffineOperator(F, F, v), AffineOperator),
            (SciMLOperators.AdjointOperator(F), SciMLOperators.AdjointOperator),
            (SciMLOperators.TransposedOperator(F), SciMLOperators.TransposedOperator),
            (SciMLOperators.InvertedOperator(F), SciMLOperators.InvertedOperator),
            (SciMLOperators.InvertibleOperator(F, F), SciMLOperators.InvertibleOperator),
        )
        L = deepcopy(L)
        L = cache_operator(L, v)

        @test L isa LT
        @test size(L) == (N, N)
        multest(L, v)

        resize!(L, M1)
        @test size(L) == (M1, M1)
        multest(L, v1)

        resize!(L, M2)
        @test size(L) == (M2, M2)
        multest(L, v2)
    end

    # InvertedOperator
    # AffineOperator
    # FunctionOperator
end
#

module SciMLOperatorsStaticArraysCoreExt

import SciMLOperators
import StaticArraysCore

function Base.copyto!(L::SciMLOperators.MatrixOperator,
        rhs::Base.Broadcast.Broadcasted{<:StaticArraysCore.StaticArrayStyle})
    (copyto!(L.A, rhs); L)
end

end #module

using SciMLOperators, Random, SparseArrays, Test, LinearAlgebra
using SciMLOperators: IdentityOperator,
    NullOperator,
    ScaledOperator,
    AddedOperator,
    ComposedOperator,
    cache_operator

function apply_op!(H, w, v, u, p, t)
    H(w, v, u, p, t)
    return nothing
end

test_apply_noalloc(H, w, v, u, p, t) = @test (@allocations apply_op!(H, w, v, u, p, t)) == 0

@testset "Allocations Check" begin
    Random.seed!(0)
    N = 8
    K = 12
    A = rand(N, N) |> MatrixOperator
    B = rand(N, N) |> MatrixOperator
    u = rand(N, K)       # Update vector
    v = rand(N, K)       # Action vector
    w = zeros(N, K)      # Output vector
    p = ()
    t = 0
    op = AddedOperator(A, B)

    apply_op!(op, w, v, u, p, t) # Warm up
    if VERSION < v"1.10" || VERSION >= v"1.11"
        test_apply_noalloc(op, w, v, u, p, t)
    else
        # Julia 1.10 has a known allocation issue with AddedOperator
        @test (@allocations apply_op!(op, w, v, u, p, t)) == 2
    end

    for T in (Float32, Float64, ComplexF32, ComplexF64)
        N = 100
        A1_sparse = MatrixOperator(sprand(T, N, N, 5 / N))
        A2_sparse = MatrixOperator(sprand(T, N, N, 5 / N))
        A3_sparse = MatrixOperator(sprand(T, N, N, 5 / N))

        A1_dense = MatrixOperator(rand(T, N, N))
        A2_dense = MatrixOperator(rand(T, N, N))
        A3_dense = MatrixOperator(rand(T, N, N))

        coeff1(a, u, p, t) = sin(p.ω * t)
        coeff2(a, u, p, t) = cos(p.ω * t)
        coeff3(a, u, p, t) = sin(p.ω * t) * cos(p.ω * t)

        c1 = ScalarOperator(rand(T), coeff1)
        c2 = ScalarOperator(rand(T), coeff2)
        c3 = ScalarOperator(rand(T), coeff3)

        H_sparse = c1 * A1_sparse + c2 * A2_sparse + c3 * A3_sparse
        H_dense = c1 * A1_dense + c2 * A2_dense + c3 * A3_dense

        u = rand(T, N)
        v = rand(T, N)
        w = similar(u)
        p = (ω = 0.1,)
        t = 0.1

        apply_op!(H_sparse, w, v, u, p, t) # Warm up
        apply_op!(H_dense, w, v, u, p, t) # Warm up
        test_apply_noalloc(H_sparse, w, v, u, p, t)
        test_apply_noalloc(H_dense, w, v, u, p, t)
    end

    # Test ComposedOperator allocations (PR #316)
    # Before the fix, tuple splatting caused many allocations.
    # After the fix, we should have minimal allocations (Julia 1.11 has 1, earlier versions have 0).
    @testset "ComposedOperator minimal allocations" begin
        N = 100

        # Create operators for composition
        A1 = MatrixOperator(rand(N, N))
        A2 = MatrixOperator(rand(N, N))
        A3 = MatrixOperator(rand(N, N))

        # Create ComposedOperator
        L = A1 * A2 * A3

        # Set up cache
        v = rand(N)
        w = similar(v)
        L = cache_operator(L, v)

        u = rand(N)
        p = nothing
        t = 0.0

        # Warm up
        mul!(w, L, v)
        L(w, v, u, p, t)

        # Test mul! - should have minimal allocations
        # Julia 1.11 has a known minor allocation issue (1 allocation)
        # Earlier versions should have 0 allocations
        allocs_mul = @allocations mul!(w, L, v)
        @test allocs_mul <= 1

        # Test operator call - should have minimal allocations
        allocs_call = @allocations L(w, v, u, p, t)
        @test allocs_call <= 1

        # Test with matrices
        K = 5
        V = rand(N, K)
        W = similar(V)
        L_mat = cache_operator(A1 * A2 * A3, V)

        # Warm up
        mul!(W, L_mat, V)
        L_mat(W, V, u, p, t)

        # Test with matrices - should have minimal allocations
        allocs_mul_mat = @allocations mul!(W, L_mat, V)
        @test allocs_mul_mat <= 1

        allocs_call_mat = @allocations L_mat(W, V, u, p, t)
        @test allocs_call_mat <= 1
    end

    # Test accepted_kwargs allocations (PR #313)
    # With Val(tuple), kwarg filtering should be compile-time with minimal allocations
    @testset "accepted_kwargs with Val" begin
        N = 50

        # Create a MatrixOperator with accepted_kwargs using Val for compile-time filtering
        J = rand(N, N)

        update_func! = (M, u, p, t; dtgamma = 1.0) -> begin
            M .= dtgamma .* J
            nothing
        end

        op = MatrixOperator(
            copy(J);
            update_func! = update_func!,
            accepted_kwargs = Val((:dtgamma,))  # Use Val for compile-time filtering
        )

        u = rand(N)
        p = nothing
        t = 0.0

        # Warm up
        update_coefficients!(op, u, p, t; dtgamma = 0.5)

        # Test that update_coefficients! with accepted_kwargs has minimal allocations
        # The Val approach significantly reduces allocations compared to plain tuples
        allocs_update = @allocations update_coefficients!(op, u, p, t; dtgamma = 0.5)
        @test allocs_update <= 6  # Some allocations may occur due to Julia version/kwarg handling

        # Test with different dtgamma values - should have similar behavior
        allocs_update2 = @allocations update_coefficients!(op, u, p, t; dtgamma = 1.0)
        @test allocs_update2 <= 6

        allocs_update3 = @allocations update_coefficients!(op, u, p, t; dtgamma = 2.0)
        @test allocs_update3 <= 6

        # Test operator application after update
        v = rand(N)
        w = similar(v)
        op(w, v, u, p, t; dtgamma = 0.5)  # Warm up
        allocs_call = @allocations op(w, v, u, p, t; dtgamma = 0.5)
        @test allocs_call <= 6
    end
end

#
# Adapt.jl integration for SciMLOperators
#
# Provides Adapt.adapt_structure methods for operators that contain array storage
# or can transitively contain adapted operators.
#

# ============================================================================
# Direct Array-Backed Operators (store arrays that need adaptation)
# ============================================================================

function Adapt.adapt_structure(to, L::MatrixOperator)
    A_adapted = Adapt.adapt(to, L.A)
    return MatrixOperator(
        A_adapted,
        L.update_func,
        L.update_func!
    )
end

function Adapt.adapt_structure(to, L::BatchedDiagonalOperator)
    diag_adapted = Adapt.adapt(to, L.diag)
    return BatchedDiagonalOperator(
        diag_adapted,
        L.update_func,
        L.update_func!
    )
end

function Adapt.adapt_structure(to, L::AffineOperator)
    A_adapted = Adapt.adapt_structure(to, L.A)
    B_adapted = Adapt.adapt_structure(to, L.B)
    b_adapted = Adapt.adapt(to, L.b)
    return AffineOperator(
        A_adapted,
        B_adapted,
        b_adapted,
        L.update_func,
        L.update_func!
    )
end

function Adapt.adapt_structure(to, L::FunctionOperator)
    u_adapted = Adapt.adapt(to, L.u)
    p_adapted = Adapt.adapt(to, L.p)
    t_adapted = Adapt.adapt(to, L.t)
    cache_adapted = Adapt.adapt(to, L.cache)

    return set_cache(
        set_t(
            set_p(
                set_u(L, u_adapted),
                p_adapted
            ),
            t_adapted
        ),
        cache_adapted
    )
end

# ============================================================================
# Recursive Wrappers (can contain adapted operators or array caches)
# ============================================================================

function Adapt.adapt_structure(to, L::ScaledOperator)
    L_adapted = Adapt.adapt_structure(to, L.L)
    return ScaledOperator(L.λ, L_adapted)
end

function Adapt.adapt_structure(to, L::AddedOperator)
    return AddedOperator(Adapt.adapt_structure(to, L.ops))
end

function Adapt.adapt_structure(to, L::ComposedOperator)
    ops_adapted = Adapt.adapt_structure(to, L.ops)
    cache_adapted = Adapt.adapt(to, L.cache)
    return ComposedOperator(ops_adapted...; cache = cache_adapted)
end

function Adapt.adapt_structure(to, L::InvertedOperator)
    L_adapted = Adapt.adapt_structure(to, L.L)
    cache_adapted = Adapt.adapt(to, L.cache)
    return InvertedOperator(L_adapted; cache = cache_adapted)
end

function Adapt.adapt_structure(to, L::InvertibleOperator)
    L_adapted = Adapt.adapt_structure(to, L.L)
    F_adapted = Adapt.adapt_structure(to, L.F)
    return InvertibleOperator(L_adapted, F_adapted)
end

function Adapt.adapt_structure(to, L::BlockDiagonalOperator)
    return BlockDiagonalOperator(Adapt.adapt_structure(to, L.ops))
end

function Adapt.adapt_structure(to, L::AdjointOperator)
    L_adapted = Adapt.adapt_structure(to, L.L)
    return AdjointOperator(L_adapted)
end

function Adapt.adapt_structure(to, L::TransposedOperator)
    L_adapted = Adapt.adapt_structure(to, L.L)
    return TransposedOperator(L_adapted)
end

function Adapt.adapt_structure(to, L::TensorProductOperator)
    ops_adapted = Adapt.adapt_structure(to, L.ops)
    cache_adapted = Adapt.adapt(to, L.cache)
    return TensorProductOperator(ops_adapted...; cache = cache_adapted)
end

function Adapt.adapt_structure(to, L::TensorSumOperator)
    ops_adapted = Adapt.adapt_structure(to, L.ops)
    return TensorSumOperator(ops_adapted...)
end

# ============================================================================
# Scalar Operators (no array storage, handled by generic Adapt fallback)
# ============================================================================
# ScalarOperator, AddedScalarOperator, ComposedScalarOperator, InvertedScalarOperator
# do not store arrays, so they use Adapt's default struct adaptation which
# recursively adapts non-array fields and leaves scalars unchanged.

# ============================================================================
# Explicitly Skipped (no arrays, no need for custom adaptation)
# ============================================================================
# IdentityOperator, NullOperator: store only integers/dimensions
# These use Adapt's default struct adaptation (which is fine since no arrays).
#

#
"""
$SIGNATURES

Represents a linear operator given by an `AbstractMatrix` that may be
applied to an `AbstractVecOrMat`. Its state is updated by the user-provided
`update_func` during operator evaluation (`L([w,], v, u, p, t)`), or by calls
to `update_coefficients[!](L, u, p, t)`. Both recursively call the
`update_function`, `update_func` which is assumed to have the signature

    update_func(A::AbstractMatrix, u, p, t; <accepted kwargs>) -> newA

or

    update_func!(A::AbstractMatrix, u, p, t; <accepted kwargs>) -> [modifies A]

The set of keyword-arguments accepted by `update_func[!]` should be provided
to `MatrixOperator` via the kwarg `accepted_kwargs` as a `Val` of a tuple of `Symbol`s
for zero-allocation kwarg filtering. For example, `accepted_kwargs = Val((:dtgamma,))`.
Plain tuples like `(:dtgamma,)` are deprecated but still supported.
`kwargs` cannot be passed down to `update_func[!]` if `accepted_kwargs`
are not provided.

$(UPDATE_COEFFS_WARNING)

# Arguments

  - `A::AbstractMatrix`: Matrix used for the current operator action.

# Keyword Arguments

  - `update_func`: Out-of-place update with signature
    `update_func(A, u, p, t; kwargs...) -> new_A`.
  - `update_func!`: In-place update with signature
    `update_func!(A, u, p, t; kwargs...)`.
  - `accepted_kwargs`: `Val` tuple of keyword names forwarded to the update function.

# Fields

  - `A`: Current matrix state.
  - `update_func`: Out-of-place matrix update function.
  - `update_func!`: In-place matrix update function.

# Interface Rules

Lazy matrix algebra is defined for `AbstractSciMLOperator`s. The Interface
supports lazy addition, subtraction, multiplication, inversion,
adjoints, and transposes. An update function must preserve the dimensions and
mathematical meaning of `A`; use `FunctionOperator` when the action itself is
nonlinear in the input vector.

# Returns

A `MatrixOperator` whose current action is `A`. When update functions are
provided, the returned operator stores them and applies them through the
documented update interface.

# Errors

Construction throws if `A` is not an `AbstractMatrix` or if a supplied update
function returns a value incompatible with the matrix action. Passing a
keyword not listed in `accepted_kwargs` is rejected by the keyword filter.

# Examples

Out-of-place update and usage

```
using LinearAlgebra, SciMLOperators

v = rand(4)
u = rand(4)
p = rand(4, 4)
t = rand()

mat_update = (A, u, p, t; scale = 0.0) -> t * p
M = MatrixOperator(zeros(4, 4); update_func = mat_update, accepted_kwargs = Val((:scale,)))

L = M * M + 3I
L = cache_operator(L, v)

# update and evaluate 
w = L(v, u, p, t; scale = 1.0)

# In-place evaluation
w = similar(v)
L(w, v, u, p, t; scale = 1.0)

# In-place with scaling
β = 0.5
L(w, v, u, p, t, 2.0, β; scale = 1.0) # w = 2.0*(L*v) + 0.5*w
```

In-place update and usage

```
w = zeros(4)
v = zeros(4)
u = rand(4)
p = rand(4) # Must be non-nothing
t = rand()

mat_update! = (A, u, p, t; scale = 0.0) -> (A .= t * p * u' * scale)
M = MatrixOperator(zeros(4, 4); update_func! = mat_update!, accepted_kwargs = Val((:scale,)))
L = M * M + 3I
L = cache_operator(L, v) 

# update L in-place and evaluate
update_coefficients!(L, u, p, t; scale = 1.0)
mul!(w, L, v)

# Or use the new interface that separates update and application
L(w, v, u, p, t; scale = 1.0)
```
"""
struct MatrixOperator{T, AT <: AbstractMatrix{T}, F, F!} <: AbstractSciMLOperator{T}
    A::AT
    update_func::F
    update_func!::F!

    function MatrixOperator(A, update_func, update_func!)
        return new{
            eltype(A),
            typeof(A),
            typeof(update_func),
            typeof(update_func!),
        }(
            A,
            update_func,
            update_func!
        )
    end
end

function MatrixOperator(
        A;
        update_func = nothing,
        update_func! = nothing,
        accepted_kwargs = nothing
    )
    update_func = preprocess_update_func(update_func, accepted_kwargs)
    update_func! = preprocess_update_func(update_func!, accepted_kwargs)

    return MatrixOperator(A, update_func, update_func!)
end

# constructors
function Base.similar(L::MatrixOperator, ::Type{T}, dims::Dims) where {T}
    return MatrixOperator(similar(L.A, T, dims))
end

# traits
# Method forwarding for MatrixOperator (previously using @forward from MacroTools)
LinearAlgebra.issymmetric(L::MatrixOperator) = LinearAlgebra.issymmetric(L.A)
LinearAlgebra.ishermitian(L::MatrixOperator) = LinearAlgebra.ishermitian(L.A)
LinearAlgebra.isposdef(L::MatrixOperator) = LinearAlgebra.isposdef(L.A)
issquare(L::MatrixOperator) = issquare(L.A)
has_ldiv(L::MatrixOperator) = has_ldiv(L.A)
has_ldiv!(L::MatrixOperator) = has_ldiv!(L.A)

isconvertible(::MatrixOperator) = true
islinear(::MatrixOperator) = true

function Base.show(io::IO, L::MatrixOperator)
    a, b = size(L)
    return print(io, "MatrixOperator($a × $b)")
end
Base.size(L::MatrixOperator) = size(L.A)
Base.iszero(L::MatrixOperator) = iszero(L.A)
for op in (
        :adjoint,
        :transpose,
    )
    @eval function Base.$op(L::MatrixOperator)
        isconstant(L) && return MatrixOperator($op(L.A))

        update_func = L.update_func === nothing ? nothing :
            (
                A, u, p, t; kwargs...,
            ) -> $op(
                L.update_func(
                    $op(L.A),
                    u,
                    p,
                    t;
                    kwargs...
                )
            )
        update_func! = L.update_func! === nothing ? nothing :
            (
                A, u, p, t; kwargs...,
            ) -> $op(
                L.update_func!(
                    $op(L.A),
                    u,
                    p,
                    t;
                    kwargs...
                )
            )

        return MatrixOperator(
            $op(L.A);
            update_func = update_func,
            update_func! = update_func!,
            accepted_kwargs = NoKwargFilter()
        )
    end
end

function Base.conj(L::MatrixOperator)
    isconstant(L) && return MatrixOperator(conj(L.A))

    update_func = L.update_func === nothing ? nothing :
        (
            A, u, p, t; kwargs...,
        ) -> conj(
            L.update_func(
                conj(L.A),
                u,
                p,
                t;
                kwargs...
            )
        )
    update_func! = L.update_func! === nothing ? nothing :
        (
            A, u, p, t; kwargs...,
        ) -> begin
            L.update_func!(conj!(L.A), u, p, t; kwargs...)
            conj!(L.A)
        end

    return MatrixOperator(
        conj(L.A);
        update_func = update_func,
        update_func! = update_func!,
        accepted_kwargs = NoKwargFilter()
    )
end

has_adjoint(L::MatrixOperator) = has_adjoint(L.A)
getops(L::MatrixOperator) = (L.A,)
function isconstant(L::MatrixOperator)
    return update_func_isconstant(L.update_func) & update_func_isconstant(L.update_func!)
end

function update_coefficients(L::MatrixOperator, u, p, t; kwargs...)
    if !isnothingfunc(L.update_func)
        @reset L.A = L.update_func(L.A, u, p, t; kwargs...)
    elseif !isnothingfunc(L.update_func!)
        L.update_func!(L.A, u, p, t; kwargs...)
    end
    return L
end

function update_coefficients!(L::MatrixOperator, u, p, t; kwargs...)
    if !isnothingfunc(L.update_func!)
        L.update_func!(L.A, u, p, t; kwargs...)
    elseif !isnothingfunc(L.update_func)
        if !ArrayInterface.ismutable(L.A)
            msg = """`update_coefficients!` cannot update a `MatrixOperator` holding
            an immutable matrix ($(typeof(L.A))) through an out-of-place
            `update_func`. Use `update_coefficients(L, u, p, t)` instead, or
            construct the operator with a mutating `update_func!`."""
            throw(ArgumentError(msg))
        end
        copyto!(L.A, L.update_func(L.A, u, p, t; kwargs...))
    end
    return nothing
end

# Out-of-place: v is action vector, u is update vector
function (L::MatrixOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    return L.A * v
end

# In-place: w is destination, v is action vector, u is update vector
function (L::MatrixOperator)(w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...)
    update_coefficients!(L, u, p, t; kwargs...)
    return mul!(w, L.A, v)
end

# In-place with scaling: w = α*(L*v) + β*w
Base.@constprop :aggressive function (L::MatrixOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    mul!(w, L.A, v, α, β)
end

# TODO - add tests for MatrixOperator indexing
# propagate_inbounds here for the getindex fallback
Base.@propagate_inbounds Base.convert(::Type{AbstractMatrix}, L::MatrixOperator) = convert(
    AbstractMatrix,
    L.A
)
Base.@propagate_inbounds Base.setindex!(L::MatrixOperator, v, i::Int) = (L.A[i] = v)
Base.@propagate_inbounds Base.setindex!(
    L::MatrixOperator, v, I::Vararg{
        Int, N,
    }
) where {N} = (L.A[I...] = v)

Base.eachcol(L::MatrixOperator) = eachcol(L.A)
Base.eachrow(L::MatrixOperator) = eachrow(L.A)
Base.length(L::MatrixOperator) = length(L.A)
Base.iterate(L::MatrixOperator, args...) = iterate(L.A, args...)
Base.axes(L::MatrixOperator) = axes(L.A)
Base.eachindex(L::MatrixOperator) = eachindex(L.A)
function Base.IndexStyle(::Type{<:MatrixOperator{T, AType}}) where {T, AType}
    return Base.IndexStyle(AType)
end
Base.copyto!(L::MatrixOperator, rhs) = (copyto!(L.A, rhs); L)
# Unwrap a MatrixOperator `rhs` so the copy hits the underlying matrices' specialized
# `copyto!` (e.g. sparse→sparse copies `nzval`/`rowval`/`colptr`) instead of the generic
# element-wise fallback, which is O(n²) with sparse-index overhead.
Base.copyto!(L::MatrixOperator, rhs::MatrixOperator) = (copyto!(L.A, rhs.A); L)

Base.Broadcast.broadcastable(L::MatrixOperator) = L
Base.ndims(::Type{<:MatrixOperator{T, AType}}) where {T, AType} = ndims(AType)
ArrayInterface.issingular(L::MatrixOperator) = ArrayInterface.issingular(L.A)
function Base.copy(L::MatrixOperator)
    return MatrixOperator(
        copy(L.A);
        update_func = L.update_func,
        update_func! = L.update_func!,
        accepted_kwargs = NoKwargFilter()
    )
end

# operator application
Base.:*(L::MatrixOperator, v::AbstractVecOrMat) = L.A * v
Base.:\(L::MatrixOperator, v::AbstractVecOrMat) = L.A \ v

@inline function LinearAlgebra.mul!(
        w::AbstractVecOrMat, L::MatrixOperator, v::AbstractVecOrMat
    )
    return mul!(w, L.A, v)
end
@inline function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::MatrixOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    return mul!(w, L.A, v, α, β)
end

# These methods are used when the operator is applied from the right
# We do this to avoid to fall into generic methods that would be inefficient
@inline LinearAlgebra.mul!(w::AbstractTransposedVecOrMat, L::MatrixOperator, v::AbstractVecOrMat) = mul!(parent(w), transpose(v), transpose(L.A))
@inline LinearAlgebra.mul!(
    w::AbstractTransposedVecOrMat,
    L::MatrixOperator,
    v::AbstractVecOrMat,
    α,
    β
) = mul!(parent(w), transpose(v), transpose(L.A), α, β)

function LinearAlgebra.ldiv!(w::AbstractVecOrMat, L::MatrixOperator, v::AbstractVecOrMat)
    return ldiv!(w, L.A, v)
end
LinearAlgebra.ldiv!(L::MatrixOperator, v::AbstractVecOrMat) = ldiv!(L.A, v)

"""
$SIGNATURES

Represents an elementwise scaling (diagonal-scaling) operation that may
be applied to an `AbstractVecOrMat`. When `diag` is an `AbstractVector`
of length N, `L = DiagonalOperator(diag, ...)` can be applied to
`AbstractArray`s with `size(u, 1) == N`. Each column of the `v` will be
scaled by `diag`, as in `LinearAlgebra.Diagonal(diag) * v`.

When `diag` is a multidimensional array, `L = DiagonalOperator(diag, ...)` forms
an operator of size `(N, N)` where `N = size(diag, 1)` is the leading length of `diag`.
`L` then is the elementwise-scaling operation on arrays of `length(v) = length(diag)`
with leading length `size(u, 1) = N`.

Its state is updated by the user-provided `update_func` during operator
evaluation (`L([w,], v, u, p, t)`), or by calls to
`update_coefficients[!](L, u, p, t)`. Both recursively call the
`update_function`, `update_func` which is assumed to have the signature

    update_func(diag::AbstractVecOrMat, u, p, t; <accepted kwargs>) -> new_diag

or

    update_func!(diag::AbstractVecOrMat, u, p, t; <accepted kwargs>) -> [modifies diag]

The set of keyword-arguments accepted by `update_func[!]` should be provided
to `DiagonalOperator` via the kwarg `accepted_kwargs` as a `Val` of a tuple of `Symbol`s
for zero-allocation kwarg filtering. For example, `accepted_kwargs = Val((:dtgamma,))`.
Plain tuples like `(:dtgamma,)` are deprecated but still supported.
`kwargs` cannot be passed down to `update_func[!]` if `accepted_kwargs`
are not provided.

$(UPDATE_COEFFS_WARNING)

# Arguments

  - `diag::AbstractVector`: Diagonal entries of the operator.

# Keyword Arguments

  - `update_func`: Out-of-place update with signature
    `update_func(diag, u, p, t; kwargs...) -> new_diag`.
  - `update_func!`: In-place update with signature
    `update_func!(diag, u, p, t; kwargs...)`.
  - `accepted_kwargs`: `Val` tuple of keyword names forwarded to the update function.

# Interface Rules

Updates must preserve the diagonal's leading dimension. For multidimensional
`diag`, the operator acts elementwise while reporting a matrix size based on
its leading dimension.

# Returns

A `DiagonalOperator` backed by `diag` and the configured update functions.

# Errors

Construction or update throws when a supplied diagonal update changes the
leading dimension or returns an incompatible value.

# Examples

```julia
using SciMLOperators

D = DiagonalOperator([2.0, 3.0])
D * [4.0, 5.0] == [8.0, 15.0]
```
"""
function DiagonalOperator(
        diag::AbstractVector;
        update_func = nothing,
        update_func! = nothing,
        accepted_kwargs = nothing
    )
    diag_update_func = update_func_isconstant(update_func) ? update_func :
        (
            A, u, p, t; kwargs...,
        ) -> update_func(A.diag, u, p, t; kwargs...) |>
        Diagonal

    diag_update_func! = update_func_isconstant(update_func!) ? update_func! :
        (A, u, p, t; kwargs...) -> update_func!(A.diag, u, p, t; kwargs...)

    return MatrixOperator(
        Diagonal(diag);
        update_func = diag_update_func,
        update_func! = diag_update_func!,
        accepted_kwargs = accepted_kwargs
    )
end
LinearAlgebra.Diagonal(L::MatrixOperator) = MatrixOperator(Diagonal(L.A))

function Base.exp(L::MatrixOperator{T, <:Diagonal}) where {T}
    update_func = (
        A, u, p, t;
        kwargs...,
    ) -> update_coefficients(L, u, p, t; kwargs...).A |>
        exp
    return MatrixOperator(exp(L.A); update_func = update_func, accepted_kwargs = NoKwargFilter())
end

function Base.show(io::IO, L::MatrixOperator{T, <:Diagonal}) where {T}
    n = length(L.A.diag)
    return print(io, "DiagonalOperator($n × $n)")
end

"""
$SIGNATURES

    InvertibleOperator(L, F)

Pair an operator with a factorization or inverse object used for division.

# Arguments

  - `L`: Original operator used for multiplication and updates.
  - `F`: Factorization or inverse supporting `\\` or `ldiv!`.

# Fields

  - `L`: Wrapped operator.
  - `F`: Factorization or inverse representation.

# Interface Rules

Constructors such as `factorize`, `lu`, and `qr` create this wrapper for
concretizable operators. `L` and `F` must represent the same current action;
after a state update, extension code is responsible for keeping both current.
Use `ldiv!` or `\\` for the inverse action rather than assuming `F` is a
public field contract.
"""
struct InvertibleOperator{T, LT, FT} <: AbstractSciMLOperator{T}
    L::LT
    F::FT

    function InvertibleOperator(L, F)
        @assert has_ldiv(F) | has_ldiv!(F) "$F is not invertible"
        T = promote_type(eltype(L), eltype(F))

        return new{T, typeof(L), typeof(F)}(L, F)
    end
end

# constructor
function LinearAlgebra.factorize(L::AbstractSciMLOperator)
    fact = factorize(convert(AbstractMatrix, L))
    return InvertibleOperator(L, fact)
end

for fact in (
        :lu, :lu!,
        :qr, :qr!,
        :cholesky, :cholesky!,
        :ldlt, :ldlt!,
        :bunchkaufman, :bunchkaufman!,
        :lq, :lq!,
        :svd, :svd!,
    )
    @eval LinearAlgebra.$fact(
        L::AbstractSciMLOperator,
        args...
    ) = InvertibleOperator(
        L,
        LinearAlgebra.$fact(convert(AbstractMatrix, L), args...)
    )
    @eval LinearAlgebra.$fact(
        L::AbstractSciMLOperator;
        kwargs...
    ) = InvertibleOperator(
        L,
        LinearAlgebra.$fact(convert(AbstractMatrix, L); kwargs...)
    )
end

function Base.convert(
        ::Type{<:Factorization},
        L::InvertibleOperator{T, LT, <:Factorization}
    ) where {T, LT}
    return L.F
end

Base.convert(::Type{AbstractMatrix}, L::InvertibleOperator) = convert(AbstractMatrix, L.L)
has_concretization(L::InvertibleOperator) = has_concretization(L.L)

# traits
function Base.show(io::IO, L::InvertibleOperator)
    print(io, "InvertibleOperator(")
    show(io, L.L)
    print(io, ", ")
    show(io, L.F)
    return print(io, ")")
end

Base.size(L::InvertibleOperator) = size(L.L)
Base.transpose(L::InvertibleOperator) = InvertibleOperator(transpose(L.L), transpose(L.F))
Base.adjoint(L::InvertibleOperator) = InvertibleOperator(L.L', L.F')
Base.conj(L::InvertibleOperator) = InvertibleOperator(conj(L.L), conj(L.F))
Base.resize!(L::InvertibleOperator, n::Integer) = (resize!(L.L, n); resize!(L.F, n); L)
LinearAlgebra.opnorm(L::InvertibleOperator{T}, p::Real = 2) where {T} = one(T) / opnorm(L.F, p)
LinearAlgebra.issuccess(L::InvertibleOperator) = issuccess(L.F)

function update_coefficients(L::InvertibleOperator, u, p, t; kwargs...)
    @reset L.L = update_coefficients(L.L, u, p, t; kwargs...)
    @reset L.F = update_coefficients(L.F, u, p, t; kwargs...)
    return L
end
function update_coefficients!(L::InvertibleOperator, u, p, t; kwargs...)
    update_coefficients!(L.L, u, p, t; kwargs...)
    update_coefficients!(L.F, u, p, t; kwargs...)
    return nothing
end

getops(L::InvertibleOperator) = (L.L, L.F)

# Copy method to avoid aliasing
function Base.copy(L::InvertibleOperator)
    return InvertibleOperator(
        copy(L.L),
        copy(L.F)
    )
end

islinear(L::InvertibleOperator) = islinear(L.L)
isconvertible(L::InvertibleOperator) = isconvertible(L.L)

# Method forwarding for InvertibleOperator (previously using @forward from MacroTools)
# LinearAlgebra methods
LinearAlgebra.issymmetric(L::InvertibleOperator) = LinearAlgebra.issymmetric(L.L)
LinearAlgebra.ishermitian(L::InvertibleOperator) = LinearAlgebra.ishermitian(L.L)
LinearAlgebra.isposdef(L::InvertibleOperator) = LinearAlgebra.isposdef(L.L)

# SciML methods
isconstant(L::InvertibleOperator) = isconstant(L.L)
has_adjoint(L::InvertibleOperator) = has_adjoint(L.L)
has_mul(L::InvertibleOperator) = has_mul(L.L)
has_mul!(L::InvertibleOperator) = has_mul!(L.L)

has_ldiv(L::InvertibleOperator) = has_mul(L.F)
has_ldiv!(L::InvertibleOperator) = has_ldiv!(L.F)

function cache_internals(L::InvertibleOperator, v::AbstractVecOrMat)
    @reset L.L = cache_operator(L.L, v)
    @reset L.F = cache_operator(L.F, v)

    return L
end

# operator application
Base.:*(L::InvertibleOperator, v::AbstractVecOrMat) = L.L * v
Base.:\(L::InvertibleOperator, v::AbstractVecOrMat) = L.F \ v
function LinearAlgebra.mul!(w::AbstractVecOrMat, L::InvertibleOperator, v::AbstractVecOrMat)
    return mul!(w, L.L, v)
end
function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::InvertibleOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    return mul!(w, L.L, v, α, β)
end
function LinearAlgebra.ldiv!(
        w::AbstractVecOrMat,
        L::InvertibleOperator,
        v::AbstractVecOrMat
    )
    return ldiv!(w, L.F, v)
end
LinearAlgebra.ldiv!(L::InvertibleOperator, u::AbstractVecOrMat) = ldiv!(L.F, u)

# Out-of-place: v is action vector, u is update vector
function (L::InvertibleOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    if !isconstant(L)
        L = update_coefficients(L, u, p, t; kwargs...)
    end
    return L.L * v
end

# In-place: w is destination, v is action vector, u is update vector
function (L::InvertibleOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    return mul!(w, L.L, v)
end

# In-place with scaling: w = α*(L*v) + β*w
function (L::InvertibleOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    return mul!(w, L.L, v, α, β)
end

"""
$SIGNATURES

Represents a generalized affine operation (`w = A * v + B * b`) that may
be applied to an `AbstractVecOrMat`. The user-provided update functions,
`update_func[!]` update the `AbstractVecOrMat` `b`, and are called
during operator evaluation (`L([w,], v, u, p, t)`), or by calls
to `update_coefficients[!](L, u, p, t)`. The update functions are
assumed to have the syntax

    update_func(b::AbstractVecOrMat, u, p, t; <accepted kwargs>) -> new_b

or

    update_func!(b::AbstractVecOrMat, u ,p , t; <accepted kwargs>) -> [modifies b]

and `B`, `b` are expected to have an appropriate size so that
`A * v + B * b` makes sense. Specifically, `size(A, 1) == size(B, 1)`, and
`size(v, 2) == size(b, 2)`.

The set of keyword-arguments accepted by `update_func[!]` should be provided
to `AffineOperator` via the kwarg `accepted_kwargs` as a `Val` of a tuple of `Symbol`s
for zero-allocation kwarg filtering. For example, `accepted_kwargs = Val((:dtgamma,))`.
Plain tuples like `(:dtgamma,)` are deprecated but still supported.
`kwargs` cannot be passed down to `update_func[!]` if `accepted_kwargs`
are not provided.

# Arguments

  - `A`: Matrix or SciML operator applied to the action vector.
  - `B`: Matrix or SciML operator applied to the additive term.
  - `b::AbstractArray`: Additive input to `B`.

# Keyword Arguments

  - `update_func`: Out-of-place update for `b`.
  - `update_func!`: In-place update for `b`.
  - `accepted_kwargs`: `Val` tuple of keyword names forwarded to the update function.

# Fields

  - `A`: Linear action component.
  - `B`: Additive-term action component.
  - `b`: Current additive input.
  - `update_func`: Out-of-place update for `b`.
  - `update_func!`: In-place update for `b`.

# Interface Rules

`AffineOperator` is not linear and cannot generally be converted to an
`AbstractMatrix`. Updates must preserve compatible dimensions for `A`, `B`,
and `b`; caching must preserve the affine action.

# Examples

```
v = rand(4)
u = rand(4)
p = rand(4)
t = rand()

A = MatrixOperator(rand(4, 4))
B = MatrixOperator(rand(4, 4))

vec_update_func = (b, u, p, t) -> p .* u * t
L = AffineOperator(A, B, zeros(4); update_func = vec_update_func)
L = cache_operator(L, v)

# update L and evaluate
w = L(v, u, p, t) # == A * v + B * (p .* u * t)
```
"""
struct AffineOperator{T, AT, BT, bT, F, F!} <: AbstractSciMLOperator{T}
    A::AT
    B::BT
    b::bT

    update_func::F # updates b
    update_func!::F! # updates b

    function AffineOperator(A, B, b, update_func, update_func!)
        T = promote_type(eltype.((A, B, b))...)

        return new{
            T,
            typeof(A),
            typeof(B),
            typeof(b),
            typeof(update_func),
            typeof(update_func!),
        }(
            A,
            B,
            b,
            update_func,
            update_func!
        )
    end
end

function AffineOperator(
        A::Union{AbstractMatrix, AbstractSciMLOperator},
        B::Union{AbstractMatrix, AbstractSciMLOperator},
        b::AbstractArray;
        update_func = nothing,
        update_func! = nothing,
        accepted_kwargs = nothing
    )
    @assert size(A, 1) == size(B, 1) "Dimension mismatch: A, B don't output vectors
  of same size"

    update_func = preprocess_update_func(update_func, accepted_kwargs)
    update_func! = preprocess_update_func(update_func!, accepted_kwargs)

    A = A isa AbstractMatrix ? MatrixOperator(A) : A
    B = B isa AbstractMatrix ? MatrixOperator(B) : B

    return AffineOperator(A, B, b, update_func, update_func!)
end

"""
$SIGNATURES

Construct the affine operation `v + b` as an `AffineOperator`.

# Arguments

  - `b::AbstractVecOrMat`: Additive term.

# Keyword Arguments

  - `update_func`: Out-of-place update for `b` with signature
    `update_func(b, u, p, t; kwargs...) -> new_b`.
  - `update_func!`: In-place update for `b` with signature
    `update_func!(b, u, p, t; kwargs...)`.
  - `accepted_kwargs`: `Val` tuple of forwarded update keyword names.

# Interface Rules

This is shorthand for `AffineOperator(I, I, b; kwargs...)`. The term `b` must
have a leading dimension compatible with the action vector. See
[`AffineOperator`](@ref) for update and caching rules.
"""
function AddVector(
        b::AbstractVecOrMat;
        update_func = nothing,
        update_func! = nothing,
        accepted_kwargs = nothing
    )
    N = size(b, 1)
    Id = IdentityOperator(N)

    return AffineOperator(
        Id, Id, b;
        update_func = update_func,
        update_func! = update_func!,
        accepted_kwargs = accepted_kwargs
    )
end

"""
$SIGNATURES

Construct the affine operation `v + B * b` as an `AffineOperator`.

# Arguments

  - `B`: Matrix or SciML operator acting on the additive term.
  - `b::AbstractVecOrMat`: Additive input to `B`.

# Keyword Arguments

  - `update_func`: Out-of-place update for `b`.
  - `update_func!`: In-place update for `b`.
  - `accepted_kwargs`: `Val` tuple of forwarded update keyword names.

# Interface Rules

`B * b` must have the same leading dimension as the action vector. This is
shorthand for `AffineOperator(I, B, b; kwargs...)`; see [`AffineOperator`](@ref)
for the update and caching contract.
"""
function AddVector(
        B, b::AbstractVecOrMat;
        update_func = nothing,
        update_func! = nothing,
        accepted_kwargs = nothing
    )
    N = size(B, 1)
    Id = IdentityOperator(N)

    return AffineOperator(
        Id, B, b;
        update_func = update_func,
        update_func! = update_func!,
        accepted_kwargs = accepted_kwargs
    )
end

function update_coefficients(L::AffineOperator, u, p, t; kwargs...)
    @reset L.A = update_coefficients(L.A, u, p, t; kwargs...)
    @reset L.B = update_coefficients(L.B, u, p, t; kwargs...)
    if !isnothingfunc(L.update_func)
        @reset L.b = L.update_func(L.b, u, p, t; kwargs...)
    end
    return L
end

function update_coefficients!(L::AffineOperator, u, p, t; kwargs...)
    if !isnothingfunc(L.update_func)
        L.update_func!(L.b, u, p, t; kwargs...)
    end
    for op in getops(L)
        update_coefficients!(op, u, p, t; kwargs...)
    end
    return nothing
end

# Copy method to avoid aliasing
function Base.copy(L::AffineOperator)
    return AffineOperator(
        copy(L.A),
        copy(L.B),
        copy(L.b);
        update_func = L.update_func,
        update_func! = L.update_func!
    )
end

function isconstant(L::AffineOperator)
    return update_func_isconstant(L.update_func) &
        update_func_isconstant(L.update_func!) &
        all(isconstant, (L.A, L.B))
end

getops(L::AffineOperator) = (L.A, L.B, L.b)

islinear(::AffineOperator) = false
isconvertible(::AffineOperator) = false

function Base.show(io::IO, L::AffineOperator)
    show(io, L.A)
    print(io, " + ")
    show(io, L.B)
    print(io, " * ")

    return if L.b isa AbstractVector
        n = size(L.b, 1)
        print(io, "AbstractVector($n)")
    elseif L.b isa AbstractMatrix
        n, k = size(L.b)
        print(io, "AbstractMatrix($n × $k)")
    end
end

Base.size(L::AffineOperator) = size(L.A)
Base.iszero(L::AffineOperator) = all(iszero, getops(L))
function Base.resize!(L::AffineOperator, n::Integer)
    resize!(L.A, n)
    resize!(L.B, n)
    resize!(L.b, n)

    return L
end

function Base.convert(::Type{AbstractMatrix}, L::AffineOperator)
    m, n = size(L)
    msg = """$L cannot be represented by an $m × $n AbstractMatrix"""
    throw(ArgumentError(msg))
end

has_adjoint(L::AffineOperator) = false
has_mul(L::AffineOperator) = has_mul(L.A)
has_mul!(L::AffineOperator) = has_mul!(L.A)
has_ldiv(L::AffineOperator) = has_ldiv(L.A)
has_ldiv!(L::AffineOperator) = has_ldiv!(L.A)

function cache_internals(L::AffineOperator, u::AbstractVecOrMat)
    @reset L.A = cache_operator(L.A, u)
    @reset L.B = cache_operator(L.B, L.b)
    return L
end

# operator application
function Base.:*(L::AffineOperator, v::AbstractVecOrMat)
    @assert size(L.b, 2) == size(v, 2)
    return (L.A * v) + (L.B * L.b)
end

function Base.:\(L::AffineOperator, v::AbstractVecOrMat)
    @assert size(L.b, 2) == size(v, 2)
    return L.A \ (v - (L.B * L.b))
end

function LinearAlgebra.mul!(w::AbstractVecOrMat, L::AffineOperator, v::AbstractVecOrMat)
    mul!(w, L.B, L.b)
    return mul!(w, L.A, v, true, true)
end

function LinearAlgebra.mul!(
        w::AbstractVecOrMat,
        L::AffineOperator,
        v::AbstractVecOrMat,
        α,
        β
    )
    mul!(w, L.B, L.b, α, β)
    return mul!(w, L.A, v, α, true)
end

function LinearAlgebra.ldiv!(w::AbstractVecOrMat, L::AffineOperator, v::AbstractVecOrMat)
    copy!(w, v)
    return ldiv!(L, w)
end

function LinearAlgebra.ldiv!(L::AffineOperator, v::AbstractVecOrMat)
    mul!(v, L.B, L.b, -1, 1)
    return ldiv!(L.A, v)
end
# Out-of-place: v is action vector, u is update vector
function (L::AffineOperator)(v::AbstractVecOrMat, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    return (L.A * v) + (L.B * L.b)
end

# In-place: w is destination, v is action vector, u is update vector
function (L::AffineOperator)(w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t; kwargs...)
    update_coefficients!(L, u, p, t; kwargs...)
    # First calculate A * v
    mul!(w, L.A, v)
    # Then add B * b
    return mul!(w, L.B, L.b, true, true)
end

# In-place with scaling: w = α*(L*v) + β*w
function (L::AffineOperator)(
        w::AbstractVecOrMat, v::AbstractVecOrMat, u, p, t, α, β; kwargs...
    )
    update_coefficients!(L, u, p, t; kwargs...)
    # Scale the existing w by β
    lmul!(β, w)
    # Add α * (A * v)
    mul!(w, L.A, v, α, true)
    # Add α * (B * b)
    return mul!(w, L.B, L.b, α, true)
end
#

has_concretization(::MatrixOperator) = true

using LinearAlgebra, SciMLOperators, Test

@testset "Documented public operator API" begin
    owner_public_names = (
        :AbstractSciMLOperator,
        :AbstractSciMLScalarOperator,
        :AbstractWOperator,
        :ScaledOperator,
        :AddedOperator,
        :ComposedOperator,
        :InvertedOperator,
        :AdjointOperator,
        :TransposedOperator,
        :AddedScalarOperator,
        :ComposedScalarOperator,
        :InvertedScalarOperator,
        :has_tensor_outer_mul_fast,
        :tensor_outer_mul_fast!,
        :getcache,
        :update_cache,
        :adopt_cache,
    )

    for name in owner_public_names
        @test isdefined(SciMLOperators, name)
        @test !Base.isexported(SciMLOperators, name)
        @static if isdefined(Base, :ispublic)
            @test Base.ispublic(SciMLOperators, name)
        end

        @static if isdefined(Base.Docs, :hasdoc)
            @test Base.Docs.hasdoc(SciMLOperators, name)
        else
            doc = sprint(
                show,
                MIME"text/plain"(),
                Base.Docs.doc(Base.Docs.Binding(SciMLOperators, name)),
            )
            @test !occursin("No documentation found", doc)
        end
    end
end

mutable struct GenericDiagonalOperator{T} <: SciMLOperators.AbstractSciMLOperator{T}
    diagonal::Vector{T}
    scale::T
end

Base.size(L::GenericDiagonalOperator) = (length(L.diagonal), length(L.diagonal))
Base.:*(L::GenericDiagonalOperator, v::AbstractVector) = L.scale .* L.diagonal .* v
Base.convert(::Type{AbstractMatrix}, L::GenericDiagonalOperator) = Diagonal(L.scale .* L.diagonal)

function LinearAlgebra.mul!(w::AbstractVector, L::GenericDiagonalOperator, v::AbstractVector)
    w .= L.scale .* L.diagonal .* v
    return w
end

function LinearAlgebra.mul!(
        w::AbstractVector, L::GenericDiagonalOperator, v::AbstractVector, α, β
    )
    w .= α .* L.scale .* L.diagonal .* v .+ β .* w
    return w
end

SciMLOperators.islinear(::GenericDiagonalOperator) = true
SciMLOperators.isconvertible(::GenericDiagonalOperator) = true
SciMLOperators.has_concretization(::GenericDiagonalOperator) = true
SciMLOperators.isconstant(::GenericDiagonalOperator) = false

function SciMLOperators.update_coefficients(
        L::GenericDiagonalOperator, u, p, t; scale = p
    )
    return GenericDiagonalOperator(copy(L.diagonal), scale)
end

function SciMLOperators.update_coefficients!(
        L::GenericDiagonalOperator, u, p, t; scale = p
    )
    L.scale = scale
    return nothing
end

@testset "AbstractSciMLOperator generic interface" begin
    L = GenericDiagonalOperator([2.0, 3.0], 1.0)
    v = [4.0, 5.0]
    w = [7.0, 11.0]

    @test size(L) == (2, 2)
    @test issquare(L)
    @test islinear(L)
    @test !isconstant(L)
    @test isconvertible(L)
    @test has_concretization(L)
    @test has_mul(L)
    @test has_mul!(L)
    @test !has_ldiv(L)
    @test !has_ldiv!(L)
    @test iscached(L)
    @test cache_operator(L, v) === L
    @test concretize(L) == Diagonal([2.0, 3.0])

    updated = update_coefficients(L, nothing, 4.0, 0.0)
    @test updated !== L
    @test updated * v == [32.0, 60.0]
    @test L * v == [8.0, 15.0]
    @test L(v, nothing, 4.0, 0.0) == [32.0, 60.0]

    @test update_coefficients!(L, nothing, 5.0, 0.0) === nothing
    @test L * v == [40.0, 75.0]

    L(w, v, nothing, 2.0, 0.0)
    @test w == [16.0, 30.0]

    L(w, v, nothing, 3.0, 0.0, 2.0, 0.5)
    @test w == [56.0, 105.0]
end

mutable struct GenericWOperator <: SciMLOperators.AbstractWOperator{Float64}
    matrix::Matrix{Float64}
    stale::Bool
end

Base.size(W::GenericWOperator) = size(W.matrix)
Base.:*(W::GenericWOperator, v::AbstractVector) = W.matrix * v
function LinearAlgebra.mul!(w::AbstractVector, W::GenericWOperator, v::AbstractVector)
    mul!(w, W.matrix, v)
    return w
end
function LinearAlgebra.mul!(
        w::AbstractVector, W::GenericWOperator, v::AbstractVector, α, β
    )
    mul!(w, W.matrix, v, α, β)
    return w
end
SciMLOperators.jacobian_stale(W::GenericWOperator) = W.stale
function SciMLOperators.mark_jacobian_updated!(W::GenericWOperator)
    W.stale = true
    return W
end
function SciMLOperators.mark_jacobian_current!(W::GenericWOperator)
    W.stale = false
    return W
end

@testset "AbstractWOperator generic interface" begin
    W = GenericWOperator([2.0 0.0; 0.0 3.0], true)
    v = [4.0, 5.0]
    w = zeros(2)

    @test size(W) == (2, 2)
    @test has_mul!(W)
    @test W * v == [8.0, 15.0]
    @test mul!(w, W, v) === w
    @test w == [8.0, 15.0]
    @test mul!(w, W, v, 2.0, 0.5) === w
    @test w == [20.0, 37.5]
    @test jacobian_stale(W)
    @test mark_jacobian_current!(W) === W
    @test !jacobian_stale(W)
    @test mark_jacobian_updated!(W) === W
    @test jacobian_stale(W)
end

mutable struct GenericScalarOperator <: SciMLOperators.AbstractSciMLScalarOperator{Float64}
    value::Float64
end

Base.convert(::Type{Number}, L::GenericScalarOperator) = L.value
SciMLOperators.isconstant(::GenericScalarOperator) = false
SciMLOperators.has_ldiv(L::GenericScalarOperator) = !iszero(L.value)
SciMLOperators.has_ldiv!(L::GenericScalarOperator) = !iszero(L.value)

function SciMLOperators.update_coefficients(
        L::GenericScalarOperator, u, p, t; scale = p
    )
    return GenericScalarOperator(scale)
end

function SciMLOperators.update_coefficients!(
        L::GenericScalarOperator, u, p, t; scale = p
    )
    L.value = scale
    return nothing
end

@testset "AbstractSciMLScalarOperator generic interface" begin
    L = GenericScalarOperator(2.0)
    v = [4.0, 5.0]
    w = [7.0, 11.0]

    @test size(L) == ()
    @test islinear(L)
    @test !isconstant(L)
    @test has_mul(L)
    @test has_mul!(L)
    @test has_ldiv(L)
    @test has_ldiv!(L)
    @test has_concretization(L)
    @test concretize(L) == 2.0
    @test L * v == [8.0, 10.0]
    @test mul!(copy(w), L, v) == [8.0, 10.0]

    updated = update_coefficients(L, nothing, 3.0, 0.0)
    @test updated !== L
    @test updated * v == [12.0, 15.0]
    @test L(v, nothing, 4.0, 0.0) == [16.0, 20.0]

    @test update_coefficients!(L, nothing, 5.0, 0.0) === nothing
    @test L * v == [20.0, 25.0]
    L(w, v, nothing, 3.0, 0.0)
    @test w == [12.0, 15.0]
end

using LinearAlgebra
using SciMLOperators
using Test

@testset "Precompile workload APIs" begin
    v = [1.0, 2.0]
    A = MatrixOperator([2.0 1.0; 1.0 3.0])
    D = DiagonalOperator([2.0, 3.0])

    @test A * v == [4.0, 7.0]
    w = zeros(2)
    @test mul!(w, A, v) === w
    @test w == [4.0, 7.0]

    @test ScalarOperator(2.0) * v == [2.0, 4.0]
    F = FunctionOperator(
        (v, u, p, t) -> 2 .* v, v;
        ifcache = false, isconstant = true, islinear = true
    )
    @test F * v == [2.0, 4.0]

    @test (A + D) * v == [6.0, 13.0]
    @test (A * D) * v == [10.0, 20.0]
    @test (A ∘ D) * v == [10.0, 20.0]
    @test (2.0 * A) * v == [8.0, 14.0]

    B = BlockDiagonalOperator(A, D)
    @test B * [1.0, 2.0, 3.0, 4.0] == [4.0, 7.0, 6.0, 12.0]

    T = kron(IdentityOperator(2), D)
    @test T * [1.0, 2.0, 3.0, 4.0] == [2.0, 6.0, 6.0, 12.0]

    cached = cache_operator(A * D, v)
    @test cached * v == [10.0, 20.0]
    w = zeros(2)
    @test mul!(w, cached, v) === w
    @test w == [10.0, 20.0]
end

#
###
# AbstractSciMLScalarOperator interface
###

function (L::AbstractSciMLScalarOperator)(v::Number, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    return convert(Number, L) * v
end

SCALINGNUMBERTYPES = (
    :AbstractSciMLScalarOperator,
    :Number,
    :UniformScaling,
)

#=
The identity operator must be listed here
so that rules for combination with scalar
operators take precedence over rules for
combining with the identity operator when
the two are combined together.
=#
SCALINGCOMBINETYPES = (
    :AbstractSciMLOperator,
    :IdentityOperator,
)

Base.length(::AbstractSciMLScalarOperator) = 1
Base.size(::AbstractSciMLScalarOperator) = ()
Base.adjoint(α::AbstractSciMLScalarOperator) = conj(α)
Base.transpose(α::AbstractSciMLScalarOperator) = α

has_mul!(::AbstractSciMLScalarOperator) = true
isconcrete(::AbstractSciMLScalarOperator) = true
islinear(::AbstractSciMLScalarOperator) = true
has_adjoint(::AbstractSciMLScalarOperator) = true
has_concretization(::AbstractSciMLScalarOperator) = true

Base.:*(α::AbstractSciMLScalarOperator, u::AbstractArray) = convert(Number, α) * u
Base.:\(α::AbstractSciMLScalarOperator, u::AbstractArray) = convert(Number, α) \ u

function LinearAlgebra.rmul!(u::AbstractArray, α::AbstractSciMLScalarOperator)
    return rmul!(u, convert(Number, α))
end
function LinearAlgebra.lmul!(α::AbstractSciMLScalarOperator, u::AbstractArray)
    return lmul!(convert(Number, α), u)
end
function LinearAlgebra.ldiv!(α::AbstractSciMLScalarOperator, u::AbstractArray)
    return ldiv!(convert(Number, α), u)
end
function LinearAlgebra.ldiv!(
        v::AbstractArray,
        α::AbstractSciMLScalarOperator,
        u::AbstractArray
    )
    return ldiv!(v, convert(Number, α), u)
end

function LinearAlgebra.mul!(
        v::AbstractArray,
        α::AbstractSciMLScalarOperator,
        u::AbstractArray
    )
    x = convert(Number, α)
    return mul!(v, x, u)
end

function LinearAlgebra.mul!(
        v::AbstractArray,
        α::AbstractSciMLScalarOperator,
        u::AbstractArray,
        a::Union{Number, AbstractSciMLScalarOperator},
        b::Union{Number, AbstractSciMLScalarOperator}
    )
    α = convert(Number, α)
    a = convert(Number, a)
    b = convert(Number, b)
    return mul!(v, α, u, a, b)
end

function LinearAlgebra.axpy!(
        α::AbstractSciMLScalarOperator,
        x::AbstractArray,
        y::AbstractArray
    )
    α = convert(Number, α)
    return axpy!(α, x, y)
end

function LinearAlgebra.axpby!(
        α::AbstractSciMLScalarOperator,
        x::AbstractArray,
        β::Number,
        y::AbstractArray
    )
    α = convert(Number, α)
    return axpby!(α, x, β, y)
end

function LinearAlgebra.axpby!(
        α::Number,
        x::AbstractArray,
        β::AbstractSciMLScalarOperator,
        y::AbstractArray
    )
    β = convert(Number, β)
    return axpby!(α, x, β, y)
end

function LinearAlgebra.axpby!(
        α::AbstractSciMLScalarOperator,
        x::AbstractArray,
        β::AbstractSciMLScalarOperator,
        y::AbstractArray
    )
    α = convert(Number, α)
    β = convert(Number, β)
    return axpby!(α, x, β, y)
end

Base.:+(α::AbstractSciMLScalarOperator) = α

mutable struct ScalarOperator{T <: Number, F} <: AbstractSciMLScalarOperator{T}
    val::T
    update_func::F
end

"""
$SIGNATURES

Represents a linear scaling operator that may be applied to a `Number`,
or an `AbstractArray` subtype. Its state is updated by the user-provided
`update_func` during operator evaluation (`L([w,] v, u, p, t)`), or by
calls to `update_coefficients[!]`. Both recursively call the
update function, `update_func` which is assumed to have the signature:

    update_func(oldval::Number, u, p, t; <accepted kwargs>) -> newval

The set of keyword-arguments accepted by `update_func` must be provided
to `ScalarOperator` via the kwarg `accepted_kwargs` as a tuple of `Symbol`s.
`kwargs` cannot be passed down to `update_func` if `accepted_kwargs`
are not provided.

$(UPDATE_COEFFS_WARNING)

# Arguments

  - `val::Number`: Current scalar value.

# Keyword Arguments

  - `update_func`: Out-of-place update with signature
    `update_func(oldval, u, p, t; kwargs...) -> newval`.
  - `accepted_kwargs`: `Val` tuple of keyword names forwarded to `update_func`.

# Fields

  - `val`: Current scalar value.
  - `update_func`: Out-of-place scalar update function.

# Interface Rules

Lazy scalar algebra is defined for `AbstractSciMLScalarOperator`s. The
interface supports lazy addition, subtraction, multiplication, and division.
Updates must return a number with the intended scalar action. The underlying
number is immutable, but `ScalarOperator` itself is mutable, so
`update_coefficients!` may replace its stored value and returns `nothing`.

# Returns

A `ScalarOperator` storing the current scalar value and the configured
out-of-place update function.

# Errors

An update function that does not return a number, or a keyword that is not
listed in `accepted_kwargs`, causes the corresponding update or evaluation to
throw.

# Examples

```
using SciMLOperators

v = rand(4)
u = rand(4)
w = zeros(4)
p = nothing
t = 0.0

val_update = (a, u, p, t; scale = 0.0) -> scale
α = ScalarOperator(0.0; update_func = val_update, accepted_kwargs = (:scale,))
β = 2 * α + 3 / α

# Update β and evaluate with the new interface
result = β(v, u, p, t; scale = 1.0)

# In-place application
β(w, v, u, p, t; scale = 1.0)

# In-place with scaling
w_orig = copy(w)
α_val = 2.0
β_val = 0.5
β(w, v, u, p, t, α_val, β_val; scale = 1.0) # w = α_val*(β*v) + β_val*w
```
"""
function ScalarOperator(
        val;
        update_func = DEFAULT_UPDATE_FUNC,
        accepted_kwargs = nothing
    )
    update_func = preprocess_update_func(update_func, accepted_kwargs)
    return ScalarOperator(val, update_func)
end

# constructors
Base.convert(T::Type{<:Number}, α::ScalarOperator) = convert(T, α.val)
Base.convert(::Type{ScalarOperator}, α::Number) = ScalarOperator(α)

ScalarOperator(α::AbstractSciMLScalarOperator) = α
ScalarOperator(λ::UniformScaling) = ScalarOperator(λ.λ)

# traits
Base.show(io::IO, α::ScalarOperator) = print(io, "ScalarOperator($(α.val))")
function Base.conj(α::ScalarOperator) # TODO - test
    val = conj(α.val)
    update_func = (
        oldval, u, p, t;
        kwargs...,
    ) -> α.update_func(
        oldval |> conj,
        u,
        p,
        t;
        kwargs...
    ) |> conj
    return ScalarOperator(val; update_func = update_func, accepted_kwargs = NoKwargFilter())
end

Base.one(::AbstractSciMLScalarOperator{T}) where {T} = ScalarOperator(one(T))
Base.zero(::AbstractSciMLScalarOperator{T}) where {T} = ScalarOperator(zero(T))

Base.one(::Type{<:AbstractSciMLScalarOperator}) = ScalarOperator(true)
Base.zero(::Type{<:AbstractSciMLScalarOperator}) = ScalarOperator(false)
Base.abs(α::ScalarOperator) = abs(α.val)

function Base.exp(α::AbstractSciMLScalarOperator)
    update_func = (
        oldval, u, p, t;
        kwargs...,
    ) -> update_coefficients(α, u, p, t; kwargs...) |>
        concretize |>
        exp
    return ScalarOperator(exp(concretize(α)); update_func = update_func, accepted_kwargs = NoKwargFilter())
end

Base.iszero(α::ScalarOperator) = iszero(α.val)

getops(α::ScalarOperator) = (α.val,)
isconstant(α::ScalarOperator) = update_func_isconstant(α.update_func)
has_ldiv(α::ScalarOperator) = !iszero(α.val)
has_ldiv!(α::ScalarOperator) = has_ldiv(α)
ArrayInterface.issingular(α::ScalarOperator) = iszero(α.val)

function update_coefficients!(L::ScalarOperator, u, p, t; kwargs...)
    L.val = L.update_func(L.val, u, p, t; kwargs...)
    return nothing
end

function update_coefficients(L::ScalarOperator, u, p, t; kwargs...)
    return ScalarOperator(L.update_func(L.val, u, p, t; kwargs...), L.update_func)
end

# Copy method to avoid aliasing
function Base.copy(L::ScalarOperator)
    return ScalarOperator(L.val, L.update_func)
end

# Add ScalarOperator specific implementations for the new interface
function (α::ScalarOperator)(v::AbstractArray, u, p, t; kwargs...)
    α = update_coefficients(α, u, p, t; kwargs...)
    return convert(Number, α) * v
end

function (α::ScalarOperator)(w::AbstractArray, v::AbstractArray, u, p, t; kwargs...)
    update_coefficients!(α, u, p, t; kwargs...)
    return mul!(w, α, v)
end

function (α::ScalarOperator)(w::AbstractArray, v::AbstractArray, u, p, t, a, b; kwargs...)
    update_coefficients!(α, u, p, t; kwargs...)
    return mul!(w, α, v, a, b)
end

"""
$TYPEDEF

    AddedScalarOperator(α, β, ...)

Lazy sum of scalar operators.

# Arguments

  - `α, β, ...`: One or more `AbstractSciMLScalarOperator`s.

# Fields

  - `ops`: Tuple of component scalar operators.

# Interface Rules

Construct through scalar addition. The current scalar value is the sum of the
updated component values, so updates and division traits are evaluated
componentwise.
"""
struct AddedScalarOperator{T, O} <: AbstractSciMLScalarOperator{T}
    ops::O

    function AddedScalarOperator(ops::NTuple{N, AbstractSciMLScalarOperator}) where {N}
        @assert !isempty(ops)
        T = promote_type(eltype.(ops)...)
        return new{T, typeof(ops)}(ops)
    end
end

# constructors
function AddedScalarOperator(ops::AbstractSciMLScalarOperator...)
    return AddedScalarOperator(ops)
end

Base.:+(ops::AbstractSciMLScalarOperator...) = AddedScalarOperator(ops...)
function Base.:+(A::AddedScalarOperator, B::AddedScalarOperator)
    return AddedScalarOperator(A.ops..., B.ops...)
end
function Base.:+(A::AbstractSciMLScalarOperator, B::AddedScalarOperator)
    return AddedScalarOperator(A, B.ops...)
end
function Base.:+(A::AddedScalarOperator, B::AbstractSciMLScalarOperator)
    return AddedScalarOperator(A.ops..., B)
end
function Base.:-(A::AbstractSciMLScalarOperator, B::AbstractSciMLScalarOperator)
    return AddedScalarOperator(A, -B)
end

for op in (:-, :+)
    for T in SCALINGNUMBERTYPES[2:end]
        @eval Base.$op(α::AbstractSciMLScalarOperator, x::$T) = AddedScalarOperator(
            α,
            ScalarOperator($op(x))
        )
        @eval Base.$op(x::$T, α::AbstractSciMLScalarOperator) = AddedScalarOperator(
            ScalarOperator(x),
            $op(α)
        )
    end
end

function Base.convert(T::Type{<:Number}, α::AddedScalarOperator)
    return sum(convert.(T, α.ops))
end

function Base.show(io::IO, α::AddedScalarOperator)
    print(io, "(")
    show(io, α.ops[1])
    for i in 2:length(α.ops)
        print(io, " + ")
        show(io, α.ops[i])
    end
    return print(io, ")")
end
Base.conj(L::AddedScalarOperator) = AddedScalarOperator(conj.(L.ops))

function update_coefficients(L::AddedScalarOperator, u, p, t; kwargs...)
    ops = ()
    for op in L.ops
        ops = (ops..., update_coefficients(op, u, p, t; kwargs...))
    end

    return AddedScalarOperator(ops)
end

function update_coefficients!(L::AddedScalarOperator, u, p, t; kwargs...)
    for op in L.ops
        update_coefficients!(op, u, p, t; kwargs...)
    end
    return nothing
end
function (α::AddedScalarOperator)(v::AbstractArray, u, p, t; kwargs...)
    α = update_coefficients(α, u, p, t; kwargs...)
    return convert(Number, α) * v
end

function (α::AddedScalarOperator)(w::AbstractArray, v::AbstractArray, u, p, t; kwargs...)
    update_coefficients!(α, u, p, t; kwargs...)
    return mul!(w, α, v)
end

function (α::AddedScalarOperator)(
        w::AbstractArray, v::AbstractArray, u, p, t, a, b; kwargs...
    )
    update_coefficients!(α, u, p, t; kwargs...)
    return mul!(w, α, v, a, b)
end

getops(α::AddedScalarOperator) = α.ops

# Copy method to avoid aliasing
function Base.copy(L::AddedScalarOperator)
    return AddedScalarOperator(map(copy, L.ops))
end

has_ldiv(α::AddedScalarOperator) = !iszero(convert(Number, α))
has_ldiv!(α::AddedScalarOperator) = has_ldiv(α)

"""
$TYPEDEF

    ComposedScalarOperator(α, β, ...)

Lazy product of scalar operators.

# Arguments

  - `α, β, ...`: One or more `AbstractSciMLScalarOperator`s.

# Fields

  - `ops`: Tuple of component scalar operators.

# Interface Rules

Construct through scalar multiplication or composition. Updates are forwarded
to every component and the converted scalar is their product. Division is
available only when every component supports it in the current state.
"""
struct ComposedScalarOperator{T, O} <: AbstractSciMLScalarOperator{T}
    ops::O

    function ComposedScalarOperator(ops::NTuple{N, AbstractSciMLScalarOperator}) where {N}
        @assert !isempty(ops)
        T = reduce(_promote_operator_eltype, ops)
        return new{T, typeof(ops)}(ops)
    end
end

# constructor
function ComposedScalarOperator(ops::AbstractSciMLScalarOperator...)
    return ComposedScalarOperator(ops)
end

for op in (:*, :∘)
    @eval Base.$op(ops::AbstractSciMLScalarOperator...) = reduce($op, ops)
    @eval Base.$op(
        A::AbstractSciMLScalarOperator, B::AbstractSciMLScalarOperator
    ) = ComposedScalarOperator(
        A,
        B
    )
    @eval Base.$op(
        A::ComposedScalarOperator,
        B::AbstractSciMLScalarOperator
    ) = ComposedScalarOperator(
        A.ops...,
        B
    )
    @eval Base.$op(
        A::AbstractSciMLScalarOperator,
        B::ComposedScalarOperator
    ) = ComposedScalarOperator(
        A,
        B.ops...
    )
    @eval Base.$op(
        A::ComposedScalarOperator,
        B::ComposedScalarOperator
    ) = ComposedScalarOperator(
        A.ops...,
        B.ops...
    )

    for T in SCALINGNUMBERTYPES[2:end]
        @eval Base.$op(α::AbstractSciMLScalarOperator, x::$T) = ComposedScalarOperator(
            α,
            ScalarOperator(x)
        )
        @eval Base.$op(x::$T, α::AbstractSciMLScalarOperator) = ComposedScalarOperator(
            ScalarOperator(x),
            α
        )
    end
end

# Different methods for constant ScalarOperators
for T in SCALINGNUMBERTYPES[2:end]
    @eval function Base.:*(α::ScalarOperator, x::$T)
        if isconstant(α)
            return ScalarOperator(concretize(α) * x)
        else
            return ComposedScalarOperator(α, ScalarOperator(x))
        end
    end
    @eval function Base.:*(x::$T, α::ScalarOperator)
        if isconstant(α)
            return ScalarOperator(concretize(α) * x)
        else
            return ComposedScalarOperator(ScalarOperator(x), α)
        end
    end
end

function Base.convert(T::Type{<:Number}, α::ComposedScalarOperator)
    iszero(α) && return zero(T)
    return prod(concretize, α.ops)
end

function Base.show(io::IO, α::ComposedScalarOperator)
    print(io, "(")
    show(io, α.ops[1])
    for i in 2:length(α.ops)
        print(io, " * ")
        show(io, α.ops[i])
    end
    return print(io, ")")
end
Base.conj(L::ComposedScalarOperator) = ComposedScalarOperator(conj.(L.ops))
Base.:-(α::AbstractSciMLScalarOperator{T}) where {T} = (-one(T)) * α

@generated function update_coefficients(L::ComposedScalarOperator, u, p, t; kwargs...)
    N = length(L.parameters[2].parameters)
    updates = [:(update_coefficients(L.ops[$i], u, p, t; kwargs...)) for i in 1:N]
    return :(ComposedScalarOperator($(Expr(:tuple, updates...))))
end

@generated function update_coefficients!(L::ComposedScalarOperator, u, p, t; kwargs...)
    N = length(L.parameters[2].parameters)
    updates = [:(update_coefficients!(L.ops[$i], u, p, t; kwargs...)) for i in 1:N]
    return Expr(:block, updates..., :(nothing))
end

function (α::ComposedScalarOperator)(v::AbstractArray, u, p, t; kwargs...)
    α = update_coefficients(α, u, p, t; kwargs...)
    return convert(Number, α) * v
end

function (α::ComposedScalarOperator)(w::AbstractArray, v::AbstractArray, u, p, t; kwargs...)
    update_coefficients!(α, u, p, t; kwargs...)
    return mul!(w, α, v)
end

function (α::ComposedScalarOperator)(
        w::AbstractArray, v::AbstractArray, u, p, t, a, b; kwargs...
    )
    update_coefficients!(α, u, p, t; kwargs...)
    return mul!(w, α, v, a, b)
end

getops(α::ComposedScalarOperator) = α.ops

# Copy method to avoid aliasing
function Base.copy(L::ComposedScalarOperator)
    return ComposedScalarOperator(map(copy, L.ops))
end

has_ldiv(α::ComposedScalarOperator) = all(has_ldiv, α.ops)
has_ldiv!(α::ComposedScalarOperator) = all(has_ldiv!, α.ops)

"""
$TYPEDEF

    InvertedScalarOperator(α)

Lazy reciprocal of a scalar operator.

# Arguments

  - `α::AbstractSciMLScalarOperator`: Scalar operator to invert.

# Fields

  - `λ`: Wrapped scalar operator.

# Interface Rules

Construct through `inv(α)`. The current scalar value must be nonzero whenever
the reciprocal is evaluated; updates are forwarded to `λ` before conversion.
"""
struct InvertedScalarOperator{T, λType} <: AbstractSciMLScalarOperator{T}
    λ::λType

    function InvertedScalarOperator(λ::AbstractSciMLScalarOperator{T}) where {T}
        return new{T, typeof(λ)}(λ)
    end
end
#=
Keeping with the style, we avoid use of the generic InvertedOperator and instead
have a specialized type for this purpose that subtypes AbstractSciMLScalarOperator.
=#
Base.inv(L::AbstractSciMLScalarOperator) = InvertedScalarOperator(L)

for op in (:/,)
    for T in SCALINGNUMBERTYPES[2:end]
        @eval Base.$op(α::AbstractSciMLScalarOperator, x::$T) = α * inv(ScalarOperator(x))
        @eval Base.$op(x::$T, α::AbstractSciMLScalarOperator) = ScalarOperator(x) * inv(α)
    end

    @eval Base.$op(α::AbstractSciMLScalarOperator, β::AbstractSciMLScalarOperator) = α *
        inv(β)
end

for op in (:\,)
    for T in SCALINGNUMBERTYPES[2:end]
        @eval Base.$op(α::AbstractSciMLScalarOperator, x::$T) = inv(α) * ScalarOperator(x)
        @eval Base.$op(x::$T, α::AbstractSciMLScalarOperator) = inv(ScalarOperator(x)) * α
    end

    @eval Base.$op(α::AbstractSciMLScalarOperator, β::AbstractSciMLScalarOperator) = inv(α) *
        β
end

function Base.convert(T::Type{<:Number}, α::InvertedScalarOperator)
    return inv(convert(Number, α.λ))
end

function Base.show(io::IO, α::InvertedScalarOperator)
    print(io, "1 / ")
    return show(io, α.λ)
end
Base.conj(L::InvertedScalarOperator) = InvertedScalarOperator(conj(L.λ))

function update_coefficients(L::InvertedScalarOperator, u, p, t; kwargs...)
    return InvertedScalarOperator(update_coefficients(L.λ, u, p, t; kwargs...))
end
function update_coefficients!(L::InvertedScalarOperator, u, p, t; kwargs...)
    update_coefficients!(L.λ, u, p, t; kwargs...)
    return nothing
end
function (α::InvertedScalarOperator)(v::AbstractArray, u, p, t; kwargs...)
    α = update_coefficients(α, u, p, t; kwargs...)
    return convert(Number, α) * v
end

function (α::InvertedScalarOperator)(w::AbstractArray, v::AbstractArray, u, p, t; kwargs...)
    update_coefficients!(α, u, p, t; kwargs...)
    return mul!(w, α, v)
end

function (α::InvertedScalarOperator)(
        w::AbstractArray, v::AbstractArray, u, p, t, a, b; kwargs...
    )
    update_coefficients!(α, u, p, t; kwargs...)
    return mul!(w, α, v, a, b)
end
getops(α::InvertedScalarOperator) = (α.λ,)

# Copy method to avoid aliasing
function Base.copy(L::InvertedScalarOperator)
    return InvertedScalarOperator(copy(L.λ))
end

has_ldiv(α::InvertedScalarOperator) = has_mul(α.λ)
has_ldiv!(α::InvertedScalarOperator) = has_ldiv(α)
#

#
"""
Matrix free operator given by a function

$(FIELDS)
"""
mutable struct FunctionOperator{
        iip, oop, mul5, T <: Number, F, Fa, Fi, Fai, Tr, U, P, Tt,
        C, iType, oType,
    } <: AbstractSciMLOperator{T}
    """ Function with signature op(v, u, p, t) and (if isinplace) op(w, v, u, p, t) """
    op::F
    """ Adjoint operator"""
    op_adjoint::Fa
    """ Inverse operator"""
    op_inverse::Fi
    """ Adjoint inverse operator"""
    op_adjoint_inverse::Fai
    """ Traits """
    traits::Tr
    """ State """
    u::U
    """ Parameters """
    p::P
    """ Time """
    t::Tt
    """ Cache """
    cache::C
end

function FunctionOperator(
        op, op_adjoint, op_inverse, op_adjoint_inverse, traits, u, p, t,
        cache, ::Type{iType}, ::Type{oType}
    ) where {iType, oType}
    iip = traits.isinplace
    oop = traits.outofplace
    mul5 = traits.has_mul5
    T = traits.T

    return FunctionOperator{
        iip, oop, mul5, T, typeof(op), typeof(op_adjoint),
        typeof(op_inverse), typeof(op_adjoint_inverse), typeof(traits), typeof(u), typeof(p),
        typeof(t), typeof(cache), iType, oType,
    }(
        op, op_adjoint, op_inverse,
        op_adjoint_inverse, traits, u, p, t, cache
    )
end

function set_op(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType,
            oType,
        },
        op
    ) where {iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType, oType}
    return FunctionOperator{
        iip, oop, mul5, T, typeof(op), Fa, Fi, Fai, Tr, U, P, Tt, C, iType,
        oType,
    }(
        op, f.op_adjoint, f.op_inverse, f.op_adjoint_inverse, f.traits, f.u, f.p, f.t,
        f.cache
    )
end

function set_op_adjoint(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        },
        op_adjoint
    ) where {
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt,
        C, iType, oType,
    }
    return FunctionOperator{
        iip, oop, mul5, T, F, typeof(op_adjoint), Fi, Fai, Tr, U, P, Tt,
        C, iType, oType,
    }(
        f.op, op_adjoint, f.op_inverse, f.op_adjoint_inverse, f.traits,
        f.u, f.p, f.t, f.cache
    )
end

function set_op_inverse(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        },
        op_inverse
    ) where {
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt,
        C, iType, oType,
    }
    return FunctionOperator{
        iip, oop, mul5, T, F, Fa, typeof(op_inverse), Fai, Tr, U, P, Tt,
        C, iType, oType,
    }(
        f.op, f.op_adjoint, op_inverse, f.op_adjoint_inverse, f.traits,
        f.u, f.p, f.t, f.cache
    )
end

function set_op_adjoint_inverse(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr,
            U, P, Tt, C, iType, oType,
        },
        op_adjoint_inverse
    ) where {
        iip, oop, mul5, T, F, Fa,
        Fi, Fai, Tr, U, P, Tt, C, iType, oType,
    }
    return FunctionOperator{
        iip, oop, mul5, T, F, Fa, Fi, typeof(op_adjoint_inverse), Tr,
        U, P, Tt, C, iType, oType,
    }(
        f.op, f.op_adjoint, f.op_inverse, op_adjoint_inverse,
        f.traits, f.u, f.p, f.t, f.cache
    )
end

function set_traits(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        },
        traits
    ) where {
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
        iType, oType,
    }
    return FunctionOperator{
        iip, oop, mul5, T, F, Fa, Fi, Fai, typeof(traits), U, P, Tt,
        C, iType, oType,
    }(
        f.op, f.op_adjoint, f.op_inverse, f.op_adjoint_inverse, traits,
        f.u, f.p, f.t, f.cache
    )
end

function set_u(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        },
        u
    ) where {
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType,
        oType,
    }
    return FunctionOperator{
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, typeof(u), P, Tt, C, iType,
        oType,
    }(
        f.op, f.op_adjoint, f.op_inverse, f.op_adjoint_inverse, f.traits, u, f.p, f.t,
        f.cache
    )
end

function set_p(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        },
        p
    ) where {
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType,
        oType,
    }
    return FunctionOperator{
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, typeof(p), Tt, C, iType,
        oType,
    }(
        f.op, f.op_adjoint, f.op_inverse, f.op_adjoint_inverse, f.traits, f.u, p, f.t,
        f.cache
    )
end

function set_t(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType,
            oType,
        },
        t
    ) where {iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType, oType}
    return FunctionOperator{
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, typeof(t), C, iType,
        oType,
    }(
        f.op, f.op_adjoint, f.op_inverse, f.op_adjoint_inverse, f.traits, f.u, f.p, t,
        f.cache
    )
end

function set_cache(
        f::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        },
        cache
    ) where {
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
        iType, oType,
    }
    return FunctionOperator{
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, typeof(cache),
        iType, oType,
    }(
        f.op, f.op_adjoint, f.op_inverse, f.op_adjoint_inverse, f.traits,
        f.u, f.p, f.t, cache
    )
end

getcache(L::FunctionOperator) = L.cache
# `cache` is a type parameter here, so it cannot be swapped with `@reset`.
update_cache(L::FunctionOperator, new_cache) = set_cache(L, new_cache)

# Deliberately no `adopt_cache` method: `cache_self` sizes its buffers from
# `traits.sizes`, the input/output *array* shapes, which `size(L) == traits.size` does not
# expose, so two same-typed operators of equal `size` can still need different buffers.
# `cache_operator` also does batch-size fixup that skipping straight to `cache_internals`
# would miss. `FunctionOperator` still shares via the post-hoc path in `_deduplicate_cache`,
# which compares buffers that have actually been allocated.

function input_eltype(
        ::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        }
    ) where {iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType, oType}
    return iType
end

function output_eltype(
        ::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        }
    ) where {iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType, oType}
    return oType
end

"""
$(SIGNATURES)

Wrap callable object `op` within an `AbstractSciMLOperator`.

# Mathematical Description

```julia
L = FunctionOperator(op, v, w; kwargs...)
```

where ``w = L(u,p,t)*v`` is done matrix-free given the function
definition ``w = op(v,u,p,t)``.

# Arguments

`op` is assumed to have signature

    op(v, u, p, t; <accepted_kwargs>) -> w

or

    op(w, v, u, p, t; <accepted_kwargs>) -> [modifies w]

and optionally

    op(w, v, u, p, t, α, β; <accepted_kwargs>) -> [modifies w]

where `u`, `v`, `w` are `AbstractArray`s, `p` is a parameter object, and
`t`, `α`, `β` are scalars. The first signature corresponds to applying
the operator with `Base.*`, and the latter two correspond to the
three-argument, and the five-argument `mul!` respectively.

`input` and `output` prototype `AbstractArray`s are required for
determining operator traits such as `eltype`, `size`, and for
preallocating cache. If `output` array is not provided, the output
is assumed to be of the same type and share as the input.

# Keyword Arguments

  - `op_adjoint`, `op_inverse`, `op_adjoint_inverse`: Optional adjoint,
    inverse, and adjoint-inverse actions. Each must follow the same callable
    contract as `op`.
  - `u`, `p`, `t`: Prototypes for state, parameters, and time passed to `op`.
  - `accepted_kwargs`: `Val` tuple of keyword names forwarded to callable actions.

# Trait Keyword Arguments

Trait keyword arguments must be truthful and uniform across `op`, `op_adjoint`,
`op_inverse`, and `op_adjoint_inverse` when those actions are supplied.

  - `u` - Prototype of the state struct passed to the operator during evaluation, i.e. `L(u, p, t)`. `u` is set to `nothing` if no value is provided.
  - `p` - Prototype of parameter struct passed to the operator during evaluation, i.e. `L(u, p, t)`. `p` is set to `nothing` if no value is provided.
  - `t` - Protype of scalar time variable passed to the operator during evaluation. `t` is set to `zero(T)` if no value is provided.
  - `accepted_kwargs` - `Val` of a `Tuple` of `Symbol`s for zero-allocation kwarg filtering. Corresponds to the keyword arguments accepted by `op*`, and `update_coefficients[!]`. For example, if `op` accepts kwarg `scale`, as in `op(u, p, t; scale)`, then `accepted_kwargs = Val((:scale,))`. Plain tuples like `(:scale,)` are deprecated but still supported.
  - `T` - `eltype` of the operator. If no value is provided, the constructor infers the value from types of `input`, and `output`
  - `isinplace` - `true` if the operator can be used is a mutating way with in-place allocations. This trait is inferred if no value is provided.
  - `outofplace` - `true` if the operator can be used is a non-mutating way with in-place allocations. This trait is inferred if no value is provided.
  - `has_mul5` - `true` if the operator provides a five-argument `mul!` via the signature `op(v, u, p, t, α, β; <accepted_kwargs>)`. This trait is inferred if no value is provided.
  - `isconstant` - `true` if the operator is constant, and doesn't need to be updated via `update_coefficients[!]` during operator evaluation. Defaults to false.
  - `islinear` - `true` if the operator is linear. Defaults to `false`.
  - `isconvertible` - `true` a cheap `convert(AbstractMatrix, L.op)` method is available. Defaults to `false`.
  - `batch` - Boolean indicating if the input/output arrays comprise of batched column-vectors stacked in a matrix. If `true`, the input/output arrays must be `AbstractVecOrMat`s, and the length of the  second dimension (the batch dimension) must be the same. The batch dimension is not involved in size computation. For example, with `batch = true`, and `size(output), size(input) = (M, K), (N, K)`, the `FunctionOperator` size is set to `(M, N)`. If `batch = false`, which is the default, the `input`/`output` arrays may of any size so long as `ndims(input) == ndims(output)`, and the `size` of `FunctionOperator` is set to `(length(input), length(output))`.
  - `ifcache` - Allocate cache arrays in constructor. Defaults to `true`. Cache can be generated afterwards by calling `cache_operator(L, input, output)`
  - `cache` - Pregenerated cache arrays for in-place evaluations. Expected to be of type and shape `(similar(input), similar(output),)`. The constructor generates cache if no values are provided. Cache generation by the constructor can be disabled by setting the kwarg `ifcache = false`.
  - `opnorm` - The norm of `op`. Can be a `Number`, or function `opnorm(p::Integer)`. Defaults to `nothing`.
  - `issymmetric` - `true` if the operator is linear and symmetric. Defaults to `false`.
  - `ishermitian` - `true` if the operator is linear and hermitian. Defaults to `false`.
  - `isposdef` - `true` if the operator is linear and positive-definite. Defaults to `false`.
  - `kwargs` - Keyword arguments for cache initialization. If `accepted_kwargs` is provided, the corresponding keyword arguments must be passed.

# Returns

A matrix-free `FunctionOperator` whose size, element type, cache layout, and
traits are inferred from `input`, `output`, and the trait keyword arguments.

# Errors

Construction validates the input/output prototype dimensions and requested
batch layout. Application or cache initialization can throw when the
callable does not satisfy the selected in-place/out-of-place contract.
"""
function FunctionOperator(
        op,
        input::AbstractArray,
        output::AbstractArray = input; op_adjoint = nothing,
        op_inverse = nothing,
        op_adjoint_inverse = nothing, u = nothing, p = nothing,
        t::Union{Number, Nothing} = nothing,
        accepted_kwargs::Union{Nothing, Val, Tuple{Vararg{Symbol}}} = nothing,

        # traits
        T::Union{Type{<:Number}, Nothing} = nothing,
        isinplace::Union{Nothing, Bool, Val} = nothing,
        outofplace::Union{Nothing, Bool, Val} = nothing,
        has_mul5::Union{Nothing, Bool, Val} = nothing,
        isconstant::Bool = false,
        islinear::Bool = false,
        isconvertible::Bool = false, batch::Bool = false,
        ifcache::Union{Bool, Val} = Val(true),
        cache::Union{Nothing, NTuple{2}} = nothing,

        # LinearAlgebra traits
        opnorm = nothing,
        issymmetric::Union{Bool, Val} = Val(false),
        ishermitian::Union{Bool, Val} = Val(false),
        isposdef::Bool = false,
        kwargs...
    )

    # establish types

    # store eltype of input/output for caching with ComposedOperator.
    _T = T === nothing ? promote_type(eltype(input), eltype(output)) : T
    _t = t === nothing ? zero(real(_T)) : t

    isinplace isa Val && (@assert _unwrap_val(isinplace) isa Bool)
    outofplace isa Val && (@assert _unwrap_val(outofplace) isa Bool)
    has_mul5 isa Val && (@assert _unwrap_val(has_mul5) isa Bool)
    issymmetric isa Val && (@assert _unwrap_val(issymmetric) isa Bool)
    ishermitian isa Val && (@assert _unwrap_val(ishermitian) isa Bool)

    @assert _T <: Number """The `eltype` of `FunctionOperator`, as well as
    the `input`/`output` arrays must be `<:Number`."""

    # establish sizes

    @assert ndims(output) == ndims(input) """`input`/`output` arrays,
    ($(typeof(input)), $(typeof(output))) provided to `FunctionOperator`
    do not have the same number of dimensions. Further, if `batch = true`,
    then both arrays must be `AbstractVector`s, or both must be
    `AbstractMatrix` types."""

    if batch
        if !isa(input, AbstractVecOrMat)
            msg = """`FunctionOperator` constructed with `batch = true` only
            accepts `AbstractVecOrMat` types with
            `size(L, 2) == size(u, 1)`."""
            throw(ArgumentError(msg))
        end

        if input isa AbstractMatrix
            # assume batches are 2nd dimension of `AbstractVecOrMat`
            if size(input, 2) != size(output, 2)
                msg = """ Batch size (length of second dimension) in `input`/
                `output` arrays to `FunctionOperator` is not equal. Input
                array, $(typeof(input)), has size $(size(input)), whereas
                output array, $(typeof(output)), has size
                $(size(output))."""
                throw(ArgumentError(msg))
            end
        end
    end

    sizes = size(input), size(output)

    _size = if batch
        # assume batches are 2nd dimension of `AbstractVecOrMat`
        (size(output, 1), size(input, 1))
    else
        (length(output), length(input))
    end

    # evaluation signatures

    _isinplace = if isinplace === nothing
        Val(hasmethod(op, typeof((output, input, u, p, _t))))
    elseif isinplace isa Bool
        Val(isinplace)
    else
        isinplace
    end

    _outofplace = if outofplace === nothing
        Val(hasmethod(op, typeof((input, u, p, _t))))
    elseif outofplace isa Bool
        Val(outofplace)
    else
        outofplace
    end

    if !_unwrap_val(_isinplace) & !_unwrap_val(_outofplace)
        @error """Please provide a function with signatures `op(v, u, p, t)` for
        applying the operator out-of-place, and/or the signature is
        `op(w, v, u, p, t)` for in-place application."""
    end

    _has_mul5 = if has_mul5 === nothing
        __and_val(
            __has_mul5(op, output, input, u, p, _t),
            __has_mul5(op_adjoint, input, output, u, p, _t),
            __has_mul5(op_inverse, output, input, u, p, _t),
            __has_mul5(op_adjoint_inverse, input, output, u, p, _t)
        )
    elseif has_mul5 isa Bool
        Val(has_mul5)
    else
        has_mul5
    end

    # traits

    isreal = _T <: Real
    selfadjoint = _unwrap_val(ishermitian) | (isreal & _unwrap_val(issymmetric))
    adjointable = !(op_adjoint isa Nothing) | _unwrap_val(selfadjoint)
    invertible = !(op_inverse isa Nothing)

    if selfadjoint & (op_adjoint isa Nothing)
        _op_adjoint = op
    else
        _op_adjoint = op_adjoint
    end

    if selfadjoint & invertible & (op_adjoint_inverse isa Nothing)
        _op_adjoint_inverse = op_inverse
    else
        _op_adjoint_inverse = op_adjoint_inverse
    end

    if accepted_kwargs === nothing
        accepted_kwargs = Val(())
        kwargs = NamedTuple()
    else
        length(kwargs) != 0 ||
            throw(ArgumentError("No keyword arguments provided. When `accepted_kwargs` is provided, the corresponding keyword arguments must be passed for cache initialization."))
        kwargs = get_filtered_kwargs(kwargs, accepted_kwargs)
    end

    traits = (;
        islinear, isconvertible, isconstant, opnorm,
        issymmetric = _unwrap_val(issymmetric), ishermitian = _unwrap_val(ishermitian),
        isposdef, isinplace = _unwrap_val(_isinplace),
        outofplace = _unwrap_val(_outofplace), has_mul5 = _unwrap_val(_has_mul5),
        ifcache = _unwrap_val(ifcache), T = _T, batch, size = _size, sizes,
        accepted_kwargs, kwargs = kwargs,
    )

    L = FunctionOperator{
        _unwrap_val(_isinplace), _unwrap_val(_outofplace),
        _unwrap_val(_has_mul5), _T, typeof(op), typeof(_op_adjoint), typeof(op_inverse),
        typeof(_op_adjoint_inverse), typeof(traits), typeof(u), typeof(p), typeof(_t), typeof(cache),
        eltype(input), eltype(output),
    }(
        op,
        _op_adjoint, op_inverse, _op_adjoint_inverse, traits, u, p, _t, cache
    )

    # create cache

    if _unwrap_val(ifcache) & (L.cache === nothing)
        L_cached = cache_operator(L, input)
    else
        L_cached = L
    end

    return L_cached
end

@inline __has_mul5(::Nothing, w, v, u, p, t) = Val(true)
@inline function __has_mul5(f::F, w, v, u, p, t) where {F}
    return Val(hasmethod(f, typeof((w, v, u, p, t, t, t))))
end
@inline __and_val(vs...) = mapreduce(_unwrap_val, *, vs)

function update_coefficients(L::FunctionOperator, u, p, t; kwargs...)

    # update u, p, t
    L = set_u(L, u)
    L = set_p(L, p)
    L = set_t(L, t)

    # filter and update kwargs
    filtered_kwargs = get_filtered_kwargs(kwargs, L.traits.accepted_kwargs)

    L = set_traits(L, merge(L.traits, (; kwargs = filtered_kwargs)))

    isconstant(L) && return L

    L = set_op(L, update_coefficients(L.op, u, p, t; filtered_kwargs...))
    L = set_op_adjoint(L, update_coefficients(L.op_adjoint, u, p, t; filtered_kwargs...))
    L = set_op_inverse(L, update_coefficients(L.op_inverse, u, p, t; filtered_kwargs...))
    return L = set_op_adjoint_inverse(
        L,
        update_coefficients(L.op_adjoint_inverse, u, p, t; filtered_kwargs...)
    )
end

function update_coefficients!(L::FunctionOperator, u, p, t; kwargs...)

    # update u, p, t
    L.u = u
    L.p = p
    L.t = t

    # filter and update kwargs
    filtered_kwargs = get_filtered_kwargs(kwargs, L.traits.accepted_kwargs)
    L.traits = merge(L.traits, (; kwargs = filtered_kwargs))

    isconstant(L) && return

    for op in getops(L)
        update_coefficients!(op, u, p, t; filtered_kwargs...)
    end

    return nothing
end

function iscached(L::FunctionOperator)
    # L.traits.ifcache ? !isnothing(L.cache) : !L.traits.ifcache
    return L.cache !== nothing
end

# Copy method to avoid aliasing
function Base.copy(L::FunctionOperator)
    return FunctionOperator(
        L.op,
        L.op_adjoint,
        L.op_inverse,
        L.op_adjoint_inverse,
        L.traits,
        isdefined(L, :u) && L.u !== nothing ? copy(L.u) : nothing,
        isdefined(L, :p) && L.p !== nothing ? deepcopy(L.p) : nothing,
        L.t,
        L.cache === nothing ? nothing : deepcopy(L.cache),
        typeof(L).parameters[end - 1],  # iType
        typeof(L).parameters[end]      # oType
    )
end

# fix method amg bw AbstractArray, AbstractVecOrMat
cache_operator(L::FunctionOperator, u::AbstractArray) = _cache_operator(L, u)
cache_operator(L::FunctionOperator, u::AbstractVecOrMat) = _cache_operator(L, u)

function _cache_operator(L::FunctionOperator, u::AbstractArray)
    U = if L.traits.batch
        if !isa(u, AbstractVecOrMat)
            msg = """$L constructed with `batch = true` only accepts
            `AbstractVecOrMat` types with `size(L, 2) == size(u, 1)`."""
            throw(ArgumentError(msg))
        end

        if size(L, 2) != size(u, 1)
            msg = """Second dimension of $L of size $(size(L))
            is not consistent with first dimension of input array `u`
            of size $(size(u))."""
            throw(DimensionMismatch(msg))
        end

        M = size(L, 1)
        K = size(u, 2)
        size_out = u isa AbstractVector ? (M,) : (M, K)

        new_traits = merge(L.traits, (; sizes = (size(u), size_out)))
        L = set_traits(L, new_traits)

        u
    else
        if size(L, 2) != length(u)
            msg = """Length of input array, $(typeof(u)), of size $(size(u))
            not consistent with second dimension of $L of size
            $(size(L))."""
            throw(DimensionMismatch(msg))
        end

        reshape(u, L.traits.sizes[1])
    end

    L = cache_self(L, U)
    L = cache_internals(L, U)
    return L
end

# fix method amg bw AbstractArray, AbstractVecOrMat
cache_self(L::FunctionOperator, v::AbstractArray) = _cache_self(L, v)
cache_self(L::FunctionOperator, v::AbstractVecOrMat) = _cache_self(L, v)

function _cache_self(
        L::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C,
            iType, oType,
        },
        v::AbstractArray
    ) where {
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P,
        Tt, C, iType, oType,
    }
    _v = similar(v, iType, L.traits.sizes[1])
    _w = similar(v, oType, L.traits.sizes[2])

    return set_cache(L, (_v, _w))
end

# fix method amg bw AbstractArray, AbstractVecOrMat
cache_internals(L::FunctionOperator, u::AbstractArray) = _cache_internals(L, u)
cache_internals(L::FunctionOperator, u::AbstractVecOrMat) = _cache_internals(L, u)

function _cache_internals(
        L::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt,
            C, iType, oType,
        },
        u::AbstractArray
    ) where {
        iip, oop, mul5, T, F, Fa, Fi, Fai, Tr,
        U, P, Tt, C, iType, oType,
    }
    newop = cache_operator(L.op, u)
    newop_adjoint = cache_operator(L.op_adjoint, u)
    newop_inverse = cache_operator(L.op_inverse, u)
    newop_adjoint_inverse = cache_operator(L.op_adjoint_inverse, u)

    return FunctionOperator{
        iip, oop, mul5, T, typeof(newop), typeof(newop_adjoint),
        typeof(newop_inverse), typeof(newop_adjoint_inverse), Tr, U, P, Tt, C, iType, oType,
    }(
        newop, newop_adjoint, newop_inverse, newop_adjoint_inverse, L.traits, L.u, L.p, L.t,
        L.cache
    )
end

function Base.show(io::IO, L::FunctionOperator)
    M, N = size(L)
    return print(io, "FunctionOperator($M × $N)")
end
Base.size(L::FunctionOperator) = L.traits.size

function Base.adjoint(
        L::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt,
            C, iType,
            oType,
        }
    ) where {iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType, oType}
    (ishermitian(L) | (isreal(L) & issymmetric(L))) && return L

    has_adjoint(L) || return AdjointOperator(L)

    op = L.op_adjoint
    op_adjoint = L.op

    op_inverse = L.op_adjoint_inverse
    op_adjoint_inverse = L.op_inverse

    traits = merge(L.traits, (; size = reverse(size(L)), sizes = reverse(L.traits.sizes)))

    cache = iscached(L) ? reverse(L.cache) : nothing

    return FunctionOperator{
        iip, oop, mul5, T, typeof(op), typeof(op_adjoint),
        typeof(op_inverse), typeof(op_adjoint_inverse), typeof(traits), U, P, Tt,
        typeof(cache), oType, iType,
    }(
        op, op_adjoint, op_inverse, op_adjoint_inverse, traits,
        L.u, L.p, L.t, cache
    )
end

function Base.inv(
        L::FunctionOperator{
            iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt,
            C, iType,
            oType,
        }
    ) where {iip, oop, mul5, T, F, Fa, Fi, Fai, Tr, U, P, Tt, C, iType, oType}
    has_ldiv(L) || return InvertedOperator(L)

    op = L.op_inverse
    op_inverse = L.op

    op_adjoint = L.op_adjoint_inverse
    op_adjoint_inverse = L.op_adjoint

    opnorm = if L.traits.opnorm isa Number
        1 / L.traits.opnorm
    elseif L.traits.opnorm isa Nothing
        nothing
    else
        (p::Real) -> 1 / L.traits.opnorm(p)
    end
    traits = merge(
        L.traits,
        (; size = reverse(size(L)), sizes = reverse(L.traits.sizes), opnorm)
    )

    cache = iscached(L) ? reverse(L.cache) : nothing

    return FunctionOperator{
        iip, oop, mul5, T, typeof(op), typeof(op_adjoint),
        typeof(op_inverse), typeof(op_adjoint_inverse), typeof(traits), U, P, Tt,
        typeof(cache), oType, iType,
    }(
        op, op_adjoint, op_inverse, op_adjoint_inverse, traits,
        L.u, L.p, L.t, cache
    )
end

Base.convert(::Type{AbstractMatrix}, L::FunctionOperator) = convert(AbstractMatrix, L.op)

function Base.resize!(L::FunctionOperator, n::Integer)

    # input/output to `L` must be `AbstractVector`s
    if length(L.traits.sizes[1]) != 1
        msg = """`Base.resize!` is only supported by $L whose input/output
        arrays are `AbstractVector`s."""
        throw(MethodError(msg))
    end

    for op in getops(L)
        if hasmethod(resize!, typeof((op, n)))
            resize!(op, n)
        end
    end

    for v in L.cache
        resize!(v, n)
    end

    L.traits = (; L.traits..., size = (n, n), sizes = ((n,), (n,)))

    return L
end

function LinearAlgebra.opnorm(L::FunctionOperator, p::Real = 2)
    L.traits.opnorm === nothing && error(
        """
        M.opnorm is nothing, please define opnorm as a function that takes one
        argument. E.g., `(p::Real) -> p == Inf ? 100 : error("only Inf norm is
        defined")`"""
    )
    opn = L.traits.opnorm
    return opn isa Number ? opn : L.traits.opnorm(p)
end
LinearAlgebra.issymmetric(L::FunctionOperator) = L.traits.issymmetric
LinearAlgebra.ishermitian(L::FunctionOperator) = L.traits.ishermitian
LinearAlgebra.isposdef(L::FunctionOperator) = L.traits.isposdef

function getops(L::FunctionOperator)
    return (;
        op = L.op,
        op_adjoint = L.op_adjoint,
        op_inverse = L.op_inverse,
        op_adjoint_inverse = L.op_adjoint_inverse,
    )
end

islinear(L::FunctionOperator) = L.traits.islinear
isconvertible(L::FunctionOperator) = L.traits.isconvertible
has_concretization(L::FunctionOperator) = isconvertible(L)
isconstant(L::FunctionOperator) = L.traits.isconstant
has_adjoint(L::FunctionOperator) = !(L.op_adjoint isa Nothing)
has_mul(::FunctionOperator{iip}) where {iip} = true
has_mul!(::FunctionOperator{iip}) where {iip} = true
has_ldiv(L::FunctionOperator{iip}) where {iip} = !(L.op_inverse isa Nothing)
has_ldiv!(L::FunctionOperator{iip}) where {iip} = iip & !(L.op_inverse isa Nothing)

function _assert_has_inverse(L::FunctionOperator)
    has_ldiv(L) && return nothing
    msg = "Cannot divide by FunctionOperator without an inverse. Provide `op_inverse` when constructing the operator."
    throw(ArgumentError(msg))
end

function _sizecheck(L::FunctionOperator, v, w)
    sizes = L.traits.sizes
    if L.traits.batch
        if !isnothing(v)
            if !isa(v, AbstractVecOrMat)
                msg = """$L constructed with `batch = true` only
                accept input arrays that are `AbstractVecOrMat`s with
                `size(L, 2) == size(v, 1)`. Received $(typeof(v))."""
                throw(ArgumentError(msg))
            end

            if size(L, 2) != size(v, 1)
                msg = """$L accepts input `AbstractVecOrMat`s of size
                ($(size(L, 2)), K). Received array of size $(size(v))."""
                throw(DimensionMismatch(msg))
            end
        end # v

        if !isnothing(w)
            if !isa(w, AbstractVecOrMat)
                msg = """$L constructed with `batch = true` only
                returns output arrays that are `AbstractVecOrMat`s with
                `size(L, 1) == size(w, 1)`. Received $(typeof(w))."""
                throw(ArgumentError(msg))
            end

            if size(L, 1) != size(w, 1)
                msg = """$L accepts output `AbstractVecOrMat`s of size
                ($(size(L, 1)), K). Received array of size $(size(w))."""
                throw(DimensionMismatch(msg))
            end
        end # w

        if !isnothing(v) & !isnothing(w)
            if size(v, 2) != size(w, 2)
                msg = """input array $v, and output array, $w, must have the
                same batch size (i.e. length of second dimension). Got
                $(size(v)), $(size(w)). If you encounter this error during
                an in-place evaluation (`LinearAlgebra.mul!`, `ldiv!`),
                ensure that the operator $L has been cached with an input
                array of the correct size. Do so by calling
                `L = cache_operator(L, v)`."""
                throw(DimensionMismatch(msg))
            end
        end # v, w

    else # !batch
        if !isnothing(v)
            if size(v) ∉ (sizes[1], tuple(size(L, 2)))
                msg = """$L received input array of size $(size(v)), but only
                accepts input arrays of size $(sizes[1]), or vectors like
                `vec(v)` of size $(tuple(prod(sizes[1])))."""
                throw(DimensionMismatch(msg))
            end
        end # v

        if !isnothing(w)
            if size(w) ∉ (sizes[2], tuple(size(L, 1)))
                msg = """$L received output array of size $(size(w)), but only
                accepts output arrays of size $(sizes[2]), or vectors like
                `vec(v)` of size $(tuple(prod(sizes[2])))"""
                throw(DimensionMismatch(msg))
            end
        end # w
    end # batch

    return
end

function _unvec(L::FunctionOperator, v, w)
    if L.traits.batch
        return v, w, false
    else
        sizes = L.traits.sizes

        # no need to vec since expected input/output are AbstractVectors
        if length(sizes[1]) == 1
            return v, w, false
        end

        vec_v = isnothing(v) ? false : size(v) != sizes[1]
        vec_w = isnothing(w) ? false : size(w) != sizes[2]

        if !isnothing(v) & !isnothing(w)
            if (vec_v & !vec_w) | (!vec_v & vec_w)
                msg = """Input / output to $L can either be of sizes
                $(sizes[1]) / $(sizes[2]), or
                $(tuple(prod(sizes[1]))) / $(tuple(prod(sizes[2]))). Got
                $(size(v)), $(size(w))."""
                throw(DimensionMismatch(msg))
            end
        end

        V = vec_v ? reshape(v, sizes[1]) : v
        W = vec_w ? reshape(w, sizes[2]) : w
        vec_output = vec_v | vec_w

        return V, W, vec_output
    end
end

# operator application
function Base.:*(L::FunctionOperator{iip, true}, v::AbstractArray) where {iip}
    _sizecheck(L, v, nothing)
    V, _, vec_output = _unvec(L, v, nothing)

    W = L.op(V, L.u, L.p, L.t; L.traits.kwargs...)

    return vec_output ? vec(W) : W
end

function Base.:*(L::FunctionOperator{iip, false}, v::AbstractArray) where {iip}
    _sizecheck(L, v, nothing)
    V, _, vec_output = _unvec(L, v, nothing)

    W, _ = L.cache
    W = copy(W)
    L.op(W, V, L.u, L.p, L.t; L.traits.kwargs...)

    return vec_output ? vec(W) : W
end

function Base.:\(L::FunctionOperator{iip, true}, v::AbstractArray) where {iip}
    _sizecheck(L, nothing, v)
    _assert_has_inverse(L)
    _, V, vec_output = _unvec(L, nothing, v)

    W = L.op_inverse(V, L.u, L.p, L.t; L.traits.kwargs...)

    return vec_output ? vec(W) : W
end

function Base.:\(L::FunctionOperator{iip, false}, v::AbstractArray) where {iip}
    _sizecheck(L, nothing, v)
    _assert_has_inverse(L)
    _, V, vec_output = _unvec(L, nothing, v)

    W, _ = L.cache
    W = copy(W)
    L.op_inverse(W, V, L.u, L.p, L.t; L.traits.kwargs...)

    return vec_output ? vec(W) : W
end

function LinearAlgebra.mul!(w::AbstractArray, L::FunctionOperator{true}, v::AbstractArray)
    _sizecheck(L, v, w)
    V, W, vec_output = _unvec(L, v, w)
    L.op(W, V, L.u, L.p, L.t; L.traits.kwargs...)
    return vec_output ? vec(W) : W
end

function LinearAlgebra.mul!(
        w::AbstractArray, L::FunctionOperator{false}, v::AbstractArray,
        args...
    )
    _sizecheck(L, v, w)
    V, W, vec_output = _unvec(L, v, w)
    W .= L.op(V, L.u, L.p, L.t; L.traits.kwargs...)
    return vec_output ? vec(W) : W
end

function LinearAlgebra.mul!(
        w::AbstractArray, L::FunctionOperator{true, oop, false},
        v::AbstractArray, α, β
    ) where {oop}
    _, Co = L.cache

    _sizecheck(L, v, w)
    V, W, _ = _unvec(L, v, w)

    copy!(Co, W)
    L.op(W, V, L.u, L.p, L.t; L.traits.kwargs...) # mul!(V, L, U)
    axpby!(β, Co, α, W)

    return w
end

function LinearAlgebra.mul!(
        w::AbstractArray, L::FunctionOperator{true, oop, true},
        v::AbstractArray, α, β
    ) where {oop}
    _sizecheck(L, v, w)
    V, W, _ = _unvec(L, v, w)

    L.op(W, V, L.u, L.p, L.t, α, β; L.traits.kwargs...)

    return w
end

function LinearAlgebra.ldiv!(w::AbstractArray, L::FunctionOperator{true}, v::AbstractArray)
    _sizecheck(L, v, w)
    _assert_has_inverse(L)
    W, V, _ = _unvec(L, w, v)

    L.op_inverse(W, V, L.u, L.p, L.t; L.traits.kwargs...)

    return w
end

function LinearAlgebra.ldiv!(L::FunctionOperator{true}, v::AbstractArray)
    _sizecheck(L, nothing, v)
    _assert_has_inverse(L)
    V, _, vec_output = _unvec(L, v, nothing)

    W, _ = L.cache
    copy!(W, V)
    L.op_inverse(W, V, L.u, L.p, L.t; L.traits.kwargs...) # ldiv!(U, L, V)

    V .= W
    return vec_output ? vec(V) : V
end

function LinearAlgebra.ldiv!(w::AbstractArray, L::FunctionOperator{false}, v::AbstractArray)
    _sizecheck(L, v, w)
    _assert_has_inverse(L)
    W, V, _ = _unvec(L, w, v)

    W .= L.op_inverse(V, L.u, L.p, L.t; L.traits.kwargs...)

    return w
end

function LinearAlgebra.ldiv!(L::FunctionOperator{false}, v::AbstractArray)
    _sizecheck(L, nothing, v)
    _assert_has_inverse(L)
    V, _, vec_output = _unvec(L, v, nothing)

    V .= L.op_inverse(V, L.u, L.p, L.t; L.traits.kwargs...) # ldiv!(W, L, V)

    return vec_output ? vec(V) : V
end

# Out-of-place: v is action vector, u is update vector
function (L::FunctionOperator)(v::AbstractArray, u, p, t; kwargs...)
    L = update_coefficients(L, u, p, t; kwargs...)
    _sizecheck(L, v, nothing)
    V, _, vec_output = _unvec(L, v, nothing)

    # Apply the operator to action vector v after updating with u
    if L.traits.outofplace
        result = L.op(V, L.u, L.p, L.t; L.traits.kwargs...)
        return vec_output ? vec(result) : result
    else
        # For operators without out-of-place methods, use their in-place methods with a temporary
        Co = similar(V)
        L.op(Co, V, L.u, L.p, L.t; L.traits.kwargs...)
        return vec_output ? vec(Co) : Co
    end

    return v
end

# In-place: w is destination, v is action vector, u is update vector
function (L::FunctionOperator)(w::AbstractArray, v::AbstractArray, u, p, t; kwargs...)
    update_coefficients!(L, u, p, t; kwargs...)

    # Check dimensions
    _sizecheck(L, v, w)
    V, W, _ = _unvec(L, v, w)

    # Apply the operator in-place to action vector v after updating with u
    if L.traits.isinplace
        L.op(W, V, L.u, L.p, L.t; L.traits.kwargs...)
    else
        # For operators without in-place methods, use their out-of-place methods
        result = L.op(V, L.u, L.p, L.t; L.traits.kwargs...)
        copyto!(W, result)
    end

    return w
end

# In-place with scaling: w = α*(L*v) + β*w
function (L::FunctionOperator)(w::AbstractArray, v::AbstractArray, u, p, t, α, β; kwargs...)
    update_coefficients!(L, u, p, t; kwargs...)

    # Check dimensions
    _sizecheck(L, v, w)
    V, W, _ = _unvec(L, v, w)

    # Apply the operator in-place to action vector v with scaling
    if L.traits.isinplace && L.traits.has_mul5
        # Direct 5-arg mul! if supported
        L.op(W, V, L.u, L.p, L.t, α, β; L.traits.kwargs...)
    elseif L.traits.isinplace
        # Use temporary for regular in-place
        temp = copy(W)
        L.op(W, V, L.u, L.p, L.t; L.traits.kwargs...)
        axpby!(β, temp, α, W)
    else
        # Out-of-place with scaling
        result = L.op(V, L.u, L.p, L.t; L.traits.kwargs...)
        axpby!(β, W, α, result)
    end

    return w
end
#

# Getting Started with Matrix-Free Operators in Julia

SciMLOperators.jl is a package for defining operators for use in solvers.
One of the major use cases is to define matrix-free operators in cases where
using a matrix would be too memory expensive. In this tutorial we will walk
through the main features of SciMLOperators and get you going with matrix-free
and updating operators.

## Simplest Operator: MatrixOperator

Before we get into the deeper operators, let's show the simplest SciMLOperator:
`MatrixOperator`. `MatrixOperator` just turns a matrix into an `AbstractSciMLOperator`,
so it's not really a matrix-free operator but it's a starting point that is good for
understanding the interface and testing. To create a `MatrixOperator`, simply call the
constructor on a matrix:

```@example getting_started
using SciMLOperators, LinearAlgebra
A = [-2.0 1 0 0 0
     1 -2 1 0 0
     0 1 -2 1 0
     0 0 1 -2 1
     0 0 0 1 -2]

opA = MatrixOperator(A)
```

The operators can do [operations as defined in the operator interface](@ref operator_interface), for example,
matrix multiplication as the core action:

```@example getting_started
v = [3.0, 2.0, 1.0, 2.0, 3.0]
opA*v
```

```@example getting_started
opA(v, nothing, nothing, nothing) # Call = opA*v
```

```@example getting_started
w = zeros(5)
mul!(w, opA, v)
```

```@example getting_started
α = 1.0;
β = 1.0
mul!(w, opA, v, α, β) # α*opA*v + β*w
```

and the inverse operation:

```@example getting_started
opA \ v
```

```@example getting_started
ldiv!(w, lu(opA), v)
```

## State, Parameter, and Time-Dependent Operators

Now let's define a `MatrixOperator` the is dependent on state, parameters, and time.
For example, let's make the operator `A .* u + dt*I` where `dt` is a parameter
and `u` is a state vector:

```@example getting_started
A = [-2.0 1 0 0 0
     1 -2 1 0 0
     0 1 -2 1 0
     0 0 1 -2 1
     0 0 0 1 -2]

function update_function!(B, u, p, t)
    dt = p
    B .= A .* u + dt*I
end

u = Array(1:1.0:5);
p = 0.1;
t = 0.0
opB = MatrixOperator(copy(A); update_func! = update_function!)
```

To update the operator, you would use `update_coefficients!(opB, u, p, t)`:

```@example getting_started
update_coefficients!(opB, u, p, t)
```

We can use the interface to see what the current matrix is by converting to a standard matrix:

```@example getting_started
convert(AbstractMatrix, opB)
```

And now applying the operator applies the updated one:

```@example getting_started
opB*v
```

Or if you use the operator application, it will update and apply in one step:

```@example getting_started
opB(v, Array(2:1.0:6), 0.5, nothing) # opB(u,p,t)*v
```

This is how for example, when an ODE solver asks for an operator `L(u,p,t)*u`, this is how
such an operator can be defined. Notice that the interface can be queried to understand
the traits of the operator, such as for example whether an operator is constant (does not
change w.r.t. `(u,p,t)`):

```@example getting_started
isconstant(opA)
```

```@example getting_started
isconstant(opB)
```

## Matrix-Free Operators via FunctionOperator

Now let's define the operators from above in a matrix-free way using `FunctionOperator`.
With `FunctionOperator`, we directly define the operator application function `opA(w,v,u,p,t)`
which means `w = opA(u,p,t)*v`. For example we can do the following:

```@example getting_started
function Afunc!(w, v, u, p, t)
    w[1] = -2v[1] + v[2]
    for i in 2:4
        w[i] = v[i - 1] - 2v[i] + v[i + 1]
    end
    w[5] = v[4] - 2v[5]
    nothing
end

function Afunc!(v, u, p, t)
    w = zeros(5)
    Afunc!(w, v, u, p, t)
    w
end

mfopA = FunctionOperator(Afunc!, zeros(5), zeros(5))
```

Now `mfopA` acts just like `A*v` and thus `opA`:

```@example getting_started
mfopA*v - opA*v
```

```@example getting_started
mfopA(v, u, p, t) - opA(v, u, p, t)
```

We can also create the state-dependent operator as well:

```@example getting_started
function Bfunc!(w, v, u, p, t)
    dt = p
    w[1] = -(2*u[1]-dt)*v[1] + v[2]*u[1]
    for i in 2:4
        w[i] = v[i - 1]*u[i] - (2*u[i]-dt)*v[i] + v[i + 1]*u[i]
    end
    w[5] = v[4]*u[5] - (2*u[5]-dt)*v[5]
    nothing
end

function Bfunc!(v, u, p, t)
    w = zeros(5)
    Bfunc!(w, v, u, p, t)
    w
end

mfopB = FunctionOperator(Bfunc!, zeros(5), zeros(5); u, p, t, isconstant = false)
```

```@example getting_started
opB(v, Array(2:1.0:6), 0.5, nothing) - mfopB(v, Array(2:1.0:6), 0.5, nothing)
```

## Operator Algebras

While the operators are lazy operations and thus are not full matrices, you can still
do algebra on operators. This will construct a new lazy operator that will be able to
compute the same action as the composed function. For example, let's create `mfopB`
using `mfopA`. Recall that we defined this via `A .* u + dt*I`. Let's first create an
operator for `A .* u` (since right now there is not a built in operator for vector scaling,
but that would be a fantastic thing to add!):

```@example getting_started
function Cfunc!(w, v, u, p, t)
    w[1] = -2v[1] + v[2]
    for i in 2:4
        w[i] = v[i - 1] - 2v[i] + v[i + 1]
    end
    w[5] = v[4] - 2v[5]
    w .= w .* u
    nothing
end

function Cfunc!(v, u, p, t)
    w = zeros(5)
    Cfunc!(w, v, u, p, t)
    w
end

mfopC = FunctionOperator(Cfunc!, zeros(5), zeros(5))
```

And now let's create the operator `mfopC + dt*I`. We can just directly build it:

```@example getting_started
mfopD = mfopC + 0.5*I
```

SciMLOperators.jl uses an `IdentityOperator` and `ScalarOperator` instead of the Base
utilities, but the final composed operator acts just like the operator that was built:

```@example getting_started
mfopB(v, Array(2:1.0:6), 0.5, nothing) - mfopD(v, Array(2:1.0:6), 0.5, nothing)
```

There are many cool things you can do with operator algebras, such as `kron` (Kronecker products),
adjoints, inverses, and more. For more information, see the [operator algebras tutorial](@ref operator_algebras).

## Where to go next?

Great! You now know how to be state/parameter/time-dependent operators and make them matrix-free, along with
doing algebras on operators. What's next?

  - Interested in more examples of building operators? See the example of [making a fast fourier transform linear operator](@ref fft)
  - Interested in more operators ready to go? See the [Premade Operators page](@ref premade_operators) for all of the operators included with SciMLOperators. Note that there are also downstream packages that make new operators.
  - Want to make your own SciMLOperator? See the [AbstractSciMLOperator interface page](@ref operator_interface) which describes the full interface.

How do you use SciMLOperators? Check out the following downstream pages:

  - [Using SciMLOperators in LinearSolve.jl for matrix-free Krylov methods](https://docs.sciml.ai/LinearSolve/stable/tutorials/linear/)
  - [Using SciMLOperators in OrdinaryDiffEq.jl for semi-linear ODE solvers](https://docs.sciml.ai/DiffEqDocs/stable/solvers/nonautonomous_linear_ode/)

# [The `AbstractSciMLOperator` Interface](@id operator_interface)

```@docs
SciMLOperators.AbstractSciMLOperator
SciMLOperators.AbstractSciMLScalarOperator
```

## Interface API Reference

```@docs
update_coefficients
update_coefficients!
cache_operator
concretize
jacobian_stale
mark_jacobian_updated!
mark_jacobian_current!
SciMLOperators.DEFAULT_UPDATE_FUNC
```

## Traits

```@docs
isconstant
iscached
issquare
islinear
isconvertible
has_adjoint
has_expmv
has_expmv!
has_exp
has_mul
has_mul!
has_ldiv
has_ldiv!
SciMLOperators.has_concretization
SciMLOperators.NoKwargFilter
```

## Developer Extension Hooks

The names in this section are qualified, developer-facing extension points.
They are documented so solver packages can depend on a stable contract, but
they are not general user construction APIs. Downstream solver developers
should extend the documented methods rather than relying on private fields or
unexported implementation helpers.

```@docs
SciMLOperators.AbstractWOperator
```

```@docs
SciMLOperators.has_tensor_outer_mul_fast
SciMLOperators.tensor_outer_mul_fast!
```

### Sharing scratch space between the summands of an `AddedOperator`

`mul!` applies the summands of an `AddedOperator` one after another, so no two of their
caches are ever live at the same time and a summand can reuse the scratch of an earlier
one. An operator type takes part by defining `getcache`, and can additionally avoid
allocating a cache it would only discard by defining `adopt_cache`. Both default to
declining, so a type that defines neither behaves exactly as it did before.

A wrapper holding no scratch of its own, such as `ScaledOperator`, forwards all three hooks
to the operator it wraps, so `2A + 3B` and `A - B` share as `A + B` does. A new wrapper of
that kind should do the same.

!!! warning "Concurrency"
    
    Applying a cached operator from several tasks at once was never safe, because they
    would write to the same scratch. Once its summands share scratch they are not
    independently safe either, so code that hand-parallelizes over the `ops` of an
    `AddedOperator` needs its own uncached copies.

```@docs
SciMLOperators.getcache
SciMLOperators.update_cache
SciMLOperators.adopt_cache
```

## Note About Affine Operators

Affine operators are operators that have the action `Q*x = A*x + b`. These operators have
no matrix representation, since if there was, it would be a linear operator instead of an
affine operator. You can only represent an affine operator as a linear operator in a
dimension of one larger via the operation: `[A b] * [u;1]`, so it would require something modified
to the input as well. As such, affine operators are a distinct generalization of linear operators.

While it seems like it might doom the idea of using matrix-free affine operators, it turns out
that affine operators can be used in all cases where matrix-free linear solvers are used due to
an easy generalization of the standard convergence proofs. If Q is the affine operator
``Q(x) = Ax + b``, then solving ``Qx = c`` is equivalent to solving ``Ax + b = c`` or ``Ax = c-b``.
If you now do this same “plug-and-chug” handling of the affine operator into the GMRES/CG/etc.
convergence proofs, move the affine part to the rhs residual, and show it converges to solving
``Ax = c-b``, and thus GMRES/CG/etc. solves ``Q(x) = c`` for an affine operator properly.

That same trick can be used mostly anywhere you would've had a linear operator to extend
the proof to affine operators, so then ``exp(A*t)*v`` operations via Krylov methods work for A being
affine as well, and all sorts of things. Thus, affine operators have no matrix representation, but they
are still compatible with essentially any Krylov method, which would otherwise be compatible with
matrix-free representations, hence their support in the SciMLOperators interface.

## Note about keyword arguments to `update_coefficients!`

In rare cases, an operator may be used in a context where additional state is expected to be provided
to `update_coefficients!` beyond `u`, `p`, and `t`. In this case, the operator may accept this additional
state through arbitrary keyword arguments to `update_coefficients!`. When the caller provides these, they will be recursively propagated downwards through composed operators just like `u`, `p`, and `t`, and provided to the operator.
For the [premade SciMLOperators](premade_operators.md), one can specify the keyword arguments used by an operator with an `accepted_kwargs` argument (by default, none are passed).

In the below example, we create an operator that gleefully ignores `u`, `p`, and `t` and uses its own special scaling.

```@example
using SciMLOperators

γ = ScalarOperator(0.0;
    update_func = (a, u, p, t; my_special_scaling) -> my_special_scaling,
    accepted_kwargs = Val((:my_special_scaling,)))

# Update coefficients, then apply operator
update_coefficients!(γ, nothing, nothing, nothing; my_special_scaling = 7.0)
@show γ * [2.0]

# Use operator application form
@show γ([2.0], nothing, nothing, nothing; my_special_scaling = 5.0)
nothing # hide
```

# SciMLOperators.jl: Unified operator interface for Julia and SciML

`SciMLOperators` is a package for managing linear, nonlinear,
time-dependent, and parameter dependent operators acting on vectors,
(or column-vectors of matrices). We provide wrappers for matrix-free
operators, fast tensor-product evaluations, pre-cached mutating
evaluations, as well as `Zygote`-compatible non-mutating evaluations.

The lazily implemented operator algebra allows the user to update the
operator state by passing in an update function that accepts arbitrary
parameter objects. Further, our operators behave like `AbstractMatrix` types
thanks to overloads defined for methods in `Base`, and `LinearAlgebra`.

Therefore, an `AbstractSciMLOperator` can be passed to `LinearSolve.jl`,
or `NonlinearSolve.jl` as a linear or nonlinear operator, or to
`OrdinaryDiffEq.jl` as an `ODEFunction`. Examples of usage within the
`SciML` ecosystem are provided in the documentation.

## Installation

To install SciMLOperators.jl, use the Julia package manager:

```julia
using Pkg
Pkg.add("SciMLOperators")
```

## Why `SciMLOperators`?

Many functions, from linear solvers to differential equations, require
the use of matrix-free operators to achieve maximum performance in
many scenarios. `SciMLOperators.jl` defines the abstract interface for how
operators in the SciML ecosystem are supposed to be defined. It gives the
common set of functions and traits that solvers can rely on for properly
performing their tasks. Along with that, `SciMLOperators.jl` provides
definitions for the basic standard operators that are used as building
blocks for most tasks, simplifying the use of operators while also
demonstrating to users how such operators can be built and used in practice.

`SciMLOperators.jl` has the design that is required to be used in
all scenarios of equation solvers. For example, Magnus integrators for
differential equations require defining an operator ``u' = A(t) u``, while
Munthe-Kaas methods require defining operators of the form ``u' = A(u) u``.
Thus, the operators need some form of time and state dependence, which the
solvers can update and query when they are non-constant
(`update_coefficients!`). Additionally, the operators need the ability to
act like “normal” functions for equation solvers. For example, if `A(v,u,p,t)`
has the same operation as `update_coefficients(A, u, p, t); A * v`, then `A`
can be used in any place where a differential equation definition
`(u,p,t) -> A(u, u, p, t)` is used without requiring the user or solver to do any extra
work.

Another example is state-dependent mass matrices. `M(u,p,t)*u' = f(u,p,t)`.
When solving such an equation, the solver must understand how to "update M"
during operations, and thus the ability to update the state of `M` is a required
function in the interface. This is also required for the definition of Jacobians
`J(u,p,t)` in order to be properly used with Krylov methods inside of ODE solves
without reconstructing the matrix-free operator at each step.

Thus while previous good efforts for matrix-free operators have existed
in the Julia ecosystem, such as
[LinearMaps.jl](https://github.com/JuliaLinearAlgebra/LinearMaps.jl), those
operator interfaces lack these aspects to actually be fully seamless
with downstream equation solvers. This necessitates the definition and use of
an extended operator interface with all of these properties, hence the
`AbstractSciMLOperator` interface.

```@docs
SciMLOperators
```

!!! warn
    
    This means that LinearMaps.jl is fundamentally lacking and is incompatible
    with many of the tools in the SciML ecosystem, except for the specific cases
    where the matrix-free operator is a constant!

## Features

  - Matrix-free operators with `FunctionOperator`
  - Fast tensor product evaluation with `TensorProductOperator`
  - Lazy algebra: addition, subtraction, multiplication, inverse, adjoint, and transpose
  - Couple fast methods for operator evaluation with inversion via `InvertibleOperator`
  - One-line API to update operator state depending on arbitrary parameters.
  - Mutating and nonmutating update behavior (Zygote compatible)
  - One-line API for pre-caching operators for in-place operator evaluations

## Contributing

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://sciml.github.io/ColPrac/)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums:
    
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the
        [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + On the [Julia Discourse forums](https://discourse.julialang.org)
      + See also [SciML Community page](https://sciml.ai/community/)

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" * name * ".jl/tree/gh-pages/v" * version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```

# [Wrap a Fourier transform with SciMLOperators](@id fft)

In this tutorial, we will wrap a Fast Fourier Transform (FFT) in a SciMLOperator via the
`FunctionOperator` interface. FFTs are commonly used algorithms for performing numerical
interpolation and differentiation. In this example, we will use the FFT to compute the
derivative of a function.

## Copy-Paste Code

```@example fft
using SciMLOperators
using LinearAlgebra, FFTW

n = 256
L = 2π

dx = L / n
x = range(start = -L / 2, stop = L / 2 - dx, length = n) |> Array
v = @. sin(5x)cos(7x);
w = @. 5cos(5x)cos(7x) - 7sin(5x)sin(7x);

k = rfftfreq(n, 2π * n / L) |> Array
m = length(k)
P = plan_rfft(x)

fwd(v, u, p, t) = P * v
bwd(v, u, p, t) = P \ v

fwd(w, v, u, p, t) = mul!(w, P, v)
bwd(w, v, u, p, t) = ldiv!(w, P, v)

F = FunctionOperator(fwd, x, im * k;
    T = ComplexF64, op_adjoint = bwd,
    op_inverse = bwd,
    op_adjoint_inverse = fwd, islinear = true
)

ik = im * DiagonalOperator(k)
Dx = F \ ik * F

Dx = cache_operator(Dx, v)

@show ≈(Dx * v, w; atol = 1e-8)
@show ≈(mul!(copy(w), Dx, v), w; atol = 1e-8)
```

## Explanation

We load `SciMLOperators`, `LinearAlgebra`, and `FFTW` (short for Fastest Fourier Transform
in the West), a common Fourier transform library. Next, we define an equispaced grid from
-π to π, and write the function `u` that we intend to differentiate. Since this is a
trivial example, we already know the derivative, `du`, and write it down to later test our
FFT wrapper.

```@example fft_explanation
using SciMLOperators
using LinearAlgebra, FFTW

L = 2π
n = 256
dx = L / n
x = range(start = -L / 2, stop = L / 2 - dx, length = n) |> Array

v = @. sin(5x)cos(7x);
w = @. 5cos(5x)cos(7x) - 7sin(5x)sin(7x);
```

Now, we define the Fourier transform. Since our input is purely Real, we use the real
Fast Fourier Transform. The function `plan_rfft` outputs a real fast Fourier transform
object that can be applied to inputs that are like `x` as follows: `xhat = transform * x`,
and `LinearAlgebra.mul!(xhat, transform, x)`.  We also get `k`, the frequency modes sampled by
our finite grid, via the function `rfftfreq`.

```@example fft_explanation
k = rfftfreq(n, 2π * n / L) |> Array
m = length(k)
P = plan_rfft(x)
```

Now we are ready to define our wrapper for the FFT object. To `FunctionOperator`, we
pass the in-place forward application of the transform,
`(w,v,u,p,t) -> mul!(w, transform, v)`, its inverse application,
`(w,v,u,p,t) -> ldiv!(w, transform, v)`, as well as input and output prototype vectors.

```@example fft_explanation
fwd(v, u, p, t) = P * v
bwd(v, u, p, t) = P \ v

fwd(w, v, u, p, t) = mul!(w, P, v)
bwd(w, v, u, p, t) = ldiv!(w, P, v)
F = FunctionOperator(fwd, x, im * k;
    T = ComplexF64, op_adjoint = bwd,
    op_inverse = bwd,
    op_adjoint_inverse = fwd, islinear = true
)
```

After wrapping the FFT with `FunctionOperator`, we are ready to compose it with other
SciMLOperators. Below, we form the derivative operator, and cache it via the function
`cache_operator` that requires an input prototype. We can test our derivative operator
both in-place, and out-of-place by comparing its output to the analytical derivative.

```@example fft_explanation
ik = im * DiagonalOperator(k)
Dx = F \ ik * F

Dx = cache_operator(Dx, x)

@show ≈(Dx * v, w; atol = 1e-8)
@show ≈(mul!(copy(w), Dx, v), w; atol = 1e-8)
```

# [Premade SciMLOperators](@id premade_operators)

## Direct Operator Definitions

```@docs
SciMLOperators.IdentityOperator
SciMLOperators.NullOperator
ScalarOperator
MatrixOperator
DiagonalOperator
SciMLOperators.BatchedDiagonalOperator
AffineOperator
AddVector
FunctionOperator
BlockDiagonalOperator
TensorProductOperator
SciMLOperators.:⊗
Base.kron
TensorSumOperator
kronsum
WOperator
SciMLOperators.StaticWOperator
```

## Lazy Scalar Operator Combination

```@docs
SciMLOperators.AddedScalarOperator
SciMLOperators.ComposedScalarOperator
SciMLOperators.InvertedScalarOperator
```

## Lazy Operator Combination

```@docs
SciMLOperators.ScaledOperator
SciMLOperators.AddedOperator
SciMLOperators.ComposedOperator
SciMLOperators.InvertedOperator
SciMLOperators.InvertibleOperator
SciMLOperators.AdjointOperator
SciMLOperators.TransposedOperator
```

# [Demonstration of Operator Algebras and Kron](@id operator_algebras)

Let `M`, `D`, `F` be matrix-based, diagonal-matrix-based, and function-based
`SciMLOperators` respectively. Here are some examples of composing operators
in order to build more complex objects and using their operations.

```@example operator_algebra
using SciMLOperators, LinearAlgebra
N = 4
function f(v, u, p, t)
    u .* v
end
function f(w, v, u, p, t)
    w .= u .* v
end

u = rand(4)
p = nothing # parameter struct
t = 0.0     # time

M = MatrixOperator(rand(N, N))
D = DiagonalOperator(rand(N))
F = FunctionOperator(f, zeros(N), zeros(N); u, p, t)
```

Then, the following codes just work.

```@example operator_algebra
L1 = 2M + 3F + LinearAlgebra.I + rand(N, N)
L2 = D * F * M'
L3 = kron(M, D, F)
L4 = lu(M) \ D
L5 = [M; D]' * [M F; F D] * [F; D]
```

Each `L#` can be applied to `AbstractVector`s of appropriate sizes:

```@example operator_algebra
v = rand(N)
w = L1(v, u, p, t) # == L1 * v

v_kron = rand(N^3)
w_kron = L3(v_kron, u, p, t) # == L3 * v_kron
```

For mutating operator evaluations, call `cache_operator` to generate an
in-place cache, so the operation is nonallocating.

```@example operator_algebra
α, β = rand(2)

# allocate cache
L2 = cache_operator(L2, u)
L4 = cache_operator(L4, u)

# allocation-free evaluation
L2(w, v, u, p, t) # == mul!(w, L2, v)
L4(w, v, u, p, t, α, β) # == mul!(w, L4, v, α, β)
```
